MultiOverlayV4 = {};
MultiOverlayV4.modDir = g_currentModDirectory;
MultiOverlayV4.settingsDir = getUserProfileAppPath().. "modSettings/MultiOverlayV4/";
MultiOverlayV4.detiServerDir = getUserProfileAppPath();
MultiOverlayV4.profileDir = MultiOverlayV4.settingsDir.. "profile/";
MultiOverlayV4.pathMap = "";

MultiOverlayV4.metadata = {
	interface = " FS22 ...",
	title = "MultiOverlayV4 Hud",
	notes = " Zeigt Aktuelle Preise/Bestände und vieles mehr in einem Tablet/PDA/Slot Hud an",
	author = " (by HappyLooser)",
	version = " v4.22 Beta",
	xmlVersion = 0.1,
	artDesignVersion = 0.1,
	clientModuleVersion = 0.1;
	serverModuleVersion = 0.1;
	clientAppVersion = 0.1;
	serverAppVersion = 0.1;
	datum = " 08.04.2015",
	update = " 28.04.2023",
	web = " http://www.modhoster.de",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:  http://www.modhoster.de"
};

function MultiOverlayV4:loadMap(mapName)		
	print("---loading ".. tostring(MultiOverlayV4.metadata.title).. tostring(MultiOverlayV4.metadata.version).. tostring(MultiOverlayV4.metadata.author).. "---")	
	if not MultiOverlayV4:getServer() then
		g_currentMission.multiOverlayV4 = {};g_currentMission.multiOverlayV4.slotCallbacks = {};g_currentMission.multiOverlayV4.pdaCallbacks = {};
		MultiOverlayV4.hlDebugMode = false;
		--MultiOverlayV4.debugPrint = false;		
		--MultiOverlayV4:loadTest();
		MultiOverlayV4.appCmd = {};
		MultiOverlayV4.testTimer = 0;
		MultiOverlayV4.loadError = false;
		MultiOverlayV4.loadHostServer = false;
		MultiOverlayV4.loadDetiServer = false;
		MultiOverlayV4.isMp = g_currentMission.missionDynamicInfo.isMultiplayer;	
		MultiOverlayV4.map = {name=tostring(g_currentMission.missionInfo.map.title),modMap=string.find(g_currentMission.missionInfo.map.id, "SampleModMap"),zipName=string.gsub(g_currentMission.missionInfo.map.id, ".SampleModMap", "")};
		MultiOverlayV4.pathMap = tostring(mapName);	
		MultiOverlayV4.isServer = false;	
		if g_server ~= nil then MultiOverlayV4.isServer = true;end;
		MultiOverlayV4.isClient = false;
		if g_client ~= nil then MultiOverlayV4.isClient = true;end;
		if MultiOverlayV4.isMp and MultiOverlayV4.isServer and MultiOverlayV4.isClient and g_dedicatedServer == nil then MultiOverlayV4.loadHostServer = true;end;
		if MultiOverlayV4.isMp and MultiOverlayV4.isServer and MultiOverlayV4.isClient and g_dedicatedServer ~= nil then MultiOverlayV4.loadDetiServer = true;MultiOverlayV4.appDir = MultiOverlayV4.detiServerDir.. "app/";end;
		generateFolders();	
		moSource:load(1);
			
		moLanguageXml:loadTable();
		moXmlSettings:load( {languageXml=true} );
		moSetGetProfilXML:loadProfileXml();		
		if moDraw == nil then
			moDraw = {};
		end;
		moSource:load(2);	
		moXmlSettings:load( {clientXml=true} );
		moSetGetOverlays:loadTables();
		moSource:load(3);
		moSetGetCmd:setMohDefaultCmds();
		--moXmlSettings:load( {clientXml=true} );				
		MultiOverlayV4.helpBox = false;		
		MultiOverlayV4.cursorInArea = false;
		MultiOverlayV4.otherMods = {};
		MultiOverlayV4.hlGui = {isLoad=false,page={},side={}};
		moSource:load(4);		
		moXmlSettings:autoSave();		
		---input register---
		
		--Player.registerActionEvents = Utils.appendedFunction(Player.registerActionEvents, MultiOverlayV4.registerActionEventsPlayer);
					
		---input register---
		Mission00.onStartMission = Utils.prependedFunction(Mission00.onStartMission, MultiOverlayV4.startMission);
		moSource:load(5);
		Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, MultiOverlayV4.onStartMission);		
	end;
end;

function MultiOverlayV4:loadTest()
	
end;

function MultiOverlayV4:onStartMission()
	if not MultiOverlayV4:getServer() then 
		moSetGet:loadDefaultWtmState();
		moSetGet:playerHandTool();
		moSetGet:vehicleZoom();		
		MultiOverlayV4:searchOtherMods();moModule:onStartMission();moXmlSettings:load( {profilXml=true} );
		if not MultiOverlayV4.hlGui.isLoad then moHlGui:generate(true, true);end; --change
		MultiOverlayV4:registerActionEventsPlayer();
		FSBaseMission.registerActionEvents = Utils.appendedFunction(FSBaseMission.registerActionEvents, MultiOverlayV4.registerActionEventsPlayer);
		moSetGetOverlaysLight:generate();
	end;	
end;

function MultiOverlayV4:startMission()
	if MultiOverlayV4:getServer() then return;end;
	moHlGui:generate(false, true);	
end;

function MultiOverlayV4:registerActionEventsPlayer()    
	local isOkay, eventName = InputBinding.registerActionEvent(g_inputBinding, 'MoV4OnOffMouseCursor', self, MultiOverlayV4.actionKeyMouse, false, true, false, true);
	if isOkay then if g_currentMission.hl.controlMod == "MultiOverlayV4" then g_inputBinding.events[eventName].displayIsVisible = false;else g_inputBinding:removeActionEvent(eventName);end;end;	
end;

function MultiOverlayV4:actionKeyMouse(actionName, keyStatus, arg4, arg5, arg6)	
	if not g_currentMission.hl.dragDrop.on then
		if not moGeneralSettings.modOn and actionName == "MoV4OnOffMouseCursor" then 
			moMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, true, true); 
		elseif actionName == "MoV4OnOffMouseCursor" then 
			moMouseKeyEvents:setKey(unicode, sym, modifier, isDownKey, false, true);	
		end;
	end;
end;

function MultiOverlayV4:delete()
	if MultiOverlayV4:getServer() then return;end;
	moXmlSettings:saveXml();
end;

function MultiOverlayV4:deleteMap()
	if MultiOverlayV4:getServer() then return;end;	
	moSetGetOverlays:deleteSlotIcons();
	moSetGetOverlays:deletePdaIcons();
	moSetGetOverlays:deleteIcons();		
end;

function MultiOverlayV4:mouseEvent(posX, posY, isDown, isUp, button)
	if MultiOverlayV4:getServer() or MultiOverlayV4:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV4:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	MultiOverlayV4.mouseCursor = {posX=posX, posY=posY, isDwon=isDown, isUp=isUp, button=button};
	if moGeneralSettings.modOn then moMouseKeyEvents:setKeyMouse(nil, nil, nil, nil, posX, posY, isDown, isUp, button);end;
	MultiOverlayV4.cursorInArea = false;
	--moMouseKeyEvents:setKeyMouseTest();
end;

local testKey = true;
function MultiOverlayV4:keyEvent(unicode, sym, modifier, isDown)
	if testKey and not MultiOverlayV4:getServer() then moMouseKeyEvents:setKeyMouseTest(self, unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);end;
	if MultiOverlayV4:getServer() or MultiOverlayV4:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV4:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	if moGeneralSettings.modOn then moMouseKeyEvents:setKeyMouse(unicode, sym, modifier, isDown, nil, nil, nil, nil, nil);end;
end;

function MultiOverlayV4:update(dt)	
	if MultiOverlayV4:getServer() or MultiOverlayV4:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV4:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;
	g_currentMission.hl.update_timers(dt, "MultiOverlayV4");
	g_currentMission.hl.updateRunMsg(dt, "MultiOverlayV4");
		
	if moGeneralSettings.modOn then moModule:update(dt);end;	
	if moGeneralSettings.modOn and MultiOverlayV4.hlGui.isLoad and not g_currentMission.hlGui.setGet:isOpen() and moGeneralSettings.cmdSettingMenue.on then moHlGuiCmdSetting:setClose();end;
	if g_currentMission.hl.isMouseCursor then g_currentMission.hl.mouseOnOff(true,g_currentMission.hlGui.menue.playerFrozen, "MultiOverlayV4");end;
	if moGeneralSettings.modOn and not moGeneralSettings.profile.viewInfo then moGeneralSettings.profile.viewInfo = true;guiDialog:onStartProfilInfoDialog();end;
	if moGeneralSettings.modOn then moSetGetOverlaysLight:update(dt);end;
end;

function MultiOverlayV4:draw()
	if MultiOverlayV4:getServer() or MultiOverlayV4:get_hl("getIngameMap", {}, "getIngameMap") or MultiOverlayV4:get_hl("getFullSize", {true, true}, "getFullSize") then return;end;	
	g_currentMission.hl.drawRunMsg("MultiOverlayV4");
	g_currentMission.hl.drawTextDisplay("MultiOverlayV4");
	
	--if moGeneralSettings.testDraw then moSetGetOverlays.previewAppIcons[1]:render();end;	
	
	
	--respect settings for other mods (not every mod) that's why
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
	if moGeneralSettings.modOn then
		local openPdas = moDraw.pda:getOpen();
		if #openPdas > 0 then
			moGeneralSettings.clickAreas.smallView = {};
			moSetGetPda:addAppIconLoadChange();
			for pda=1, #openPdas do				
				moDraw.pda:setOpenDraw(openPdas[pda]);
			end;
		else
			moDraw.smallView:setOpen();
		end;
		local openSlots = moDraw.slot:getOpen();
		if #openSlots > 0 then
			for slot=1, #openSlots do				
				moDraw.slot:setOpenDraw(openSlots[slot]);
			end;
		end;
		if g_currentMission.hl.dragDrop.on and g_currentMission.hl.isMouseCursor then 
			moDragDrop:setOpen();
		end;
		moDraw.infoHelpBox:setOpenDraw();		
		moSetGet:setMiniMapState();
		moSetGet:setPlayerPos();
		
		if moSetGetOverlaysLight:isVisible() then			
			moDraw.light:setOpenDraw();
		end;
	end;	
	if #moGeneralSettings.testNumber > 0 then		 
		setTextBold(true);
		for a=1, #moGeneralSettings.testNumber do		
			local posY = 20+a+1/100;
			renderText(0.1, posY, 0.010, "-N ".. tostring(a).. "- ".. tostring(moGeneralSettings.testNumber[a]));
		end;
	end;	
	if #moGeneralSettings.testString > 0 then
		setTextBold(true);		
		for a=1, #moGeneralSettings.testString do
			local posY = 0.25-(a/100);
			renderText(0.5, posY, 0.010, "-S ".. tostring(a).. "- ".. tostring(moGeneralSettings.testString[a]));
		end;
	end;
		
	--respect settings for other mods
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods	
end;
addModEventListener(MultiOverlayV4);

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function MultiOverlayV4:searchOtherMods()
	local env = getfenv(0);		
	if env["FS22_AutoDrive"] ~= nil and env["FS22_AutoDrive"]["AutoDrive"] ~= nil then
		MultiOverlayV4.otherMods.autoDrive = env["FS22_AutoDrive"];
	end;
	if env["FS22_Courseplay"] ~= nil and env["FS22_Courseplay"]["Courseplay"] ~= nil then
		MultiOverlayV4.otherMods.courseplay = env["FS22_Courseplay"]; 
	end;
	if env["FS22_StrongFarmer"] ~= nil and env["FS22_StrongFarmer"]["StrongFarmer"] ~= nil then
		MultiOverlayV4.otherMods.strongFarmer = true;
		moGeneralSettings.other.strongFarmer.isOn = true;
		moGeneralSettings.other.strongFarmer.maxMass = Player.MAX_PICKABLE_OBJECT_MASS;
		--moGeneralSettings.other.strongFarmer.maxDistance = Player.MAX_PICKABLE_OBJECT_DISTANCE;
	end;
	if env["FS22_PowerPack"] ~= nil and env["FS22_PowerPack"]["PowerPack"] ~= nil then
		MultiOverlayV4.otherMods.strongFarmer = true;
		moGeneralSettings.other.strongFarmer.isOn = true;
		moGeneralSettings.other.strongFarmer.maxMass = Player.MAX_PICKABLE_OBJECT_MASS;
		--moGeneralSettings.other.strongFarmer.maxDistance = Player.MAX_PICKABLE_OBJECT_DISTANCE;
	end;
	--if env["FS22_BetterContracts"] ~= nil and env["FS22_BetterContracts"]["BetterContracts"] ~= nil then
	--	MultiOverlayV4.otherMods.betterContracts = env["FS22_BetterContracts"];
	--end;
	if env["VehicleInspector"] ~= nil and env["VehicleInspector"]["VehicleInspector"] ~= nil then
		MultiOverlayV4.otherMods.vehicleInspector = env["VehicleInspector"];
	end;
	if env["FS22_ProductionInfoHud"] ~= nil and env["FS22_ProductionInfoHud"]["ProductionInfoHud"] ~= nil then
		MultiOverlayV4.otherMods.productionInfoHud = env["FS22_ProductionInfoHud"];		
	end;
	if env["FS22_AIVehicleExtension"] ~= nil and env["FS22_AIVehicleExtension"]["AIVehicleExtension"] ~= nil then
		MultiOverlayV4.otherMods.aiVehicleExtension = env["FS22_AIVehicleExtension"];			
	end;
	if env["FS22_guidanceSteering"] ~= nil and env["FS22_guidanceSteering"]["GuidanceSteering"] ~= nil then
		MultiOverlayV4.otherMods.gps = env["FS22_guidanceSteering"];		
	end;
	if env["FS22_park_vehicle"] ~= nil and env["FS22_park_vehicle"]["ParkVehicle"] ~= nil then
		MultiOverlayV4.otherMods.parkVehicle = env["FS22_park_vehicle"];			
	end;
	if env["FS22_ContractHUD"] ~= nil and env["FS22_ContractHUD"]["ContractHUD"] ~= nil then
		MultiOverlayV4.otherMods.contractHud = env["FS22_ContractHUD"];			
	end;
	if env["FS22_VehicleControlAddon"] ~= nil and env["FS22_VehicleControlAddon"]["vehicleControlAddon"] ~= nil then
		MultiOverlayV4.otherMods.vca = env["FS22_VehicleControlAddon"];			
	end;
	--if env["FS22_lockSteeringAxles"] ~= nil and env["FS22_lockSteeringAxles"]["LockSteeringAxles"] ~= nil then
	--	MultiOverlayV4.otherMods.lockSteeringAxles = env["FS22_lockSteeringAxles"];			
	--end;
	if env["FS22_TrailerJointBlock"] ~= nil and env["FS22_TrailerJointBlock"]["TrailerJointBlock"] ~= nil then
		MultiOverlayV4.otherMods.trailerJointBlock = env["FS22_TrailerJointBlock"];			
	end;
	if env["FS22_EasyDevControls"] ~= nil and env["FS22_EasyDevControls"]["EasyDevControls"] ~= nil then
		MultiOverlayV4.otherMods.easyDevControls = env["FS22_EasyDevControls"];		
	end;
	--if env["FS22_CbRadioHelper"] ~= nil and env["FS22_CbRadioHelper"]["CBRadioHelper"] ~= nil then
	--	MultiOverlayV4.otherMods.cbRadioHelper = env["FS22_CbRadioHelper"];		
	--end;
	if env["FS22_VehicleExplorer"] ~= nil and env["FS22_VehicleExplorer"]["VehicleSort"] ~= nil then
		MultiOverlayV4.otherMods.vehicleExplorer = env["FS22_VehicleExplorer"];
		if FS22_VehicleExplorer.envTardis == nil and FS22_VehicleExplorer.VehicleSort.config[22][2] then
			-- Integration with Tardis
			local TardisName = "FS19_Tardis";
			if g_modIsLoaded[TardisName] then
				envTardis = getfenv(0)[TardisName];				
			end;
		end;
	end;
	if env["FS22_InfoMessageHUD"] ~= nil and env["FS22_InfoMessageHUD"]["InfoMessageHUD"] ~= nil then
		MultiOverlayV4.otherMods.infoMessageHud = env["FS22_InfoMessageHUD"];
		if MultiOverlayV4.otherMods.infoMessageHud.InfoMessageHUD.draw ~= nil then
			MultiOverlayV4:cloneInfoMessageHud();
		end;
	end;	
	if MultiOverlayV4.otherMods.vehicleInspector == nil and g_currentMission.vehicleInspector ~= nil then MultiOverlayV4.otherMods.vehicleInspector = g_currentMission.vehicleInspector;end;
end;

function MultiOverlayV4:getServer()	
	return g_server ~= nil and g_client ~= nil and g_dedicatedServer ~= nil;
	--return MultiOverlayV4.loadDetiServer;
end;

function MultiOverlayV4:getHostServer()	
	return MultiOverlayV4.loadHostServer;
end;

function generateFolders()
	createFolder(getUserProfileAppPath().. "modSettings/");
	createFolder(MultiOverlayV4.settingsDir);	
	createFolder(MultiOverlayV4.profileDir);	
end;

function MultiOverlayV4:cloneInfoMessageHud()	
	MultiOverlayV4.otherMods.infoMessageHud.mohDraw = function()return;end;
	MultiOverlayV4.otherMods.infoMessageHud.on = true;	
	MultiOverlayV4.otherMods.infoMessageHud.modDraw = FS22_InfoMessageHUD.InfoMessageHUD.draw;		
end;

function MultiOverlayV4:getActiveProfil()
	return moSetGetProfilXML:getActiveProfil();
end;

function MultiOverlayV4:getMapName()
	local mapName = "Unknown";
	if g_currentMission.missionInfo ~= nil then
		mapName = tostring(g_currentMission.missionInfo.name);
		local map = g_mapManager:getMapById(g_currentMission.missionInfo.mapId);
		if map ~= nil and g_currentMission.missionInfo:isa(FSCareerMissionInfo) then
			mapName = tostring(map.title);
		end;
	end;
	return mapName;
end;

--_hl Freeware ls17,19,22--
function MultiOverlayV4:get_hl(args, argsTable, errorTxtCall) --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
	local isOkay, result, argsError, errorTxt = nil,nil,nil,errorTxtCall;
	if MultiOverlayV4.hlDebugMode and (errorTxtCall == nil or type(errorTxtCall) ~= "string" or string.len(errorTxtCall) == 0) then errorTxt = "Unknown";end;
	local foundArgsError = false;
	if type(argsTable) == "table" and g_currentMission.hl[args] ~= nil then	
		isOkay, result = pcall(g_currentMission.hl[args], unpack(argsTable));
	else
		foundArgsError = true;
	end;
	if MultiOverlayV4.hlDebugMode and foundArgsError then isOkay=false;argsError="Unknown args or argsTable or argsTable = 0";end;		
	if MultiOverlayV4.hlDebugMode and (not isOkay or foundArgsError) then g_currentMission.hl.setDebug("MultiOverlayV4Mod", args or "Unknown", errorTxt, argsError or "No args error", result or "NO result error");end;
	return result, isOkay;	
end;
--_hl Freeware ls17,19,22--

function MultiOverlayV4:sortTable(sortTable)
	function comp(w1,w2)			
		if w1 > w2 then
			return true;
		end;			
	end;	
	table.sort(sortTable, comp);	
end;

--ls 15
function MultiOverlayV4:tableToString(tt, indent, done)
	--print(DebugUtil.printTableRecursively(lineTable, "fillTypes ", 0, 5))	
	--print(tostring(MultiOverlayV4:tableToString(...)));
	--for key, value in pairs(.....) do
	--	print("key und value ...".. tostring(key).. " ----- ".. tostring(value))
	--end;	
	done = done or {};
	indent = indent or 0;
	if type(tt) == "table" then
		local sb = {};
		for key, value in pairs (tt) do
			table.insert(sb, string.rep (" ", indent));
			if type (value) == "table" and not done [value] then
				done [value] = true;
				table.insert(sb, "{\n");
				table.insert(sb, MultiOverlayV4:tableToString (value, indent + 2, done));
				table.insert(sb, string.rep (" ", indent));
				table.insert(sb, "}\n");
			elseif "number" == type(key) then
				table.insert(sb, string.format("\"%s\"\n", tostring(value)));
			else
				table.insert(sb, string.format("%s = \"%s\"\n", tostring(key), tostring(value)));
			end
		end
		return table.concat(sb)
	else
		if tt == nil then return "table error.........";end;
		return tt .. "\n";
	end;
end;
-------------------------
