moSetGetClientXML = {};

function moSetGetClientXML:loadConfig(Xml, xmlType)
	local xmlNameTag = xmlType;
	if Xml ~= nil then
		if xmlType == "clientXML" then
			local groupNameTag = (xmlNameTag.. ".global(%d)"):format(0);
			if getXMLBool(Xml, groupNameTag.."#modOn") ~= nil then
				moGeneralSettings.modOn = getXMLBool(Xml, groupNameTag.. "#modOn");
			end;
			if getXMLBool(Xml, groupNameTag.."#miniMapAutoState") ~= nil then
				moGeneralSettings.miniMapAutoState.on = getXMLBool(Xml, groupNameTag.. "#miniMapAutoState");
			end;
			if getXMLBool(Xml, groupNameTag.."#viewMiniMapStateIcons") ~= nil then
				moGeneralSettings.miniMapAutoState.viewIcons = getXMLBool(Xml, groupNameTag.. "#viewMiniMapStateIcons");
			end;
			if getXMLBool(Xml, groupNameTag.."#miniMapState1") ~= nil then
				moGeneralSettings.miniMapAutoState.state[1] = getXMLBool(Xml, groupNameTag.. "#miniMapState1");
			end;
			if getXMLBool(Xml, groupNameTag.."#miniMapState2") ~= nil then
				moGeneralSettings.miniMapAutoState.state[2] = getXMLBool(Xml, groupNameTag.. "#miniMapState2");
			end;
			if getXMLBool(Xml, groupNameTag.."#miniMapState3") ~= nil then
				moGeneralSettings.miniMapAutoState.state[3] = getXMLBool(Xml, groupNameTag.. "#miniMapState3");
			end;
			function errorSetMiniMapAutoState()
				return not moGeneralSettings.miniMapAutoState.state[1] and not moGeneralSettings.miniMapAutoState.state[2] and not moGeneralSettings.miniMapAutoState.state[3];
			end;
			if errorSetMiniMapAutoState() then moGeneralSettings.miniMapAutoState.state[1] = true;end;
			--if getXMLBool(Xml, groupNameTag.."#backupClientSettingsXml") ~= nil then
			--	moGeneralSettings.backupSettings.clientSettings = getXMLBool(Xml, groupNameTag.. "#backupClientSettingsXml");
			--end;
			--if getXMLBool(Xml, groupNameTag.."#backupProfilSettingsXml") ~= nil then
			--	moGeneralSettings.backupSettings.profilSettings = getXMLBool(Xml, groupNameTag.. "#backupProfilSettingsXml");
			--end;
			if getXMLFloat(Xml, groupNameTag.."#iconWidescreenFix") ~= nil then
				moGeneralSettings.iconWidescreenFix = getXMLFloat(Xml, groupNameTag.. "#iconWidescreenFix");
				if moGeneralSettings.iconWidescreenFix ~= nil and (moGeneralSettings.iconWidescreenFix > 0 or moGeneralSettings.iconWidescreenFix < 0) then
					--moSetGetOverlays.buttonGfxWidth1 = (1 / g_screenWidth)/1+(0.3);
					--moSetGetOverlays.buttonGfxWidth1 = moSetGetOverlays.buttonGfxWidth1/(moGeneralSettings.iconWidescreenFix);
					moSetGetOverlays.iconWidescreenFix = moGeneralSettings.iconWidescreenFix;
				end;
			end;
			if getXMLBool(Xml, groupNameTag.."#viewPlayerPos") ~= nil then
				moGeneralSettings.other.viewPlayerPos = getXMLBool(Xml, groupNameTag.. "#viewPlayerPos");
			end;
			if getXMLBool(Xml, groupNameTag.."#deleteConfirm") ~= nil then
				moGeneralSettings.deleteConfirm = getXMLBool(Xml, groupNameTag.. "#deleteConfirm");
			end;
			---module---
			moModule:loadConfigs(Xml, xmlNameTag, MultiOverlayV4.settingsDir, "clientSettings");
			---module---
		end;
	end;	
	if not MultiOverlayV4:getServer() and moGeneralSettings.backupSettings.clientSettings then moSetGetClientXML:saveBackup();end;	
end;

function moSetGetClientXML:saveConfig(xmlType)
	local file = MultiOverlayV4.settingsDir.. "clientSettings.xml";
	local Xml = createXMLFile("MultiOverlayV4_XML", file, xmlType);
	local xmlNameTag = xmlType;
	if Xml ~= nil then
		if xmlType == "clientXML" then
			local groupNameTag = (xmlNameTag.. ".global(%d)"):format(0);
			setXMLBool(Xml, groupNameTag.. "#modOn", moGeneralSettings.modOn);
			setXMLBool(Xml, groupNameTag.. "#hlDebugMode", MultiOverlayV4.hlDebugMode);
			setXMLBool(Xml, groupNameTag.. "#miniMapAutoState", moGeneralSettings.miniMapAutoState.on);
			setXMLBool(Xml, groupNameTag.. "#viewMiniMapStateIcons", moGeneralSettings.miniMapAutoState.viewIcons);
			setXMLBool(Xml, groupNameTag.. "#miniMapState1", moGeneralSettings.miniMapAutoState.state[1]);
			setXMLBool(Xml, groupNameTag.. "#miniMapState2", moGeneralSettings.miniMapAutoState.state[2]);
			setXMLBool(Xml, groupNameTag.. "#miniMapState3", moGeneralSettings.miniMapAutoState.state[3]);
			--setXMLBool(Xml, groupNameTag.. "#backupClientSettingsXml", moGeneralSettings.backupSettings.clientSettings);
			--setXMLBool(Xml, groupNameTag.. "#backupProfilSettingsXml", moGeneralSettings.backupSettings.profilSettings);
			setXMLFloat(Xml, groupNameTag.. "#iconWidescreenFix", moGeneralSettings.iconWidescreenFix);
			setXMLBool(Xml, groupNameTag.. "#viewPlayerPos", moGeneralSettings.other.viewPlayerPos);
			setXMLBool(Xml, groupNameTag.. "#deleteConfirm", moGeneralSettings.deleteConfirm);
			
			---module---
			moModule:saveConfigs(Xml, xmlNameTag, MultiOverlayV4.settingsDir, "clientSettings");
			---module---
		end;
		saveXMLFile(Xml);		
	else
		print("!!!! WARNING !!!!".. tostring(MultiOverlayV4.metadata.title).. " save file error "..file);	
	end;	
end;

function moSetGetClientXML:saveBackup()	
	local file = MultiOverlayV4.settingsDir.. "clientSettings.xml";
	local fileBackup = MultiOverlayV4.settingsDir.. "clientSettingsBackup.xml";	
	if fileExists(file) then copyFile(file, fileBackup, true, true);end; --true, replace old file
	--getfenv(0).deleteFile(fileBackup)
end;