moSetGetProfilXML = {};

function moSetGetProfilXML:loadConfig(Xml, xmlType)
	local xmlNameTag = xmlType;
	if Xml ~= nil then
		if xmlType == "profilXML" then			
			local groupNameTag = (xmlNameTag.. ".profil(%d)"):format(0);
			local directory = moGeneralSettings.profile.load.. "/"
			local profilName = moGeneralSettings.profile.found[moGeneralSettings.profile.load];
			if directory ~= nil and profilName ~= nil then				
				if moSetGetOverlays.previewIcons["MultiOverlayV4"] == nil then moSetGetOverlays:loadPreviewIcons();end;
				if getXMLString(Xml, groupNameTag.. "#name") ~= nil then
					local profilNameTemp = getXMLString(Xml, groupNameTag.. "#name");
					if profilNameTemp ~= profilName then moGeneralSettings.profile.found[moGeneralSettings.profile.load] = profilNameTemp;end;
				end;
				local int = 0;
				while true do
					groupNameTag = (xmlNameTag.. ".pda(%d)"):format(int);
					if groupNameTag == nil or getXMLString(Xml, groupNameTag.. "#name") == nil or not getXMLString(Xml, groupNameTag.. "#name") or int > 100 then break;else
					moSetGetProfilXML:loadPda(directory, getXMLString(Xml, groupNameTag.. "#name"));
					int = int+1;
					end;
				end;				
				int = 0;
				while true do
					groupNameTag = (xmlNameTag.. ".slot(%d)"):format(int);
					if groupNameTag == nil or getXMLString(Xml, groupNameTag.. "#name") == nil or not getXMLString(Xml, groupNameTag.. "#name") or int >100 then break;else
					moSetGetProfilXML:loadSlot(directory, getXMLString(Xml, groupNameTag.. "#name"));
					int = int+1;
					end;
				end;				
				---others intern---
				moSetGetProfilXML:loadOthersIntern(Xml, xmlNameTag);
				---others intern---
				---module---
				moModule:loadConfigs(Xml, xmlNameTag, directory, "profilSettings");
				---module---
				moSetGetOverlays:deletePreviewIcons();				
			else
				print("!!!! WARNING !!!!".. tostring(MultiOverlayV4.metadata.title).. " load profile directory error ".. tostring(directory));
			end;
		end;
	end;	
	if not MultiOverlayV4:getServer() and moGeneralSettings.backupSettings.profilSettings then moSetGetProfilXML:saveBackup();end;	
end;

function moSetGetProfilXML:saveConfig(xmlType, directory, profilName, defaultProfil)
	local profil = moGeneralSettings.profile.load;
	local profilName = profilName;
	local directory = directory;
	if directory == nil then directory = profil.. "/";end;
	if profilName == nil then profilName = string.gsub(directory, "/", "");end;
	local file = MultiOverlayV4.profileDir.. tostring(directory).. "profilSettings.xml";
	local Xml = createXMLFile("MultiOverlayV4_XML", file, xmlType);
	local xmlNameTag = xmlType;
	if Xml ~= nil then
		if xmlType == "profilXML" then
			local groupNameTag = (xmlNameTag.. ".info(%d)"):format(0);
			setXMLString(Xml, groupNameTag.."#WARNING", "NOT EDIT THIS XML OR MOH CAN CRASH");
			groupNameTag = (xmlNameTag.. ".profil(%d)"):format(0);
			setXMLString(Xml, groupNameTag.."#name", moGeneralSettings.profile.found[moGeneralSettings.profile.load]);
			local int = 0;
			groupNameTag = (xmlNameTag.. ".pda(%d)"):format(0);			
			local pdas = moSetGetPda:getPdas();
			local slots = moSetGetSlot:getSlots();
			if #pdas > 0 then
				for pda=1, #pdas do
					local pdaTable = moSetGetPda:getPdaTable(pdas[pda])
					if pdaTable ~= nil then
						groupNameTag = (xmlNameTag.. ".pda(%d)"):format(int);
						setXMLString(Xml, groupNameTag.."#name", pdas[pda]);
						moSetGetProfilXML:savePda(directory, pdas[pda], pdaTable);
						int = int+1;
					end;
				end;			
			end;
			int = 0;
			if #slots > 0 then
				for slot=1, #slots do
					local slotTable = moSetGetSlot:getSlotTable(slots[slot])
					if slotTable ~= nil then
						groupNameTag = (xmlNameTag.. ".slot(%d)"):format(int);
						setXMLString(Xml, groupNameTag.."#name", slots[slot]);
						moSetGetProfilXML:saveSlot(directory, slots[slot], slotTable);
						int = int+1;
					end;
				end;			
			end;
			if defaultProfil == nil or not defaultProfil then
				---module---
				moModule:saveConfigs(Xml, xmlNameTag, MultiOverlayV4.profileDir.. tostring(directory), "profilSettings");
				---module---
			end;
			---others intern---
			moSetGetProfilXML:saveOthersIntern(Xml, xmlNameTag);
			---others intern---
			moSetGetProfilXML:saveProfileXml();
		end;
		saveXMLFile(Xml);		
	else
		print("!!!! WARNING !!!!".. tostring(MultiOverlayV4.metadata.title).. " save file error ".. tostring(file));	
	end;	
end;

function moSetGetProfilXML:loadOthersIntern(Xml, xmlNameTag)
	--wtm--
	local groupNameTag = (xmlNameTag.. ".wtm.weather(%d)"):format(0);
	function setTxtColor(what)
		local minColor = 1;
		if what == "temperature" then minColor = 0;end;
		local txtColor = getXMLInt(Xml, groupNameTag.."#txtColor");
		if txtColor > moGeneralSettings.wtm.maxAcceptsTxtColor or txtColor < minColor then txtColor = 1;end;
		if what == "temperature" and txtColor == 0 and not moGeneralSettings.wtm.temperature.color then txtColor = 1;end;
		moGeneralSettings.wtm[what].txtColor = txtColor;
	end;
	function setModus(what)
		local modus = getXMLInt(Xml, groupNameTag.."#modus");
		if modus > moGeneralSettings.wtm[what].maxModus or modus < 1 then modus = 1;end;
		moGeneralSettings.wtm[what].modus = modus;
	end;
	function setOrder(what)
		local order = getXMLInt(Xml, groupNameTag.."#order");
		if order > moGeneralSettings.wtm[what].maxOrder or order < 1 then order = 1;end;
		moGeneralSettings.wtm[what].order = order;
	end;	
	if getXMLBool(Xml, groupNameTag.."#show") ~= nil then
		moSetGet:setWtmState("ShowWeather", getXMLBool(Xml, groupNameTag.."#show"));		
	end;
	groupNameTag = (xmlNameTag.. ".wtm.temperature(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#show") ~= nil then
		moSetGet:setWtmState("ShowTemperature", getXMLBool(Xml, groupNameTag.."#show"));		
		--ls wtm extended--
		if getXMLBool(Xml, groupNameTag.."#iconColor") ~= nil then moGeneralSettings.wtm.temperature.color = getXMLBool(Xml, groupNameTag.."#iconColor");end;
		if getXMLInt(Xml, groupNameTag.."#modus") ~= nil then 
			setModus("temperature");
		end;
		if getXMLInt(Xml, groupNameTag.."#txtColor") ~= nil then 
			setTxtColor("temperature");
		end;
		if getXMLInt(Xml, groupNameTag.."#order") ~= nil then 
			setOrder("temperature");
		end;
		--ls wtm extended--
	end;
	groupNameTag = (xmlNameTag.. ".wtm.ingamedate(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#show") ~= nil then
		moSetGet:setWtmState("ShowIngameDate", getXMLBool(Xml, groupNameTag.."#show"));		
		--ls wtm extended--
		if getXMLInt(Xml, groupNameTag.."#modus") ~= nil then 
			setModus("ingamedate");			
		end;
		if getXMLInt(Xml, groupNameTag.."#txtColor") ~= nil then 
			setTxtColor("ingamedate");
		end;
		if getXMLInt(Xml, groupNameTag.."#order") ~= nil then 
			setOrder("ingamedate");
		end;
		--ls wtm extended--
	end;
	groupNameTag = (xmlNameTag.. ".wtm.ingametime(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#show") ~= nil then
		moSetGet:setWtmState("ShowIngameTime", getXMLBool(Xml, groupNameTag.."#show"));		
		--ls wtm extended--
		if getXMLBool(Xml, groupNameTag.."#iconColor") ~= nil then moGeneralSettings.wtm.ingametime.color = getXMLBool(Xml, groupNameTag.."#iconColor");end;
		if getXMLInt(Xml, groupNameTag.."#modus") ~= nil then 
			setModus("ingametime");	
		end;
		if getXMLInt(Xml, groupNameTag.."#txtColor") ~= nil then 
			setTxtColor("ingametime");
		end;
		if getXMLInt(Xml, groupNameTag.."#order") ~= nil then 
			setOrder("ingametime");
		end;
		if getXMLBool(Xml, groupNameTag.."#showDay") ~= nil then moGeneralSettings.wtm.ingametime.day = getXMLBool(Xml, groupNameTag.."#showDay");end;
		if getXMLBool(Xml, groupNameTag.."#showPlaydays") ~= nil then moGeneralSettings.wtm.ingametime.playdays = getXMLBool(Xml, groupNameTag.."#showPlaydays");end;
		if not moGeneralSettings.wtm.ingametime.day and not moGeneralSettings.wtm.ingametime.playdays then moGeneralSettings.wtm.ingametime.day = true;end;
		--ls wtm extended--
	end;
	groupNameTag = (xmlNameTag.. ".wtm.money(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#show") ~= nil then
		moSetGet:setWtmState("ShowMoney", getXMLBool(Xml, groupNameTag.."#show"));		
		--ls wtm extended--
		if getXMLInt(Xml, groupNameTag.."#modus") ~= nil then 
			setModus("money");
		end;
		if getXMLInt(Xml, groupNameTag.."#txtColor") ~= nil then 
			setTxtColor("realdata");
		end;
		if getXMLInt(Xml, groupNameTag.."#order") ~= nil then 
			setOrder("realdata");
		end;
		if getXMLBool(Xml, groupNameTag.."#showRealDay") ~= nil then moGeneralSettings.wtm.realdata.day = getXMLBool(Xml, groupNameTag.."#showRealDay");end;
		if getXMLBool(Xml, groupNameTag.."#showRealTime") ~= nil then moGeneralSettings.wtm.realdata.time = getXMLBool(Xml, groupNameTag.."#showRealTime");end;
		if getXMLBool(Xml, groupNameTag.."#showRealDate") ~= nil then moGeneralSettings.wtm.realdata.date = getXMLBool(Xml, groupNameTag.."#showRealDate");end;
		if not moGeneralSettings.wtm.realdata.date and not moGeneralSettings.wtm.realdata.time and not moGeneralSettings.wtm.realdata.day then moGeneralSettings.wtm.realdata.day = true;end;
		--ls wtm extended--
	end;
	groupNameTag = (xmlNameTag.. ".wtm.mohWtmBackground(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#show") ~= nil then
		moGeneralSettings.wtm.mohWtmBackground =  getXMLBool(Xml, groupNameTag.."#show");		
	end;
	--wtm--
	--handToolsSwitch--
	groupNameTag = (xmlNameTag.. ".other.handToolsSwitch(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#isOn") ~= nil then
		moGeneralSettings.other.handToolsSwitch =  getXMLBool(Xml, groupNameTag.."#isOn");		
	end;
	--handToolsSwitch--
	--strongFarmer--
	groupNameTag = (xmlNameTag.. ".other.strongFarmer(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#isOn") ~= nil then
		moGeneralSettings.other.strongFarmer.isOn =  getXMLBool(Xml, groupNameTag.."#isOn");		
		if MultiOverlayV4.otherMods.strongFarmer ~= nil and not moGeneralSettings.other.strongFarmer.isOn then
			moGeneralSettings.other.strongFarmer.isOn = true;
			moCmd.strongFarmer({}, false, true); --set off
		end;
	end;
	--strongFarmer--
	--view PlayerPos--
	groupNameTag = (xmlNameTag.. ".other.player(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#viewPos") ~= nil then
		moGeneralSettings.other.viewPlayerPos =  getXMLBool(Xml, groupNameTag.."#viewPos");		
	end;
	--view PlayerPos--
	--view revampModeInfo--
	groupNameTag = (xmlNameTag.. ".other.revamp(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#viewModeInfo") ~= nil then
		moGeneralSettings.other.revamp.viewModeInfo =  getXMLBool(Xml, groupNameTag.."#viewModeInfo");		
	end;
	--view revampModeInfo--
	--view variableOpeningTimeInfo---
	groupNameTag = (xmlNameTag.. ".other.vot(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.."#viewOpeningTimeInfo") ~= nil then
		moGeneralSettings.other.vot.viewOpeningTimeInfo =  getXMLBool(Xml, groupNameTag.."#viewOpeningTimeInfo");		
	end;
	--view variableOpeningTimeInfo--
end;

function moSetGetProfilXML:loadPda(directory, pdaTableName)
	local file = MultiOverlayV4.profileDir.. directory.. pdaTableName.. ".xml";
	if fileExists(file) then 		
		local Xml = loadXMLFile("MultiOverlayV4_XML", MultiOverlayV4.profileDir.. directory.. pdaTableName.. ".xml", "PDA");
		if Xml ~= nil then
			local xmlNameTag = "PDA";	
			local groupNameTag = (xmlNameTag):format(0);
			if getXMLString(Xml, groupNameTag.. "#name") ~= nil then
				local pdaName = getXMLString(Xml, groupNameTag.. "#name");
				if moSetGetPda:getPdaTable(pdaTableName) == nil then
					moSetGetPda:generatePda(pdaTableName, pdaName);
					local pdaTable = moSetGetPda:getPdaTable(pdaTableName);					
					if getXMLBool(Xml, groupNameTag.."#isOpen") ~= nil then
						pdaTable.isOpen = getXMLBool(Xml, groupNameTag.."#isOpen");
					end;
					if getXMLBool(Xml, groupNameTag.."#isUp") ~= nil then
						pdaTable.isUp = getXMLBool(Xml, groupNameTag.."#isUp");
					end;
					if getXMLInt(Xml, groupNameTag.."#viewModus") ~= nil then
						pdaTable.view.isModus = getXMLInt(Xml, groupNameTag.."#viewModus");
					end;
					if getXMLInt(Xml, groupNameTag.."#maxViewModus") ~= nil then
						pdaTable.view.max = getXMLInt(Xml, groupNameTag.."#maxViewModus");
					end;
					for a=1, pdaTable.view.max do
						groupNameTag = (xmlNameTag.. ".viewModus_".. tostring(a).. "(%d)"):format(0);
						if groupNameTag ~= nil then
							if pdaTable.view[a] == nil then pdaTable.view[a] = {};end;
							if getXMLBool(Xml, groupNameTag.."#isSmallView") ~= nil then
								pdaTable.view[a].isSmallView = getXMLBool(Xml, groupNameTag.."#isSmallView");
							end;
							if pdaTable.posX[a] == nil then pdaTable.posX[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#posX") ~= nil then
								pdaTable.posX[a] = getXMLFloat(Xml, groupNameTag.."#posX");
							end;
							if pdaTable.posY[a] == nil then pdaTable.posY[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#posY") ~= nil then
								pdaTable.posY[a] = getXMLFloat(Xml, groupNameTag.."#posY");
							end;
							if pdaTable.width[a] == nil then pdaTable.width[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#width") ~= nil then
								pdaTable.width[a] = getXMLFloat(Xml, groupNameTag.."#width");
							end;
							if pdaTable.height[a] == nil then pdaTable.height[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#height") ~= nil then
								pdaTable.height[a] = getXMLFloat(Xml, groupNameTag.."#height");
							end;
						end;
					end;
					
					groupNameTag = (xmlNameTag.. ".frame(%d)"):format(0);
					if getXMLInt(Xml, groupNameTag.."#zoomOutIn") ~= nil then
						pdaTable.frameZoomOutIn = getXMLInt(Xml, groupNameTag.."#zoomOutIn");
					end;
					
					groupNameTag = (xmlNameTag.. ".setting(%d)"):format(0);
					if getXMLInt(Xml, groupNameTag.."#zoomOutIn") ~= nil then
						pdaTable.settingZoomOutIn = getXMLInt(Xml, groupNameTag.."#zoomOutIn");
					end;
					if getXMLBool(Xml, groupNameTag.."#up") ~= nil then
						pdaTable.setting.up = getXMLBool(Xml, groupNameTag.."#up");
					end;
					if getXMLBool(Xml, groupNameTag.."#canCloseAll") ~= nil then
						pdaTable.setting.canCloseAll = getXMLBool(Xml, groupNameTag.."#canCloseAll");
					end;
					--if getXMLBool(Xml, groupNameTag.."#defaultLine") ~= nil then
						pdaTable.setting.defaultLine = false; --getXMLBool(Xml, groupNameTag.."#defaultLine");
					--end;
					--if getXMLBool(Xml, groupNameTag.."#settingLine") ~= nil then
						pdaTable.setting.settingLine = true; --getXMLBool(Xml, groupNameTag.."#settingLine");
					--end;
					if getXMLBool(Xml, groupNameTag.."#extraLine") ~= nil then
						pdaTable.setting.extraLine = getXMLBool(Xml, groupNameTag.."#extraLine");
					end;
					if getXMLBool(Xml, groupNameTag.."#infoLine") ~= nil then
						pdaTable.setting.infoLine = getXMLBool(Xml, groupNameTag.."#infoLine");
					end;
					
					groupNameTag = (xmlNameTag.. ".appIcon(%d)"):format(0);
					if getXMLInt(Xml, groupNameTag.."#zoomOutIn") ~= nil then
						pdaTable.appIconZoomOutIn = getXMLInt(Xml, groupNameTag.."#zoomOutIn");
					end;
					if getXMLInt(Xml, groupNameTag.."#distanceWidth") ~= nil then
						pdaTable.distanceAppIconWidth = getXMLInt(Xml, groupNameTag.."#distanceWidth");
					end;
					if getXMLInt(Xml, groupNameTag.."#distanceHeight") ~= nil then
						pdaTable.distanceAppIconHeight = getXMLInt(Xml, groupNameTag.."#distanceHeight");
					end;
					if getXMLFloat(Xml, groupNameTag.."#txtSize") ~= nil then
						pdaTable.txtSize = getXMLFloat(Xml, groupNameTag.."#txtSize");
					end;
					if getXMLFloat(Xml, groupNameTag.."#txtLineDistance") ~= nil then
						pdaTable.txtLineDistance = getXMLFloat(Xml, groupNameTag.."#txtLineDistance");
					end;
					if getXMLInt(Xml, groupNameTag.."#txtWidthFix") ~= nil then
						pdaTable.txtWidthFix = getXMLInt(Xml, groupNameTag.."#txtWidthFix");
					end;
					
					local intL = 0;
					local intA = 0;
					local intC = 0;
					--if test then
						while true do
							groupNameTag = (xmlNameTag.. ".line(%d)"):format(intL);
							if groupNameTag == nil or getXMLInt(Xml, groupNameTag.. "#pos") == nil or intL > 100 then break;end;
							local appLine = getXMLInt(Xml, groupNameTag.. "#pos");
							intA = 0;
							while true do
								local appGroupNameTag = (groupNameTag.. ".app(%d)"):format(intA);
								if appGroupNameTag == nil or getXMLInt(Xml, appGroupNameTag.. "#pos") == nil or intA > 100 then break;end;
								local appPos = getXMLInt(Xml, appGroupNameTag.. "#pos");
								local isGenerateApp = moSetGetPda:generateApp( {appValue={appLine,appPos}, whatClick=tostring(pdaTableName)},true );
								moSetGetPda:setSave("", true);
								local iconGroupNameTag = (appGroupNameTag.. ".icon(%d)"):format(0);
								if isGenerateApp and iconGroupNameTag ~= nil and getXMLString(Xml, iconGroupNameTag.. "#name") ~= nil and getXMLInt(Xml, iconGroupNameTag.. "#place") ~= nil then
									if pdaTable.apps[appLine][appPos].icon == nil then pdaTable.apps[appLine][appPos].icon = {};end; 
									local iconPlace = getXMLInt(Xml, iconGroupNameTag.. "#place");
									local iconType = getXMLInt(Xml, iconGroupNameTag.. "#type");
									local iconName = getXMLString(Xml, iconGroupNameTag.. "#name");
									local modName = getXMLString(Xml, iconGroupNameTag.. "#modName");
									local groupName = getXMLString(Xml, iconGroupNameTag.. "#groupName");
									if modName ~= nil and groupName ~= nil then
										function loadChange()
											moSetGetOverlays.appIconLoadChange[#moSetGetOverlays.appIconLoadChange+1] = {whichPda=tostring(pdaTableName),appValue={appLine,appPos},iconPlace=iconPlace,iconName=iconName,modName=modName,groupName=groupName,iconType=iconType};
											pdaTable.apps[appLine][appPos].icon.loadChange = {iconPlace=iconPlace,iconName=iconName,modName=modName,groupName=groupName,iconType=iconType};
										end;
										if moSetGetOverlays.previewIcons[modName] == nil or moSetGetOverlays.previewIcons[modName][groupName] == nil or moSetGetOverlays.previewIcons[modName][groupName][iconPlace] == nil then 
											loadChange();
										else
											local iconFile = moSetGetOverlays.previewIcons[modName][groupName][iconPlace];										
											local saveArgsNew = g_currentMission.hl.getTableCopy(iconFile.saveArgs);
											saveArgsNew.loadIcons={iconPlace};saveArgsNew.previewIcons=nil;saveArgsNew.whichPda=tostring(pdaTableName);saveArgsNew.appIcon={appLine,appPos};
											local firstIcon, endIcon = moSetGetOverlays:loadIcons(saveArgsNew);
											if firstIcon == nil or endIcon == nil then loadChange();end;
										end;									
									end;
								end;
								if isGenerateApp then
									intC = 0;
									while true do
										local cmdGroupNameTag = (appGroupNameTag.. ".cmd(%d)"):format(intC);
										if cmdGroupNameTag == nil or not getXMLString(Xml, cmdGroupNameTag.. "#regName") or intC > 50 then break;end;
										if pdaTable.apps[appLine][appPos].cmd == nil then pdaTable.apps[appLine][appPos].cmd = {};end;
										pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd+1] = {};
										pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd].regName = getXMLString(Xml, cmdGroupNameTag.. "#regName");
										pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd].displayName = getXMLString(Xml, cmdGroupNameTag.. "#displayName") or "Unknown";
										if getXMLBool(Xml, cmdGroupNameTag.. "#mcl") ~= nil then
											if pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd].mouseClick == nil then pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd].mouseClick = {};end;
											pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd].mouseClick[1] = getXMLBool(Xml, cmdGroupNameTag.. "#mcl");
											pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd].mouseClick[2] = getXMLBool(Xml, cmdGroupNameTag.. "#mcm");
											pdaTable.apps[appLine][appPos].cmd[#pdaTable.apps[appLine][appPos].cmd].mouseClick[3] = getXMLBool(Xml, cmdGroupNameTag.. "#mcr");
										end;
										intC = intC+1;
									end;
								end;
								intA = intA+1;
							end;						
							intL = intL+1;						
						--end;
					end;
					---module---
					moModule:loadConfigs(Xml, xmlNameTag, MultiOverlayV4.profileDir.. tostring(directory), "PDA");
					---module---				
				end;				
			end;
		end;
	elseif pdaTableName == "dummyPda_" then
		moSetGetPda:generateDummyPdas();	
	end;
end;

function moSetGetProfilXML:saveOthersIntern(Xml, xmlNameTag)
	--wtm--
	local groupNameTag = (xmlNameTag.. ".wtm.weather(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#show", moSetGet:getWtmState("ShowWeather"));
	
	groupNameTag = (xmlNameTag.. ".wtm.temperature(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.."#show", moSetGet:getWtmState("ShowTemperature"));
		--ls wtm extended--
		setXMLBool(Xml, groupNameTag.."#iconColor", moGeneralSettings.wtm.temperature.color);
		setXMLInt(Xml, groupNameTag.."#modus", moGeneralSettings.wtm.temperature.modus);
		setXMLInt(Xml, groupNameTag.."#txtColor", moGeneralSettings.wtm.temperature.txtColor);
		setXMLInt(Xml, groupNameTag.."#order", moGeneralSettings.wtm.temperature.order);
		--ls wtm extended--
	
	groupNameTag = (xmlNameTag.. ".wtm.ingamedate(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.."#show", moSetGet:getWtmState("ShowIngameDate"));
		--ls wtm extended--
		setXMLInt(Xml, groupNameTag.."#modus", moGeneralSettings.wtm.ingamedate.modus);
		setXMLInt(Xml, groupNameTag.."#txtColor", moGeneralSettings.wtm.ingamedate.txtColor);
		setXMLInt(Xml, groupNameTag.."#order", moGeneralSettings.wtm.ingamedate.order);
		--ls wtm extended--
	
	groupNameTag = (xmlNameTag.. ".wtm.ingametime(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.."#show", moSetGet:getWtmState("ShowIngameTime"));
		--ls wtm extended--
		setXMLBool(Xml, groupNameTag.."#iconColor", moGeneralSettings.wtm.ingametime.color);
		setXMLInt(Xml, groupNameTag.."#modus", moGeneralSettings.wtm.ingametime.modus);
		setXMLInt(Xml, groupNameTag.."#txtColor", moGeneralSettings.wtm.ingametime.txtColor);
		setXMLInt(Xml, groupNameTag.."#order", moGeneralSettings.wtm.ingametime.order);
		setXMLBool(Xml, groupNameTag.."#showDay", moGeneralSettings.wtm.ingametime.day);
		setXMLBool(Xml, groupNameTag.."#showPlaydays", moGeneralSettings.wtm.ingametime.playdays);
		--ls wtm extended--
	
	groupNameTag = (xmlNameTag.. ".wtm.money(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.."#show", moSetGet:getWtmState("ShowMoney"));
		--ls wtm extended--
		setXMLInt(Xml, groupNameTag.."#modus", moGeneralSettings.wtm.money.modus);
		setXMLInt(Xml, groupNameTag.."#txtColor", moGeneralSettings.wtm.realdata.txtColor);
		setXMLInt(Xml, groupNameTag.."#order", moGeneralSettings.wtm.realdata.order);
		setXMLBool(Xml, groupNameTag.."#showRealDay", moGeneralSettings.wtm.realdata.day);
		setXMLBool(Xml, groupNameTag.."#showRealTime", moGeneralSettings.wtm.realdata.time);
		setXMLBool(Xml, groupNameTag.."#showRealDate", moGeneralSettings.wtm.realdata.date);
		--ls wtm extended--
		
	groupNameTag = (xmlNameTag.. ".wtm.mohWtmBackground(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#show", moGeneralSettings.wtm.mohWtmBackground);	
	--wtm--	
	--handToolsSwitch--
	groupNameTag = (xmlNameTag.. ".other.handToolsSwitch(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#isOn", moGeneralSettings.other.handToolsSwitch);
	--handToolsSwitch--
	--strongFarmer--
	groupNameTag = (xmlNameTag.. ".other.strongFarmer(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#isOn", moGeneralSettings.other.strongFarmer.isOn);
	--strongFarmer--
	--viewPlayerPos--
	groupNameTag = (xmlNameTag.. ".other.player(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#viewPos", moGeneralSettings.other.viewPlayerPos);
	--viewPlayerPos--
	--view revampModeInfo--
	groupNameTag = (xmlNameTag.. ".other.revamp(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#viewModeInfo", moGeneralSettings.other.revamp.viewModeInfo);
	--view revampModeInfo--
	--view variableOpeningTimeInfo--
	groupNameTag = (xmlNameTag.. ".other.vot(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#viewOpeningTimeInfo", moGeneralSettings.other.vot.viewOpeningTimeInfo);
	--view variableOpeningTimeInfo--
end;

function moSetGetProfilXML:savePda(directory, pdaTableName, pdaTable)	
	local file = MultiOverlayV4.profileDir.. tostring(directory).. tostring(pdaTableName).. ".xml";
	local Xml = createXMLFile("MultiOverlayV4_XML", file, "PDA");
	local xmlNameTag = "PDA";	
	local groupNameTag = (xmlNameTag):format(0);
	
	groupNameTag = (xmlNameTag.. ".info(%d)"):format(0);
	setXMLString(Xml, groupNameTag.."#WARNING", "NOT EDIT THIS XML OR MOH CAN CRASH");
		
	groupNameTag = (xmlNameTag):format(0);
	setXMLString(Xml, groupNameTag.."#name", pdaTable.name);	
	setXMLInt(Xml, groupNameTag.."#typ", pdaTable.typ);
	setXMLBool(Xml, groupNameTag.."#isOpen", pdaTable.isOpen);
	setXMLBool(Xml, groupNameTag.."#isUp", pdaTable.isUp);
	setXMLInt(Xml, groupNameTag.."#viewModus", pdaTable.view.isModus);
	setXMLInt(Xml, groupNameTag.."#maxViewModus", pdaTable.view.max);
	for a=1, pdaTable.view.max do
		groupNameTag = (xmlNameTag.. ".viewModus_".. tostring(a).. "(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.."#isSmallView", pdaTable.view[a].isSmallView);
		setXMLFloat(Xml, groupNameTag.."#posX", pdaTable.posX[a]);
		setXMLFloat(Xml, groupNameTag.."#posY", pdaTable.posY[a]);
		setXMLFloat(Xml, groupNameTag.."#width", pdaTable.width[a]);
		setXMLFloat(Xml, groupNameTag.."#height", pdaTable.height[a]);
	end;
	
	groupNameTag = (xmlNameTag.. ".frame(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.."#zoomOutIn", pdaTable.frameZoomOutIn);
	
	groupNameTag = (xmlNameTag.. ".setting(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.."#zoomOutIn", pdaTable.settingZoomOutIn);
	setXMLBool(Xml, groupNameTag.."#up", pdaTable.setting.up);
	setXMLBool(Xml, groupNameTag.."#canCloseAll", pdaTable.setting.canCloseAll);
	setXMLBool(Xml, groupNameTag.."#defaultLine", pdaTable.setting.defaultLine);
	setXMLBool(Xml, groupNameTag.."#settingLine", pdaTable.setting.settingLine);
	setXMLBool(Xml, groupNameTag.."#extraLine", pdaTable.setting.extraLine);
	setXMLBool(Xml, groupNameTag.."#infoLine", pdaTable.setting.infoLine);
	
	groupNameTag = (xmlNameTag.. ".appIcon(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.."#zoomOutIn", pdaTable.appIconZoomOutIn);
	setXMLInt(Xml, groupNameTag.."#distanceWidth", pdaTable.distanceAppIconWidth);
	setXMLInt(Xml, groupNameTag.."#distanceHeight", pdaTable.distanceAppIconHeight);
	setXMLFloat(Xml, groupNameTag.."#txtSize", pdaTable.txtSize);
	setXMLFloat(Xml, groupNameTag.."#txtLineDistance", pdaTable.txtLineDistance);
	setXMLInt(Xml, groupNameTag.."#txtWidthFix", pdaTable.txtWidthFix);
	
	local intL = 0;
	local intA = 0;
	local intC = 0;
	if pdaTable.apps ~= nil then
		for appLine=1, 100 do
			if pdaTable.apps[appLine] ~= nil then
				groupNameTag = (xmlNameTag.. ".line(%d)"):format(intL);
				setXMLInt(Xml, groupNameTag.."#pos", appLine);
				intA = 0;
				for appPos=1, 100 do					
					if pdaTable.apps[appLine][appPos] ~= nil then
						intC = 0;
						local appGroupNameTag = (groupNameTag.. ".app(%d)"):format(intA);						
						setXMLInt(Xml, appGroupNameTag.."#pos", appPos);
						if pdaTable.apps[appLine][appPos].icon ~= nil and pdaTable.apps[appLine][appPos].icon[1] ~= nil then
							local iconGroupNameTag = (appGroupNameTag.. ".icon(%d)"):format(0);							
							setXMLString(Xml, iconGroupNameTag.."#name", tostring(pdaTable.apps[appLine][appPos].icon[1].iconName));
							setXMLInt(Xml, iconGroupNameTag.."#type", pdaTable.apps[appLine][appPos].icon[1].iconType);
							setXMLString(Xml, iconGroupNameTag.."#modName", tostring(pdaTable.apps[appLine][appPos].icon[1].modName));
							setXMLString(Xml, iconGroupNameTag.."#groupName", tostring(pdaTable.apps[appLine][appPos].icon[1].groupName));
							setXMLInt(Xml, iconGroupNameTag.."#place", pdaTable.apps[appLine][appPos].icon[1].iconPlace);
							if pdaTable.apps[appLine][appPos].icon[1].txt ~= nil and (pdaTable.apps[appLine][appPos].icon[1].iconType == 0 or pdaTable.apps[appLine][appPos].icon[1].iconType == 3) and pdaTable.apps[appLine][appPos].icon[1].editTxt then
								local txt1 = nil;
								local txt2 = nil;
								if pdaTable.apps[appLine][appPos].icon[1].txt[1] ~= nil then txt1 = pdaTable.apps[appLine][appPos].icon[1].txt[1].txt;end;
								if pdaTable.apps[appLine][appPos].icon[1].txt[2] ~= nil then txt2 = pdaTable.apps[appLine][appPos].icon[1].txt[2].txt;end;
								if txt1 ~= nil then setXMLString(Xml, iconGroupNameTag.."#txt1", tostring(txt1));end;
								if txt2 ~= nil then setXMLString(Xml, iconGroupNameTag.."#txt2", tostring(txt2));end;
							end;
						elseif pdaTable.apps[appLine][appPos].icon ~= nil and pdaTable.apps[appLine][appPos].icon.loadChange ~= nil then
							local iconGroupNameTag = (appGroupNameTag.. ".icon(%d)"):format(0);
							setXMLString(Xml, iconGroupNameTag.."#name", tostring(pdaTable.apps[appLine][appPos].icon.loadChange.iconName));
							setXMLInt(Xml, iconGroupNameTag.."#type", pdaTable.apps[appLine][appPos].icon.loadChange.iconType);
							setXMLString(Xml, iconGroupNameTag.."#modName", tostring(pdaTable.apps[appLine][appPos].icon.loadChange.modName));
							setXMLString(Xml, iconGroupNameTag.."#groupName", tostring(pdaTable.apps[appLine][appPos].icon.loadChange.groupName));
							setXMLInt(Xml, iconGroupNameTag.."#place", pdaTable.apps[appLine][appPos].icon.loadChange.iconPlace);
							setXMLString(Xml, iconGroupNameTag.."#info", "Last Start !Icon not Found!");
						end;
						if pdaTable.apps[appLine][appPos].cmd ~= nil and #pdaTable.apps[appLine][appPos].cmd > 0 then
							for cmd=1, #pdaTable.apps[appLine][appPos].cmd do
								if pdaTable.apps[appLine][appPos].cmd[cmd] ~= nil then
									local cmdGroupNameTag = (appGroupNameTag.. ".cmd(%d)"):format(intC);
									setXMLString(Xml, cmdGroupNameTag.."#regName", tostring(pdaTable.apps[appLine][appPos].cmd[cmd].regName));
									setXMLString(Xml, cmdGroupNameTag.."#displayName", tostring(pdaTable.apps[appLine][appPos].cmd[cmd].displayName));
									if MultiOverlayV4.cmd[pdaTable.apps[appLine][appPos].cmd[cmd].regName] == nil then
										setXMLString(Xml, cmdGroupNameTag.."#info", "Last Start !Cmd not Found!");
									end;
									if pdaTable.apps[appLine][appPos].cmd[cmd].mouseClick ~= nil then
										setXMLBool(Xml, cmdGroupNameTag.."#mcl", pdaTable.apps[appLine][appPos].cmd[cmd].mouseClick[1]);
										setXMLBool(Xml, cmdGroupNameTag.."#mcm", pdaTable.apps[appLine][appPos].cmd[cmd].mouseClick[2]);
										setXMLBool(Xml, cmdGroupNameTag.."#mcr", pdaTable.apps[appLine][appPos].cmd[cmd].mouseClick[3]);
									end;
									intC = intC+1;
								end;
							end;						
						end;
						intA = intA+1;
					end;
				end;
				intL = intL+1;
			end;
		end;
	end;
	---module---
	moModule:saveConfigs(Xml, xmlNameTag, MultiOverlayV4.profileDir.. tostring(directory), "PDA");
	---module---
	saveXMLFile(Xml);
end;

function moSetGetProfilXML:loadSlot(directory, slotTableName)
	local file = MultiOverlayV4.profileDir.. directory.. slotTableName.. ".xml";
	if fileExists(file) then 		
		local Xml = loadXMLFile("MultiOverlayV4_XML", MultiOverlayV4.profileDir.. directory.. slotTableName.. ".xml", "SLOT");
		if Xml ~= nil then
			local xmlNameTag = "SLOT";	
			local groupNameTag = (xmlNameTag):format(0);
			if getXMLString(Xml, groupNameTag.. "#name") ~= nil then
				local slotName = getXMLString(Xml, groupNameTag.. "#name");
				if moSetGetSlot:getSlotTable(slotTableName) == nil then				
					moSetGetSlot:generateSlot(slotTableName, slotName);				
					local slotTable = moSetGetSlot:getSlotTable(slotTableName);
					if getXMLBool(Xml, groupNameTag.."#isOpen") ~= nil then
						slotTable.isOpen = getXMLBool(Xml, groupNameTag.."#isOpen");
					end;
					if getXMLBool(Xml, groupNameTag.."#isUp") ~= nil then
						slotTable.isUp = getXMLBool(Xml, groupNameTag.."#isUp");
					end;
					if getXMLInt(Xml, groupNameTag.."#viewModus") ~= nil then
						slotTable.view.isModus = getXMLInt(Xml, groupNameTag.."#viewModus");
					end;
					if getXMLInt(Xml, groupNameTag.."#maxViewModus") ~= nil then
						slotTable.view.max = getXMLInt(Xml, groupNameTag.."#maxViewModus");
					end;
					for a=1, slotTable.view.max do
						groupNameTag = (xmlNameTag.. ".viewModus_".. tostring(a).. "(%d)"):format(0);
						if groupNameTag ~= nil then
							if slotTable.view[a] == nil then slotTable.view[a] = {};end;
							if getXMLBool(Xml, groupNameTag.."#isSmallView") ~= nil then
								slotTable.view[a].isSmallView = getXMLBool(Xml, groupNameTag.."#isSmallView");
							end;
							if slotTable.posX[a] == nil then slotTable.posX[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#posX") ~= nil then
								slotTable.posX[a] = getXMLFloat(Xml, groupNameTag.."#posX");
							end;
							if slotTable.posY[a] == nil then slotTable.posY[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#posY") ~= nil then
								slotTable.posY[a] = getXMLFloat(Xml, groupNameTag.."#posY");
							end;
							if slotTable.width[a] == nil then slotTable.width[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#width") ~= nil then
								slotTable.width[a] = getXMLFloat(Xml, groupNameTag.."#width");
							end;
							if slotTable.height[a] == nil then slotTable.height[a] = {};end;
							if getXMLFloat(Xml, groupNameTag.."#height") ~= nil then
								slotTable.height[a] = getXMLFloat(Xml, groupNameTag.."#height");
							end;
						end;
					end;
									
					groupNameTag = (xmlNameTag.. ".setting(%d)"):format(0);
					if getXMLInt(Xml, groupNameTag.."#zoomOutIn") ~= nil then
						slotTable.settingZoomOutIn = getXMLInt(Xml, groupNameTag.."#zoomOutIn");
					end;
					if getXMLBool(Xml, groupNameTag.."#up") ~= nil then
						slotTable.setting.up = getXMLBool(Xml, groupNameTag.."#up");
					end;					
					if getXMLBool(Xml, groupNameTag.."#canCloseAll") ~= nil then
						slotTable.setting.canCloseAll = getXMLBool(Xml, groupNameTag.."#canCloseAll");
					end;
					--if getXMLBool(Xml, groupNameTag.."#defaultLine") ~= nil then
						slotTable.setting.defaultLine = false; --getXMLBool(Xml, groupNameTag.."#defaultLine");
					--end;
					--if getXMLBool(Xml, groupNameTag.."#settingLine") ~= nil then
						slotTable.setting.settingLine = true; --getXMLBool(Xml, groupNameTag.."#settingLine");
					--end;
					if getXMLBool(Xml, groupNameTag.."#extraLine") ~= nil then
						slotTable.setting.extraLine = getXMLBool(Xml, groupNameTag.."#extraLine");
					end;
					if getXMLBool(Xml, groupNameTag.."#infoLine") ~= nil then
						slotTable.setting.infoLine = getXMLBool(Xml, groupNameTag.."#infoLine");
					end;
					
					groupNameTag = (xmlNameTag.. ".output(%d)"):format(0);				
					if getXMLBool(Xml, groupNameTag.."#productionWarning") ~= nil then
						slotTable.isWarning = getXMLBool(Xml, groupNameTag.."#productionWarning");
					end;
					if getXMLBool(Xml, groupNameTag.."#productionWarningBlinking") ~= nil then
						slotTable.isWarningBlinking = getXMLBool(Xml, groupNameTag.."#productionWarningBlinking");
					end;
					if getXMLFloat(Xml, groupNameTag.."#txtSize") ~= nil then
						slotTable.txtSize = getXMLFloat(Xml, groupNameTag.."#txtSize");
					end;
					if getXMLFloat(Xml, groupNameTag.."#txtLineDistance") ~= nil then
						slotTable.txtLineDistance = getXMLFloat(Xml, groupNameTag.."#txtLineDistance");
					end;
					if getXMLInt(Xml, groupNameTag.."#txtWidthFix") ~= nil then
						slotTable.txtWidthFix = getXMLInt(Xml, groupNameTag.."#txtWidthFix");
					end;				
					local int = 0;
					while true do
						local groupNameTag = (xmlNameTag.. ".cmd(%d)"):format(int);
						if groupNameTag == nil or not getXMLString(Xml, groupNameTag.. "#regName") or int > 50 then break;end;
						slotTable.cmd[#slotTable.cmd+1] = {};
						slotTable.cmd[#slotTable.cmd].regName = getXMLString(Xml, groupNameTag.. "#regName");
						slotTable.cmd[#slotTable.cmd].displayName = "Unknown";
						if getXMLString(Xml, groupNameTag.. "#displayName") ~= nil then
							slotTable.cmd[#slotTable.cmd].displayName = getXMLString(Xml, groupNameTag.. "#displayName");
						end;
						if getXMLBool(Xml, groupNameTag.. "#mcl") ~= nil then
							if slotTable.cmd[#slotTable.cmd].mouseClick == nil then slotTable.cmd[#slotTable.cmd].mouseClick = {};end;
							slotTable.cmd[#slotTable.cmd].mouseClick[1] = getXMLBool(Xml, groupNameTag.. "#mcl");
							slotTable.cmd[#slotTable.cmd].mouseClick[2] = getXMLBool(Xml, groupNameTag.. "#mcm");
							slotTable.cmd[#slotTable.cmd].mouseClick[3] = getXMLBool(Xml, groupNameTag.. "#mcr");
						end;
						int = int+1;
					end;				
					---module---
					moModule:loadConfigs(Xml, xmlNameTag, MultiOverlayV4.profileDir.. tostring(directory), "PDA");
					---module---				
				end;		
			end;
		end;	
	elseif slotTableName == "dummySlot_" then
		moSetGetSlot:generateDummySlots();	
	end;
end;

function moSetGetProfilXML:saveSlot(directory, slotTableName, slotTable)	
	local file = MultiOverlayV4.profileDir.. tostring(directory).. tostring(slotTableName).. ".xml";
	local Xml = createXMLFile("MultiOverlayV4_XML", file, "SLOT");
	local xmlNameTag = "SLOT";	
	local groupNameTag = (xmlNameTag):format(0);	
	
	groupNameTag = (xmlNameTag.. ".info(%d)"):format(0);
	setXMLString(Xml, groupNameTag.."#WARNING", "NOT EDIT THIS XML OR MOH CAN CRASH");
		
	groupNameTag = (xmlNameTag):format(0);
	setXMLString(Xml, groupNameTag.."#name", slotTable.name);	
	setXMLInt(Xml, groupNameTag.."#typ", slotTable.typ);
	setXMLBool(Xml, groupNameTag.."#isOpen", slotTable.isOpen);
	setXMLBool(Xml, groupNameTag.."#isUp", slotTable.isUp);
	setXMLInt(Xml, groupNameTag.."#viewModus", slotTable.view.isModus);
	setXMLInt(Xml, groupNameTag.."#maxViewModus", slotTable.view.max);
	for a=1, slotTable.view.max do
		groupNameTag = (xmlNameTag.. ".viewModus_".. tostring(a).. "(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.."#isSmallView", slotTable.view[a].isSmallView);
		setXMLFloat(Xml, groupNameTag.."#posX", slotTable.posX[a]);
		setXMLFloat(Xml, groupNameTag.."#posY", slotTable.posY[a]);
		setXMLFloat(Xml, groupNameTag.."#width", slotTable.width[a]);
		setXMLFloat(Xml, groupNameTag.."#height", slotTable.height[a]);
	end;
	
	groupNameTag = (xmlNameTag.. ".setting(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.."#zoomOutIn", slotTable.settingZoomOutIn);
	setXMLBool(Xml, groupNameTag.."#up", slotTable.setting.up);
	setXMLBool(Xml, groupNameTag.."#canCloseAll", slotTable.setting.canCloseAll);
	setXMLBool(Xml, groupNameTag.."#defaultLine", slotTable.setting.defaultLine);
	setXMLBool(Xml, groupNameTag.."#settingLine", slotTable.setting.settingLine);
	setXMLBool(Xml, groupNameTag.."#extraLine", slotTable.setting.extraLine);
	setXMLBool(Xml, groupNameTag.."#infoLine", slotTable.setting.infoLine);
	
	groupNameTag = (xmlNameTag.. ".output(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.."#productionWarning", slotTable.isWarning);
	setXMLBool(Xml, groupNameTag.."#productionWarningBlinking", slotTable.isWarningBlinking);
	setXMLFloat(Xml, groupNameTag.."#txtSize", slotTable.txtSize);
	setXMLFloat(Xml, groupNameTag.."#txtLineDistance", slotTable.txtLineDistance);
	setXMLInt(Xml, groupNameTag.."#txtWidthFix", slotTable.txtWidthFix);
	
	if slotTable.cmd ~= nil and #slotTable.cmd > 0 then
		local int = 0;
		for cmd=1, #slotTable.cmd do
			if slotTable.cmd[cmd] ~= nil then
				groupNameTag = (xmlNameTag.. ".cmd(%d)"):format(int);
				setXMLString(Xml, groupNameTag.."#regName", slotTable.cmd[cmd].regName);
				setXMLString(Xml, groupNameTag.."#displayName", slotTable.cmd[cmd].displayName);
				if slotTable.cmd[cmd].mouseClick ~= nil then
					setXMLBool(Xml, groupNameTag.."#mcl", slotTable.cmd[cmd].mouseClick[1]);
					setXMLBool(Xml, groupNameTag.."#mcm", slotTable.cmd[cmd].mouseClick[2]);
					setXMLBool(Xml, groupNameTag.."#mcr", slotTable.cmd[cmd].mouseClick[3]);
				end;
				int = int+1;
			end;
		end;
	end;
	---module---
	moModule:saveConfigs(Xml, xmlNameTag, MultiOverlayV4.profileDir.. tostring(directory), "SLOT");
	---module---
	saveXMLFile(Xml);
end;

function moSetGetProfilXML:loadNewProfil(profilName, notMultiple)
	if profilName == nil or type(profilName) ~= "string" then return;end;
	local directoryName = string.gsub(profilName, " ", "");
	if moSetGetProfilXML:isDirectoryNameExists(directoryName) then
		moXmlSettings:saveXml();
		moCmd.closeAllPdas();
		moCmd.closeAllSlots();			
		moSetGetOverlays:deleteSlotIcons();
		moSetGetOverlays:deletePdaIcons();
		moSetGetCmd:deleteAllSlotCmds();
		moSetGetOverlays.slot = {};	
		moSetGetOverlays.slotSettingCopyPaste = {};
		moSetGetCmd:deleteAllPdaCmds();
		moSetGetOverlays.pda = {};
		moSetGetOverlays.pdaSettingCopyPaste = {};	
		moSetGetOverlays.appIconLoadChange = {};
		moHlGuiAppIconSetting:setClose();
		moHlGuiCmdSetting:setClose();
		moGeneralSettings.clickAreas.masterSlot = {};
		moGeneralSettings.clickAreas.masterPda = {};
		moGeneralSettings.clickAreas.slot = {};
		moGeneralSettings.clickAreas.smallView = {};
		moGeneralSettings.clickAreas.miniMapAutoState = {};
		moGeneralSettings.clickAreas.pda = {};		
		moSetGetProfilXML:setLoadProfil(directoryName);
		moSetGetProfilXML:saveProfileXml();
		moSetGet:refreshWtmState();
		moTeleportPointsConfig:defaultValues();
		moGeneralSettings.other.handToolsSwitch = true;
		moCmd.strongFarmer("", true, true);
		moXmlSettings:load( {profilXml=true} );
	elseif notMultiple == nil or not notMultiple then 
		g_currentMission.hl.addTextDisplay( {txt="Directory Name is corrupt (load Default Profil)", txtBold=true, duration=3, warning=true} );		
		if moGeneralSettings.profile.load ~= "DefaultProfil" then		
			moSetGetProfilXML:loadNewProfil("DefaultProfil", true);			
		else
			moGeneralSettings.profile.select = moGeneralSettings.profile.load;
		end;
	else
		moGeneralSettings.profile.select = moGeneralSettings.profile.load;
	end;
end;

function moSetGetProfilXML:deleteXml(whichName, xmlType, typ)	
	if xmlType == "profilXML" then		
		local file = MultiOverlayV4.profileDir.. moGeneralSettings.profile.load.. "/".. tostring(whichName).. ".xml";
		if fileExists(file) then getfenv(0).deleteFile(file);end;		
	end;
end;

function moSetGetProfilXML:deleteProfil(profilName)	
	if profilName == nil or type(profilName) ~= "string" then return;end;			
	local directoryName = string.gsub(profilName, " ", "");
	local directory = directoryName.. "/";
	local fileXml = MultiOverlayV4.profileDir.. directory.. "profilSettings.xml";
	local file = MultiOverlayV4.profileDir.. directory;
	if fileExists(fileXml) then 
		getfenv(0).deleteFolder(file);
		moGeneralSettings.profile.found[directoryName] = nil;
		moSetGetProfilXML:saveProfileXml();
		g_currentMission.hl.addTextDisplay( {txt="Delete Profil", txtBold=true, duration=3, warning=true} );		
	else
		directory = moGeneralSettings.profile.select.. "/";
		file = MultiOverlayV4.profileDir.. directory;		
		getfenv(0).deleteFolder(file);
		moGeneralSettings.profile.found[directoryName] = nil;
		moSetGetProfilXML:saveProfileXml();
		g_currentMission.hl.addTextDisplay( {txt="Delete Profil", txtBold=true, duration=3, warning=true} );		
	end;	
end;

function moSetGetProfilXML:generateProfil(xmlType, file, profilName)	
	local Xml = createXMLFile("MultiOverlayV4_XML", file, xmlType);	
	local xmlNameTag = ("profilXML"):format(0);
	local groupNameTag = (xmlNameTag.. ".profil(%d)"):format(0);
	setXMLString(Xml, xmlNameTag.."#name", tostring(profilName));	
	groupNameTag = (xmlNameTag.. ".pda(%d)"):format(0);
	setXMLString(Xml, groupNameTag.."#name", "dummyPda_");	
	groupNameTag = (xmlNameTag.. ".slot(%d)"):format(0);
	setXMLString(Xml, groupNameTag.."#name", "dummySlot_");	
	saveXMLFile(Xml);	
end;

function moSetGetProfilXML:generateNewProfil(profilName, guiDialog)	
	if profilName == nil or type(profilName) ~= "string" then return;end;
	local directoryName = string.gsub(profilName, " ", "");
	if not moSetGetProfilXML:isDirectoryNameExists(directoryName) then
		moSetGetProfilXML:generateProfilDirectory(directoryName);
		local fileXml = MultiOverlayV4.profileDir.. directoryName.. "/profilSettings.xml";		
		moGeneralSettings.profile.found[directoryName] = tostring(profilName);
		moSetGetProfilXML:generateProfil("profilXML", fileXml, profilName);		
		moSetGetProfilXML:saveProfileXml();
		if guiDialog ~= nil and guiDialog then g_currentMission.hl.addTextDisplay( {txt="New Profil created", txtBold=true, duration=3} );end;	
	else
		if guiDialog ~= nil and guiDialog then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.titel = "Generate New Profil";
			moSetGetOverlays.infoHelpBox.help.txt = "generate profil directory error *".. tostring(directoryName).. "* (directory already exists)";
		else
			print("!!!! WARNING !!!!".. tostring(MultiOverlayV4.metadata.title).. " generate profile directory error ".. tostring(directoryName).. " (directory already exists or !)");
		end;
	end;
end;

function moSetGetProfilXML:getDirectoryNameByProfilName(name)
	if name == nil or type(name) ~= "string" then return nil;end;
	for directoryName, profilName in pairs (moGeneralSettings.profile.found) do
		if profilName == name then return true, directoryName;end;
	end;
	return false;
end;

function moSetGetProfilXML:getProfilNameByDirectoryName(dir)
	if dir == nil or type(dir) ~= "string" then return nil;end;
	for directoryName, profilName in pairs (moGeneralSettings.profile.found) do
		if directoryName == dir then return true, profilName;end;
	end;
	return false;
end;

function moSetGetProfilXML:isProfilNameExists(name)
	if name == nil or type(name) ~= "string" then return nil;end;
	for directoryName, profilName in pairs (moGeneralSettings.profile.found) do
		if profilName == name then return true;end;
	end;
	return false;
end;

function moSetGetProfilXML:isDirectoryNameExists(dir)
	if dir == nil or type(dir) ~= "string" then return nil;end;
	local fileXml = MultiOverlayV4.profileDir.. dir.. "/profilSettings.xml";
	if not fileExists(fileXml) and moGeneralSettings.profile.found[dir] == nil then return false;end;	
	return true;
end;

function moSetGetProfilXML:generateProfilDirectory(dir)
	if dir == nil or type(dir) ~= "string" then return nil;end;
	createFolder(MultiOverlayV4.profileDir.. dir.. "/");
	return true;
end;

function moSetGetProfilXML:setProfilNameByDirectoryName(dir, name)
	if dir == nil or type(dir) ~= "string" or name == nil or type(name) ~= "string" then return nil;end;
	for directoryName, profilName in pairs (moGeneralSettings.profile.found) do
		if directoryName == dir then moGeneralSettings.profile.found[directoryName] = name;return true;end;
	end;
	return false;
end;

function moSetGetProfilXML:setLoadProfil(dir)
	if dir == nil or type(dir) ~= "string" or moGeneralSettings.profile.found[dir] == nil then dir = "DefaultProfil";end;
	moGeneralSettings.profile.load = tostring(dir);
	moGeneralSettings.profile.select = tostring(dir);
end;

function moSetGetProfilXML:getLoadProfil()
	local file = MultiOverlayV4.profileDir.. "profile.xml";
	if not fileExists(file) then				
		moSetGetProfilXML:generateDefaultProfilXml(file);
	end;
	return moGeneralSettings.profile.load;
end;

function moSetGetProfilXML:getAllProfile()	
	return moGeneralSettings.profile.found;
end;

function moSetGetProfilXML:getActiveProfil()	
	return moGeneralSettings.profile.load;
end;

function moSetGetProfilXML:saveProfileXml()
	local file = MultiOverlayV4.profileDir.. "profile.xml";
	local Xml = createXMLFile("MultiOverlayV4_XML", file, "profileXML");
	local xmlNameTag = ("profileXML"):format(0);
	setXMLString(Xml, xmlNameTag.."#load", tostring(moGeneralSettings.profile.load));
	setXMLInt(Xml, xmlNameTag.."#max", moGeneralSettings.profile.max);	
	local int = 0;
	for directoryName, profilName in pairs (moGeneralSettings.profile.found) do
		local groupNameTag = (xmlNameTag.. ".profil(%d)"):format(int);
		setXMLString(Xml, groupNameTag.."#directory", tostring(directoryName));	
		setXMLString(Xml, groupNameTag.."#name", tostring(profilName));
		setXMLInt(Xml, groupNameTag.."#infoOnStart", moGeneralSettings.profile.infoOnStart);
		int = int+1;
	end;	
	saveXMLFile(Xml);
end;

function moSetGetProfilXML:loadProfileXml()
	local file = MultiOverlayV4.profileDir.. "profile.xml";
	if not fileExists(file) then
		moSetGetProfilXML:generateDefaultProfilXml(file);
		moSetGetProfilXML:searchProfile();
	else
		moSetGetProfilXML:searchProfile();
		local Xml = loadXMLFile("MultiOverlayV4_XML", file, "profileXML");
		if Xml ~= nil then
			local xmlNameTag = ("profileXML"):format(0);
			if getXMLString(Xml, xmlNameTag.."#load") ~= nil then
				moGeneralSettings.profile.load = getXMLString(Xml, xmlNameTag.."#load");
				if moGeneralSettings.profile.found[moGeneralSettings.profile.load] == nil then
					moSetGetProfilXML:setLoadProfil("DefaultProfil");
				else
					moGeneralSettings.profile.select = moGeneralSettings.profile.load;
				end;
			end;
			if getXMLInt(Xml, xmlNameTag.."#max") ~= nil then
				moGeneralSettings.profile.max = getXMLInt(Xml, xmlNameTag.."#max");
			end;
			for profil=1, moGeneralSettings.profile.max do 
				local groupNameTag = (xmlNameTag.. ".profil(%d)"):format(profil-1);
				if groupNameTag ~= nil then
					local profilName = nil;
					local directoryName = nil;
					if getXMLString(Xml, groupNameTag.."#name") ~= nil then
						profilName = getXMLString(Xml, groupNameTag.."#name");
					end;
					if getXMLString(Xml, groupNameTag.."#directory") ~= nil then
						directoryName = getXMLString(Xml, groupNameTag.."#directory");
					end;
					if getXMLInt(Xml, groupNameTag.."#infoOnStart") ~= nil then
						moGeneralSettings.profile.infoOnStart = getXMLInt(Xml, groupNameTag.."#infoOnStart");
					end;
					if directory ~= nil and type(directory) == "string" and directory:len() > 0 then
						if profilName == nil or type(profilName) ~= "string" or profilName:len() < 1 then profilName = directoryName;end;						
						if moGeneralSettings.profile.found[directoryName] ~= nil then 
							moGeneralSettings.profile.found[directoryName] = tostring(profilName);
						end;
					end;
				end;				
			end;			
			for directoryName, profilName in pairs (moGeneralSettings.profile.found) do
				if profileName == nil then
					moGeneralSettings.profile.found[directoryName] = tostring(directoryName);					
				end;
			end;
			moSetGetProfilXML:saveProfileXml();
			MultiOverlayV4:sortTable(moGeneralSettings.profile.found);
		end;
	end;			
end;

function moSetGetProfilXML:generateDefaultProfilXml(file)			
	moSetGetProfilXML:generateProfilDirectory("DefaultProfil");	
	local Xml = createXMLFile("MultiOverlayV4_XML", file, "profileXML");
	local xmlNameTag = ("profileXML"):format(0);
	setXMLString(Xml, xmlNameTag.."#load", "DefaultProfil");
	setXMLInt(Xml, xmlNameTag.."#max", moGeneralSettings.profile.max);
	xmlNameTag = ("profileXML.profil(%d)"):format(0);
	setXMLString(Xml, xmlNameTag.."#directory", "DefaultProfil");
	setXMLString(Xml, xmlNameTag.."#name", "Default Profil");
	setXMLInt(Xml, xmlNameTag.."#infoOnStart", moGeneralSettings.profile.infoOnStart);
	saveXMLFile(Xml);
	moSetGetProfilXML:setLoadProfil("DefaultProfil");	
	local fileXml = MultiOverlayV4.profileDir.. "DefaultProfil/profilSettings.xml";
	moGeneralSettings.profile.found["DefaultProfil"] = "Default Profil";
	moSetGetProfilXML:generateProfil("profilXML", fileXml, "Default Profil");	
end;

function moSetGetProfilXML:refreshProfileDirectorys()
	local refreshDirectorys = {};	
	moSetGetProfilXML:searchProfile(true, refreshDirectorys);
	for directoryName, profilName in pairs (refreshDirectorys) do
		if directoryName ~= nil then
			if moGeneralSettings.profile.found[directoryName] == nil then
				moGeneralSettings.profile.found[directoryName] = profilName;			
			end;
		end;
	end;	
end;

function moSetGetProfilXML:searchProfile(refresh, refreshDirectorys)
	local files = Files.new(MultiOverlayV4.profileDir);	
	for _, v in pairs(files.files) do
		local profilName = nil
		if v.isDirectory then
			profilName = v.filename
			if refresh == nil or not refresh then
				moGeneralSettings.profile.found[tostring(profilName)] = tostring(profilName);
			else
				local directoryName = string.gsub(profilName, " ", "");
				refreshDirectorys[tostring(directoryName)] = tostring(profilName);
			end;		
		end;		
	end;
	if refresh ~= nil and refresh then return refreshDirectorys;end;
end;

function moSetGetProfilXML:cloneProfil()
	local loadProfil = moGeneralSettings.profile.load;
	local file = MultiOverlayV4.profileDir.. loadProfil.. "-Clone/profilSettings.xml";
	if fileExists(file) then g_currentMission.hl.addTextDisplay( {txt="Clone Profil already Exists", txtBold=true, duration=3, warning=true} );end;
	moSetGetProfilXML:generateProfilDirectory(loadProfil.. "-Clone");
	local files = Files.new(MultiOverlayV4.profileDir.. loadProfil.. "/");
	local oldDirectory = MultiOverlayV4.profileDir.. loadProfil.. "/";
	local newDirectory = MultiOverlayV4.profileDir.. loadProfil.. "-Clone/";
	local isClone = false;
	for _, v in pairs(files.files) do
		if not v.isDirectory then
			copyFile(oldDirectory.. "/".. v.filename, newDirectory.. "/".. v.filename, true, true);
			isClone = true;
		end;
	end;
	if isClone then		
		moSetGetProfilXML:refreshProfileDirectorys();		
		moGeneralSettings.isSave = false;
		g_currentMission.hl.addTextDisplay( {txt="Generated Clone Profil\nEdit Profile Name in ....-Clone or...", maxLine=2, txtBold=true, duration=3} );		
	else
		g_currentMission.hl.addTextDisplay( {txt="*ERROR* NOT Generated Clone Profil (! is corrupt loaded Profil !)", txtBold=true, duration=3, warning=true} );
	end;
end;

function moSetGetProfilXML:saveBackup()	
	local file = MultiOverlayV4.profileDir.. tostring(moGeneralSettings.profile.load).. "/profilSettings.xml";
	local fileBackup = MultiOverlayV4.profileDir.. tostring(moGeneralSettings.profile.load).. "/profilSettingsBackup.xml";	
	if fileExists(file) then copyFile(file, fileBackup, true, true);end; --true, replace old file
	--getfenv(0).deleteFile(fileBackup)
	--getfenv(0).deleteFolder(MultiOverlayV4.profileDir.. "profil1")
end;