moXmlSettings = {};
source(MultiOverlayV4.modDir.."defaultSettings/moSetGetClientXML.lua");
source(MultiOverlayV4.modDir.."defaultSettings/moSetGetProfilXML.lua");

function moXmlSettings:saveXml()	
	moSetGetClientXML:saveConfig("clientXML");
	moSetGetProfilXML:saveConfig("profilXML");
	moGeneralSettings.isSave = true;
end;

function moXmlSettings:load(args)
	local file;
	function checkFile(xmlType, file, tableType)
		if not fileExists(file) then 
			moXmlSettings:generateXml(xmlType, file, tableType, false);
		else				
			moXmlSettings:loadXml(xmlType, file, tableType);			
		end;
	end;	
	if not MultiOverlayV4.loadDetiServer or MultiOverlayV4.loadHostServer then		
		if args.languageXml then
			file = MultiOverlayV4.settingsDir.. "language.xml";			
			checkFile("languageXML", file, moLanguageDefault);
		elseif args.profilXml then
			file = MultiOverlayV4.profileDir.. tostring(moGeneralSettings.profile.load).. "/profilSettings.xml";			
			checkFile("profilXML", file);
		elseif args.clientXml then
			file = MultiOverlayV4.settingsDir.. "clientSettings.xml";			
			checkFile("clientXML", file);
		end;
	end;	
end;

function moXmlSettings:generateXml(xmlType, file, tableType, replaceXml)
	if replaceXml then
		print(tostring(MultiOverlayV4.metadata.title).. " replace ".. tostring(xmlType).. " xml file")
	else
		print(tostring(MultiOverlayV4.metadata.title).. " generated ".. tostring(xmlType).. " xml file")
	end;
	local int = 0;
	if xmlType == "languageXML" then
		local Xml = createXMLFile("MultiOverlayV4_XML", file, xmlType);				
		local xmlNameTag = ("languageXML"):format(0);
		local setLanguage = "";
		for a=1, #MultiOverlayV4.languageAccepts do
			if a == #MultiOverlayV4.languageAccepts then
				setLanguage = setLanguage.. tostring(MultiOverlayV4.languageAccepts[a]);
			else
				setLanguage = setLanguage.. tostring(MultiOverlayV4.languageAccepts[a]).. " ";
			end;
		end;		
		setXMLString(Xml, xmlNameTag.."#accepts", setLanguage);
		for name, v in pairs(tableType) do			
			if name ~= nil and tableType[name] ~= nil then
				xmlNameTag = ("languageXML.text(%d)"):format(int);				
				setXMLString(Xml, xmlNameTag.."#name", name);
				for nameLanguage, v1 in pairs(v) do					
					setXMLString(Xml, xmlNameTag.. "#" ..tostring(nameLanguage), tostring(v1));				
				end;				
				int = int+1;
			end;
		end;				
		if not replaceXml then moLanguage = tableType;end;
		saveXMLFile(Xml);
		return;
	end;	
	if xmlType == "profilXML" then		
		moSetGetProfilXML:generateProfil(xmlType, file);		
		return;		
	end;
	if xmlType == "clientXML" then			
		moSetGetClientXML:saveConfig(xmlType);		
		return;		
	end;
end;

function moXmlSettings:loadXml(xmlType, file, tableType)
	local profilSave = "";
	if xmlType == "profilXML" then profilSave = " (".. tostring(moGeneralSettings.profile.found[moGeneralSettings.profile.load]).. ")";end;	
	print(tostring(MultiOverlayV4.metadata.title).. " load ".. tostring(xmlType).. " xml profil file ".. tostring(profilSave))
	local int=0;
	local Xml = loadXMLFile("MultiOverlayV4_XML", file, xmlType);
	local xmlReplace = false;	
	if xmlType == "languageXML" then
		local xmlNameTag = ("languageXML"):format(0);		
		if getXMLString(Xml, xmlNameTag.."#accepts") then
			local acceptLanguage = getXMLString(Xml, xmlNameTag.."#accepts");
			local splitString = g_currentMission.hl.stringSplit(acceptLanguage, " ", true);
			if splitString ~= nil and #splitString > 0 then
				MultiOverlayV4.languageAccepts = {};
				for a=1, #splitString do
					MultiOverlayV4.languageAccepts[#MultiOverlayV4.languageAccepts+1] = splitString[a];
				end;				
			end;
		end;
		while true do			
			xmlNameTag = ("languageXML.text(%d)"):format(int);			
			if getXMLString(Xml, xmlNameTag.."#name") then
				local name = string.lower(getXMLString(Xml, xmlNameTag.."#name"));				
				moLanguage[name] = {};								
				for a=1, #MultiOverlayV4.languageAccepts do	
					local text = getXMLString(Xml, xmlNameTag.. "#" ..tostring(MultiOverlayV4.languageAccepts[a]));
					if text ~= nil and string.len(text) >= 1 then
						moLanguage[name][MultiOverlayV4.languageAccepts[a]] = tostring(text);
						if tableType[name] ~= nil and tableType[name][MultiOverlayV4.languageAccepts[a]] ~= nil then tableType[name][MultiOverlayV4.languageAccepts[a]] = nil;end;						
					else
						if tableType[name] ~= nil and tableType[name][MultiOverlayV4.languageAccepts[a]] ~= nil then 
							moLanguage[name][MultiOverlayV4.languageAccepts[a]] = tostring(tableType[name][MultiOverlayV4.languageAccepts[a]]);
							xmlReplace = true;
						end;
					end;
				end;				
				if tableType[name] ~= nil and #tableType[name] <= 0 then tableType[name]=nil;end;
			else
				break;
			end;
			int = int+1;			
		end;		
		for name, v in pairs(tableType) do
			if name ~= nil and tableType[name] ~= nil then 			
				moLanguage[name] = {};
				for a=1, #MultiOverlayV4.languageAccepts do										
					local text = tostring(MultiOverlayV4.languageAccepts[a]);
					if text ~= nil and tableType[name][text] ~= nil then
						moLanguage[name][MultiOverlayV4.languageAccepts[a]] = tableType[name][text];
					end;					
				end;					
				xmlReplace = true;
			end;
		end;		
		--table.insert(moDeleteOldLanguage, "eggsbarn");
		for a=1, #moDeleteOldLanguage do
			if moLanguage[moDeleteOldLanguage[a]] ~= nil then
				moLanguage[moDeleteOldLanguage[a]] = nil;
				xmlReplace = true;
			end;
		end;		
		if xmlReplace then 
			moXmlSettings:generateXml(xmlType, file, moLanguage, true);			
		end;
		return;		
	end;
	if xmlType == "profilXML" then		
		moSetGetProfilXML:loadConfig(Xml, xmlType);
		return;		
	end;
	if xmlType == "clientXML" then		
		moSetGetClientXML:loadConfig(Xml, xmlType);
		return;		
	end;
end;

function moXmlSettings:autoSave()
	oldSavegameController = SavegameController.saveSavegame;
	SavegameController.saveSavegame = function(self, savegame, blocking)
		local isOkay, result = pcall(oldSavegameController, self, savegame, blocking);		
		if isOkay then			
			moXmlSettings:saveXml();
			return result;
		end;
	end;
end;