RenameInfoDialog = {
	CONTROLS = {
		"titleText",		
		"renameButton"
	}
}
local RenameInfoDialog_mt = Class(RenameInfoDialog, DialogElement)

function RenameInfoDialog.new(target, custom_mt)
	local self = DialogElement.new(target, custom_mt or RenameInfoDialog_mt)
	self:registerControls(RenameInfoDialog.CONTROLS)
	self.inputDelay = 0
	return self
end

function RenameInfoDialog:onOpen()
	RenameInfoDialog:superClass().onOpen(self)
	self.inputDelay = self.time + 250
end

function RenameInfoDialog:onClose()	
	RenameInfoDialog:superClass().onClose(self)
end

function RenameInfoDialog:setData(data)
	local name = data:getName()
	self.data = data
	self.titleText:setText(name)
	self.renameButton:setVisible(true)	
end

function RenameInfoDialog:setCallback(callbackFunc, target, args)
	self.callbackFunc = callbackFunc
	self.target = target
	self.callbackArgs = args
end

function RenameInfoDialog:onClickBack()
	if self.inputDelay < self.time then
		self:sendCallback(false)
		self:close()
		return false
	else
		return true
	end
end

function RenameInfoDialog:sendCallback(didSell)
	if self.callbackFunc ~= nil then
		if self.target ~= nil then
			self.callbackFunc(self.target, didSell, self.callbackArgs)
		else
			self.callbackFunc(didSell, self.callbackArgs)
		end
	end
end

function RenameInfoDialog:onClickRename(whatTable)
	local text = g_i18n:getText("button_changeName")
	g_gui:showTextInputDialog({
		text = text,
		defaultText = self.data:getName(),
		callback = function (result, yes)
			if yes then
				if result:len() == 0 then
					result = nil
				else
					whatTable.name = tostring(result);
				end
								
				self:setData(self.data)
			end
		end
		dialogPrompt = g_i18n:getText("ui_enterName"),
		imePrompt = g_i18n:getText("ui_enterName"),
		confirmText = g_i18n:getText("button_change")
	})
end

