---not edit script---

guiMenueInOutPutTextDialog = {};
local guiMenueInOutPutTextDialog_mt = Class(guiMenueInOutPutTextDialog, YesNoDialog)
guiMenueInOutPutTextDialog.types = { "folder", "filter" };

guiMenueInOutPutTextDialog.CONTROLS = {	
	HELP_BOX_TEXT = "helpBoxText",
    HELP_BOX = "helpBox",
	DIALOG_TITLE_ELEMENT1 = "dialogTitleElement1", --over Dialog Box (big size)
	DIALOG_TITLE_ELEMENT2 = "dialogTitleElement2", --over Dialog Box Copyright (small size)
	DIALOG_TEXT_ELEMENT1 = "dialogTextElement1", --over input Text Box (small size)
	DIALOG_TEXT_ELEMENT2 = "dialogTextElement2", --at Dialog Box (normal size)
	YES_BUTTON = "yesButton", --onClickOk
    NO_BUTTON = "noButton", --onClickQuit
    CANCEL_BUTTON = "cancelButton", --onClickCancel (reset/delete input)
	SAVE_BUTTON = "saveButton", --onClickSave
	CHECKSAVE_BUTTON = "checkSaveButton", --onClickSave
	CHECK_BUTTON = "checkButton", --onClickCheck
	--DELETE_BUTTON = "deleteButton",	
	--QUIT_BUTTON = "bendenButton",
	--REFRESH_BUTTON = "refreshButton",
	TEXT_INPUT = 'textElement'	
}

function guiMenueInOutPutTextDialog:new(target, custom_mt)
	if custom_mt == nil then
		custom_mt = guiMenueInOutPutTextDialog_mt;
	end;
		
	local self = YesNoDialog:new(target, custom_mt);
	self:registerControls(guiMenueInOutPutTextDialog.CONTROLS);
	-- needed for onClickBack to work.
	self.returnScreenName = "";	
	
	self.isFirstDefaultValues = false;
	self.lastMouseCursorState = false;
	self.lastTextLength = 0;	
	self.inputTextSave = false;
	self.modAppValues = {};
	self.defaultVisibleYesButton = true;
	self.defaultYesButtonText = "Ok";
	self.defaultVisibleNoButton = true;
	self.defaultNoButtonText = "Quit";
	self.defaultVisibleCancelButton = true;
	self.defaultCancelButtonText = "Cancel";
	self.defaultVisibleSaveButton = false;
	self.defaultSaveButtonText = "Save";	
	self.defaultVisibleCheckSaveButton = false;
	self.isCheckSaveButton = false;
	self.defaultVisibleCheckButton = true;
	self.defaultCheckButtonText = "Check Input";
	self.defaultDialogTitel = "Gui Menue Dialog (load over App/Mod)";
	self.defaultMaxTextLength = 15;
	self.defaultMinTextLength = 1;
	self.minTextLength = 1;	 --check	
	self.defaultDialogText1 = "max length "; --max length 15 (no special character)
	self.defaultDialogText2 = "";	
	--self.defaultNoCharacterText = '\"/,!@#%^&*()+-={}|[]`~´°^'; --check
	self.defaultNoCharacterText = "\"/,!?@#&*+-=|"; --check
	self.noCharacterText = ""; --check	
	self.defaultUnicodeText = true; --check (automatic over LS !!! check later) or use guiMenueInOutPutTextDialog:onIsUnicodeAllowed(unicode)
	self.unicodeText = true;
	self.defaultAlreadyText = false;
	self.alreadyExistsTextAllow = false;
	self.alreadyExistsTextTable = {}; --clear table is onClose
	self.callbackTable = {inputText="", helpBoxText="", errorCheckText={}, thisGui=nil, ownValues=nil};
	self.helpInfoBox = true;
	self.inputTextAppendEnd = ""; --add
	self.inputTextAppendBegin = ""; --add
	self.testValue = false;	
	return self;
end; 

function guiMenueInOutPutTextDialog:onDraw(dt)	
	if self.modAppValues ~= nil and self.modAppValues.onDrawCallback ~= nil and type(self.modAppValues.onDrawCallback) == "function" then self.modAppValues.onDrawCallback(self.callbackTable) end;
	if self.modAppValues.onDrawDisabled then return;end;
	local showText = string.len(self.helpBoxText:getText()) > 0;	
	self.helpBox:setVisible(showText);
	self.callbackTable.helpBoxText = self.helpBoxText:getText();	
end;

function guiMenueInOutPutTextDialog:keyEvent(unicode, sym, modifier, isDown)
	if self.modAppValues ~= nil and self.modAppValues.keyEventCallback ~= nil and type(self.modAppValues.keyEventCallback) == "function" then self.modAppValues.keyEventCallback(self.callbackTable) end;
	if self.modAppValues.keyEventDisabled then return;end;
	if self.modAppValues.visibleButton.saveButton ~= nil or self.isCheckSaveButton or self.modAppValues.visibleButton.checkButton ~= nil then
		if self.textElement ~= nil then
			if self.textElement.blockTime <= 0 and self:getIsActive() then --and self:getOverlayState() == GuiOverlay.STATE_PRESSED then --later check this STATE_NORMAL
				local inputText = Utils.getNoNil(self.textElement:getText(), "");
				if string.len(inputText) ~= self.lastTextLength then
					if self.modAppValues.visibleButton.checkButton ~= nil then
						if self.modAppValues.visibleButton.saveButton ~= nil then self.saveButton:setVisible(false);end;
						if self.modAppValues.visibleButton.saveButton == nil and self.isCheckSaveButton then self.checkSaveButton:setVisible(false);end;
					end;					
					self.lastTextLength = string.len(inputText);
					self.checkButton:setTextColor(unpack(guiSetGet.colors.red));					
					self.helpBoxText:setText("");
					self.inputTextSave = false;
				end;
			end;			
		end;
	end;
end;

function guiMenueInOutPutTextDialog:onOpen(element)	
	self.lastMouseCursorState = g_inputBinding:getShowMouseCursor();
    g_inputBinding:setShowMouseCursor(true);	
	FocusManager:setFocus(self.textElement);	
	self.callbackTable.thisGui = self;
	if self.modAppValues ~= nil and self.modAppValues.onOpenCallback ~= nil and type(self.modAppValues.onOpenCallback) == "function" then self.modAppValues.onOpenCallback(self.callbackTable) end;
	--self.textElement.blockTime = 0 --later check new function
	--self.textElement:onFocusActivate() --later check new function
end; 

function guiMenueInOutPutTextDialog:onClose(element)
	guiMenueInOutPutTextDialog:superClass().onClose(self);
end;

function guiMenueInOutPutTextDialog:onCloseGui(element)	
	g_inputBinding:setShowMouseCursor(self.lastMouseCursorState);
	-- makes sure that the input mode is disabled when clicking directly on a "back" button while text input is active    
	guiMenueInOutPutTextDialog:superClass().onClose(self);	
	if not self.useIme then
       --self:setForcePressed(false) --later set new function
    end;
	if self.modAppValues ~= nil and self.modAppValues.onCloseCallback ~= nil and type(self.modAppValues.onCloseCallback) == "function" then self.modAppValues.onCloseCallback(self.callbackTable) end;
	self.modAppValues = {};
	self:close();
	--g_currentMission.guiMenue.guiSetGet:closeLsOrGuiMenueDialog();
end;

function guiMenueInOutPutTextDialog:onClickSave()	
	local helpBoxText = {"InputText was save", "InputText ***SAVE ERROR***"};	
	local saveButtonTemp, helpBoxTextModTemp = true, "";
	local saveButton = true;
	if self.modAppValues ~= nil and self.modAppValues.onSaveCallback ~= nil and type(self.modAppValues.onSaveCallback) == "function" then saveButtonTemp, helpBoxTextModTemp = self.modAppValues.onSaveCallback(self.callbackTable);end;
	if self.modAppValues.onSaveDisabled then return;end;	 
	if saveButtonTemp ~= nil and type(saveButtonTemp) == "boolean" then saveButton = saveButtonTemp;end;
	local helpBoxTextMod = helpBoxTextModTemp or nil;	
	if type(helpBoxTextMod) == "string" and string.len(helpBoxTextMod) > 0 then 
		helpBoxText[1] = helpBoxTextMod;helpBoxText[2] = helpBoxTextMod;
	end;
	if saveButton then 
		self.inputTextSave = true;
		if self.helpInfoBox then			
			self.helpBoxText:setText(helpBoxText[1]);
		end;
		self.checkButton:setTextColor(unpack(guiSetGet.colors.red));self.saveButton:setVisible(false);self.checkSaveButton:setVisible(false);
	end;
	if not saveButton and self.helpInfoBox then self.helpBoxText:setText(helpBoxText[2]);self.inputTextSave = false;end;
end;

function guiMenueInOutPutTextDialog:onClickCheck()	
	local helpBoxText = "Check Okay (Ready for Save)";	
	local checkInputTextModTemp, helpBoxTextModTemp = true, "";
	local checkInputTextMod = true;
	if self.modAppValues ~= nil and self.modAppValues.onCheckCallback ~= nil and type(self.modAppValues.onCheckCallback) == "function" then checkInputTextModTemp, helpBoxTextModTemp = self.modAppValues.onCheckCallback(self.callbackTable);end;
	if self.modAppValues.onCheckDisabled then return;end;
	if checkInputTextModTemp ~= nil and type(checkInputTextModTemp) == "boolean" then checkInputTextMod = checkInputTextModTemp;end;
	local helpBoxTextMod = helpBoxTextModTemp or nil;	
	local checkInputTextGui = self:checkInputText();
	if checkInputTextGui and checkInputTextMod then
		self.checkButton:setTextColor(unpack(guiSetGet.colors.green));
		if self.helpInfoBox then 
			if type(helpBoxTextMod) == "string" and string.len(helpBoxTextMod) > 0 then 
				helpBoxText = helpBoxTextMod;
			end;
			self.helpBoxText:setText(tostring(helpBoxText));
		end;
		if self.modAppValues.visibleButton.saveButton ~= nil and self.modAppValues.visibleButton.checkButton ~= nil then 
			self.saveButton:setVisible(true);
		elseif self.modAppValues.visibleButton.saveButton == nil and self.isCheckSaveButton then 
			self.checkSaveButton:setVisible(true);
		end;
	else
		self.checkButton:setTextColor(unpack(guiSetGet.colors.red));
	end;
end;

function guiMenueInOutPutTextDialog:onClickQuit()	
	self:onCloseGui();
	return false;
end;

function guiMenueInOutPutTextDialog:onClickCancel()	
	self.textElement:setText("");	
	self.helpBoxText:setText("");
	self.inputTextSave = false;
	if self.modAppValues ~= nil and self.modAppValues.onCancelCallback ~= nil and type(self.modAppValues.onCancelCallback) == "function" then self.modAppValues.onCancelCallback(self.callbackTable) end;
end;

function guiMenueInOutPutTextDialog:onClickOk() --pressed Enter and TextInput NOT Select/Active = pressed Start Button or pressed Start Button with Mouse
	self:onCloseGui();
	return true;
end;

--function guiMenueInOutPutTextDialog:onEnterPressed()		
--end;

--function guiMenueInOutPutTextDialog:onEscPressed()	
--end;

function guiMenueInOutPutTextDialog:onTextChanged()
	if self.modAppValues ~= nil and self.modAppValues.onTextChangedCallback ~= nil and type(self.modAppValues.onTextChangedCallback) == "function" then self.modAppValues.onTextChangedCallback(self.callbackTable) end;
	if self.modAppValues.onTextChangedDisabled then return;end;
	if self.textElement ~= nil then		
		self.callbackTable.inputText = self.textElement:getText();		
		if string.len(self.textElement:getText()) >= self.minTextLength then			
			if self.modAppValues.visibleButton.checkButton ~= nil then self.checkButton:setVisible(true);end;
			if self.modAppValues.visibleButton.checkButton == nil and self.modAppValues.visibleButton.saveButton ~= nil then self.saveButton:setVisible(true);end;
			--if self.modAppValues.visibleButton.checkButton ~= nil and not self.modAppValues.visibleButton.checkButton and not self.isCheckSaveButton then self.saveButton:setVisible(true);end;		
		else
			self.checkButton:setVisible(false);			
			self.saveButton:setVisible(false);
			self.checkSaveButton:setVisible(false);
		end;	
	end;
end;

function guiMenueInOutPutTextDialog:onIsUnicodeAllowed(unicode)	
	if unicode == 13 or unicode == 10 then
        return false
    end
    if not getCanRenderUnicode(unicode) then
        return false
    end
    return Utils.getNoNil(self:raiseCallback("onIsUnicodeAllowedCallback", unicode), true) --set later
end; 

function guiMenueInOutPutTextDialog:checkInputText(other)
	function checkError()
	end;
	function checkNoCharacterText(inputText)
		if string.len(self.noCharacterText) > 0 then
			charTable = {};
			for c in self.noCharacterText:gmatch "." do
				table.insert(charTable, c);
			end;
			for a=1, #charTable do				
				if string.find(inputText, charTable[a]) then 
				if self.helpInfoBox then self.helpBoxText:setText("Special Charakter Found at InputText");end;return false;end;
			end;
			return true;
		end;
		return true;
	end;
	function checkAlreadyExistsText(inputText)		
		local inputTextTemp = string.lower(self.inputTextAppendBegin.. inputText.. self.inputTextAppendEnd);		
		for key, v in pairs (self.alreadyExistsTextTable) do			
			if string.find(inputTextTemp, string.lower(v)) and string.len(inputTextTemp) == string.len(v) then 
				if self.helpInfoBox then self.helpBoxText:setText("InputText Already Exists");end;
				if not self.alreadyExistsTextAllow then
					return false;
				end;
			end;
		end;
		return true;
	end;
	if self.modAppValues.visibleButton.checkButton == nil or (self.modAppValues.visibleButton.checkButton ~= nil and self.modAppValues.visibleButton.checkButton) or other then
		if self.textElement ~= nil then
			local inputText = Utils.getNoNil(self.textElement:getText(), "");
			if string.len(inputText) >= self.minTextLength then
				local noCharacterTextOkay = checkNoCharacterText(inputText);
				local alreadyExistsTextOkay = checkAlreadyExistsText(inputText);
				self.callbackTable.errorCheckText = {alreadyExistsTextOkay=alreadyExistsTextOkay, noCharacterTextOkay=noCharacterTextOkay};				
				if alreadyExistsTextOkay and noCharacterTextOkay then return true;end;
			end;
		end;
	end;
	self.callbackTable.errorCheckText = {alreadyExistsTextOkay=false, noCharacterTextOkay=false};
	return false;
end;

function guiMenueInOutPutTextDialog:setModAppValues()
	local dialog = g_gui.guis["GuiMenueInOutPutTextDialog"];
	if dialog ~= nil and dialog.target ~= nil then
		local self = dialog.target;
		--if not self.isFirstDefaultValues then self:setDefaultValues();end; --1x save first default values and buttons (for game session)
		function is_TableEmpty(t)
			for _,_ in pairs(t) do
				return false;
			end
			return true;
		end;	
		if self.modAppValues ~= nil then			
			--mod own values
			self.callbackTable.ownValues = self.modAppValues.ownValues;
			--mod own values
			if self.modAppValues.dialogTitel ~= nil then self.dialogTitleElement1:setText(tostring(self.modAppValues.dialogTitel));end;			
			if self.modAppValues.dialogText1 ~= nil then self.dialogTextElement1:setText(tostring(self.modAppValues.dialogText1));end;
			if self.modAppValues.dialogText2 ~= nil then self.dialogTextElement2:setText(tostring(self.modAppValues.dialogText2));end;
			--buttons
			if self.modAppValues.visibleButton ~= nil and type(self.modAppValues.visibleButton) == "table" and not is_TableEmpty(self.modAppValues.visibleButton) then			
				--text
				if self.modAppValues.visibleButton.saveButtonText ~= nil then self.saveButton:setText(tostring(self.modAppValues.visibleButton.saveButtonText));self.checkSaveButton:setText(tostring(self.modAppValues.visibleButton.saveButtonText))end;
				if self.modAppValues.visibleButton.yesButtonText ~= nil then self.yesButton:setText(tostring(self.modAppValues.visibleButton.yesButtonText));end;
				if self.modAppValues.visibleButton.noButtonText ~= nil then self.noButton:setText(tostring(self.modAppValues.visibleButton.noButtonText));end;
				if self.modAppValues.visibleButton.cancelButtonText ~= nil then self.cancelButton:setText(tostring(self.modAppValues.visibleButton.cancelButtonText));end;
				if self.modAppValues.visibleButton.checkButtonText ~= nil then self.checkButton:setText(tostring(self.modAppValues.visibleButton.checkButtonText));end;
				--text
				--visible
				if self.modAppValues.visibleButton.yesButton ~= nil and not self.modAppValues.visibleButton.yesButton then self.yesButton:setVisible(self.modAppValues.visibleButton.yesButton);end;				
				if self.modAppValues.visibleButton.noButton ~= nil and not self.modAppValues.visibleButton.noButton then self.noButton:setVisible(self.modAppValues.visibleButton.noButton);end;
				if self.modAppValues.visibleButton.cancelButton ~= nil and not self.modAppValues.visibleButton.cancelButton then self.cancelButton:setVisible(self.modAppValues.visibleButton.cancelButton);end;
				--visible save							
				local saveButtonNil = false;
				if self.modAppValues.visibleButton.saveButton ~= nil and self.modAppValues.visibleButton.saveButton and self.modAppValues.onSaveCallback ~= nil and type(self.modAppValues.onSaveCallback) == "function" then 
					self.saveButton:setVisible(false); -->for first open visible or is checkSaveButton true (for safety)
				else 
					saveButtonNil = true;
				end;
				--visible save				
				--visible check
				if self.modAppValues.visibleButton.checkButton ~= nil and not self.modAppValues.visibleButton.checkButton then 
					self.checkButton:setVisible(false);self.modAppValues.visibleButton.checkButton=nil;
				elseif self.modAppValues.visibleButton.checkButton == nil then 
					self.modAppValues.visibleButton.checkButton = true;
					if not saveButtonNil then self.isCheckSaveButton = true;end;saveButtonNil=true;
				end;				
				if saveButtonNil then self.modAppValues.visibleButton.saveButton = nil;end; -->all saveButton visible
				self.checkButton:setVisible(false); -->for first open visible (for safety)
				self.saveButton:setVisible(false); -->for first open visible (for safety)
				self.checkSaveButton:setVisible(false); -->for first open visible (for safety)
				--visible check	
				--visible							
			end;
			--buttons
			--checkText
			if self.modAppValues.checkText ~= nil and type(self.modAppValues.checkText) == "table" and not is_TableEmpty(self.modAppValues.checkText) then			
				if self.modAppValues.checkText.alreadyExistsTable ~= nil and type(self.modAppValues.checkText.alreadyExistsTable) == "table" and not is_TableEmpty(self.modAppValues.checkText.alreadyExistsTable) then
					self.alreadyExistsTextTable = self.modAppValues.checkText.alreadyExistsTable;
					if self.modAppValues.checkText.alreadyExistsAllow ~= nil and self.modAppValues.checkText.alreadyExistsAllow then					
						self.alreadyExistsTextAllow = true;
					end;
				end;
				if self.modAppValues.checkText.noCharacterText ~= nil and type(self.modAppValues.checkText.noCharacterText) == "string" and string.len(tostring(self.modAppValues.checkText.noCharacterText)) > 0 then			
					if self.modAppValues.checkText.noCharacterTextReplace ~= nil and self.modAppValues.checkText.noCharacterTextReplace then 
						self.noCharacterText = tostring(self.modAppValues.checkText.noCharacterText);
					elseif self.modAppValues.checkText.noCharacterTextReplace ~= nil and not self.modAppValues.checkText.noCharacterTextReplace then
						self.noCharacterText = self.noCharacterText.. tostring(self.modAppValues.checkText.noCharacterText);
					end;
				end;
				if self.modAppValues.checkText.inputTextAppendBegin ~= nil and string.len(self.modAppValues.checkText.inputTextAppendBegin) > 0 then self.inputTextAppendBegin = self.modAppValues.checkText.inputTextAppendBegin;end;
				if self.modAppValues.checkText.inputTextAppendEnd ~= nil and string.len(self.modAppValues.checkText.inputTextAppendEnd) > 0 then self.inputTextAppendEnd = self.modAppValues.checkText.inputTextAppendEnd;end;
				if self.modAppValues.checkText.helpInfoBox ~= nil and not self.modAppValues.checkText.helpInfoBox then self.helpInfoBox = false;end;
				if self.modAppValues.checkText.unicodeText ~= nil and not self.modAppValues.checkText.unicodeText then self.unicodeText = false;end;
				if self.modAppValues.checkText.minLengthText ~= nil and type(self.modAppValues.checkText.minLengthText) == "number" then self.minTextLength = self.modAppValues.checkText.minLengthText;end;
				if self.modAppValues.checkText.maxLengthText ~= nil and type(self.modAppValues.checkText.maxLengthText) == "number" then 
					self.textElement.maxCharacters = self.modAppValues.checkText.maxLengthText;
					if self.modAppValues.dialogText1 == nil then self.dialogTextElement1:setText(tostring(self.defaultDialogText1).. tostring(self.textElement.maxCharacters).. " (min length ".. tostring(self.minTextLength).. ")");end;
				end;
			end;
			--checkText
		end;
	end;
end;

function guiMenueInOutPutTextDialog:setDefaultValues()
	local dialog = g_gui.guis["GuiMenueInOutPutTextDialog"];
	if dialog ~= nil and dialog.target ~= nil then
		local self = dialog.target;
		if not self.isFirstDefaultValues then self.defaultYesButtonText = self.yesButton:getText(self.yesButton);end;
		self.isFirstDefaultValues = true;
		self.testValue = false;
		self.alreadyExistsTextTable = {};
		self.alreadyExistsTextAllow = false;
		self.textElement:setText("");		
		self.inputTextAppendEnd = "";
		self.inputTextAppendtBegin = "";
		self.inputTextSave = false;
		self.helpBoxText:setText("");
		self.helpInfoBox = true;
		self.isCheckSaveButton = self.defaultVisibleCheckSaveButton;
		self.callbackTable = {inputText="", helpBoxText="", errorCheckText={}, thisGui=nil, ownValues=nil};
		self.checkButton:setText(tostring(self.defaultCheckButtonText));
		self.saveButton:setText(tostring(self.defaultSaveButtonText));
		self.checkSaveButton:setText(tostring(self.defaultSaveButtonText));		
		self.cancelButton:setText(tostring(self.defaultCancelButtonText));
		self.yesButton:setText(tostring(self.defaultYesButtonText));
		self.noButton:setText(tostring(self.defaultNoButtonText));
		self.checkButton:setVisible(self.defaultVisibleCheckButton);
		--self.checkButton:setDisabled(false);
		self.cancelButton:setVisible(self.defaultVisibleCancelButton);
		--self.cancelButton:setDisabled(false);		
		self.saveButton:setVisible(self.defaultVisibleSaveButton);
		self.checkSaveButton:setVisible(tostring(self.defaultVisibleCheckSaveButton));
		--self.saveButton:setDisabled(true);
		self.yesButton:setVisible(self.defaultVisibleYesButton);
		self.noButton:setVisible(self.defaultVisibleNoButton);
		self.unicodeText = self.defaultUnicodeText;
		self.noCharacterText = self.defaultNoCharacterText;
		self.minTextLength = self.defaultMinTextLength;
		self.textElement.maxCharacters = self.defaultMaxTextLength;
		self.dialogTitleElement1:setText(tostring(self.defaultDialogTitel))		
		local copyright = "copyright"; --tostring(g_currentMission.guiMenue.master.metadata.title).. tostring(g_currentMission.guiMenue.master.metadata.version).. tostring(g_currentMission.guiMenue.master.metadata.author);
		self.dialogTitleElement2:setText(tostring(copyright))
		self.dialogTextElement1:setText(tostring(self.defaultDialogText1).. tostring(self.defaultMaxTextLength).. " (min length ".. tostring(self.defaultMinTextLength).. ")");
		self.dialogTextElement2:setText(tostring(self.defaultDialogText2));
	end;
end;

g_GuiMenueInOutPutTextDialog = guiMenueInOutPutTextDialog:new();
--'dataS/gui/dialogs/TextInputDialog.xml' --simple Gui Element
g_gui:loadGui(MultiOverlayV4.modDir.. 'gui_Dialogs/TextInputDialog.xml', 'GuiMenueInOutPutTextDialog', g_GuiMenueInOutPutTextDialog);