moCmd = {};

function moCmd.emptyCmd()
end;

function moCmd.openCloseSlot(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moSetGetOverlays.slot[args.cmdTable.ownTable.whichSlot].isOpen = not moSetGetOverlays.slot[args.cmdTable.ownTable.whichSlot].isOpen;
end;

function moCmd.openSlot(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moSetGetOverlays.slot[args.cmdTable.ownTable.whichSlot].isOpen = true;		
end;

function moCmd.closeSlot(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moDraw.slot:setClose(args.cmdTable.ownTable.whichSlot);	
end;

function moCmd.openClosePda(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moSetGetOverlays.pda[args.cmdTable.ownTable.whichPda].isOpen = not moSetGetOverlays.pda[args.cmdTable.ownTable.whichPda].isOpen;
end;

function moCmd.openPda(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moSetGetOverlays.pda[args.cmdTable.ownTable.whichPda].isOpen = true;
end;

function moCmd.closePda(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;	
	moDraw.pda:setClose(args.cmdTable.ownTable.whichPda);
end;

function moCmd.closeAllPdas()
	moDraw.pda:setClose();	
end;

function moCmd.saveAllData()
	if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["saveAllData"] == nil then
		g_currentMission.hl.addTimer({name="saveAllData", delay=20, repeatable=false});
	elseif g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["saveAllData"] ~= nil then		
		g_currentMission.hl.addTextDisplay( {txt="Cooldown Timer active (wait)", txtBold=true, duration=3} );
		return;
	end;
	moXmlSettings:saveXml();
	g_currentMission.hl.addTextDisplay( {txt="Saved all MultiOverlayV4 Data", txtBold=true, duration=3} );	
end;

function moCmd.switchViewModusPda(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	moDraw.pda:setViewModus(args.cmdTable.ownTable.whichPda);		
end;

function moCmd.closeAllSlots()
	moDraw.slot:setClose();	
end;

function moCmd.switchProfile(args)
	if args == nil or type(args) ~= "table" then return;end;
	local profile = {};
	local found, activeProfil = tostring(moSetGetProfilXML:getDirectoryNameByProfilName(moSetGetProfilXML:getActiveProfil()));
	if not found then g_currentMission.hl.addTextDisplay( {txt="Active Directory/Profil Name is corrupt, can not Switch Profil other Profile", txtBold=true, duration=3} );return;end;
	for directoryName, profilName in pairs (moSetGetProfilXML:getAllProfile()) do		
		profile[#profile+1] = {
			name = tostring(profilName);
			dir = directoryName;
			isActive = moGeneralSettings.profile.select == directoryName;			
		};		
	end;	
	function comp(w1,w2)			
		if w1.dir < w2.dir then
			return true;
		end;			
	end;
	table.sort(profile, comp);
	
	if #profile > 1 then		
		for p=1, #profile do			
			if profile[p].isActive then
				if args.mouseClick == "MOUSE_BUTTON_LEFT" then
					if profile[p+1] ~= nil then
						moGeneralSettings.profile.select = profile[p+1].dir;					
						moSetGetProfilXML:loadNewProfil(profile[p+1].dir);
						g_currentMission.hl.addTextDisplay( {txt="Load Profil: ".. tostring(profile[p+1].name), txtBold=true, duration=3} ); --txt, txtSize, txtBold, txtColor, maxLine, duration, add, bg, bgColor, posX, posY, warning
						--g_currentMission:showBlinkingWarning("Load Profil: ".. tostring(profile[p+1].name), 2500);
						break;
					else
						moGeneralSettings.profile.select = profile[1].dir;					
						moSetGetProfilXML:loadNewProfil(profile[1].dir);
						g_currentMission.hl.addTextDisplay( {txt="Load Profil: ".. tostring(profile[1].name), txtBold=true, duration=3} );						
						--g_currentMission:showBlinkingWarning("Load Profil: ".. tostring(profile[1].name), 2500);
						break;
					end;
				elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" then
					if profile[p-1] ~= nil then
						moGeneralSettings.profile.select = profile[p-1].dir;					
						moSetGetProfilXML:loadNewProfil(profile[p-1].dir);
						g_currentMission.hl.addTextDisplay( {txt="Load Profil: ".. tostring(profile[p-1].name), txtBold=true, duration=3} );						
						--g_currentMission:showBlinkingWarning("Load Profil: ".. tostring(profile[p-1].name), 2500);
						break;
					else
						moGeneralSettings.profile.select = profile[#profile].dir;					
						moSetGetProfilXML:loadNewProfil(profile[#profile].dir);
						g_currentMission.hl.addTextDisplay( {txt="Load Profil: ".. tostring(profile[#profile].name), txtBold=true, duration=3} );						
						--g_currentMission:showBlinkingWarning("Load Profil: ".. tostring(profile[#profile].name), 2500);
						break;
					end;				
				end;
			end;
		end;
	else
		g_currentMission.hl.addTextDisplay( {txt="Found One Profil, can not Switch other Profile", txtBold=true, duration=3, warning=true} );
		--g_currentMission:showBlinkingWarning("Found One Profil, can not Switch other Profile", 2500);
	end;
end;

function moCmd.openCloseGuiMenue(args)
	if args == nil or type(args) ~= "table" then return;end;
	if g_currentMission.hlGui.setGet:isOpen() then
		g_currentMission.hlGui.setGet:setClose();		
	else
		g_currentMission.hl.mouseOnOff(true,true, tostring(g_currentMission.hl.controlMod)); --force Mousecursor
		g_currentMission.hlGui.setGet:setOpen("MultiOverlayV4", MultiOverlayV4.hlGui.page["GlobalSetting"], MultiOverlayV4.hlGui.side["GlobalSetting"]);
	end;
end;

function moCmd.setMouseCursor(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	if args.cmdTable.ownTable[1] == "mohMouseCursorOff" then
		if g_currentMission.hl.isMouseCursor then g_currentMission.hl.mouseOnOff(false,false, tostring(g_currentMission.hl.controlMod));end; --force Mousecursor
	elseif args.cmdTable.ownTable[1] == "mohMouseCursorOn" then
		if not g_currentMission.hl.isMouseCursor then g_currentMission.hl.mouseOnOff(true,true, tostring(g_currentMission.hl.controlMod));end; --force MouseCursor
	elseif args.cmdTable.ownTable[1] == "lsMouseCursorOn" then
		g_inputBinding:setShowMouseCursor(true);
	elseif args.cmdTable.ownTable[1] == "lsMouseCursorOff" then
		g_inputBinding:setShowMouseCursor(false);
	end;	
end;

function moCmd.handToolsSwitch(args)
	if args == nil or type(args) ~= "table" then return;end;		
	if moGeneralSettings.other.handToolsSwitch then				
		moGeneralSettings.other.handToolsSwitch = false;
		if g_currentMission.player:hasHandtoolEquipped() then 
			g_currentMission.hl.addTextDisplay( {txt="Hand Tools Switch Off ! HAND NOT EMPTY !", txtBold=true, duration=3} );						
		else
			g_currentMission.hl.addTextDisplay( {txt="Hand Tools Switch Off", txtBold=true, duration=3} );			
		end;
	else 
		moGeneralSettings.other.handToolsSwitch = true;				
		g_currentMission.hl.addTextDisplay( {txt="Hand Tools On", txtBold=true, duration=3} );		
	end;	
end;

function moCmd.openCloseAiVehicleExtension(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.aiVehicleExtension == nil then g_currentMission.hl.addTextDisplay( {txt="AI-Vehicle Extension Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.aiVehicleExtension.AIVehicleExtension ~= nil and MultiOverlayV4.otherMods.aiVehicleExtension.AIVehicleExtension.showGui ~= nil then 
		if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.trainSystem == nil then
			local vehicle = g_currentMission.controlledVehicle
			if vehicle ~= nil then				
				local guiActive = false
				if vehicle.atHud ~= nil and vehicle.atHud.GuiActive ~= nil then
					guiActive = vehicle.atHud.GuiActive;
				end;				
				FS22_AIVehicleExtension.AIVehicleExtension.showGui(vehicle, not guiActive);				
			end;
		end;		
	end;
end;

function moCmd.openCloseInfoMessageHud(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.infoMessageHud == nil then g_currentMission.hl.addTextDisplay( {txt="InfoMessageHUD Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.infoMessageHud.modDraw ~= nil and MultiOverlayV4.otherMods.infoMessageHud.mohDraw ~= nil then
		function setInfoMessageHudOnOff()
			MultiOverlayV4.otherMods.infoMessageHud.on = not MultiOverlayV4.otherMods.infoMessageHud.on;
			if MultiOverlayV4.otherMods.infoMessageHud.on then
				FS22_InfoMessageHUD.InfoMessageHUD.draw = Utils.overwrittenFunction(FS22_InfoMessageHUD.InfoMessageHUD.draw, MultiOverlayV4.otherMods.infoMessageHud.modDraw);
			else
				FS22_InfoMessageHUD.InfoMessageHUD.draw = Utils.overwrittenFunction(FS22_InfoMessageHUD.InfoMessageHUD.draw, MultiOverlayV4.otherMods.infoMessageHud.mohDraw);
			end;
		end;
		setInfoMessageHudOnOff();
	end;
end;

function moCmd.openCloseProductionInfoHud(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.productionInfoHud == nil then g_currentMission.hl.addTextDisplay( {txt="ProduktionInfo Hud Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud ~= nil and MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud.settings ~= nil and MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud.settings.display ~= nil and MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud.settings.display.showType ~= nil then
		if FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType == nil then FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType = FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType;end;
		local showType = FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType;
		if showType == "ALL" or showType == "PRODUCTION" or showType == "SELLPRICE" then
			FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType = "NONE";			
		else
			if FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType == "NONE" then
				FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType = "ALL";
			else
				FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType = FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType;
			end;			
		end;
	end;
end;

function moCmd.switchModusProductionInfoHud(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.productionInfoHud == nil then g_currentMission.hl.addTextDisplay( {txt="ProduktionInfo Hud Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud ~= nil and MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud.settings ~= nil and MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud.settings.display ~= nil and MultiOverlayV4.otherMods.productionInfoHud.ProductionInfoHud.settings.display.showType ~= nil then
		if FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType == nil then FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType = FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType;end;
		local showType = FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType;		
		if showType == "NONE" then return;end;		
		if FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType ~= showType then FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType = showType;end;
		local sellPriceTriggerAvailable = true;
		if FS22_SellPriceTrigger == nil or FS22_SellPriceTrigger.SellPriceTrigger == nil or FS22_SellPriceTrigger.SellPriceTrigger.triggers == nil then 
			sellPriceTriggerAvailable = false; 
		end;
		if sellPriceTriggerAvailable then
			if showType == "ALL" then 
				showType = "PRODUCTION";				
			elseif showType == "PRODUCTION" then 
				showType = "SELLPRICE";				
			else --if showType == "SELLPRICE" then				
				showType = "ALL";				
			end;
			FS22_ProductionInfoHud.ProductionInfoHud.settings.display.showType = showType;
			FS22_ProductionInfoHud.ProductionInfoHud.settings.lastShowType = showType;			
			g_currentMission.hl.addTextDisplay( {txt="ProduktionInfo Hud ShowType ".. tostring(showType), txtBold=true, duration=3} );
		else
			g_currentMission.hl.addTextDisplay( {txt="ProduktionInfo Hud: Not Found SellPriceTrigger Mod", txtBold=true, duration=3, warning=true} );
		end;		
	end;
end;

function moCmd.openCloseAutoDrive(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.autoDrive == nil then g_currentMission.hl.addTextDisplay( {txt="AutoDrive Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.autoDrive.ADInputManager ~= nil and g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.trainSystem == nil then
		MultiOverlayV4.otherMods.autoDrive.ADInputManager.onActionCall(g_currentMission.controlledVehicle, "ADToggleHud");						
	end;
end;

function moCmd.openCloseCourseplay(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.courseplay == nil then g_currentMission.hl.addTextDisplay( {txt="Courseplay Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.courseplay ~= nil and g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.trainSystem == nil then
		local vehicle = g_currentMission.controlledVehicle
		if vehicle ~= nil and vehicle.getCpHud ~= nil and vehicle.closeCpHud ~= nil then
			local cpHud = vehicle:getCpHud();
			if cpHud ~= nil then
				if cpHud:getIsOpen() then
					vehicle:closeCpHud();					
				else
					cpHud:openClose(true);
					MultiOverlayV4.otherMods.courseplay.CpHud.isHudActive = true;
				end;
			end;
		end;
	end;
end;

function moCmd.vca(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;	
	if MultiOverlayV4.otherMods.vca == nil then g_currentMission.hl.addTextDisplay( {txt="VehicleControlAddon Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;	
	if args.cmdTable.ownTable[1] == "vcaGlobalSettingOn" then
		if MultiOverlayV4.otherMods.vca.vehicleControlAddonRegister ~= nil and MultiOverlayV4.otherMods.vca.vehicleControlAddonRegister.onToggleMenu ~= nil then			
			FS22_VehicleControlAddon.vehicleControlAddonRegister:onToggleMenu();			
		end;
	elseif args.cmdTable.ownTable[1] == "vcaVehicleSettingOn" then
		if MultiOverlayV4.otherMods.vca.vehicleControlAddon ~= nil and MultiOverlayV4.otherMods.vca.vehicleControlAddon.vcaShowSettingsUI ~= nil then
			if g_currentMission.controlledVehicle ~= nil then
				local vehicle = g_currentMission.controlledVehicle;			
				if vehicle ~= nil then
					if vehicle.spec_vca == nil or vehicle.spec_vca.activeActionEvents == nil then  
						return; 
					end; 
					FS22_VehicleControlAddon.vehicleControlAddon.vcaShowSettingsUI(vehicle);
				end;
			end;
		end;
	end;
end;

function moCmd.easyDevControls(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.easyDevControls == nil then g_currentMission.hl.addTextDisplay( {txt="Easy Development Controls Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if FS22_EasyDevControls.EasyDevControlsUI ~= nil and FS22_EasyDevControls.EasyDevControlsUI.onOpenMenu ~= nil then		
		FS22_EasyDevControls.EasyDevControlsUI:onOpenMenu(false);		
	end;
end;

function moCmd.lockSteeringAxles(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.lockSteeringAxles == nil then g_currentMission.hl.addTextDisplay( {txt="LockSteeringAxles Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.lockSteeringAxles.LockSteeringAxles.toggleSteeringAxleActive ~= nil then
		if g_currentMission.controlledVehicle ~= nil then
			local vehicle = g_currentMission.controlledVehicle;			
			if vehicle ~= nil and vehicle.spec_lockSteeringAxles ~= nil then
				FS22_lockSteeringAxles.LockSteeringAxles.toggleSteeringAxleActive(vehicle);
			end;
		end;
	end;
end;

function moCmd.trailerJointBlock(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.trailerJointBlock == nil then g_currentMission.hl.addTextDisplay( {txt="Trailer Axle Blocker Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.trailerJointBlock.TrailerJointBlock.actionEventBlock ~= nil then
		if g_currentMission.controlledVehicle ~= nil then
			local vehicle = g_currentMission.controlledVehicle;			
			if vehicle ~= nil then 
				function getDirection(attachedVehicle)
					local x1, y1, z1 = getRotation(attachedVehicle.components[1].node);
					local x2, y2, z2 = getRotation(attachedVehicle.components[2].node);
					if math.abs(y1 - y2) < 0.05 then return true;end;
					return false;
				end;
				function getAttached(vehicle, aTable) --by VehicleInspector					
					if vehicle.getAttachedImplements == nil then return aTable;end;	
					local attachedImplements = vehicle:getAttachedImplements();
					for _, implement in pairs(attachedImplements) do
						local object = implement.object;
						if object ~= nil then							
							if object.spec_trailerJointBlock ~= nil then 
								if (object.spec_trailer ~= nil or #object.spec_trailerJointBlock.componentJoints > 1) and object.components ~= nil and #object.components > 1 then								
									table.insert(aTable, {rootNode=Utils.getNoNil(object.rootNode, 0)});
								end;
							end;							
							getAttached(object, aTable);
						end;
					end;
					return aTable, found;
				end;
				function setTrailerJointBlock(attachedVehicle)
					attachedVehicle.specializationsByName.trailerJointBlock.actionEventBlock(attachedVehicle);					
					if getDirection(attachedVehicle) then
						if attachedVehicle.spec_trailerJointBlock.isBlocked then
							g_currentMission.hl.addTextDisplay( {txt="Blocked Trailer Axle", txtBold=true, duration=3} );
						else
							g_currentMission.hl.addTextDisplay( {txt="Unblocked Trailer Axle", txtBold=true, duration=3} );
						end;
					end;
				end;
				local attached = getAttached(vehicle, {});				
				if attached ~= nil and #attached > 0 then
					for o=1, #attached do
						if attached[o] ~= nil then							
							local attachedVehicle = g_currentMission:getNodeObject(attached[o].rootNode);
							if attachedVehicle ~= nil then								
								if #attached == 1 then 
									setTrailerJointBlock(attachedVehicle);
									break;
								else
									if attachedVehicle:getIsSelected() then										
										setTrailerJointBlock(attachedVehicle);
										break;
									end;
									if o == #attached then
										g_currentMission.hl.addTextDisplay( {txt="Select a Trailer for Un/Blocked Trailer Axle", txtBold=true, duration=3, warning=true} );										
									end;
								end;								
							end;
						end;
					end;					
				elseif vehicle.spec_trailerJointBlock ~= nil and (vehicle.spec_trailer ~= nil or #vehicle.spec_trailerJointBlock.componentJoints > 1) and object.components ~= nil and #object.components > 1 then
					setTrailerJointBlock(vehicle);
				end;				
			end;
		end;	
	end;
end;

function moCmd.lsRadio(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	local isActive = g_gameSettings:getValue(GameSettings.SETTING.RADIO_IS_ACTIVE);
	function setRadioOn()
		g_gameSettings:setValue(GameSettings.SETTING.RADIO_IS_ACTIVE, not isActive);
	end;
	if args.cmdTable.ownTable[1] == "radioOnOff" then
		setRadioOn();
	elseif args.cmdTable.ownTable[1] == "radioNextChannel" then
		if g_soundPlayer ~= nil then
			if not isActive then setRadioOn();end;
			g_soundPlayer:nextChannel();
		end;
	elseif args.cmdTable.ownTable[1] == "radioPreviousChannel" then
		if g_soundPlayer ~= nil then
			if not isActive then setRadioOn();end;
			g_soundPlayer:previousChannel()
		end;
	elseif args.cmdTable.ownTable[1] == "radioNextSong" then
		if g_soundPlayer ~= nil then
			if not isActive then setRadioOn();end;
			g_soundPlayer:nextItem();
		end;
	elseif args.cmdTable.ownTable[1] == "radioPreviousSong" then
		if g_soundPlayer ~= nil then
			if not isActive then setRadioOn();end;
			g_soundPlayer:previousItem();
		end;
	elseif args.cmdTable.ownTable[1] == "radioVolumePlus" then
		if g_soundPlayer ~= nil then
			if not isActive then setRadioOn();end;
			local isVolume = g_gameSettings:getValue(GameSettings.SETTING.VOLUME_RADIO);
			if isVolume >= 1 then return;end;
			g_gameSettings:setValue(GameSettings.SETTING.VOLUME_RADIO, MathUtil.clamp(isVolume+0.1, 0, 1));
			g_soundMixer:setAudioGroupVolumeFactor(AudioGroup.RADIO, g_gameSettings:getValue(GameSettings.SETTING.VOLUME_RADIO));
			g_currentMission.hl.addTextDisplay( {txt=g_i18n:getText("setting_volumeRadio").. ": ".. tostring(math.floor(isVolume*10), 0.5).. " (10)", txtBold=true, duration=3} );
			--g_i18n:getText("setting_volumeRadio")			
		end;
	elseif args.cmdTable.ownTable[1] == "radioVolumeMinus" then
		if g_soundPlayer ~= nil then
			if not isActive then setRadioOn();end;
			local isVolume = g_gameSettings:getValue(GameSettings.SETTING.VOLUME_RADIO);
			if isVolume <= 0 then return;end;
			g_gameSettings:setValue(GameSettings.SETTING.VOLUME_RADIO, MathUtil.clamp(isVolume-0.1, 0, 1));
			g_soundMixer:setAudioGroupVolumeFactor(AudioGroup.RADIO, g_gameSettings:getValue(GameSettings.SETTING.VOLUME_RADIO));
			g_currentMission.hl.addTextDisplay( {txt=g_i18n:getText("setting_volumeRadio").. ": ".. tostring(math.floor(isVolume*10, -0.5)).. " (10)", txtBold=true, duration=3} );			
		end;	
	end;
end;

function moCmd.openCloseCbRadioHelper(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.cbRadioHelper == nil then g_currentMission.hl.addTextDisplay( {txt="CB Radio Helper Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;	
end;

function moCmd.openCloseCourseplayInfoHud(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.courseplay == nil then g_currentMission.hl.addTextDisplay( {txt="Courseplay Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;	
	if MultiOverlayV4.otherMods.courseplay.g_Courseplay ~= nil and MultiOverlayV4.otherMods.courseplay.g_Courseplay.globalSettings ~= nil then
		local settings = MultiOverlayV4.otherMods.courseplay.g_Courseplay.globalSettings;
		settings.infoTextHudActive:setValue(not settings.infoTextHudActive:getValue());
	end;
end;

function moCmd.gpsOnOff(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	if MultiOverlayV4.otherMods.gps == nil then g_currentMission.hl.addTextDisplay( {txt="GuidanceSteering(GPS) Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if g_currentMission.controlledVehicle ~= nil then
		local vehicle = g_currentMission.controlledVehicle;			
		if vehicle ~= nil then
			local spec = vehicle.spec_globalPositioningSystem;
			local hasGuidanceSystem = spec ~= nil and spec.hasGuidanceSystem;
			if not hasGuidanceSystem then g_currentMission.hl.addTextDisplay( {txt="GuidanceSteering(GPS) Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
			if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown and args.cmdTable.ownTable.onOff == "gps" then				
				spec.lastInputValues.guidanceIsActive = not spec.lastInputValues.guidanceIsActive;		
				spec.lastInputValues.guidanceSteeringIsActive = false;
				if spec.lastInputValues.guidanceIsActive then g_currentMission.hl.addTextDisplay( {txt="Vehicle GPS ON", txtBold=true, duration=3} );
				elseif not spec.lastInputValues.guidanceIsActive then g_currentMission.hl.addTextDisplay( {txt="Vehicle GPS OFF", txtBold=true, duration=3} );end;
			elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown and args.cmdTable.ownTable.onOff == "gpsHud" then
				g_currentMission.guidanceSteering.ui:onToggleUI();
			end;			
		end;
	end;
end;

function moCmd.contractHud(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	if MultiOverlayV4.otherMods.contractHud == nil then g_currentMission.hl.addTextDisplay( {txt="Contract HUD Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if MultiOverlayV4.otherMods.contractHud.ContractHUD ~= nil and MultiOverlayV4.otherMods.contractHud.ContractHUD.displayMode ~= nil then		
		if FS22_ContractHUD.ContractHUD.lastDisplayMode == nil then FS22_ContractHUD.ContractHUD.lastDisplayMode = FS22_ContractHUD.ContractHUD.displayMode;end;
		local displayMode = FS22_ContractHUD.ContractHUD.displayMode;		
		if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown and args.cmdTable.ownTable[1] == "contractHudOnOff" then
			if displayMode == 2 then				
				if FS22_ContractHUD.ContractHUD.lastDisplayMode == 2 then
					FS22_ContractHUD.ContractHUD.displayMode = 0;
					FS22_ContractHUD.ContractHUD.lastDisplayMode = 0;
				else
					FS22_ContractHUD.ContractHUD.displayMode = FS22_ContractHUD.ContractHUD.lastDisplayMode;
				end;
			else
				FS22_ContractHUD.ContractHUD.displayMode = 2;
			end;
		elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown and args.cmdTable.ownTable[1] == "contractHudSwitch" then			
			if displayMode == 2 then return;end;
			if displayMode == 0 then
				FS22_ContractHUD.ContractHUD.displayMode = 1;
				FS22_ContractHUD.ContractHUD.lastDisplayMode = 1;
			else
				FS22_ContractHUD.ContractHUD.displayMode = 0;
				FS22_ContractHUD.ContractHUD.lastDisplayMode = 0;
			end;
		end;
	end;
end;

function moCmd.parkVehicleOnOff(args)
	if args == nil or type(args) ~= "table" then return;end;
	if MultiOverlayV4.otherMods.parkVehicle == nil then g_currentMission.hl.addTextDisplay( {txt="ParkVehicle Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if g_currentMission.controlledVehicle ~= nil then
		local vehicle = g_currentMission.controlledVehicle;			
		if vehicle ~= nil and vehicle.spec_parkvehicle ~= nil then
			vehicle.spec_parkvehicle.inputPressed = true;			
		end;
	end;
end;

function moCmd.vehicleExplorer(args)	
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;
	if MultiOverlayV4.otherMods.vehicleExplorer == nil then g_currentMission.hl.addTextDisplay( {txt="VehicleExplorer Mod Not Found", txtBold=true, duration=3, warning=true} );return;end;
	if FS22_VehicleExplorer ~= nil and FS22_VehicleExplorer.VehicleSort ~= nil then
		if args.cmdTable.ownTable[1] == "veSortOnOff" then			
			if not FS22_VehicleExplorer.VehicleSort.showVehicles then 
				FS22_VehicleExplorer.VehicleSort.selectedLock = false;
				FS22_VehicleExplorer.VehicleSort.showConfig = false;
			end;
			FS22_VehicleExplorer.VehicleSort.showVehicles = not FS22_VehicleExplorer.VehicleSort.showVehicles;
		elseif args.cmdTable.ownTable[1] == "veConfigOnOff" then
			if FS22_VehicleExplorer.VehicleSort.showVehicles then FS22_VehicleExplorer.VehicleSort.showVehicles = false;end;
			FS22_VehicleExplorer.VehicleSort.showConfig = not FS22_VehicleExplorer.VehicleSort.showConfig;
		end;
	end;
end;	

function moCmd.strongFarmer(args, reset, noShowWarning)
	if (MultiOverlayV4.otherMods.strongFarmer ~= nil or MultiOverlayV4.otherMods.strongFarmer ~= nil) and MultiOverlayV4.otherMods.easyDevControls ~= nil then
		if noShowWarning == nil or (noShowWarning ~= nil and not noShowWarning) then
			g_currentMission.hl.addTextDisplay( {txt="Found EasyDevControls Mod, Cmd StrongFarmer On/Off not compatible", txtBold=true, duration=3, warning=true} );			
		end;
		return;
	end;
	if reset ~= nil and reset then
		if MultiOverlayV4.otherMods.strongFarmer == nil then return;end;		
		moGeneralSettings.other.strongFarmer.isOn = true;
		Player.MAX_PICKABLE_OBJECT_MASS = moGeneralSettings.other.strongFarmer.maxMass;
		--Player.MAX_PICKABLE_OBJECT_DISTANCE = moGeneralSettings.other.strongFarmer.maxDistance;
	end;
	if args == nil or type(args) ~= "table" then return;end;	
	if MultiOverlayV4.otherMods.strongFarmer == nil then 
		if noShowWarning == nil or (noShowWarning ~= nil and not noShowWarning) then
			g_currentMission.hl.addTextDisplay( {txt="StrongFarmer Mods Not Found", txtBold=true, duration=3, warning=true} );			
		end;
		return;		
	end;
	if moGeneralSettings.other.strongFarmer.isOn then 
		moGeneralSettings.other.strongFarmer.isOn = false;
		Player.MAX_PICKABLE_OBJECT_MASS = 0.2;
		Player.MAX_PICKABLE_OBJECT_DISTANCE = 15;
		if noShowWarning == nil or (noShowWarning ~= nil and not noShowWarning) then
			g_currentMission.hl.addTextDisplay( {txt="Strong Farmer Off", txtBold=true, duration=3} );			
		end;
	else
		moGeneralSettings.other.strongFarmer.isOn = true;
		Player.MAX_PICKABLE_OBJECT_MASS = moGeneralSettings.other.strongFarmer.maxMass;
		--Player.MAX_PICKABLE_OBJECT_DISTANCE = moGeneralSettings.other.strongFarmer.maxDistance;
		if noShowWarning == nil or (noShowWarning ~= nil and not noShowWarning) then
			g_currentMission.hl.addTextDisplay( {txt="Strong Farmer On", txtBold=true, duration=3} );			
		end;
	end;
end;
	



