moSetGetCmd = {};
source(MultiOverlayV4.modDir.."scripte/cmd/moCmd.lua");
source(MultiOverlayV4.modDir.."scripte/cmd/outputActionOpenCloseCmd.lua");

function moSetGetCmd:generateCmd(args)
	if MultiOverlayV4.cmd == nil then MultiOverlayV4.cmd = {};end;
	if MultiOverlayV4.cmdSetting == nil then MultiOverlayV4.cmdSetting = {selectCmd={}};end;
	if MultiOverlayV4.cmdByGroupName == nil then MultiOverlayV4.cmdByGroupName = {};end;
	if MultiOverlayV4.cmdByModName == nil then MultiOverlayV4.cmdByModName = {};end;
	if args == nil or type(args) ~= "table" or args.modName == nil or args.cmdName == nil then return false, "missing args table or incorrect";end;
	if args.typ == nil or type(args) ~= "table" then return false, "missing args typ= {action_ } or {output_} or {outputAction_} or {actionOutput_}";end;
	if string.find(args.cmdName, " ") then return false, "cmdName must not have any spaces";end;
	if string.find(args.groupName, " ") then return false, "groupName must not have any spaces";end;
	if not string.find(args.cmdName, "_", string.len(args.cmdName)-1) then return false, "cmdName must have _ on end";end;
	local modName = string.gsub(args.modName, " ", "");	
	if MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] ~= nil then return false, "cmd name already exists";end;
	if args.actionCallback == nil or type(args.actionCallback) ~= "function" then return false, "actionCallback not a function or incorrect";end;
	MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] = {};
	local cmdTable = MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName];
	cmdTable.regName = modName.. "_cmd_".. args.cmdName;
	cmdTable.cmdName = args.cmdName;
	cmdTable.modName = modName;
	cmdTable.realModName = args.modName;
	cmdTable.actionCallback = args.actionCallback;
	cmdTable.freeCmd = args.freeCmd; --default true 
	cmdTable.mouseClickAccepts = args.mouseClickAccepts; --default all, a table {true,true,false} left,middle,right
	if cmdTable.mouseClickAccepts == nil or type(cmdTable.mouseClickAccepts) ~= "table" or #cmdTable.mouseClickAccepts < 3 then cmdTable.mouseClickAccepts = {true,true,true};end;
	cmdTable.displayName = args.displayName or "Unknown";
	cmdTable.groupName = args.groupName or "Unknown";	
	cmdTable.infoTxt = args.infoTxt;
	cmdTable.helpTxt = args.helpTxt;
	cmdTable.ownTable = args.ownTable;
	cmdTable.object = args.object;	
	cmdTable.typ = args.typ;	
	function comp(w1,w2)		
		if w1 < w2 then
			return true;
		end;				
	end;			
	if MultiOverlayV4.cmdByGroupName[cmdTable.groupName] == nil then
		MultiOverlayV4.cmdByGroupName[cmdTable.groupName] = {};		
	end;	
	MultiOverlayV4.cmdByGroupName[cmdTable.groupName][#MultiOverlayV4.cmdByGroupName[cmdTable.groupName]+1] ={cmd = modName.. "_cmd_".. args.cmdName};
	table.sort(MultiOverlayV4.cmdByGroupName, comp);	
	if MultiOverlayV4.cmdByModName[modName] == nil then
		MultiOverlayV4.cmdByModName[modName] = {};		
	end;
	MultiOverlayV4.cmdByModName[modName][#MultiOverlayV4.cmdByModName[modName]+1] = {cmd = modName.. "_cmd_".. args.cmdName};
	table.sort(MultiOverlayV4.cmdByModName, comp);
	if args.setCmdCallback ~= nil and type(args.setCmdCallback) == "function" then
		cmdTable.setCmdCallback = args.setCmdCallback;
	end;
	if args.delCmdCallback ~= nil and type(args.delCmdCallback) == "function" then
		cmdTable.delCmdCallback = args.delCmdCallback;
	end;
	return true;
end;

function moSetGetCmd:deleteCmd(args)
	if args == nil or type(args) ~= "table" then return false, "missing args table";end;
	if args.modName == nil or args.cmdName == nil then return false, "missing args modName= and or cmdName=";end;
	local modName = string.gsub(args.modName, " ", "");
	if MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] == nil then return false, "cmd not found";end;
	MultiOverlayV4.cmd[modName.. "_cmd_".. args.cmdName] = nil;	
	for a=1, #MultiOverlayV4.cmdByModName[modName] do
		if MultiOverlayV4.cmdByModName[modName][a].cmd == modName.. "_cmd_".. args.cmdName then MultiOverlayV4.cmdByModName[modName][a].cmd = nil;break;end;
	end;
	if #MultiOverlayV4.cmdByModName[modName] == 0 then MultiOverlayV4.cmdByModName[modName] = nil;end;
	local foundGroup = false;
	for groupName, index in pairs (MultiOverlayV4.cmdByGroupName) do
		for a=1, #MultiOverlayV4.cmdByGroupName[groupName] do
			if MultiOverlayV4.cmdByGroupName[groupName][a].cmd == modName.. "_cmd_".. args.cmdName then MultiOverlayV4.cmdByGroupName[groupName][a].cmd = nil;foundGroup=true;break;end;
		end;
		if foundGroup and #MultiOverlayV4.cmdByGroupName[groupName] == 0 then MultiOverlayV4.cmdByGroupName[groupName]=nil;break;end;
		if foundGroup then break;end;
	end;
	return true;
end;

function moSetGetCmd:deleteAllPdaCmds()
	local pdas = moSetGetPda:getPdas();
	if #pdas > 0 then
		for pda=1, #pdas do				
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="outputAction_".. tostring(pdas[pda])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_".. tostring(pdas[pda])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_switchViewModus_".. tostring(pdas[pda])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_open_".. tostring(pdas[pda])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_close_".. tostring(pdas[pda])} );
		end;
	end;		
end;

function moSetGetCmd:deleteAllSlotCmds()
	local slots = moSetGetSlot:getSlots();
	if #slots > 0 then
		for slot=1, #slots do				
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="outputAction_".. tostring(slots[slot])} );
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_".. tostring(slots[slot])} );	
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_open_".. tostring(slots[slot])} );	
			moSetGetCmd:deleteCmd( {modName="MultiOverlayV4", cmdName="action_close_".. tostring(slots[slot])} );	
		end;
	end;
end;

function moSetGetCmd:setOpenCloseSlotCmd(whichSlot)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_"..whichSlot;
			groupName = "Open/Close";			
			displayName = "Slot ".. moSetGetOverlays.slot[whichSlot].name;			
			infoTxt = "Open/Close this Slot";
			typ = {"outputAction_"};
			mouseClickAccepts = {true,false,false}; 
			ownTable = {whichSlot=whichSlot};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_"..whichSlot;
			groupName = "Open/Close";			
			displayName = "Slot ".. moSetGetOverlays.slot[whichSlot].name;			
			infoTxt = "Open/Close this Slot";
			typ = {"action_"};
			ownTable = {whichSlot=whichSlot};
			actionCallback = moCmd.openCloseSlot;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_open_"..whichSlot;
			groupName = "Only-Open-Slot/Pda";			
			displayName = "Slot ".. moSetGetOverlays.slot[whichSlot].name;			
			infoTxt = "Only Open this Slot";
			typ = {"action_"};
			ownTable = {whichSlot=whichSlot};
			actionCallback = moCmd.openSlot;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_close_"..whichSlot;
			groupName = "Only-Close-Slot/Pda";			
			displayName = "Slot ".. moSetGetOverlays.slot[whichSlot].name;			
			infoTxt = "Only Close this Slot";
			typ = {"action_"};
			ownTable = {whichSlot=whichSlot};
			actionCallback = moCmd.closeSlot;			
		}
	)
end;

function moSetGetCmd:setOpenClosePdaCmd(whichPda) --new +switchViewModus
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_"..whichPda;
			groupName = "Open/Close";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Open/Close this Pda";
			typ = {"outputAction_"};
			mouseClickAccepts = {true,false,false};
			ownTable = {whichPda=whichPda};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_"..whichPda;
			groupName = "Open/Close";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Open/Close this Pda";
			typ = {"action_"};			
			ownTable = {whichPda=whichPda};
			actionCallback = moCmd.openClosePda;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_switchViewModus_"..whichPda;
			groupName = "Pda-SwitchModus";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Switch ViewModus this Pda";
			typ = {"action_"};			
			ownTable = {whichPda=whichPda};
			actionCallback = moCmd.switchViewModusPda;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_open_"..whichPda;
			groupName = "Only-Open-Slot/Pda";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Only Open this Pda";
			typ = {"action_"};			
			ownTable = {whichPda=whichPda};
			actionCallback = moCmd.openPda;			
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_close_"..whichPda;
			groupName = "Only-Close-Slot/Pda";			
			displayName = "Pda ".. moSetGetOverlays.pda[whichPda].name;			
			infoTxt = "Only Close this Pda";
			typ = {"action_"};			
			ownTable = {whichPda=whichPda};
			actionCallback = moCmd.closePda;			
		}
	)
end;

function moSetGetCmd:setMohDefaultCmds()
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_saveAllData_";
			groupName = "Speziale";			
			displayName = "Save all MultiOverlayV4 Data";
			infoTxt = "Save all MultiOverlayV4 Data";
			typ = {"action_"};			
			actionCallback = moCmd.saveAllData;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_openCloseGuiMenu_";
			groupName = "Speziale";			
			displayName = "GUI Menu Open/Close";
			infoTxt = "Öffnet/Schliesst das GUI Menü (Open/Close GUI Menue)";
			typ = {"action_"};			
			actionCallback = moCmd.openCloseGuiMenue;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_switchProfile_";
			groupName = "Speziale";			
			displayName = "Profile Switch (MultiOverlayV4 Profile)";
			infoTxt = "Profile Switch (MultiOverlayV4 Profile)";
			typ = {"action_"};			
			mouseClickAccepts = {true,false,true};
			actionCallback = moCmd.switchProfile;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_radioOnOff_";
			groupName = "Speziale";			
			displayName = "Radio On/Off";
			infoTxt = "Radio On/Off";
			typ = {"action_"};
			ownTable = {"radioOnOff"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.lsRadio;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_radioNextChannel_";
			groupName = "Speziale";			
			displayName = "Radio Next Channel (Automatic Radio On)";
			infoTxt = "Radio Next Channel (Automatic Radio On)";
			typ = {"action_"};
			ownTable = {"radioNextChannel"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.lsRadio;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_radioPreviousChannel_";
			groupName = "Speziale";			
			displayName = "Radio Previous Channel (Automatic Radio On)";
			infoTxt = "Radio Previous Channel (Automatic Radio On)";
			typ = {"action_"};
			ownTable = {"radioPreviousChannel"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.lsRadio;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_radioNextSong_";
			groupName = "Speziale";			
			displayName = "Radio Next Song (Automatic Radio On)";
			infoTxt = "Radio Next Song (Automatic Radio On)";
			typ = {"action_"};
			ownTable = {"radioNextSong"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.lsRadio;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_radioPreviousSong_";
			groupName = "Speziale";			
			displayName = "Radio Previous Song (Automatic Radio On)";
			infoTxt = "Radio Previous Song (Automatic Radio On)";
			typ = {"action_"};
			ownTable = {"radioPreviousSong"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.lsRadio;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_radioVolumePlus_";
			groupName = "Speziale";			
			displayName = "Radio Volume + (Automatic Radio On)";
			infoTxt = "Radio Volume + (Automatic Radio On)";
			typ = {"action_"};
			ownTable = {"radioVolumePlus"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.lsRadio;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_radioVolumeMinus_";
			groupName = "Speziale";			
			displayName = "Radio Volume - (Automatic Radio On)";
			infoTxt = "Radio Volume - (Automatic Radio On)";
			typ = {"action_"};
			ownTable = {"radioVolumeMinus"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.lsRadio;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_mohMouseOff_";
			groupName = "Speziale";			
			displayName = "MOH MauseZeiger Aus";
			infoTxt = "MultiOverlayV4 Hud MouseCursor Off, is automatic LS mouseCursor Off";
			typ = {"action_"};
			ownTable = {"mohMouseCursorOff"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.setMouseCursor;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_mohMouseOn_";
			groupName = "Speziale";			
			displayName = "MOH MauseZeiger An";
			infoTxt = "MultiOverlayV4 Hud MouseCursor On, is automatic LS mouseCursor On";
			typ = {"action_"};
			ownTable = {"mohMouseCursorOn"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.setMouseCursor;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_lsMouseOn_";
			groupName = "Speziale";			
			displayName = "LS22 MauseZeiger An";
			infoTxt = "LS22 MouseCursor On";
			typ = {"action_"};
			ownTable = {"lsMouseCursorOn"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.setMouseCursor;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_lsMouseOff_";
			groupName = "Speziale";			
			displayName = "LS22 MauseZeiger Aus";
			infoTxt = "LS22 MouseCursor Off. If MOH MouseCursor On is this Cmd not Active";
			typ = {"action_"};
			ownTable = {"lsMouseCursorOff"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.setMouseCursor;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_closeAllSlots_";
			groupName = "Close";			
			displayName = "Close all Slots";
			infoTxt = "Close all MultiOverlay Slots";
			typ = {"outputAction_"};
			ownTable = {closeAll="slots"};
			mouseClickAccepts = {true,false,false};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_closeAllSlots_";
			groupName = "Close";			
			displayName = "Close all Slots";
			infoTxt = "Close all MultiOverlay Slots";
			typ = {"action_"};			
			actionCallback = moCmd.closeAllSlots;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "outputAction_closeAllPdas_";
			groupName = "Close";			
			displayName = "Close all Pdas";
			infoTxt = "Close all MultiOverlay Pdas";
			typ = {"outputAction_"};
			ownTable = {closeAll="pdas"};
			mouseClickAccepts = {true,false,false};
			actionCallback = outputActionOpenCloseCmd.giveOutputTable;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_closeAllPdas_";
			groupName = "Close";			
			displayName = "Close all Pdas";
			infoTxt = "Close all MultiOverlay Pdas";
			typ = {"action_"};			
			actionCallback = moCmd.closeAllPdas;
		}
	)	
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_handToolsSwitch_";
			groupName = "OnOff-OtherMods";			
			displayName = "Hand Tools Switch On/Off";
			infoTxt = "Verhindert das Hand Tools Scollen\nChainsaw etc.";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.handToolsSwitch;
		}
	)
	--moSetGetCmd:generateCmd( {	
	--		modName = "MultiOverlayV4";
	--		cmdName = "action_cbRadioHelper_";
	--		groupName = "OnOff-OtherMods";			
	--		displayName = "CB Radio Helper On/Off";
	--		infoTxt = "Aktiviert und deaktiviert den CB Radio Helper (Funk). (On/Off AutoDrive Hud) *needs CB Radio Helper Mod*";
	--		typ = {"action_"};			
	--		mouseClickAccepts = {true,true,true};
	--		actionCallback = moCmd.openCloseCbRadioHelper;
	--	}
	--)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_autoDrive_";
			groupName = "OnOff-OtherMods";			
			displayName = "AutoDrive Hud On/Off";
			infoTxt = "Öffnet und schliesst das AutoDrive Hud Fenster. (Open/Close AutoDrive Hud) *needs AutoDrive Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.openCloseAutoDrive;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_courseplay_";
			groupName = "OnOff-OtherMods";			
			displayName = "Courseplay Hud On/Off";
			infoTxt = "Öffnet und schliesst das Courseplay Hud Fenster. (Open/Close Courseplay Hud) *needs Courseplay Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.openCloseCourseplay;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_courseplayInfoHud_";
			groupName = "OnOff-OtherMods";			
			displayName = "Courseplay Info Hud On/Off";
			infoTxt = "Öffnet und schliesst das Courseplay Info Hud Fenster. (Open/Close Courseplay Info Hud) *needs Courseplay Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.openCloseCourseplayInfoHud;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_productionInfoHud_";
			groupName = "OnOff-OtherMods";			
			displayName = "ProduktionInfo Hud On/Off";
			infoTxt = "Öffnet und schliesst das ProductionInfo Hud Fenster. (Open/Close ProductionInfo Hud) *needs ProduktionInfoHud Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.openCloseProductionInfoHud;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_switchProductionInfoHud_";
			groupName = "OtherMods-Switch";			
			displayName = "ProduktionInfo Hud Switch Modus";
			infoTxt = "Ändert den Anzeige Modus für den ProductionInfo Hud. (Switch Modus ProductionInfo Hud) *needs ProduktionInfoHud Mod and SellPriceTrigger Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.switchModusProductionInfoHud;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_contractHud_";
			groupName = "OnOff-OtherMods";			
			displayName = "Contract Hud On/Off";
			infoTxt = "Öffnet und schliesst das Contract Hud. (On/Off Contract Hud) *needs Contract HUD Mod*";
			typ = {"action_"};
			ownTable = {"contractHudOnOff"};			
			mouseClickAccepts = {true,false,false};
			actionCallback = moCmd.contractHud;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_contractHudSwitch_";
			groupName = "OtherMods-Switch";			
			displayName = "Contract Hud Switch Modus";
			infoTxt = "Ändert den Anzeige Modus für den Contract Hud. (Switch Modus Contract Hud) *needs Contract HUD Mod*";
			typ = {"action_"};
			ownTable = {"contractHudSwitch"};			
			mouseClickAccepts = {false,false,true};
			actionCallback = moCmd.contractHud;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_parkVehicle_";
			groupName = "OtherMods";			
			displayName = "Park Vehicle On/Off";
			infoTxt = "Fahrzeug Parken An/Aus. (On/Off Park Vehicle) *needs ParkVehicle Mod*";
			typ = {"action_"};						
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.parkVehicleOnOff;
		}
	)
	--moSetGetCmd:generateCmd( {
	--		modName = "MultiOverlayV4";
	--		cmdName = "action_lockSteeringAxles_";
	--		groupName = "OtherMods";			
	--		displayName = "Vehicle(Trailer) Lock Steering Axles On/Off";
	--		infoTxt = "Schaltet beim Fahrzeug(Anhänger) die Gelenkachse An/Aus. (On/Off Steering Axles) *needs LockSteeringAxles Mod*";
	--		typ = {"action_"};						
	--		mouseClickAccepts = {true,true,true};
	--		actionCallback = moCmd.lockSteeringAxles;
	--	}
	--)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_trailerJointBlock_";
			groupName = "OtherMods";			
			displayName = "Vehicle(Trailer) Trailer Axles Blocked On/Off";
			infoTxt = "Schaltet beim Fahrzeug(Anhänger) die Gelenkachse An/Aus. (On/Off Trailer Axles Blocked) *needs Trailer Axle Blocker Mod*";
			typ = {"action_"};						
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.trailerJointBlock;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_easyDevControls_";
			groupName = "OtherMods";			
			displayName = "EasyDevControls Setting On";
			infoTxt = "EasyDevControls Setting On. *needs Easy Development Controls Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.easyDevControls;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_vcaGlobalSetting_";
			groupName = "OtherMods";			
			displayName = "VCA Global Setting On";
			infoTxt = "Fahrzeug VCA Global Setting An. (On VehicleControlAddon) *needs VehicleControlAddon Mod*";
			typ = {"action_"};
			ownTable = {"vcaGlobalSettingOn"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.vca;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_vcaVehicleSetting_";
			groupName = "OtherMods";			
			displayName = "VCA Vehicle Setting On";
			infoTxt = "Fahrzeug VCA Vehicle Setting An. (On VehicleControlAddon) *needs VehicleControlAddon Mod*";
			typ = {"action_"};
			ownTable = {"vcaVehicleSettingOn"};
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.vca;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_veSortHud_";
			groupName = "OnOff-OtherMods";			
			displayName = "Vehicle Explorer Sort Hud On/Off";
			infoTxt = "Vehicle Explorer Sort Hud An/Aus. (On/Off Vehicle Explorer) *needs VehicleExplorer Mod*";
			typ = {"action_"};
			ownTable = {"veSortOnOff"};
			mouseClickAccepts = {true,false,false};
			actionCallback = moCmd.vehicleExplorer;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_veConfigHud_";
			groupName = "OnOff-OtherMods";			
			displayName = "Vehicle Explorer Config Hud On/Off";
			infoTxt = "Vehicle Explorer Config Hud An/Aus. (On/Off Vehicle Explorer) *needs VehicleExplorer Mod*";
			typ = {"action_"};
			ownTable = {"veConfigOnOff"};
			mouseClickAccepts = {false,false,true};
			actionCallback = moCmd.vehicleExplorer;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_gps_";
			groupName = "OnOff-OtherMods";			
			displayName = "GPS Vehicle On/Off";
			infoTxt = "Fahrzeug GPS An/Aus (buy Shop). (On/Off GPS) *needs GPS Mod (GuidanceSteering)*";
			typ = {"action_"};
			ownTable = {onOff="gps"};			
			mouseClickAccepts = {true,false,false};
			actionCallback = moCmd.gpsOnOff;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_gpsHud_";
			groupName = "OnOff-OtherMods";			
			displayName = "GPS Hud On/Off";
			infoTxt = "Öffnet und schliesst das GPS Hud. (Open/Close GPS Hud) *needs GPS Mod (GuidanceSteering)*";
			typ = {"action_"};			
			ownTable = {onOff="gpsHud"};	
			mouseClickAccepts = {false,false,true};
			actionCallback = moCmd.gpsOnOff;
		}
	)	
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_aiVehicleExtension_";
			groupName = "OnOff-OtherMods";			
			displayName = "AI-Vehicle Extension Hud On/Off";
			infoTxt = "Öffnet und schliesst das AI-Vehicle Extension Hud Fenster. (Open/Close AI-Vehicle Extension Hud) *needs AI-Vehicle Extension Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.openCloseAiVehicleExtension;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_infoMessageHud_";
			groupName = "OnOff-OtherMods";			
			displayName = "InfoMessage Hud On/Off";
			infoTxt = "Öffnet und schliesst das InfoMessage Hud Fenster. (Open/Close InfoMessage Hud) *needs InfoMessageHUD Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};			
			actionCallback = moCmd.openCloseInfoMessageHud;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_strongFarmer_";
			groupName = "OnOff-OtherMods";			
			displayName = "Strong Farmer On/Off";
			infoTxt = "Starker Bauer On/Off. *needs StrongFarmer Mod*";
			typ = {"action_"};			
			mouseClickAccepts = {true,true,true};
			actionCallback = moCmd.strongFarmer;
		}
	)
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "output_test_";
			groupName = "Test-Cmd";			
			displayName = "Test On/Off";
			infoTxt = "Dummy Test Cmd";
			typ = {"output_"};			
			freeCmd = false;
			mouseClickAccepts = {true,true,true};			
			setCmdCallback = moSetGetCmd.setTestCmd;
			delCmdCallback = moSetGetCmd.delTestCmd;
			actionCallback = moSetGetCmd.actionTestCmd;
		}
	)	
end;

function moSetGetCmd.actionTestCmd(args)
	return;
end;

function moSetGetCmd.setTestCmd(slotTable, cmdTable)
	if slotTable == nil or cmdTable == nil then return;end;
	return;
end;

function moSetGetCmd.delTestCmd(slotTable, cmdTable)
	if slotTable == nil or cmdTable == nil then return;end;
	return;
end;

function moSetGetCmd:getCmdTable()
	return MultiOverlayV4.cmd;
end;

function moSetGetCmd:getGroupCmdTable(group)
	return MultiOverlayV4.cmdByGroupName[group];
end;

function moSetGetCmd:getModCmdTable(modName)
	local modName = string.gsub(modName, " ", "");
	return MultiOverlayV4.cmdByModName[modName];
end;

function moSetGetCmd:isCmdActiveAtSlot(args)
	if args == nil or type(args) ~= "table" then return false, "missing args table";end;
	if args.modName == nil or args.cmdName == nil then return false, "missing args modName= and or cmdName=";end;
	local modName = string.gsub(args.modName, " ", "");
	local regName = modName.. "_cmd_".. args.cmdName;
	local foundCmd = 0;
	local slots = moSetGetSlot:getSlots();
	if #slots > 0 then
		for slot=1, #slots do
			if moSetGetOverlays.slot[slots[slot]] ~= nil and moSetGetOverlays.slot[slots[slot]].cmd ~= nil and #moSetGetOverlays.slot[slots[slot]].cmd > 0 then
				for cmd=1, #moSetGetOverlays.slot[slots[slot]].cmd do
					if moSetGetOverlays.slot[slots[slot]].cmd[cmd] ~= nil then
						if moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName ~= nil then
							if moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName == regName and moSetGetOverlays.slot[slots[slot]].cmd[cmd].regName:len() == regName:len() then 
								foundCmdTable[#foundCmdTable+1] = {slotName=slots[slot], cmdPos=cmd};								
							end;
						end;
					end;
				end;
			end;
		end;
		return true, foundCmdTable;
	else
		return true, foundCmdTable;
	end;	
	return false;
end;

function moSetGetCmd:isCmdActiveAtPda(args)
	if args == nil or type(args) ~= "table" then return false, "missing args table";end;
	if args.modName == nil or args.cmdName == nil then return false, "missing args modName= and or cmdName=";end;
	local modName = string.gsub(args.modName, " ", "");
	local regName = modName.. "_cmd_".. args.cmdName;
	local foundCmdTable = {};
	local pdas = moSetGetPda:getPdas();
	if #pdas > 0 then
		for pda=1, #pdas do
			if moSetGetOverlays.pda[pdas[pda]] ~= nil and moSetGetOverlays.pda[pdas[pda]].apps ~= nil and #moSetGetOverlays.pda[pdas[pda]].apps > 0 then
				local apps = moSetGetOverlays.pda[pdas[pda]].apps;
				for appLine=1, #apps do
					if apps[appLine] ~= nil and #apps[appLine] > 0 then
						for appPos=1, #apps[appLine] do
							if apps[appLine][appPos] ~= nil and apps[appLine][appPos].cmd ~= nil and #apps[appLine][appPos].cmd > 0 then						
								for cmd=1, #apps[appLine][appPos].cmd do
									if apps[appLine][appPos].cmd[cmd] ~= nil then
										if apps[appLine][appPos].cmd[cmd].regName ~= nil then
											if apps[appLine][appPos].cmd[cmd].regName == regName and apps[appLine][appPos].cmd[cmd].regName:len() == regName:len() then 
												foundCmdTable[#foundCmdTable+1] = {pdaName=pdas[pda], appLine=appLine, appPos=appPos,cmdPos=cmd};												
											end;
										end;
									end;
								end;
							end;
						end;
					end;
				end;
			end;
		end;
		return true, foundCmdTable;
	else
		return true, foundCmdTable;
	end;	
	return false;
end;
-------------mod setGetCmdFunction-------------
g_currentMission.multiOverlayV4.cmdFunction={
	generateCmd = function(args)return moSetGetCmd:generateCmd(args);end;
	deleteCmd = function(args)return moSetGetCmd:deleteCmd(args);end;
	getCmdTable = function()return moSetGetCmd:getCmdTable();end;
	getGroupCmdTable = function(group)return moSetGetCmd:getGroupCmdTable(group);end;
	getModCmdTable = function(modName)return moSetGetCmd:getModCmdTable(modName);end;
	isCmdActiveAtSlot = function(args)return moSetGetCmd:isCmdActiveAtSlot(args);end;
	isCmdActiveAtPda = function(args)return moSetGetCmd:isCmdActiveAtPda(args);end;
};
-------------mod setGetCmdFunction-------------