outputActionOpenCloseCmd = {};

function outputActionOpenCloseCmd:loadOne(cmdTable, slot)	
	local lineTable = {line={}};
	lineTable.line[#lineTable.line+1] = {};
	local isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	isLineTable.txt[1].width = 20;
	if not slot then		
		if moSetGetOverlays.pda[cmdTable.ownTable.whichPda].isOpen then
			isLineTable.txt[1].slotColor = "settingOn";
		else
			isLineTable.txt[1].slotColor = "txtOutputTitle";
		end;
		isLineTable.txt[1].callback = outputActionOpenCloseCmd.returnClickOpenClosePda;
		isLineTable.txt[1].ownTable = {whichPda=cmdTable.ownTable.whichPda}
	else
		if moSetGetOverlays.slot[cmdTable.ownTable.whichSlot].isOpen then
			isLineTable.txt[1].slotColor = "settingOn";
		else
			isLineTable.txt[1].slotColor = "txtOutputTitle";
		end;
		isLineTable.txt[1].callback = outputActionOpenCloseCmd.returnClickOpenCloseSlot;
		isLineTable.txt[1].ownTable = {whichSlot=cmdTable.ownTable.whichSlot};
	end;
	--isLineTable.txt[1].icon = {before={},after={}};
	--isLineTable.txt[1].icon.before[1] = {name="buttonOnOff", color="green", settingButton=true};
	--isLineTable.txt[1].icon.before[2] = {name="buttonDelete", color="yellow", settingButton=true};	
	--isLineTable.txt[1].icon.after[1] = {name="buttonUpDown", color="ls15", settingButton=true, halfButton="upDown", callback={[1]=outputActionOpenCloseCmd.returnClickButtonUp,[2]=outputActionOpenCloseCmd.returnClickButtonDown}};
	--isLineTable.txt[1].icon.after[2] = {name="buttonLeft", color="ls15", settingButton=true};
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(cmdTable.displayName);
	
	--isLineTable.txt[2] = {};
	--isLineTable.txt[2].bold = true;
	--isLineTable.txt[2].txt = "Langer test text";
	--isLineTable.txt[2].icon = {before={}};
	--isLineTable.txt[2].icon.before[1] = {name="vehicle2", slotColor="txtOutputTitle", settingButton=true};
	
	outputActionOpenCloseCmd[cmdTable.regName] = {output=lineTable};
end;

function outputActionOpenCloseCmd:loadAll(cmdTable, slot)	
	local lineTable = {line={}};
	lineTable.line[#lineTable.line+1] = {};
	local isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	if not slot then		
		local openPdas = moDraw.pda:getOpen();
		if #openPdas > 0 then
			isLineTable.txt[1].slotColor = "txtOutputTitle";
		else
			isLineTable.txt[1].slotColor = "settingOn";
		end;
		isLineTable.txt[1].callback = outputActionOpenCloseCmd.returnClickCloseAllPdas;
	else		
		isLineTable.txt[1].color = "txtOutputTitle";
		isLineTable.txt[1].callback = outputActionOpenCloseCmd.returnClickCloseAllSlots;
	end;
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(cmdTable.displayName);	
	outputActionOpenCloseCmd[cmdTable.regName] = {output=lineTable};
end;

function outputActionOpenCloseCmd.returnClickButtonUp(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.whichSlot == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		--print("click button up")
	end;
end;

function outputActionOpenCloseCmd.returnClickButtonDown(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.whichSlot == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		--print("click button down")
	end;
end;

function outputActionOpenCloseCmd.returnClickOpenCloseSlot(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.whichSlot == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moCmd.openCloseSlot( args );
	end;
end;

function outputActionOpenCloseCmd.returnClickOpenClosePda(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil or args.ownTable.whichPda == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moCmd.openClosePda( args );
	end;
end;

function outputActionOpenCloseCmd.returnClickCloseAllSlots(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moCmd.closeAllSlots();
	end;
end;

function outputActionOpenCloseCmd.returnClickCloseAllPdas(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moCmd.closeAllPdas();
	end;
end;

function outputActionOpenCloseCmd.giveOutputTable(args)	
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.ownTable == nil then return;end;	
	if args.cmdTable.ownTable.whichSlot ~= nil and moSetGetOverlays.slot[args.cmdTable.ownTable.whichSlot] ~= nil then
		outputActionOpenCloseCmd:loadOne(args.cmdTable, true);
		return outputActionOpenCloseCmd[args.cmdTable.regName].output;
	elseif args.cmdTable.ownTable.whichPda ~= nil and moSetGetOverlays.pda[args.cmdTable.ownTable.whichPda] ~= nil then
		outputActionOpenCloseCmd:loadOne(args.cmdTable, false);
		return outputActionOpenCloseCmd[args.cmdTable.regName].output;
	elseif args.cmdTable.ownTable.closeAll ~= nil then
		if args.cmdTable.ownTable.closeAll == "slots" then
			outputActionOpenCloseCmd:loadAll(args.cmdTable, true);
			return outputActionOpenCloseCmd[args.cmdTable.regName].output;
		elseif args.cmdTable.ownTable.closeAll == "pdas" then
			outputActionOpenCloseCmd:loadAll(args.cmdTable, false);
			return outputActionOpenCloseCmd[args.cmdTable.regName].output;
		end;
	end;		
end;