moDraw.light = {};
source(MultiOverlayV4.modDir.."scripte/draw/light/moDrawInfoBar.lua");
source(MultiOverlayV4.modDir.."scripte/draw/menue/moDrawLightSettings.lua");

function moDraw.light:setOpenDraw()
	if not moGeneralSettings.pdaType.light then return;end;
	if moSetGetOverlaysLight.default.setting.on then
		moDrawLightSettings:setOpen();
	end;
	moGeneralSettings.clickAreas.lightMaster = {};
	moGeneralSettings.clickAreas.lightPda = {};
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	moSetGetOverlaysLight.default.masterPda.background:render();	
	local overlay = moSetGetOverlaysLight.default.masterPda.background;
	if not disableClickArea then moDraw.light:clickAreas(true, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="masterPda"});end;
	if not g_currentMission.hl.dragDrop.on and g_currentMission.hl.isMouseCursor then
		moSetGetOverlaysLight.default.masterPda.buttonLeft:render();
		overlay = moSetGetOverlaysLight.default.masterPda.buttonLeft;
		if not disableClickArea then moDraw.light:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="masterPda", whereClick="buttonLeft_"});end;
		moSetGetOverlaysLight.default.masterPda.buttonSetting:render();
		overlay = moSetGetOverlaysLight.default.masterPda.buttonSetting;
		if not disableClickArea then moDraw.light:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="masterPda", whereClick="buttonSetting_"});end;
	end;	
	local maxIconWidth = moSetGetOverlaysLight:getMasterPdaMaxViewApps();
	moGeneralSettings.testString[1] = "maxIcons: ".. tostring(maxIconWidth);
	moGeneralSettings.testString[2] = "bounds1: ".. tostring(moSetGetOverlaysLight.default.masterPda.bounds[1])
	moGeneralSettings.testString[3] = "bounds2: ".. tostring(moSetGetOverlaysLight.default.masterPda.bounds[2])
	moGeneralSettings.testString[4] = "maxViewApps bounds3: ".. tostring(moSetGetOverlaysLight.default.masterPda.bounds[3])
	moGeneralSettings.testString[5] = "visibleApps bounds4: ".. tostring(moSetGetOverlaysLight.default.masterPda.bounds[4])	
	local optiSize = moSetGetOverlaysLight.default.masterPda.optiHeightSize;
	local viewApps = 0;
	local leftPosX = moSetGetOverlaysLight.default.masterPda.buttonLeft.x+moSetGetOverlaysLight.default.masterPda.buttonLeft.width;	
	for app=1, #moSetGetOverlaysLight.default.masterPda.app do
		if moSetGetOverlaysLight.default.masterPda.app[app].view then
			overlay = moSetGetOverlaysLight.default.masterPda.app[app];
			g_currentMission.hl.setOverlay(overlay, leftPosX+(moSetGetOverlaysLight.default.masterPda.appWidth*(viewApps)));			
			local iconColor = g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.default, true);
			local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height});
			function setIconColor()
				if moSetGetOverlays[moSetGetOverlaysLight.default.masterPda.appOrder[app][4]] ~= nil and moSetGetOverlays[moSetGetOverlaysLight.default.masterPda.appOrder[app][4]][moSetGetOverlaysLight.default.masterPda.appOrder[app][3]] ~= nil then
					local slotPdaTable = moSetGetOverlays[moSetGetOverlaysLight.default.masterPda.appOrder[app][4]][moSetGetOverlaysLight.default.masterPda.appOrder[app][3]];
					if not slotPdaTable.isOpen then
						moDraw["infoBar"]:setMasterPda(overlay, disableClickArea, moSetGetOverlaysLight.default.masterPda.appOrder[app]);						
					end;
					if isInArea then 
						iconColor = g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.select, true);
					elseif slotPdaTable.isOpen then
						iconColor = g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.open, true);						
					end;
				else
					if isInArea then iconColor = g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.selectInactive, true);else iconColor = g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.inactive, true);end;
				end;
			end;
			setIconColor();
			if app == moSetGetOverlaysLight.default.masterPda.selectApp and (moSetGetOverlaysLight.default.keyInteraction) then
				g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.masterPda.appSelect, overlay.x, nil, overlay.width);
				moSetGetOverlaysLight.default.masterPda.appSelect:render();
			end;			
			g_currentMission.hl.setBackgroundColor(overlay, iconColor);
			overlay:render();
			if moSetGetOverlaysLight.default.masterPda.appOrder[app][4] == "pda" or moSetGetOverlaysLight.default.masterPda.appOrder[app][4] == "cmd" then
				local txt = tostring(moSetGetOverlaysLight.default.masterPda.appOrder[app][4]:upper());
				optiSize = g_currentMission.hl.optiWidthSize(overlay.width, txt, optiSize-0.004)
				local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
				setTextBold(true);	
				setTextColor(unpack(iconColor));
				renderText(overlay.x+(overlay.width/2)-(txtWidth/2), overlay.y+overlay.height-0.002, optiSize, txt);
			end;
			if not disableClickArea then moDraw.light:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="masterPda", whereClick="appIcon_", app=app});end;
			viewApps = viewApps+1;
		end;
	end;
	setTextBold(false);	
	setTextColor(1, 1, 1, 1);
end;

function moDraw.light:getIconSelectColor(disableClickArea, value)
	if disableClickArea then return false;end;
	return g_currentMission.hl.mouseIsInArea(MultiOverlayV4.mouseCursor.posX, MultiOverlayV4.mouseCursor.posY, unpack(value))
end;

function moDraw.light:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.lightMaster[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;			
		};
	else	
		if moGeneralSettings.clickAreas.lightPda[args.whatClick] == nil then moGeneralSettings.clickAreas.lightPda[args.whatClick] = {};end;
		moGeneralSettings.clickAreas.lightPda[args.whatClick][#moGeneralSettings.clickAreas.lightPda[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1			
			mouseClick = "";
			whatClick = args.whatClick;			
			whereClick = args.whereClick;			
			app = args.app;
		};		
	end;
end;