moDrawLightSettings = {};

function moDrawLightSettings:setOpen()
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	moGeneralSettings.clickAreas.lightSetting = {};
	moGeneralSettings.clickAreas.lightSettingPda = {};
	if disableClickArea or moSetGetOverlaysLight.default.setting.typ:len() == 0 or moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ] == nil or g_currentMission.hlGui.menue.isOpen then moSetGetOverlaysLight.default.setting.on = false;return;end;
	local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
	if lightTyp.appOrder == nil or #lightTyp.appOrder <= 0 then 
		moSetGetOverlaysLight.default.setting.on = false;
		g_currentMission.hl.addTextDisplay( {txt="!! AppOrder missing !!\nLight Pda/Slot have incorrect values", txtBold=true, duration=4, warning=true} );
		return;
	end;
	if moSetGetOverlaysLight.default.setting.selectApp > #lightTyp.appOrder then moSetGetOverlaysLight.default.setting.selectApp = 0;end;
	local isMasterPda = moSetGetOverlaysLight.default.setting.typ == "masterPda";
	local edgeWidth = 2;
	local edgeHeight = 3;
	local maxAppWidth = 10;
	local overlay = moSetGetOverlaysLight.default.setting.background;
	local width = lightTyp.appWidth*(maxAppWidth+edgeWidth);
	local height = lightTyp.appHeight*(math.floor((#lightTyp.appOrder/maxAppWidth)+0.5)+edgeHeight);
	g_currentMission.hl.setOverlay(overlay, 0.5-(width/2), 0.5, width, height);
	overlay:render();
	if not disableClickArea then moDrawLightSettings:clickAreas(true, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="lightSettingPda"});end;
	local tempOverlay = moSetGetOverlaysLight.default.setting.buttonClose;
	g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-(tempOverlay.width), overlay.y+overlay.height-(tempOverlay.height));
	tempOverlay:render();
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="buttonClose_"});end;
	
	local optiSize = moSetGetOverlaysLight.default.masterPda.optiHeightSize;
	local posX = overlay.x;
	local firstPosX = posX;
	local posY = overlay.y+overlay.height-(lightTyp.appHeight*(edgeHeight/2));
	local iconColor = lightTyp.color.default;
	local txtSeperatorWidth = getTextWidth(optiSize, utf8Substr("|", 0));
	local txt = "AutoWidth OFF";
	local color = lightTyp.color.inactive;
	local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
	if isMasterPda then if lightTyp.autoWidth then color = "green";txt = "AutoWidth ON";else color = lightTyp.color.default;end;end;	
	local txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));	
	setTextBold(true);	
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));		
	local txtPosX = overlay.x+lightTyp.appWidth;
	local txtPosY = overlay.y+(lightTyp.appHeight/4)
	renderText(txtPosX, txtPosY, optiSize, txt);
	if not disableClickArea and isMasterPda then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, txtPosY, txtPosY+txtHeight, whatClick="lightSettingPda", whereClick="autoWidthOnOff_"});end;
	
	color = "green";
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX+txtWidth+(lightTyp.appWidth/2), txtPosY, optiSize, "|");
	txt = "Min. view Apps ".. tostring(lightTyp.minViewApps);
	if lightTyp.autoWidth then color = lightTyp.color.inactive;txt = "Min. view Apps ".. tostring(moSetGetOverlaysLight.default.limitMinViewApps);end;
	txtPosX = txtPosX+txtWidth+lightTyp.appWidth;	
	txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));	
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX, txtPosY, optiSize, txt);
	if not disableClickArea and not lightTyp.autoWidth then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, txtPosY, txtPosY+txtHeight, whatClick="lightSettingPda", whereClick="minViewApps_"});end;	
	if moSetGetOverlaysLight.default.setting.selectApp ~= 0 then
		local appOrder = lightTyp.appOrder[moSetGetOverlaysLight.default.setting.selectApp];
		local tempPosX = overlay.x+lightTyp.appWidth;
		---
		tempOverlay = moSetGetOverlaysLight.default.setting.buttonView;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+lightTyp.appHeight);
		if appOrder[2] then color = lightTyp.color.select;else color = "red";end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "View";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;
		txtPosY = tempOverlay.y+(tempOverlay.height/2)-(txtHeight/2);
		color = lightTyp.color.open;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appView_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		txtPosX = txtPosX+txtWidth+0.001;
		color = lightTyp.color.inactive;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, "|");		
		---
		tempPosX = txtPosX+txtSeperatorWidth+0.001;
		tempOverlay = moSetGetOverlaysLight.default.setting.buttonLeftRight;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+lightTyp.appHeight);
		color = lightTyp.color.open;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "Pos ".. tostring(moSetGetOverlaysLight.default.setting.selectApp);
		txtWidth = getTextWidth(optiSize, utf8Substr("Pos 99", 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appLeftRight_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		txtPosX = txtPosX+txtWidth+0.001;
		color = lightTyp.color.inactive;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, "|");
		---
		tempPosX = txtPosX+txtSeperatorWidth+0.001;		
		tempOverlay = moSetGetOverlaysLight.default.setting.buttonAutoClose;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+lightTyp.appHeight);
		color = lightTyp.color.inactive;
		if appOrder[4] ~= "cmd" then
			if appOrder[5] then color = lightTyp.color.select;else color = "red";end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "AutoClose";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		if color == lightTyp.color.select or color == "red" then color = lightTyp.color.open;end;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea and appOrder[4] ~= "cmd" then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appAutoClose_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		if appOrder[4] == "cmd" then
			local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, overlay.y, tempOverlay.y+tempOverlay.height});
			if isInArea and #g_currentMission.hl.textDisplay == 0 then g_currentMission.hl.addTextDisplay( {txt="For Cmd AppIcons not available", txtBold=true, duration=3, warning=true} );end;
		end;
		txtPosX = txtPosX+txtWidth+0.001;
		color = lightTyp.color.inactive;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, "|");
		---
		tempPosX = txtPosX+txtSeperatorWidth+0.001;	
		tempOverlay = moSetGetOverlaysLight.default.setting.buttonInfoBar;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+lightTyp.appHeight);
		color = lightTyp.color.inactive;
		if appOrder[4] == "slot" and appOrder[6][1] ~= nil then
			if appOrder[6][1] then color = lightTyp.color.select;else color = "red";end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "InfoBar";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		if color == lightTyp.color.select or color == "red" then color = lightTyp.color.open;end;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea and appOrder[4] == "slot" and appOrder[6][1] ~= nil then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appInfoBar_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		if appOrder[6][1] == nil then
			local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, overlay.y, tempOverlay.y+tempOverlay.height});
			if isInArea and #g_currentMission.hl.textDisplay == 0 then g_currentMission.hl.addTextDisplay( {txt="Not Installed for this AppIcon", txtBold=true, duration=3, warning=true} );end;
		end;
		---
		
	end;
	setTextBold(false);		
	setTextColor(1, 1, 1, 1);
	local appPos = 1;
	for app=1, #lightTyp.appOrder do
		overlay = lightTyp.app[app];
		if overlay ~= nil then
			local oldPosY = overlay.y
			g_currentMission.hl.setOverlay(overlay, posX+(lightTyp.appWidth*(appPos)), posY);			
			if lightTyp.appOrder[app][2] then iconColor = lightTyp.color.default;else iconColor = lightTyp.color.inactive;end;
			local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height});
			if app == moSetGetOverlaysLight.default.setting.selectApp then iconColor = moSetGetOverlaysLight.default.masterPda.color.open;end;
			if isInArea then iconColor = moSetGetOverlaysLight.default.masterPda.color.select;end;
			g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(iconColor, true));
			overlay:render();
			if not disableClickArea then moDrawLightSettings:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="lightSettingPda", whereClick="appIcon_", app=app});end;
			setTextColor(unpack(g_currentMission.hl.getColor(iconColor, true)));
			txt = tostring(lightTyp.appOrder[app][4]:upper());
			txtWidth = getTextWidth(optiSize-0.004, utf8Substr(txt, 0));
			renderText(overlay.x+(overlay.width/2)-(txtWidth/2), overlay.y+overlay.height+0.001, optiSize-0.004, txt);			
			g_currentMission.hl.setOverlay(overlay, nil, oldPosY);
			
			
			
			appPos = appPos+1;
			if appPos > maxAppWidth then appPos = 1;posX = firstPosX;posY = posY-(lightTyp.appHeight*1.5);end;
		end;
	end;
end;

function moDrawLightSettings:setOpenOld()
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	moGeneralSettings.clickAreas.lightSetting = {};
	moGeneralSettings.clickAreas.lightSettingPda = {};
	if disableClickArea or moSetGetOverlaysLight.default.setting.typ:len() == 0 or moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ] == nil or g_currentMission.hlGui.menue.isOpen then moSetGetOverlaysLight.default.setting.on = false;return;end;
	local lightTyp = moSetGetOverlaysLight.default[moSetGetOverlaysLight.default.setting.typ];
	if lightTyp.appOrder == nil or #lightTyp.appOrder <= 0 then 
		moSetGetOverlaysLight.default.setting.on = false;
		g_currentMission.hl.addTextDisplay( {txt="!! AppOrder missing !!\nLight Pda/Slot have incorrect values", txtBold=true, duration=4, warning=true} );
		return;
	end;
	local overlay = moSetGetOverlaysLight.default.setting.background;
	local width = lightTyp.appWidth*(#lightTyp.appOrder+2);
	local height = lightTyp.appHeight*4;
	g_currentMission.hl.setOverlay(overlay, 0.5-(width/2), 0.5, width, height);
	overlay:render();	
	if not disableClickArea then moDrawLightSettings:clickAreas(true, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="lightSettingPda"});end;
	local tempOverlay = moSetGetOverlaysLight.default.setting.buttonClose;
	g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-(tempOverlay.width), overlay.y+overlay.height-(tempOverlay.height));
	tempOverlay:render();
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="buttonClose_"});end;
	local leftPosX = overlay.x;
	local posY = overlay.y+overlay.height-(lightTyp.appHeight*2);
	local iconColor = lightTyp.color.default;	
		
	local txt = "Auto Width OFF";
	local color = lightTyp.color.default;
	if lightTyp.autoWidth then color = "green";txt = "Auto Width ON";end;
	local optiSize = g_currentMission.hl.optiHeightSize(lightTyp.appHeight/2, txt, 0.013);
	local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
	local txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));	
	setTextBold(true);	
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));		
	local txtPosX = overlay.x+lightTyp.appWidth;
	local txtPosY = overlay.y+(lightTyp.appHeight/4)
	renderText(txtPosX, txtPosY, optiSize, txt);
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, txtPosY, txtPosY+txtHeight, whatClick="lightSettingPda", whereClick="autoWidthOnOff_"});end;
	color = lightTyp.color.inactive;
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX+txtWidth+(lightTyp.appWidth/2), txtPosY, optiSize, "|");
	txt = "Min. view Apps ".. tostring(lightTyp.minViewApps);
	txtPosX = txtPosX+txtWidth+lightTyp.appWidth;	
	if lightTyp.autoWidth then color = "green";end;
	txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX, txtPosY, optiSize, txt);
	if not disableClickArea and lightTyp.autoWidth then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, txtPosY, txtPosY+txtHeight, whatClick="lightSettingPda", whereClick="minViewApps_"});end;
	setTextBold(false);		
	setTextColor(1, 1, 1, 1);
	
	for app=1, #lightTyp.appOrder do
		overlay = lightTyp.app[app];
		if overlay ~= nil then
			local oldPosY = overlay.y
			g_currentMission.hl.setOverlay(overlay, leftPosX+(lightTyp.appWidth*(app)), posY);			
			if lightTyp.appOrder[app][2] then iconColor = lightTyp.color.default;else iconColor = lightTyp.color.inactive;end;
			g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(iconColor, true));
			overlay:render();
			if not disableClickArea then moDrawLightSettings:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="lightSettingPda", whereClick="appIcon_", app=app});end;
			tempOverlay = moSetGetOverlaysLight.default.setting.buttonLeftRight;
			g_currentMission.hl.setOverlay(tempOverlay, overlay.x+(overlay.width/2)-(tempOverlay.width/2), overlay.y-(lightTyp.appHeight/2));
			tempOverlay:render();
			if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appLeftRight_", app=app});end;
			
			tempOverlay = moSetGetOverlaysLight.default.setting.buttonAutoClose;
			g_currentMission.hl.setOverlay(tempOverlay, overlay.x+(overlay.width/2)-(tempOverlay.width/2), overlay.y-(lightTyp.appHeight));
			if lightTyp.appOrder[app][5] then iconColor = "green";else iconColor = "red";end;
			g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(iconColor, true));
			tempOverlay:render();
			if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appAutoClose_", app=app});end;
			
			g_currentMission.hl.setOverlay(overlay, nil, oldPosY);
			if lightTyp.appOrder[app][6][1] ~= nil then
				tempOverlay = moSetGetOverlaysLight.default.masterPda.appInfoBar;				
				oldPosY = tempOverlay.y;
				g_currentMission.hl.setOverlay(tempOverlay, overlay.x, posY+lightTyp.appHeight);
				if lightTyp.appOrder[app][6][1] then iconColor = lightTyp.color.default;else iconColor = lightTyp.color.inactive;end;
				g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(iconColor, true));
				tempOverlay:render();
				if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appInfoBar_", app=app});end;
				g_currentMission.hl.setOverlay(tempOverlay, nil, oldPosY);
			end;			
		end;
	end;	
end;

function moDrawLightSettings:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.lightSetting[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;			
		};
	else	
		if moGeneralSettings.clickAreas.lightSettingPda[args.whatClick] == nil then moGeneralSettings.clickAreas.lightSettingPda[args.whatClick] = {};end;
		moGeneralSettings.clickAreas.lightSettingPda[args.whatClick][#moGeneralSettings.clickAreas.lightSettingPda[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1			
			mouseClick = "";
			whatClick = args.whatClick;			
			whereClick = args.whereClick;			
			app = args.app;
		};		
	end;
end;