moSetGetDraw = {};
source(MultiOverlayV4.modDir.."scripte/draw/menue/moDrawCmdSetting.lua");
source(MultiOverlayV4.modDir.."scripte/draw/menue/moDrawAppIconSetting.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawDigiClock.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawDigiMoney.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawTimeScale.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawTime.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawRealDate.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawPlayDays.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawWeather.lua");
source(MultiOverlayV4.modDir.."scripte/draw/moDragDrop.lua");
source(MultiOverlayV4.modDir.."scripte/draw/moDrawInfoHelpBox.lua");
source(MultiOverlayV4.modDir.."scripte/draw/moDrawSmallView.lua");
source(MultiOverlayV4.modDir.."scripte/draw/moDrawMiniMapState.lua");
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawOtherMods.lua");

function moSetGetDraw:setLineHorizontal(line, x, y, width, height, setColor)
	g_currentMission.hl.setOverlay(line, x, y, width, height);
	local color = MultiOverlayV4:get_hl("getColor", {"black", true}, "moSetGetDraw:setLineHorizontal");
	if setColor ~= nil then color = MultiOverlayV4:get_hl("getColor", {tostring(setColor), true}, "moSetGetDraw:setLineHorizontal");end;
	g_currentMission.hl.setBackgroundColor(line, color);	
	local xPixel = moSetGetOverlays.buttonGfxWidth1;
	local yPixel = moSetGetOverlays.buttonGfxHeight1;
	renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY-yPixel, line.width+2*xPixel, yPixel);
end;

function moSetGetDraw:setLineVertical(line, x, y, width, height, setColor)
	g_currentMission.hl.setOverlay(line, x, y, width, height);
	local color = MultiOverlayV4:get_hl("getColor", {"black", true}, "moSetGetDraw:setLineVertical");
	if setColor ~= nil then color = MultiOverlayV4:get_hl("getColor", {tostring(setColor), true}, "moSetGetDraw:setLineVertical");end;
	g_currentMission.hl.setBackgroundColor(line, color);	
	local xPixel = moSetGetOverlays.buttonGfxWidth1;
	local yPixel = moSetGetOverlays.buttonGfxHeight1;
	renderOverlay(line.overlayId, line.x+line.offsetX-xPixel+line.width, line.y+line.offsetY, xPixel, line.height);
end;

function moSetGetDraw:setLineBorder(line, referenceOverlay, length, fat, up, down, left, right, setColor, alignment)	
	local color = MultiOverlayV4:get_hl("getColor", {"black", true}, "moSetGetDraw:setLineBorder");
	if setColor ~= nil then color = MultiOverlayV4:get_hl("getColor", {tostring(setColor), true}, "moSetGetDraw:setLineBorder");end;
	g_currentMission.hl.setBackgroundColor(line, color);	
	
	--line.debugEnabled = true;		
	local xPixel = moSetGetOverlays.buttonGfxWidth1;
	local yPixel = moSetGetOverlays.buttonGfxHeight1;
	local tempLengthW = xPixel*length;
	local tempLengthH = yPixel*length;	
	
	if up then 
		if alignment == nil or alignment == 0 then --left pos
			g_currentMission.hl.setOverlay(line, referenceOverlay.x, referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 1 then --middle pos
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+(referenceOverlay.width/2)-((referenceOverlay.width/length-(fat/2))/2), referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 2 then --right pos
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+referenceOverlay.width-(referenceOverlay.width/length-(fat/2)), referenceOverlay.y+referenceOverlay.height-(fat/2), referenceOverlay.width/length-(fat/2), fat);
		end;
		line:render();
		--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY-yPixel, line.width+2*xPixel, yPixel);
	end;		
	
	if down then 
		if alignment == nil or alignment == 0 then
			g_currentMission.hl.setOverlay(line, referenceOverlay.x, referenceOverlay.y, referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 1 then
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+(referenceOverlay.width/2)-(referenceOverlay.width/length-(fat/2)/2), referenceOverlay.y, referenceOverlay.width/length-(fat/2), fat);
		elseif alignment == 2 then
			g_currentMission.hl.setOverlay(line, referenceOverlay.x+referenceOverlay.width-referenceOverlay.width/length-(fat/2), referenceOverlay.y, referenceOverlay.width/length-(fat/2), fat);
		end;
		line:render();
		--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY-yPixel, line.width+2*xPixel, yPixel);
	end;	
		
	if left then g_currentMission.hl.setOverlay(line, referenceOverlay.x, referenceOverlay.y, fat, referenceOverlay.height/length);
		line:render();
	--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel, line.y+line.offsetY, xPixel, line.height);
	end;
		
	
	if right then g_currentMission.hl.setOverlay(line, referenceOverlay.x+referenceOverlay.width-(fat/2), referenceOverlay.y, fat, referenceOverlay.height/length);
		line:render();
		--renderOverlay(line.overlayId, line.x+line.offsetX-xPixel+line.width, line.y+line.offsetY, xPixel, line.height);
	end;	
end;

function moSetGetDraw:setFormatIconTxt(whatTable, overlay)
	if overlay == nil or whatTable == nil then return nil;end;
	local iconFormatTxt = {};
	for a=1, #overlay.txt do
		if overlay.txt[a] ~= nil then
			if overlay.txt[a].txt ~= nil or utf8Strlen(utf8Substr(txt, 0)) > 0 then
				local txt = utf8Substr(overlay.txt[a].txt, 0);
				local optiSize = whatTable.appOptiSizeTxtHeight;
				local optiSizeHalf = whatTable.appOptiSizeHalfTxtHeight;
				local sizeDif = 0;
				if overlay.txt[a].sizeDif ~= nil then sizeDif = overlay.txt[a].sizeDif;end;
				local color = g_currentMission.hl.getColor(whatTable.color.txt, true);				
				if overlay.txt[a].color ~= nil then color = g_currentMission.hl.getColor(overlay.txt[a].color, true);end;
				if overlay.txt[a].widthLimit then
					if overlay.iconType == 3 then 
						txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, overelay.width, "..", whatTable.txtWidthFix);
					elseif overlay.iconType == 0 then
						if a == 1 then
							if overlay.txt[a+1] == nil then
								txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSize, overelay.width, "..", whatTable.txtWidthFix);
							else
								txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSizeHalf, overelay.width, "..", whatTable.txtWidthFix);
							end;
						else
							txt = g_currentMission.hl.getTxtToWidthFix(txt, optiSizeHalf, overelay.width, "..", whatTable.txtWidthFix);
						end;
					end;
				end;				
				if overlay.txt[a].optiWidthSize then 
					optiSize = g_currentMission.hl.optiWidthSize(overlay.width, txt, optiSize);
					optiSizeHalf = g_currentMission.hl.optiWidthSize(overlay.width, txt, optiSizeHalf);
				end;
				optiSize = optiSize-sizeDif;
				optiSizeHalf = optiSizeHalf-sizeDif;
				local txtHeight = getTextHeight(optiSize, txt);
				local txtHeightHalf = getTextHeight(optiSizeHalf, txt);
				iconFormatTxt[a] = {run=true, txt=txt, color=color, bold=overlay.txt[a].bold};
				if overlay.iconType == 3 then					
					iconFormatTxt[a].size = optiSize;
					if overlay.txt[a].centerW then
						iconFormatTxt[a].x = overlay.x;
					else
						local txtWidth = getTextWidth(optiSize, txt);
						iconFormatTxt[a].x = overlay.x+(overlay.width/2)-(txtWidth/2);
					end;
					if overlay.txt[a].centerH then
						iconFormatTxt[a].y = overlay.y+(overlay.height/2)-(txtHeight/2);
					else
						iconFormatTxt[a].y = overlay.y;
					end;
				elseif overlay.iconType == 0 then
					if a == 1 then						
						if overlay.txt[a+1] == nil then
							iconFormatTxt[a].size = optiSize;
							if overlay.txt[a].centerW then
								local txtWidth = getTextWidth(optiSize, txt);
								iconFormatTxt[a].x = overlay.x+(overlay.width/2)-(txtWidth/2);
							else
								iconFormatTxt[a].x = overlay.x;
							end;							
							if overlay.txt[a].centerH then							
								iconFormatTxt[a].y = overlay.y+(overlay.height/2)-(txtHeight/2);
							else
								iconFormatTxt[a].y = overlay.y;
							end;
						else
							iconFormatTxt[a].size = optiSizeHalf;
							if overlay.txt[a].centerW then
								local txtWidth = getTextWidth(optiSizeHalf, txt);
								iconFormatTxt[a].x = overlay.x+(overlay.width/2)-(txtWidth/2);
							else
								iconFormatTxt[a].x = overlay.x;
							end;
							if overlay.txt[a].centerH then							
								iconFormatTxt[a].y = overlay.y+(overlay.height/1.5)-(txtHeightHalf/2);
							else
								iconFormatTxt[a].y = overlay.y+(overlay.height/2);
							end;
						end;
					else
						iconFormatTxt[a].size = optiSizeHalf;
						if overlay.txt[a].centerW then
							local txtWidth = getTextWidth(optiSizeHalf, txt);
							iconFormatTxt[a].x = overlay.x+(overlay.width/2)-(txtWidth/2);
						else
							iconFormatTxt[a].x = overlay.x;
						end;
						if overlay.txt[a].centerH then							
							iconFormatTxt[a].y = overlay.y+(overlay.height/3)-(txtHeightHalf/2);
						else
							iconFormatTxt[a].y = overlay.y;
						end;
					end;
				end;
			else
				iconFormatTxt[a] = {run=false};	
			end;
		end;	
	end;
	overlay.isFormatTxt = true;
	if #iconFormatTxt > 0 then		
		overlay.iconFormatTxt = iconFormatTxt;
		return true;
	end;
	return nil;	
end;

function moSetGetDraw:getMaxWidth(maxWidth, iconWidth)
	local maxWidth = math.floor(maxWidth/iconWidth, -0.5);	
	return maxWidth;
end;

function moSetGetDraw:getMaxHeight(maxHeight, iconHeight)	
	local maxHeight = math.floor(maxHeight/iconHeight, -0.5);	
	return maxHeight;
end;

function moSetGetDraw:closeAllMenues()
	moHlGuiCmdSetting:setClose();
	moHlGuiAppIconSetting:setClose();
end;