moDraw.digi_clock = {};

function moDraw.digi_clock.onOpen(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	if args.overlay.isFormatTxt ~= nil then 		
		args.overlay.colorState = g_currentMission.hl.getColor("gray", true);
		args.overlay.isFormatTxt = nil;
	end;
end;

function moDraw.digi_clock.setOpen(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	
	local digiClockIcons = moDraw.digi_clock:getDigiClock(g_currentMission.environment.dayTime, args.overlay.ownValue == "getHour", args.overlay.ownValue == "getMin", args.overlay.ownValue == "getSec");
	if digiClockIcons ~= nil and moSetGetOverlays.icons["MultiOverlayV4"]["digiclock"] ~= nil then
		local pdaTable = moSetGetOverlays.pda[args.whichPda];
		local digiOverlay = moSetGetOverlays.icons["MultiOverlayV4"]["digiclock"];
		if args.overlay.ownValue == "getHour" then											
			for _, icon in pairs(digiClockIcons.hours[1]) do
				g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
				digiOverlay[icon]:render();
				digiOverlay[icon]:render();
			end;
			for _, icon in pairs(digiClockIcons.hours[2]) do
				g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
				digiOverlay[icon]:render();
				digiOverlay[icon]:render();
			end;
		end;										
		if args.overlay.ownValue == "getMin" then
			g_currentMission.hl.setOverlay(digiOverlay[2], args.overlay.x-(args.overlay.width/2)-(moSetGetOverlays.buttonGfxWidth1*pdaTable.distanceAppIconWidth/2), args.overlay.y, args.overlay.width, args.overlay.height);
			digiOverlay[2]:render();
			for _, icon in pairs(digiClockIcons.minutes[1]) do
				g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
				digiOverlay[icon]:render();
				digiOverlay[icon]:render();
			end;
			for _, icon in pairs(digiClockIcons.minutes[2]) do
				g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
				digiOverlay[icon]:render();
				digiOverlay[icon]:render();
			end;			
		end;
		if args.overlay.ownValue == "getSec" then
			g_currentMission.hl.setOverlay(digiOverlay[2], args.overlay.x-(args.overlay.width/2)-(moSetGetOverlays.buttonGfxWidth1*pdaTable.distanceAppIconWidth/2), args.overlay.y, args.overlay.width, args.overlay.height);
			digiOverlay[2]:render();
			for _, icon in pairs(digiClockIcons.seconds[1]) do
				g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
				digiOverlay[icon]:render();
				digiOverlay[icon]:render();
			end;
			for _, icon in pairs(digiClockIcons.seconds[2]) do
				g_currentMission.hl.setOverlay(digiOverlay[icon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
				digiOverlay[icon]:render();
				digiOverlay[icon]:render();
			end;
		end;
	end;
	
end;

---MultiOverlayV3---
function moDraw.digi_clock:getDigiClock(sMilliSeconds, getHour, getMin, getSec)	
	local digiClock = {hours={[1]={},[2]={}},minutes={[1]={},[2]={}},seconds={[1]={},[2]={}}};
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == 0 then	
		return nil;
	end;	
	local nHours = string.format("%02.f", math.floor(nMilliSeconds/3600000));
	local nMins = string.format("%02.f", math.floor(nMilliSeconds/60000 - (nHours*60)));	
	local nSecs = string.format("%02.f", math.floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));		
	local fInt = {};
	fInt[0]={3,4,5,6,7,8};fInt[1]={4,5};fInt[2]={3,4,6,7,9};fInt[3]={3,4,5,6,9};fInt[4]={4,5,8,9};fInt[5]={3,5,6,8,9};fInt[6]={3,5,6,7,8,9};fInt[7]={3,4,5,8};fInt[8]={3,4,5,6,7,8,9};fInt[9]={3,4,5,6,8,9};
	local eInt = {}
	eInt[0]={10,11,12,13,14,15};eInt[1]={11,12};eInt[2]={10,11,13,14,16};eInt[3]={10,11,12,13,16};eInt[4]={11,12,15,16};eInt[5]={10,12,13,15,16};eInt[6]={10,12,13,14,15,16};eInt[7]={10,11,12,15};eInt[8]={10,11,12,13,14,15,16};eInt[9]={10,11,12,13,15,16};
	if getHour then
		local hour1 = tonumber(string.sub(nHours, 1, 1));
		local hour2 = tonumber(string.sub(nHours, 2, 2));			
		if hour1 > 0 then digiClock.hours[1] = fInt[hour1];end;
		digiClock.hours[2] = eInt[hour2];			
	end;
	if getMin then
		local mins1 = tonumber(string.sub(nMins, 1, 1));
		local mins2 = tonumber(string.sub(nMins, 2, 2));
		digiClock.minutes[1] = fInt[mins1];
		digiClock.minutes[2] = eInt[mins2];			
	end;
	if getSec then
		local sec1 = tonumber(string.sub(nSecs, 1, 1));
		local sec2 = tonumber(string.sub(nSecs, 2, 2));
		digiClock.seconds[1] = fInt[sec1];
		digiClock.seconds[2] = eInt[sec2];			
	end;		
	return digiClock;	
end;
---MultiOverlayV3---