moDraw.pda= {};
source(MultiOverlayV4.modDir.."scripte/draw/pda/moDrawPda_Typ1.lua");

function moDraw.pda:setOpenDraw(whichPda)
	local whichSubPda = whichPda or "dummyPda_";
	if moSetGetOverlays.pda[whichSubPda] == nil then return;end;	
	local pdaTable = moSetGetOverlays.pda[whichSubPda];
	if pdaTable.typ == 1 then
		if #pdaTable.setting.openCallback > 0 then
			for a=1, #pdaTable.setting.openCallback do
				if type(pdaTable.setting.openCallback[a]) == "function" then
					pdaTable.setting.openCallback[a]( {whichPda=whichSubPda} );
				end;
			end;
		end;
		if not pdaTable.isOtherPda.on or (pdaTable.isOtherPda.on and pdaTable.isOtherPda.isMenue and pdaTable.isOtherPda.menueDraw == nil) then
			moDraw["pda_typ1"]:setOpen(whichSubPda, pdaTable);
		elseif pdaTable.isOtherPda.on and pdaTable.isOtherPda.otherDraw ~= nil and type(pdaTable.isOtherPda.otherDraw) == "function" then
			pdaTable.isOtherPda.otherDraw(whichSubPda, pdaTable);
		elseif pdaTable.isOtherPda.on and pdaTable.isOtherPda.isMenue and pdaTable.isOtherPda.menueDraw ~= nil and type(pdaTable.isOtherPda.menueDraw) == "function" then
			pdaTable.isOtherPda.menueDraw(whichSubPda, pdaTable);
		end;		
	end;	
end;

function moDraw.pda:getOpen(whichPda)	
	local openPdas = {};	
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then return moSetGetOverlays.pda[whichPda].isOpen;end;
		for pdaName, pdaTable in pairs(moSetGetOverlays.pda) do				
			if pdaTable.isOpen then
				openPdas[#openPdas+1] = tostring(pdaName);				
			end;
		end;		
	end;
	return openPdas;
end;

function moDraw.pda:setOpen(whichPda)		
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].isOpen = true;return true;end;					
	end;
	return false;
end;

function moDraw.pda:setClose(whichPda)		
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then			
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][whichPda] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", whichPda}, "moDraw.pda:setClose");
			end;			
			moDraw.pda:closeSetting(whichPda);moSetGetOverlays.pda[whichPda].isOpen = false;
			moDraw.pda:setCmdSettingMenue(whichPda, false);
			moDraw.pda:setAppIconSettingMenue(whichPda, {moSetGetOverlays.pda[whichPda].selectApp[1], moSetGetOverlays.pda[whichPda].selectApp[2]}, true);
			moGeneralSettings.clickAreas.pda[whichPda] = {};
			moGeneralSettings.clickAreas.masterPda[whichPda] = {};
			return true;
		end;
		moDraw.pda:setCmdSettingMenue("", true);
		moDraw.pda:setAppIconSettingMenue("", {}, true);		
		for pdaName, pdaTable in pairs(moSetGetOverlays.pda) do						
			if pdaTable.setting.canCloseAll then
				if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][pdaName] ~= nil then
					MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", pdaName}, "moDraw.pda:setClose");
				end;
				pdaTable.setting.on = false;
				pdaTable.isOpen = false;
				moGeneralSettings.clickAreas.pda[pdaName] = {};
				moGeneralSettings.clickAreas.masterPda[pdaName] = {};
			end;
		end;
		return true;
	end;
	return false;
end;

function moDraw.pda:setViewModus(whichPda)	
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then 
			if moSetGetOverlays.pda[whichPda].view.isModus == moSetGetOverlays.pda[whichPda].view.max then 
				moSetGetOverlays.pda[whichPda].view.isModus = 1;
			else
				moSetGetOverlays.pda[whichPda].view.isModus = moSetGetOverlays.pda[whichPda].view.isModus+1;
			end;		
			moSetGetPda:resetSettingLinesBounds(whichPda)
			return true;
		end;
	end;
	return false;
end;

function moDraw.pda:setSetting(whichPda)		
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].setting.on = not moSetGetOverlays.pda[whichPda].setting.on;return true;end;		
	end;
	return false;
end;

function moDraw.pda:setSettingMoveUpDown(whichPda)		
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].setting.up = not moSetGetOverlays.pda[whichPda].setting.up;return true;end;		
	end;
	return false;
end;

function moDraw.pda:setSettingExtraLine(whichPda)	
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].setting.extraLine = not moSetGetOverlays.pda[whichPda].setting.extraLine;return true;end;
	end;
	return false;
end;

function moDraw.pda:setSettingInfoLine(whichPda)		
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].setting.infoLine = not moSetGetOverlays.pda[whichPda].setting.infoLine;return true;end;		
	end;
	return false;
end;

function moDraw.pda:setSettingModLine(whichPda)		
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].setting.modLine = not moSetGetOverlays.pda[whichPda].setting.modLine;return true;end;		
	end;
	return false;
end;

function moDraw.pda:closeSetting(whichPda)		
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].setting.on = false;return true;end;					
		for pdaName, pdaTable in pairs(moSetGetOverlays.pda) do			
			pdaTable.setting.on = false;			
		end;
		return true;
	end;
	return false;
end;

function moDraw.pda:setSettingDefaultLine(whichPda)	
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then moSetGetOverlays.pda[whichPda].setting.defaultLine = not moSetGetOverlays.pda[whichPda].setting.defaultLine;end;					
		if not moSetGetOverlays.pda[whichPda].setting.defaultLine then moDraw.pda:closeSetting(whichPda);end;		
		return true;
	end;
	return false;
end;

function moDraw.pda:setCmdSettingMenue(whichPda, closeAll)
	if moGeneralSettings.cmdSettingMenue.typ == "Pda" then
		if closeAll then moHlGuiCmdSetting:setClose();return;end;
		if moHlGuiCmdSetting:isOpen("Pda", whichPda) then moHlGuiCmdSetting:setClose();return;end;
	end;
end;

function moDraw.pda:setAppIconSettingMenue(whichPda, appValue, closeAll)	
	if closeAll then moHlGuiAppIconSetting:setClose();return;end;
	if moHlGuiAppIconSetting:isOpen(whichPda, appValue) then moHlGuiAppIconSetting:setClose();return;end;	
end;

function moDraw.pda:setSmallView(whichPda)	
	if moSetGetOverlays.pda ~= nil then		
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then 
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][whichPda] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", whichPda}, "moDraw.pda:setSmallView");
			end;
			moSetGetOverlays.pda[whichPda].view[moSetGetOverlays.pda[whichPda].view.isModus].isSmallView = not moSetGetOverlays.pda[whichPda].view[moSetGetOverlays.pda[whichPda].view.isModus].isSmallView
			return true;
		end;					
		for pdaName, pdaTable in pairs(moSetGetOverlays.pda) do				
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][pdaName] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", pdaName}, "moDraw.pda:setSmallView");
			end;
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"]["cmdSettingMenue"] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", "cmdSettingMenue"}, "moDrawCmdSettingMenue:setOpen");
			end;
			for a=1, pdaTable.view.max do
				pdaTable.view[a].isSmallView = true;
			end;					
		end;
		return true;
	end;
	return false;
end;

function moDraw.pda:setDesignColor(whichPda, overlays)
	if moSetGetOverlays.pda ~= nil then
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then
			for a=1, #overlays do
				local oR,oG,oB,oA = overlays[a].r, overlays[a].g, overlays.b, overlays.a;
				local sR,sG,sB,sA = unpack(g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.ground, true));				
				if oR ~= sR or oG ~= sG or oB ~= sB then --or oA ~= sA then 
					g_currentMission.hl.setBackgroundColor(overlays[a], {sR,sG,sB,oA});
				end;
			end;
			return true;
		end;
	end;
	return false;
end;

function moDraw.pda:setDesignGroundColor(whichPda, overlays, colorName)
	if moSetGetOverlays.pda ~= nil then
		if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then
			for a=1, #overlays do				
				local color = g_currentMission.hl.getColor(colorName, true);				
				if a == 1 then color[4] = 0.6 else color[4] = 0.8;end;
				g_currentMission.hl.setBackgroundColor(overlays[a], color);				
			end;
			return true;
		end;
	end;
	return false;
end;

function moDraw.pda.testCallback(clickAreaTable) --test callback pda iconAreaName settings
	if clickAreaTable ~= nil then		
				
	end;
end;

function moDraw.pda.iconColor(args) --setting iconAreaName onOpen callback
	if args == nil or type(args) ~= "table" or args.whichPda == nil or args.overlay == nil or args.areaName == nil then return;end;
	if moSetGetOverlays.pda[args.whichPda] ~= nil then
		local color = "";
		local whichPda = args.whichPda;
		local overlay = args.overlay;
		local iconAreaName = args.areaName;
		if overlay.iconName == "buttonLoad" then
			color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			overlay.colorState = color;
		end;		
		if iconAreaName == "buttonSeparatorHorizontal_" or iconAreaName == "buttonSeparatorVertical_" then
			color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingDefault, true);
			overlay.colorState = color;
		
		elseif iconAreaName == "pdaAppIconDistanceWidthUp_" then
			if moSetGetOverlays.pda[whichPda].distanceAppIconWidth == moSetGetOverlays.pda[whichPda].defaultDistanceAppIconWidth then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].distanceAppIconWidth < moSetGetOverlays.pda[whichPda].maxDistanceAppIconWidth then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "pdaAppIconDistanceWidthDown_" then
			if moSetGetOverlays.pda[whichPda].distanceAppIconWidth == moSetGetOverlays.pda[whichPda].defaultDistanceAppIconWidth then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].distanceAppIconWidth > moSetGetOverlays.pda[whichPda].minDistanceAppIconWidth then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "pdaAppIconDistanceHeightUp_" then
			if moSetGetOverlays.pda[whichPda].distanceAppIconHeight == moSetGetOverlays.pda[whichPda].defaultDistanceAppIconHeight then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].distanceAppIconHeight < moSetGetOverlays.pda[whichPda].maxDistanceAppIconHeight then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "pdaAppIconDistanceHeightDown_" then
			if moSetGetOverlays.pda[whichPda].distanceAppIconHeight == moSetGetOverlays.pda[whichPda].defaultDistanceAppIconHeight then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].distanceAppIconHeight > moSetGetOverlays.pda[whichPda].minDistanceAppIconHeight then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "pdaAppIconTxtWidthFixUp_" then
			if moSetGetOverlays.pda[whichPda].txtWidthFix == moSetGetOverlays.pda[whichPda].defaultTxtWidthFix then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].txtWidthFix < moSetGetOverlays.pda[whichPda].maxTxtWidthFix then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "pdaAppIconTxtWidthFixDown_" then
			if moSetGetOverlays.pda[whichPda].txtWidthFix == moSetGetOverlays.pda[whichPda].defaultTxtWidthFix then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].txtWidthFix > moSetGetOverlays.pda[whichPda].minTxtWidthFix then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;		
		elseif iconAreaName == "settingZoomOut_" then
			if moSetGetOverlays.pda[whichPda].settingZoomOutIn == moSetGetOverlays.pda[whichPda].defaultSettingZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].settingZoomOutIn < moSetGetOverlays.pda[whichPda].maxSettingZoomOutIn then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "settingZoomIn_" then
			if moSetGetOverlays.pda[whichPda].settingZoomOutIn == moSetGetOverlays.pda[whichPda].defaultSettingZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].settingZoomOutIn > moSetGetOverlays.pda[whichPda].minSettingZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		
		elseif iconAreaName == "pdaFrameZoomOut_" then
			if moSetGetOverlays.pda[whichPda].frameZoomOutIn == moSetGetOverlays.pda[whichPda].defaultFrameZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].frameZoomOutIn < moSetGetOverlays.pda[whichPda].maxFrameZoomOutIn then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "pdaFrameZoomIn_" then
			if moSetGetOverlays.pda[whichPda].frameZoomOutIn == moSetGetOverlays.pda[whichPda].defaultFrameZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].frameZoomOutIn > moSetGetOverlays.pda[whichPda].minFrameZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;	
		
		elseif iconAreaName == "pdaAppIconZoomOut_" then
			if moSetGetOverlays.pda[whichPda].appIconZoomOutIn == moSetGetOverlays.pda[whichPda].defaultAppIconZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].appIconZoomOutIn < moSetGetOverlays.pda[whichPda].maxAppIconZoomOutIn then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "pdaAppIconZoomIn_" then
			if moSetGetOverlays.pda[whichPda].appIconZoomOutIn == moSetGetOverlays.pda[whichPda].defaultAppIconZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			elseif moSetGetOverlays.pda[whichPda].appIconZoomOutIn > moSetGetOverlays.pda[whichPda].minAppIconZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;		
		elseif iconAreaName == "pdaCanCloseAll_" then
			if moSetGetOverlays.pda[whichPda].setting.canCloseAll then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			end;
			overlay.colorState = color;			
		elseif iconAreaName == "settingPdaCopyPaste_" then			
			if #moSetGetOverlays.pdaSettingCopyPaste > 0 then
				if moSetGetOverlays.pdaSettingCopyPaste[1].pdaName == whichPda then
					color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
					overlay.isBlinking = false;
				else
					color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
					overlay.isBlinking = true;	
				end;
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingDefault, true);
				overlay.isBlinking = false;
			end;
			overlay.colorState = color;
		elseif iconAreaName == "deletePda_" then
			if whichPda == "dummyPda_" then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
				overlay.isBlinking = false;
			elseif moSetGetOverlays.pda[whichPda].setting.deletePda then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingReady, true);
				overlay.isBlinking = true;
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingDefault, true);
				overlay.isBlinking = false;
			end;
			overlay.colorState = color;
		elseif iconAreaName == "generateNewPda_" then
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewPda"] ~= nil then
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOff, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.pda[whichPda].color.settingOn, true);
			end;
			overlay.colorState = color;
		end;
	end;
end;

--help global--
function moDraw.pda:helpTxt(clickAreaTable)
	if moSetGetOverlays.pda ~= nil then
		if clickAreaTable.whatClick ~= nil and moSetGetOverlays.pda[clickAreaTable.whatClick] ~= nil then
			if moSetGetOverlays.pda[clickAreaTable.whatClick].help.globalOn and moSetGetOverlays.pda[clickAreaTable.whatClick].setting.infoLine then
				--moGeneralSettings.testString[2] = "In Area".. tostring(clickAreaTable.whereClick);
				return true;
			end;
		end;
	end;
	return false;
end;
--help global--	








