moDraw.weather = {};

function moDraw.weather.onOpen(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	args.overlay.visible = false;		
end;

function moDraw.weather.onDrawBefore(args)
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	if not moGeneralSettings.wtm.mohWtmBackground then return;end;
	local weatherOverlay = moSetGetOverlays.icons["MultiOverlayV4"]["weather"];
	if weatherOverlay ~= nil then
		local isNight = moDraw.weather:getDayNight();		
		local overlay = weatherOverlay[1];		
		if isNight then overlay = weatherOverlay[2];end;
		g_currentMission.hl.setOverlay(overlay, args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
		overlay:render();
	end;
	moDraw.weather:getPeriod();
end;

function moDraw.weather.onDrawAfter(args)	
	if args == nil or args.overlay == nil or args.whichPda == nil or moSetGetOverlays.pda[args.whichPda] == nil then return;end;
	local weatherOverlay = moSetGetOverlays.icons["MultiOverlayV4"]["weather"];
	if weatherOverlay ~= nil then
		if args.overlay.ownValue == "currentWeather" or args.overlay.ownValue == "nextWeather" then
			local isNight = moDraw.weather:getDayNight();		
			local weatherIcons = moDraw.weather:getTypWeatherIcons(isNight);		
			if weatherIcons ~= nil then
				if args.overlay.ownValue == "currentWeather" then
					for weatherTyp, typIcon in pairs (weatherIcons.currentWeather) do
						if typIcon ~= nil and #typIcon > 0 then
							if typIcon[1] ~= nil and weatherOverlay[typIcon[1]] ~= nil then
								g_currentMission.hl.setOverlay(weatherOverlay[typIcon[1]], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
								weatherOverlay[typIcon[1]]:render();
							end;
							if typIcon[2] ~= nil and weatherOverlay[typIcon[2]] ~= nil then
								g_currentMission.hl.setOverlay(weatherOverlay[typIcon[2]], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
								weatherOverlay[typIcon[2]]:render();
							end;
							if typIcon[3] ~= nil and weatherOverlay[typIcon[3]] ~= nil then
								g_currentMission.hl.setOverlay(weatherOverlay[typIcon[3]], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
								weatherOverlay[typIcon[3]]:render();
							end;
						end;
					end;
				elseif args.overlay.ownValue == "nextWeather" then
					for weatherTyp, typIcon in pairs (weatherIcons.nextWeather) do
						if typIcon ~= nil and #typIcon > 0 then
							if typIcon[1] ~= nil and weatherOverlay[typIcon[1]] ~= nil then
								g_currentMission.hl.setOverlay(weatherOverlay[typIcon[1]], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
								weatherOverlay[typIcon[1]]:render();
								if weatherTyp == "windy" then
									setTextBold(true);	
									setTextColor(unpack(g_currentMission.hl.getColor("black", true)));		
									local txt = tostring(moDraw.weather:getWindSpeed());
									local isSize = moSetGetOverlays.pda[args.whichPda].appOptiSizeHalfTxtHeight-(2/1000)
									local txtHeight = getTextHeight(isSize, txt);									
									renderText(args.overlay.x+(args.overlay.width/2), args.overlay.y+(args.overlay.height/2)-txtHeight, isSize, txt);
									renderText(args.overlay.x+(args.overlay.width/2), args.overlay.y+(args.overlay.height/2)-txtHeight, isSize, txt);
									setTextBold(false);		
									setTextColor(1, 1, 1, 1);
								end;
							end;
							if typIcon[2] ~= nil and weatherOverlay[typIcon[2]] ~= nil then
								g_currentMission.hl.setOverlay(weatherOverlay[typIcon[2]], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
								weatherOverlay[typIcon[2]]:render();
							end;
							if typIcon[3] ~= nil and weatherOverlay[typIcon[3]] ~= nil then
								g_currentMission.hl.setOverlay(weatherOverlay[typIcon[3]], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
								weatherOverlay[typIcon[3]]:render();
							end;						
						end;
					end;			
				end;
			end;
		elseif args.overlay.ownValue == "typ1_season" or args.overlay.ownValue == "typ2_season" then
			local seasonIcon = moDraw.weather:getTypSeasonIcon(args.overlay.ownValue == "typ1_season", args.overlay.ownValue == "typ2_season");
			if weatherOverlay[seasonIcon] ~= nil then
				g_currentMission.hl.setOverlay(weatherOverlay[seasonIcon], args.overlay.x, args.overlay.y, args.overlay.width, args.overlay.height);
				weatherOverlay[seasonIcon]:render();
				setTextBold(true);	
				setTextColor(unpack(g_currentMission.hl.getColor("black", true)));		
				local txt = tostring(moDraw.weather:getPeriod());
				local isSize = moSetGetOverlays.pda[args.whichPda].appOptiSizeHalfTxtHeight-(2/1000)
				local txtHeight = getTextHeight(isSize, txt);								
				local txtWidth = getTextWidth(isSize, txt);
				local optiSize = isSize;
				if txtWidth > args.overlay.width then optiSize = g_currentMission.hl.optiWidthSize(args.overlay.width, txt, isSize);end; --better check before set
				renderText(args.overlay.x+(args.overlay.width/2)-(txtWidth/2), args.overlay.y+(0.0015), optiSize, txt);
				renderText(args.overlay.x+(args.overlay.width/2)-(txtWidth/2), args.overlay.y+(0.0015), optiSize, txt);
				setTextBold(false);		
				setTextColor(1, 1, 1, 1);
			end;
		end;
	end;
end;

--Weather,CLEAR = 1,CLOUDY = 2,MIXED = 3,WINDY = 4,RAIN = 5,SNOW = 6,HAIL = 7,FOG = 8,THUNDER = 9
--WeatherType,SUN = 1,CLOUDY = 2,RAIN= 3,SNOW = 4
function moDraw.weather:getTypWeatherIcons(isNight)
	local weatherIcons = {currentWeather={clear={},cloudy={},mixed={},windy={},rain={},snow={},hail={},fog={},thunder={}},nextWeather={clear={},cloudy={},mixed={},windy={},rain={},snow={},hail={},fog={},thunder={}} };
	local currentWeather, nextWeather = moDraw.weather:getWeatherStates();
	local season = moDraw.weather:getSeason();
	if season == nil then season = 0;end;	
	if currentWeather == 1 then
		weatherIcons.currentWeather.clear[1] = 3;if isNight then weatherIcons.currentWeather.clear[1] = 4;end;
	elseif currentWeather == 2 then
		weatherIcons.currentWeather.cloudy[1] = 5;
	elseif currentWeather == 3 then
		weatherIcons.currentWeather.mixed[1] = 3;if isNight then weatherIcons.currentWeather.mixed[1] = 4;end;
		weatherIcons.currentWeather.mixed[2] = 6;
		if season == 0 or season == 3 then
			weatherIcons.currentWeather.mixed[3] = 9;
		else
			weatherIcons.currentWeather.mixed[3] = 7;
		end;
	elseif currentWeather == 4 then
		weatherIcons.currentWeather.mixed[1] = 3;if isNight then weatherIcons.currentWeather.mixed[1] = 4;end;
		weatherIcons.currentWeather.mixed[2] = 6;
		if season == 0 or season == 3 then
			weatherIcons.currentWeather.mixed[3] = 8;
		else
			weatherIcons.currentWeather.mixed[3] = 9;
		end;
	elseif currentWeather == 5 then
		weatherIcons.currentWeather.rain[1] = 5;
		weatherIcons.currentWeather.rain[2] = 7;
	elseif currentWeather == 6 then
		weatherIcons.currentWeather.snow[1] = 5;
		weatherIcons.currentWeather.snow[2] = 8;
	elseif currentWeather == 7 then
		weatherIcons.currentWeather.hail[1] = 5;
		weatherIcons.currentWeather.hail[2] = 10;	
	elseif currentWeather == 8 then
		weatherIcons.currentWeather.fog[1] = 5;
		weatherIcons.currentWeather.fog[2] = 11;
	elseif currentWeather == 9 then
		weatherIcons.currentWeather.thunder[1] = 5;
		weatherIcons.currentWeather.thunder[2] = 12;	
	end;
	if currentWeather == nextWeather then nextWeather = 0;end;	
	if nextWeather == 1 then
		weatherIcons.nextWeather.clear[1] = 3;if isNight then weatherIcons.nextWeather.clear[1] = 4;end;
	elseif nextWeather == 2 then
		weatherIcons.nextWeather.cloudy[1] = 5;
	elseif nextWeather == 3 then
		weatherIcons.nextWeather.mixed[1] = 3;if isNight then weatherIcons.nextWeather.mixed[1] = 4;end;
		weatherIcons.nextWeather.mixed[2] = 6;
		if season == 0 or season == 3 then
			weatherIcons.nextWeather.mixed[3] = 9;
		else
			weatherIcons.nextWeather.mixed[3] = 7;
		end;	
	elseif nextWeather == 4 then
		weatherIcons.nextWeather.mixed[1] = 3;if isNight then weatherIcons.nextWeather.mixed[1] = 4;end;
		weatherIcons.nextWeather.mixed[2] = 6;
		if season == 0 or season == 3 then
			weatherIcons.nextWeather.mixed[3] = 9;
		else
			weatherIcons.nextWeather.mixed[3] = 8;
		end;		
	elseif nextWeather == 0 then
		weatherIcons.nextWeather.windy[1] = 13;	
	elseif nextWeather == 5 then
		weatherIcons.nextWeather.rain[1] = 5;
		weatherIcons.nextWeather.rain[2] = 7;
	elseif nextWeather == 6 then
		weatherIcons.nextWeather.snow[1] = 5;
		weatherIcons.nextWeather.snow[2] = 8;
	elseif nextWeather == 7 then
		weatherIcons.nextWeather.hail[1] = 5;
		weatherIcons.nextWeather.hail[2] = 10;	
	elseif nextWeather == 8 then
		weatherIcons.nextWeather.fog[1] = 5;
		weatherIcons.nextWeather.fog[2] = 11;
	elseif nextWeather == 9 then
		weatherIcons.nextWeather.thunder[1] = 5;
		weatherIcons.nextWeather.thunder[2] = 12;	
	end;	
	return weatherIcons;
end;

--Season, SPRING = 0,SUMMER = 1,AUTUMN = 2,WINTER = 3
--Periode--
--SPRING, EARLY_SPRING = 1,MID_SPRING = 2,LATE_SPRING = 3
--SUMMER, EARLY_SUMMER = 4,MID_SUMMER = 5,LATE_SUMMER = 6,
--AUTUMN, EARLY_AUTUMN = 7,MID_AUTUMN = 8,LATE_AUTUMN = 9,
--WINTER, EARLY_WINTER = 10,MID_WINTER = 11,LATE_WINTER = 12,
--Periode--

function moDraw.weather:getTypSeasonIcon(typ1, typ2)
	local seasonIcon = 15;
	local season = moDraw.weather:getSeason();
	if typ1 then
		if season == 0 then 
			seasonIcon = 14;
		elseif season == 1 then
			seasonIcon = 15;
		elseif season == 2 then
			seasonIcon = 16;
		elseif season == 3 then
			seasonIcon = 17;	
		else 
			seasonIcon = 15;
		end;
	elseif typ2 then
		if season == 0 then 
			seasonIcon = 18;
		elseif season == 1 then
			seasonIcon = 19;
		elseif season == 2 then
			seasonIcon = 20;
		elseif season == 3 then
			seasonIcon = 21;	
		else 
			seasonIcon = 19;
		end;
	end;
	return seasonIcon;
end;

function moDraw.weather:getPeriod()
	local period = g_currentMission.environment.currentPeriod;
	local dayInPeriod = g_currentMission.environment.currentDayInPeriod;
	local periodString = g_i18n:formatDayInPeriod(dayInPeriod, period, true); --true short month
	return tostring(periodString);	
end;

function moDraw.weather:getSeason()
	return g_currentMission.environment.currentSeason;
end;

function moDraw.weather:getDayNight()
	local dayMinutes = g_currentMission.environment.dayTime/60000;
	return g_currentMission.environment.daylight.logicalNightStartMinutes+30 <= dayMinutes or dayMinutes < g_currentMission.environment.daylight.logicalNightEndMinutes-30;	
end;

function moDraw.weather:getWeatherStates()
	local sixHours = 21600000;
	local env = g_currentMission.environment;
	local dayPlus6h, timePlus6h = env:getDayAndDayTime(env.dayTime + sixHours, env.currentMonotonicDay);
	local currentWeather = env.weather:getCurrentWeatherType();
	local nextWeather = env.weather:getNextWeatherType(dayPlus6h, timePlus6h);	
	return currentWeather, nextWeather;
end;

function moDraw.weather:getWindSpeed()
	local env = g_currentMission.environment;
	local windX, windZ, windSpeed = env.weather.windUpdater:getCurrentValues();	
	return math.floor(math.pow(math.ceil(windSpeed, 0) / 0.836, 0.6666666666666666));	
end;
