moDraw.slot= {};
source(MultiOverlayV4.modDir.."scripte/draw/slot/moDrawSlot_Typ1.lua");

function moDraw.slot:setOpenDraw(whichSlot)
	local whichSubSlot = whichSlot or "dummySlot_";
	if moSetGetOverlays.slot[whichSubSlot] == nil then return;end;	
	local slotTable = moSetGetOverlays.slot[whichSubSlot];
	if slotTable.typ == 1 then
		if #slotTable.setting.openCallback > 0 then
			for a=1, #slotTable.setting.openCallback do
				if type(slotTable.setting.openCallback[a]) == "function" then
					slotTable.setting.openCallback[a]( {whichSlot=whichSubSlot} );
				end;
			end;
		end;
		if not slotTable.isOtherSlot.on or (slotTable.isOtherSlot.on and slotTable.isOtherSlot.isMenue and slotTable.isOtherSlot.menueDraw == nil) then
			moDraw["slot_typ1"]:setOpen(whichSubSlot, slotTable);
		elseif slotTable.isOtherSlot.on and slotTable.isOtherSlot.otherDraw ~= nil and type(slotTable.isOtherSlot.otherDraw) == "function" then
			slotTable.isOtherSlot.otherDraw(whichSubSlot, slotTable);
		elseif slotTable.isOtherSlot.on and slotTable.isOtherSlot.isMenue and slotTable.isOtherSlot.menueDraw ~= nil and type(slotTable.isOtherSlot.menueDraw) == "function" then
			slotTable.isOtherSlot.menueDraw(whichSubSlot, slotTable);
		end;		
	end;	
end;

function moDraw.slot:getOpen(whichSlot)	
	local openSlots = {};	
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then return moSetGetOverlays.slot[whichSlot].isOpen;end;
		for slotName, slotTable in pairs(moSetGetOverlays.slot) do				
			if slotTable.isOpen then
				openSlots[#openSlots+1] = tostring(slotName);				
			end;
		end;		
	end;
	return openSlots;
end;

function moDraw.slot:setOpen(whichSlot)		
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then moSetGetOverlays.slot[whichSlot].isOpen = true;return true;end;					
	end;
	return false;
end;

function moDraw.slot:setClose(whichSlot)		
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then 
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][whichSlot] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", whichSlot}, "moDraw.slot:setClose");
			end;
			moDraw.slot:closeSetting(whichSlot);moSetGetOverlays.slot[whichSlot].isOpen = false;
			moDraw.slot:setCmdSettingMenue(whichSlot, false);					
			moGeneralSettings.clickAreas.slot[whichSlot] = {};
			moGeneralSettings.clickAreas.masterSlot[whichSlot] = {};
			return true;
		end;
		moDraw.slot:setCmdSettingMenue("", true);		
		for slotName, slotTable in pairs(moSetGetOverlays.slot) do				
			if slotTable.setting.canCloseAll then
				if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][slotName] ~= nil then
					MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", slotName}, "moDraw.slot:setClose");
				end;			
				slotTable.setting.on = false;
				slotTable.isOpen = false;
				moGeneralSettings.clickAreas.slot[slotName] = {};
				moGeneralSettings.clickAreas.masterSlot[slotName] = {};
			end;
		end;
		return true;
	end;
	return false;
end;

function moDraw.slot:setSmallView(whichSlot)	
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then 
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][whichSlot] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", whichSlot}, "moDraw.slot:setSmallView");
			end;
			moSetGetOverlays.slot[whichSlot].view[moSetGetOverlays.slot[whichSlot].view.isModus].isSmallView = not moSetGetOverlays.slot[whichSlot].view[moSetGetOverlays.slot[whichSlot].view.isModus].isSmallView;
			return true;
		end;					
		for slotName, slotTable in pairs(moSetGetOverlays.slot) do				
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"][slotName] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", slotName}, "moDraw.slot:setSmallView");
			end;
			if g_currentMission.hl.runMsg["MultiOverlayV4"] ~= nil and g_currentMission.hl.runMsg["MultiOverlayV4"]["cmdSettingMenue"] ~= nil then
				MultiOverlayV4:get_hl("removeRunMsg", {"MultiOverlayV4", "cmdSettingMenue"}, "moDrawCmdSettingMenue:setOpen");
			end;
			for a=1, slotTable.view.max do
				slotTable.view[a].isSmallView = true;
			end;			
		end;
		return true;
	end;
	return false;
end;

function moDraw.slot:setViewModus(whichSlot)	
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then 
			if moSetGetOverlays.slot[whichSlot].view.isModus == moSetGetOverlays.slot[whichSlot].view.max then 
				moSetGetOverlays.slot[whichSlot].view.isModus = 1;
			else
				moSetGetOverlays.slot[whichSlot].view.isModus = moSetGetOverlays.slot[whichSlot].view.isModus+1;
			end;
			moSetGetSlot:resetSettingLinesBounds(whichSlot);
			return true;
		end;
	end;
	return false;
end;

function moDraw.slot:setSettingDefaultLine(whichSlot)	
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then moSetGetOverlays.slot[whichSlot].setting.defaultLine = not moSetGetOverlays.slot[whichSlot].setting.defaultLine;end;					
		if not moSetGetOverlays.slot[whichSlot].setting.defaultLine then moDraw.slot:closeSetting(whichSlot);end;		
		return true;
	end;
	return false;
end;

function moDraw.slot:setSettingExtraLine(whichSlot)	
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then moSetGetOverlays.slot[whichSlot].setting.extraLine = not moSetGetOverlays.slot[whichSlot].setting.extraLine;return true;end;
	end;
	return false;
end;

function moDraw.slot:setSettingInfoLine(whichSlot)		
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then moSetGetOverlays.slot[whichSlot].setting.infoLine = not moSetGetOverlays.slot[whichSlot].setting.infoLine;return true;end;		
	end;
	return false;
end;

function moDraw.slot:setSettingModLine(whichSlot)		
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then moSetGetOverlays.slot[whichSlot].setting.modLine = not moSetGetOverlays.slot[whichSlot].setting.modLine;return true;end;		
	end;
	return false;
end;

function moDraw.slot:setSetting(whichSlot)		
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then moSetGetOverlays.slot[whichSlot].setting.on = not moSetGetOverlays.slot[whichSlot].setting.on;return true;end;		
	end;
	return false;
end;

function moDraw.slot:setCmdSettingMenue(whichSlot, closeAll)
	if moGeneralSettings.cmdSettingMenue.typ == "Slot" then
		if closeAll then moHlGuiCmdSetting:setClose();return;end;
		if moHlGuiCmdSetting:isOpen("Slot", whichSlot) then moHlGuiCmdSetting:setClose();return;end;
	end;
end;

function moDraw.slot:closeSetting(whichSlot)		
	if moSetGetOverlays.slot ~= nil then		
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then moSetGetOverlays.slot[whichSlot].setting.on = false;return true;end;					
		for slotName, slotTable in pairs(moSetGetOverlays.slot) do			
			slotTable.setting.on = false;			
		end;
		return true;
	end;
	return false;
end;

function moDraw.slot:setDesignColor(whichSlot, overlays)
	if moSetGetOverlays.slot ~= nil then
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then
			for a=1, #overlays do
				local oR,oG,oB,oA = overlays[a].r, overlays[a].g, overlays.b, overlays.a;
				local sR,sG,sB,sA = unpack(g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.ground, true));				
				if oR ~= sR or oG ~= sG or oB ~= sB then --or oA ~= sA then 
					g_currentMission.hl.setBackgroundColor(overlays[a], {sR,sG,sB,oA});
				end;
			end;
			return true;
		end;
	end;
	return false;
end;

function moDraw.slot:setDesignGroundColor(whichSlot, overlays, colorName)
	if moSetGetOverlays.slot ~= nil then
		if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then
			for a=1, #overlays do				
				local color = g_currentMission.hl.getColor(colorName, true);				
				if a == 1 then color[4] = 0.6 else color[4] = 0.8;end;
				g_currentMission.hl.setBackgroundColor(overlays[a], color);				
			end;
			return true;
		end;
	end;
	return false;
end;

function moDraw.slot.testCallback(clickAreaTable) --test callback slot iconAreaName settings
	if clickAreaTable ~= nil then		
				
	end;
end;

function moDraw.slot.iconColor(args) --setting iconAreaName onOpen callback
	if args == nil or type(args) ~= "table" or args.whichSlot == nil or args.overlay == nil or args.areaName == nil then return;end;
	if moSetGetOverlays.slot[args.whichSlot] ~= nil then
		local color = "";
		local whichSlot = args.whichSlot;
		local overlay = args.overlay;
		local iconAreaName = args.areaName;		
		if iconAreaName == "buttonSeparatorHorizontal_" or iconAreaName == "buttonSeparatorVertical_" then
			color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingDefault, true);
			overlay.colorState = color;
		elseif iconAreaName == "buttonLoad_" then
			color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.txtExtra, true);
			overlay.colorState = color;	
		elseif iconAreaName == "settingZoomOut_" then
			if moSetGetOverlays.slot[whichSlot].settingZoomOutIn == moSetGetOverlays.slot[whichSlot].defaultSettingZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].settingZoomOutIn < moSetGetOverlays.slot[whichSlot].maxSettingZoomOutIn then	
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "settingZoomIn_" then
			if moSetGetOverlays.slot[whichSlot].settingZoomOutIn == moSetGetOverlays.slot[whichSlot].defaultSettingZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].settingZoomOutIn > moSetGetOverlays.slot[whichSlot].minSettingZoomOutIn then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "outputTxtSizeUp_" then
			if moSetGetOverlays.slot[whichSlot].txtSize == moSetGetOverlays.slot[whichSlot].defaultTxtSize then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].txtSize < moSetGetOverlays.slot[whichSlot].maxTxtSize then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "outputTxtSizeDown_" then
			if moSetGetOverlays.slot[whichSlot].txtSize == moSetGetOverlays.slot[whichSlot].defaultTxtSize then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].txtSize > moSetGetOverlays.slot[whichSlot].minTxtSize then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;		
		elseif iconAreaName == "outputDistanceUpHorizontal_" then
			if moSetGetOverlays.slot[whichSlot].txtLineDistance == moSetGetOverlays.slot[whichSlot].defaultTxtLineDistance then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].txtLineDistance < moSetGetOverlays.slot[whichSlot].maxTxtLineDistance then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "outputDistanceDownHorizontal_" then
			if moSetGetOverlays.slot[whichSlot].txtLineDistance == moSetGetOverlays.slot[whichSlot].defaultTxtLineDistance then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].txtLineDistance > moSetGetOverlays.slot[whichSlot].minTxtLineDistance then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;		
		elseif iconAreaName == "outputTxtWidthFixUp_" then
			if moSetGetOverlays.slot[whichSlot].txtWidthFix == moSetGetOverlays.slot[whichSlot].defaultTxtWidthFix then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].txtWidthFix < moSetGetOverlays.slot[whichSlot].maxTxtWidthFix then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;
		elseif iconAreaName == "outputTxtWidthFixDown_" then
			if moSetGetOverlays.slot[whichSlot].txtWidthFix == moSetGetOverlays.slot[whichSlot].defaultTxtWidthFix then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			elseif moSetGetOverlays.slot[whichSlot].txtWidthFix > moSetGetOverlays.slot[whichSlot].minTxtWidthFix then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;		
		elseif iconAreaName == "slotCanCloseAll_" then
			if moSetGetOverlays.slot[whichSlot].setting.canCloseAll then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			end;
			overlay.colorState = color;			
		elseif iconAreaName == "settingSlotCopyPaste_" then			
			if #moSetGetOverlays.slotSettingCopyPaste > 0 then
				if moSetGetOverlays.slotSettingCopyPaste[1].slotName == whichSlot then
					color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
					overlay.isBlinking = false;
				else
					color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
					overlay.isBlinking = true;	
				end;
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingDefault, true);
				overlay.isBlinking = false;
			end;
			overlay.colorState = color;
		elseif iconAreaName == "deleteSlot_" then
			if whichSlot == "dummySlot_" then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
				overlay.isBlinking = false;
			elseif moSetGetOverlays.slot[whichSlot].setting.deleteSlot then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingReady, true);
				overlay.isBlinking = true;
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingDefault, true);
				overlay.isBlinking = false;
			end;
			overlay.colorState = color;
		elseif iconAreaName == "generateNewSlot_" then
			if g_currentMission.hl.timers ~= nil and g_currentMission.hl.timers["generateNewSlot"] ~= nil then
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOff, true);
			else
				color = g_currentMission.hl.getColor(moSetGetOverlays.slot[whichSlot].color.settingOn, true);
			end;
			overlay.colorState = color;		
		end;
	end;
end;

--help global--
function moDraw.slot:helpTxt(clickAreaTable)
	if moSetGetOverlays.slot ~= nil then
		if clickAreaTable.whatClick ~= nil and moSetGetOverlays.slot[clickAreaTable.whatClick] ~= nil then
			if moSetGetOverlays.slot[clickAreaTable.whatClick].help.globalOn and moSetGetOverlays.slot[clickAreaTable.whatClick].setting.infoLine then
				--moGeneralSettings.testString[2] = "In Area".. tostring(clickAreaTable.whereClick);
				return true;
			end;
		end;
	end;
	return false;
end;
--help global--	
