moHlGuiAppIconSetting = {};

function moHlGuiAppIconSetting:load(editTable, editIconTable)		
	
end;

function moHlGuiAppIconSetting:isHlGuiOpen()
	if not MultiOverlayV4.hlGui.isLoad then return false;end;
	local isOpen, isMod, isPage, isSide = g_currentMission.hlGui.setGet:getOpenAndWhat();
	return isOpen and isMod == "MultiOverlayV4" and isPage == MultiOverlayV4.hlGui.page["AppIconSetting"] and isSide == MultiOverlayV4.hlGui.side["AppIconSetting"];
end;

function moHlGuiAppIconSetting:isOn()
	if not MultiOverlayV4.hlGui.isLoad then return false;end;
	return moGeneralSettings.appIconSettingMenue.on and string.len(moGeneralSettings.appIconSettingMenue.name) > 0;
end;

function moHlGuiAppIconSetting:isOpen(name, appValue)
	if moHlGuiAppIconSetting:isOn() then
		if moSetGetOverlays.pda[name] ~= nil then
			if moGeneralSettings.appIconSettingMenue.name == name then
				if appValue == nil then return true;end;
				if moGeneralSettings.appIconSettingMenue.app[1] == appValue[1] and moGeneralSettings.appIconSettingMenue.app[2] == appValue[2] then return true;end;
			end;
		end;
	end;
	return false;
end;

function moHlGuiAppIconSetting:setOpen(args)
	if not MultiOverlayV4.hlGui.isLoad then return false;end;
	if args ~= nil and args.name ~= nil then
		if moHlGuiAppIconSetting:isOn() and moHlGuiAppIconSetting:isOpen(args.name, args.appValue) then moHlGuiAppIconSetting:setClose();return;end;
		moGeneralSettings.appIconSettingMenue.name = tostring(args.name);		
		if args.appValue ~= nil and args.appValue[1] ~= nil and args.appValue[2] ~= nil then
			moGeneralSettings.appIconSettingMenue.app = {args.appValue[1],args.appValue[2]};
		end;
		moGeneralSettings.appIconSettingMenue.on = true;
	end;
	moHlGuiCmdSetting:setClose();
	g_currentMission.hlGui.setGet:setOpen("MultiOverlayV4", MultiOverlayV4.hlGui.page["AppIconSetting"], MultiOverlayV4.hlGui.side["AppIconSetting"]);
end;

function moHlGuiAppIconSetting:setClose()
	moGeneralSettings.appIconSettingMenue = {on=false, name="", app={0,0}};
	moGeneralSettings.clickAreas.menue["appIconSettingMenue"] = {};
	moGeneralSettings.clickAreas.masterMenue["appIconSettingMenue"] = {};
	moSetGetOverlays:deletePreviewIcons();
end;

function moHlGuiAppIconSetting:getEditTables()
	if moHlGuiAppIconSetting:isOn() then
		local editTable = nil;
		local editIconTable = nil;
		local title = "";
		local name = tostring(moGeneralSettings.appIconSettingMenue.name);	
		if moSetGetOverlays.pda[name] ~= nil then 
			editTable = moSetGetOverlays.pda[name];
			title = "Pda *".. moSetGetOverlays.pda[name].name.. "*";
			if moGeneralSettings.appIconSettingMenue.app[1] > 0 and moGeneralSettings.appIconSettingMenue.app[2] > 0 and editTable.selectApp[1] > 0 and editTable.selectApp[2] > 0 and g_currentMission.hl.dragDrop.what ~= "_dragDropArea_" then					
				if moGeneralSettings.appIconSettingMenue.app[1] == editTable.selectApp[1] and moGeneralSettings.appIconSettingMenue.app[2] == editTable.selectApp[2] then
					if editTable.apps ~= nil and editTable.apps[moGeneralSettings.appIconSettingMenue.app[1]] ~= nil and editTable.apps[moGeneralSettings.appIconSettingMenue.app[1]][moGeneralSettings.appIconSettingMenue.app[2]] ~= nil and editTable.apps[moGeneralSettings.appIconSettingMenue.app[1]][moGeneralSettings.appIconSettingMenue.app[2]].icon ~= nil then
						editIconTable = editTable.apps[moGeneralSettings.appIconSettingMenue.app[1]][moGeneralSettings.appIconSettingMenue.app[2]].icon;
						title = title.. " (Line ".. tostring(moGeneralSettings.appIconSettingMenue.app[1]).. ",App ".. tostring(moGeneralSettings.appIconSettingMenue.app[2].. ")");
					end;
				end;
			end;
		end;		
		return editTable, editIconTable, title;
	end;
	return nil, nil;
end;

function moHlGuiAppIconSetting:addIcon(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil then return;end;
	local name = tostring(moGeneralSettings.appIconSettingMenue.name);
	local appLine = args.editTable.selectApp[1];
	local appPos = args.editTable.selectApp[2];
	if appLine == nil or appLine <=0 or appPos == nil or appPos <= 0 then return nil;end;
	if args.editTable.apps[appLine][appPos].icon ~= nil and args.editTable.apps[appLine][appPos].icon[1] ~= nil then
		moHlGuiAppIconSetting:deleteIcon(args)
	end;
	local iconFile = moSetGetOverlays.previewIcons[args.editTable.appIconSettings.openMod][args.editTable.appIconSettings.openGroup][args.editTable.appIconSettings.selectIcon];
	if iconFile ~= nil then	
		local saveArgsNew = g_currentMission.hl.getTableCopy(iconFile.saveArgs);
		saveArgsNew.loadIcons={iconFile.iconPlace};saveArgsNew.previewIcons=nil;saveArgsNew.whichPda=name;saveArgsNew.appIcon={appLine,appPos};
		local firstIcon, endIcon = moSetGetOverlays:loadIcons(saveArgsNew);
		if firstIcon == nil or endIcon == nil then return nil;end;
		moGeneralSettings.isSave = false;
	end;
	return false;
end;

function moHlGuiAppIconSetting:deleteIcon(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil then return;end;	
	local appLine = args.editTable.selectApp[1];
	local appPos = args.editTable.selectApp[2];
	if appLine == nil or appLine <=0 or appPos == nil or appPos <= 0 then return nil;end;
	if args.editTable.apps[appLine][appPos].icon ~= nil and args.editTable.apps[appLine][appPos].icon[1] ~= nil then
		moSetGetOverlays:deleteOldOverlay(args.editTable.apps[appLine][appPos].icon[1], "moSetGetPda:deleteAppIcon");
		args.editTable.apps[appLine][appPos].icon[1] = nil;
		moGeneralSettings.isSave = false;
	end;	
end;

--disabled
function moHlGuiAppIconSetting:setLineBounds(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.mouseClick == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT_UP" then
	
	elseif args.mouseClick == "MOUSE_BUTTON_LEFT_DOWN" then
	
	elseif args.mouseClick == "MOUSE_BUTTON_WHEEL_UP" then
		if args.editTable.cmdSettings.bounds[1]-1 < 1 then return;end;		
		args.editTable.cmdSettings.bounds[1] = args.editTable.cmdSettings.bounds[1]-1;
		args.editTable.cmdSettings.bounds[2] = args.editTable.cmdSettings.bounds[2]-1;
	elseif args.mouseClick == "MOUSE_BUTTON_WHEEL_DOWN" then		
		if args.editTable.cmdSettings.bounds[2]+1 > args.editTable.cmdSettings.bounds[3] then return;end;
		args.editTable.cmdSettings.bounds[1] = args.editTable.cmdSettings.bounds[1]+1;
		args.editTable.cmdSettings.bounds[2] = args.editTable.cmdSettings.bounds[2]+1;
	end;
end;
--disabled

function moHlGuiAppIconSetting:setSelectIcon(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.ownTable == nil then return;end;
	args.editTable.appIconSettings.selectIcon = args.ownTable.icon;
end;

function moHlGuiAppIconSetting:setBoundsOpenMod(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.mouseClick == nil then return;end;
	local modNameTable = moHlGuiAppIconSetting:getModNameTable({});
	if args.mouseClick == "MOUSE_BUTTON_LEFT_LEFT" then
		for a=1, #modNameTable do
			if modNameTable[a].modName == args.editTable.appIconSettings.openMod then
				if a == 1 then args.editTable.appIconSettings.openMod = modNameTable[#modNameTable].modName;args.editTable.appIconSettings.openGroup = modNameTable[#modNameTable].groupName;break;end;
				if modNameTable[a-1] ~= nil then args.editTable.appIconSettings.openMod = modNameTable[a-1].modName;args.editTable.appIconSettings.openGroup = modNameTable[a-1].groupName;break;end;
			end;
		end;
		args.editTable.appIconSettings.selectIcon = 1;
	elseif args.mouseClick == "MOUSE_BUTTON_LEFT_RIGHT" then
		for a=1, #modNameTable do
			if modNameTable[a].modName == args.editTable.appIconSettings.openMod then					
				if a == #modNameTable then args.editTable.appIconSettings.openMod = modNameTable[1].modName;args.editTable.appIconSettings.openGroup = modNameTable[1].groupName;break;end;
				if modNameTable[a+1] ~= nil then args.editTable.appIconSettings.openMod = modNameTable[a+1].modName;args.editTable.appIconSettings.openGroup = modNameTable[a+1].groupName;break;end;
			end;
		end;
		args.editTable.appIconSettings.selectIcon = 1;
	end;
end;

function moHlGuiAppIconSetting:getModNameTable(nameTable)
	for modName,groupTable in pairs (moSetGetOverlays.previewIcons) do
		nameTable[#nameTable+1] = {modName=modName};
		for groupName,_ in pairs (groupTable) do
			nameTable[#nameTable].groupName = groupName;
			break;
		end;
	end;	
	return nameTable;
end;

function moHlGuiAppIconSetting:setBoundsOpenGroup(args)
	if args == nil or type(args) ~= "table" or args.editTable == nil or args.mouseClick == nil then return;end;
	local groupNameTable = moHlGuiAppIconSetting:getGroupNameTable({}, args.editTable.appIconSettings.openMod);
	if args.mouseClick == "MOUSE_BUTTON_LEFT_LEFT" then		
		for a=1, #groupNameTable do
			if groupNameTable[a].groupName == args.editTable.appIconSettings.openGroup then					
				if a == 1 then args.editTable.appIconSettings.openGroup = groupNameTable[#groupNameTable].groupName;break;end;
				if groupNameTable[a-1] ~= nil then args.editTable.appIconSettings.openGroup = groupNameTable[a-1].groupName;break;end;
			end;
		end;
		args.editTable.appIconSettings.selectIcon = 1;
	elseif args.mouseClick == "MOUSE_BUTTON_LEFT_RIGHT" then
		for a=1, #groupNameTable do
			if groupNameTable[a].groupName == args.editTable.appIconSettings.openGroup then					
				if a == #groupNameTable then args.editTable.appIconSettings.openGroup = groupNameTable[1].groupName;break;end;
				if groupNameTable[a+1] ~= nil then args.editTable.appIconSettings.openGroup = groupNameTable[a+1].groupName;break;end;
			end;
		end;
		args.editTable.appIconSettings.selectIcon = 1;
	end;
end;

function moHlGuiAppIconSetting:getGroupNameTable(nameTable, openMod)
	for groupName,_ in pairs (moSetGetOverlays.previewIcons[openMod]) do
		nameTable[#nameTable+1] = {groupName=groupName};		
	end;
	return nameTable;
end;














