moAmounts = {};
source(MultiOverlayV4.modDir.."scripte/module/amounts/moAmountsConfig.lua");
--source(MultiOverlayV4.modDir.."scripte/module/amounts/moAmountsOutput.lua");

function moAmounts:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="amounts"} ) then
		if moAmountsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateAmounts"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moAmountsConfig.values.updateTimer, name="updateAmounts", repeatable=1, ms=moAmountsConfig.values.msec, action=moAmounts.load} ); 
		else
			moAmounts:load();
		end;
	end;
end;

function moAmounts.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moAmountsConfig.values == nil then moAmountsConfig:defaultValues();end;	
	moAmounts:loadAllAmounts();
	
end;

function moAmounts.load() --updateTimer Callback	
	moAmounts:loadAllAmounts();	
end;

function moAmounts:loadAllAmounts()	
	local playerFarmId = g_currentMission.player.farmId;	
	--local farmId = g_currentMission:getFarmId()
	moFillTypes.values.amount = {}; --new
	moFillTypes.values.storages = {}; --new
	for _, storage in pairs(g_currentMission.storageSystem:getStorages()) do
		if storage:getOwnerFarmId() == playerFarmId then --and storage.foreignSilo ~= farmSilo then	--train other		
			local fillLevels = storage:getFillLevels();
			if fillLevels ~= nil then
				for fillType, fillLevel in pairs(fillLevels) do
					if storage:getIsFillTypeSupported(fillType) then
						moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);
						if storage.loadingStations ~= nil then
							for _, loadingStation in pairs (storage.loadingStations) do
								local objectId = loadingStation.rootNode or loadingStation.nodeId;
								if objectId ~= nil then
									local mapHotspot = nil;
									if loadingStation.owningPlaceable ~= nil then mapHotspot = loadingStation.owningPlaceable.spec_hotspots;end;
									if moFillTypes.values.storages[fillType] == nil then moFillTypes.values.storages[fillType] = {storage={}};end;
									if moFillTypes.values.storages[fillType].storage[objectId] == nil then 
										moFillTypes.values.storages[fillType].storage[objectId] = {objectId=objectId,mapHotspot=mapHotspot,fillLevel=0,storageName=""};
										moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(fillLevel, 0);
										moFillTypes.values.storages[fillType].storage[objectId].storageName = Utils.getNoNil(loadingStation:getName(), "Unknown");									
									else
										moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(moFillTypes.values.storages[fillType].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
									end;
								end;								
							end;
						end;						
					end;					
				end;				
			end;			
		end;		
	end;
	moItems.load();
	moAnimals:loadNumOfAnimals();
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="amounts" } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moAmounts.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moAmounts.update } );