moAnimals = {};
source(MultiOverlayV4.modDir.."scripte/module/animals/moAnimalsConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/animals/moAnimalsOutput.lua");

function moAnimals:update(dt)	
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="animals"} ) then
		if moAnimalsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateAnimals"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moAnimalsConfig.values.updateTimer, name="updateAnimals", repeatable=1, ms=moAnimalsConfig.values.msec, action=moAnimals.load} ); 
		else
			moAnimals:load();
		end;
	end;
end;

function moAnimals.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moAnimalsConfig.values == nil then moAnimalsConfig:defaultValues();end;
	if update then moAnimalsConfig:deleteCmd();end;
	moAnimals:loadAllAnimals(true);	
end;

function moAnimals.load() --updateTimer Callback	
	moAnimals:loadAllAnimals();	
end;

function moAnimals:loadAllAnimals(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	if moModule.animals ~= nil and #moModule.animals > 0 then
		local deleteObject = {};
		for index=1, #moModule.animals do			
			if moModule.animals[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.animals[index].object);
				if isObject then
					local animal = moModule.animals[index].object;
					local isViewOutput = (generateCmd ~= nil and generateCmd) or animal.ownerFarmId == playerFarmId or animal.ownerFarmId == 0;
					if isViewOutput then						
						if animal.mohTable == nil then
							animal.mohTable = {general={},production={},output={},input={}};						
						else
							animal.mohTable.general={};animal.mohTable.production={};animal.mohTable.output={};animal.mohTable.input={};
						end;
						if animal.mohTable.viewOutput == nil then animal.mohTable.viewOutput = false;end;	
						if animal.mohTable.viewInput == nil then animal.mohTable.viewInput = false;end;
						if animal.mohTable.viewMoreInfo == nil then animal.mohTable.viewMoreInfo = false;end;
						if animal.mohTable.viewProductionInfo == nil then animal.mohTable.viewProductionInfo = false;end;
						if animal.mohTable.viewProductionInfoSmall == nil then animal.mohTable.viewProductionInfoSmall = true;end;
						---general output---
						animal.mohTable.general[#animal.mohTable.general+1] = {};
						local isLineTableGeneral = animal.mohTable.general[#animal.mohTable.general];
						if animal.mohDisplayName ~= nil then 
							isLineTableGeneral.objectName = animal.mohTable.mohDisplayName;
						else
							isLineTableGeneral.objectName = animal.mohTable.name;
						end;
						isLineTableGeneral.age = animal.age;
						isLineTableGeneral.isHorse = animal.spec_husbandryAnimals.animalTypeIndex == AnimalType.HORSE;
						isLineTableGeneral.isChicken = animal.spec_husbandryAnimals.animalTypeIndex == AnimalType.CHICKEN;
						local moreInfos = {};
						isLineTableGeneral.numAnimals = Utils.getNoNil(animal.spec_husbandryAnimals:getNumOfAnimals(), 0);						
						isLineTableGeneral.maxNumAnimals = Utils.getNoNil(animal.spec_husbandryAnimals:getMaxNumOfAnimals(), 0);
						isLineTableGeneral.maxNumVisualAnimals = Utils.getNoNil(animal.spec_husbandryAnimals.maxNumVisualAnimals, 0);
						isLineTableGeneral.productivityName = g_i18n:getText("statistic_productivity");
						isLineTableGeneral.productivity = Utils.getNoNil(animal:getGlobalProductionFactor(), 0)*100;
						isLineTableGeneral.productivityWarning = false;
						isLineTableGeneral.productivityColor = 1;
						if animal.mohTable.viewMoreInfo and isLineTableGeneral.numAnimals > 0 then
							moreInfos = moModuleSetGet:getMoreAnimalsInfo(animal, isLineTableGeneral.isHorse);
							if moreInfos ~= nil then
								if moreInfos.feedingRobot ~= nil then
									isLineTableGeneral.feedingRobot = moreInfos.feedingRobot;
									if moreInfos.feedingRobotState ~= nil then
										isLineTableGeneral.feedingRobotState = moreInfos.feedingRobotState;
									end;
									if moreInfos.feedingRobotFillLevel ~= nil then
										isLineTableGeneral.feedingRobotFillLevel = g_i18n:formatNumber(Utils.getNoNil(moreInfos.feedingRobotFillLevel, 0));
									end;
								end;
								if moreInfos.animalClusters ~= nil then
									local tempCluster = moreInfos.animalClusters;
									if tempCluster.health ~= nil then
										isLineTableGeneral.health = math.floor(tempCluster.health[1]/tempCluster.health[2]);
										isLineTableGeneral.healthColor = 7;
										isLineTableGeneral.healthClusters = tempCluster.health[2];
										if isLineTableGeneral.health > 0 then
											isLineTableGeneral.healthColor = g_currentMission.hl.getProzentColor(Utils.getNoNil(isLineTableGeneral.health, 0), true);
										end;
										isLineTableGeneral.highestHealth = Utils.getNoNil(math.floor(tempCluster.health[3][1]), 0);
										isLineTableGeneral.lowestHealth = Utils.getNoNil(math.floor(tempCluster.health[3][#tempCluster.health[3]]), 0);
									end;
									if tempCluster.duration ~= nil then
										isLineTableGeneral.duration = math.floor(tempCluster.duration[1]/tempCluster.duration[2]);
										isLineTableGeneral.durationClusters = tempCluster.duration[2];
										isLineTableGeneral.highestDuration = Utils.getNoNil(math.floor(tempCluster.duration[3][1]), 0);
										isLineTableGeneral.lowestDuration = Utils.getNoNil(math.floor(tempCluster.duration[3][#tempCluster.duration[3]]), 0);
									end;
									if tempCluster.reproduction ~= nil then
										isLineTableGeneral.reproduction = math.floor((tempCluster.reproduction[1]/tempCluster.reproduction[2]));
										isLineTableGeneral.reproductionClusters = tempCluster.reproduction[2];
										isLineTableGeneral.highestReproduction = Utils.getNoNil(math.floor(tempCluster.reproduction[3][1]), 0);
										isLineTableGeneral.lowestReproduction = Utils.getNoNil(math.floor(tempCluster.reproduction[3][#tempCluster.reproduction[3]]), 0);										
										isLineTableGeneral.reproductionColor = 1;
										if tempCluster.reproductionStand ~= nil then
											local reproductionStand = math.floor((tempCluster.reproductionStand[1]/tempCluster.reproductionStand[2]));
											if reproductionStand < 100 then
												isLineTableGeneral.reproductionColor = 7;
											end;
										end;										
										if tempCluster.reproductionMonth ~= nil then
											isLineTableGeneral.highestReproductionMonth = Utils.getNoNil(math.floor(tempCluster.reproductionMonth[3][1]), 0);
											isLineTableGeneral.lowestReproductionMonth = Utils.getNoNil(math.floor(tempCluster.reproductionMonth[3][#tempCluster.reproductionMonth[3]]), 0);
											isLineTableGeneral.lowestReproductionMonthTotal = 0;
											for a=1, #tempCluster.reproductionMonth[3] do
												if math.floor(tempCluster.reproductionMonth[3][a]) == isLineTableGeneral.lowestReproductionMonth then
													isLineTableGeneral.lowestReproductionMonthTotal = isLineTableGeneral.lowestReproductionMonthTotal+1;
												end;											
											end;
											if isLineTableGeneral.lowestReproductionMonthTotal == 0 then isLineTableGeneral.lowestReproductionMonthTotal = 1;end;
										end;
									end;									
									if tempCluster.puberty ~= nil then
										isLineTableGeneral.puberty = math.floor((tempCluster.puberty[1]/tempCluster.puberty[2])*100);
										isLineTableGeneral.pubertyClusters = tempCluster.puberty[2];
										isLineTableGeneral.highestPuberty = Utils.getNoNil(math.floor(tempCluster.puberty[3][1]*100), 0);
										isLineTableGeneral.lowestPuberty = Utils.getNoNil(math.floor(tempCluster.puberty[3][#tempCluster.puberty[3]]), 0);
									end;
									if tempCluster.age ~= nil then
										isLineTableGeneral.ageAnimal = math.floor(tempCluster.age[1]/tempCluster.age[2]);
										isLineTableGeneral.ageAnimalClusters = tempCluster.age[2];
										isLineTableGeneral.highestAgeAnimal = Utils.getNoNil(math.floor(tempCluster.age[3][1]), 0);
										isLineTableGeneral.lowestAgeAnimal = Utils.getNoNil(math.floor(tempCluster.age[3][#tempCluster.age[3]]), 0);
									end;
									if tempCluster.names ~= nil and tempCluster.names.typName ~= nil and #tempCluster.names.typName > 0 then
										isLineTableGeneral.typName = tempCluster.names.typName;
									end;
									if tempCluster.gender ~= nil then
										isLineTableGeneral.genderMale = tempCluster.gender[2];
										isLineTableGeneral.genderFemale = tempCluster.gender[1];
									end;
									if tempCluster.sellPriceTotal ~= nil then
										isLineTableGeneral.totalSellPrice = tempCluster.sellPriceTotal[1];										
									end;									
									if isLineTableGeneral.isHorse then
										isLineTableGeneral.dirt = math.floor(tempCluster.dirt[1]/tempCluster.dirt[2]);
										isLineTableGeneral.dirtClusters = tempCluster.dirt[2];
										isLineTableGeneral.highestDirt = Utils.getNoNil(math.floor(tempCluster.dirt[3][1]), 0);
										isLineTableGeneral.lowestDirt = Utils.getNoNil(math.floor(tempCluster.dirt[3][#tempCluster.dirt[3]]), 0);
										isLineTableGeneral.fitness = math.floor(tempCluster.fitness[1]/tempCluster.fitness[2]);
										isLineTableGeneral.fitnessClusters = tempCluster.fitness[2];
										isLineTableGeneral.highestFitness = Utils.getNoNil(math.floor(tempCluster.fitness[3][1]), 0);
										isLineTableGeneral.lowestFitness = Utils.getNoNil(math.floor(tempCluster.fitness[3][#tempCluster.fitness[3]]), 0);
										isLineTableGeneral.riding = math.floor(tempCluster.riding[1]/tempCluster.riding[2]);
										isLineTableGeneral.ridingClusters = tempCluster.riding[2];
										isLineTableGeneral.highestRiding = Utils.getNoNil(math.floor(tempCluster.riding[3][1]), 0);
										isLineTableGeneral.lowestRiding = Utils.getNoNil(math.floor(tempCluster.riding[3][#tempCluster.riding[3]]), 0);									
									end;
								end;
								if moreInfos.health ~= nil then
									isLineTableGeneral.health = math.floor(moreInfos.health);
									isLineTableGeneral.healthColor = 7;
									isLineTableGeneral.healthClusters = moreInfos.healthClusters;
									if moreInfos.health > 0 then
										isLineTableGeneral.healthColor = g_currentMission.hl.getProzentColor(Utils.getNoNil(moreInfos.health, 0), true);
									end;
									if moreInfos.highestHealth ~= nil and moreInfos.highestHealth > 0 then
										isLineTableGeneral.highestHealth = math.floor(moreInfos.highestHealth);
									end;
									if moreInfos.lowestHealth ~= nil and moreInfos.lowestHealth > 0 then
										isLineTableGeneral.lowestHealth = math.floor(moreInfos.lowestHealth);
									end;
								end;
								if moreInfos.reproduction ~= nil then
									isLineTableGeneral.reproduction = math.floor(moreInfos.reproduction*100);
									isLineTableGeneral.reproductionClusters = moreInfos.reproductionClusters;
									isLineTableGeneral.noReproduction = moreInfos.noReproduction;
									if moreInfos.highestReproduction ~= nil and moreInfos.highestReproduction > 0 then
										isLineTableGeneral.highestReproduction = math.floor(moreInfos.highestReproduction*100);
									end;
									if moreInfos.lowestReproduction ~= nil and moreInfos.lowestReproduction > 0 then
										isLineTableGeneral.lowestReproduction = math.floor(moreInfos.lowestReproduction*100);
									end;
								end;
								if moreInfos.duration ~= nil then
									isLineTableGeneral.duration = math.floor(moreInfos.duration);
									isLineTableGeneral.durationClusters = moreInfos.durationClusters;									
									if moreInfos.highestDuration ~= nil and moreInfos.highestDuration > 0 then
										isLineTableGeneral.highestDuration = math.floor(moreInfos.highestDuration);
									end;
									if moreInfos.lowestDuration ~= nil and moreInfos.lowestDuration > 0 then
										isLineTableGeneral.lowestDuration = math.floor(moreInfos.lowestDuration);
										isLineTableGeneral.lowestDurationTotal = moreInfos.lowestDurationTotal;
									end;
								end;
								if moreInfos.totalSellPrice ~= nil then
									isLineTableGeneral.totalSellPrice = moreInfos.totalSellPrice;
								end;
								
								if isLineTableGeneral.isHorse then
									isLineTableGeneral.horseClusters = moreInfos.horseClusters;
									if moreInfos.dirt ~= nil then
										isLineTableGeneral.dirt = math.floor(moreInfos.dirt);
										if moreInfos.highestDirt ~= nil and moreInfos.highestDirt > 0 then
											isLineTableGeneral.highestDirt = math.floor(moreInfos.highestDirt);
										end;
										if moreInfos.lowestDirt ~= nil and moreInfos.lowestDirt > 0 then
											isLineTableGeneral.lowestDirt = math.floor(moreInfos.lowestDirt);
										end;
									end;
									if moreInfos.fitness ~= nil then
										isLineTableGeneral.fitness = math.floor(moreInfos.fitness);										
										if moreInfos.highestFitness ~= nil and moreInfos.highestFitness > 0 then
											isLineTableGeneral.highestFitness = math.floor(moreInfos.highestFitness);
										end;
										if moreInfos.lowestFitness ~= nil and moreInfos.lowestFitness > 0 then
											isLineTableGeneral.lowestFitness = math.floor(moreInfos.lowestFitness);
										end;
									end;
									if moreInfos.riding ~= nil then
										isLineTableGeneral.riding = math.floor(moreInfos.riding);										
										if moreInfos.highestRiding ~= nil and moreInfos.highestRiding > 0 then
											isLineTableGeneral.highestRiding = math.floor(moreInfos.highestRiding);
										end;
										if moreInfos.lowestRiding ~= nil and moreInfos.lowestRiding > 0 then
											isLineTableGeneral.lowestRiding = math.floor(moreInfos.lowestRiding);
										end;
									end;
								end;
							end;
						end;
						local round = 0;
						if isLineTableGeneral.productivity > 0.1 then round = 0.5;end; 
						isLineTableGeneral.productivity = math.floor(isLineTableGeneral.productivity + round);
						if isLineTableGeneral.productivity == 0 then
							isLineTableGeneral.productivityColor = 7;
						else
							isLineTableGeneral.productivityColor = g_currentMission.hl.getProzentColor(Utils.getNoNil(isLineTableGeneral.productivity, 0), true);
							if isLineTableGeneral.productivityColor == 1 then isLineTableGeneral.productivityColor = 2;end;
						end;
						if isLineTableGeneral.productivity < 1 and isLineTableGeneral.numAnimals > 0 then isLineTableGeneral.productivityWarning = true;end;
						isLineTableGeneral.costsPerActiveMonth = 0;
						isLineTableGeneral.ownedFarmId = animal.ownerFarmId;
						isLineTableGeneral.price = Utils.getNoNil(animal.price, 0);
						---general output---
						
						local isFillLevelInformation = false;
						---output---											
						function setOutput(fillLevelInformationOutput)
							isFillLevelInformation = true;							
							animal.mohTable.output[#animal.mohTable.output+1] = {};	
							local isLineTableOutput = animal.mohTable.output[#animal.mohTable.output];
							isLineTableOutput.groupName = fillLevelInformationOutput.title;
							isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationOutput.fillLevel, 0));
							isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationOutput.capacity, 0));
							isLineTableOutput.ratio = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationOutput.ratio, 0));
							if fillLevelInformationOutput.foodGroupFillTypes ~= nil then
								for a=1,  #fillLevelInformationOutput.foodGroupFillTypes do
									if fillLevelInformationOutput.foodGroupFillTypes[a] ~= nil then
										local fillType = moFillTypes.values.fillTypes[fillLevelInformationOutput.foodGroupFillTypes[a]];
										if isLineTableOutput.fillTypeNames ~= nil then isLineTableOutput.fillTypeNames = isLineTableOutput.fillTypeNames.. "-";else isLineTableOutput.fillTypeNames="";end;
										if fillType ~= nil then
											isLineTableOutput.fillTypeNames = isLineTableOutput.fillTypeNames.. fillType.name;
										else
											isLineTableOutput.fillTypeNames = isLineTableOutput.fillTypeNames.. moLanguageXml:getTxt("unknown", nil, "Unknown");
										end;
									end;
								end;
							end;
						end;
						---output---
						---input---											
						function setInput(fillLevelInformationInput)
							isFillLevelInformation = true;
							animal.mohTable.input[#animal.mohTable.input+1] = {};	
							local isLineTableInput = animal.mohTable.input[#animal.mohTable.input];
							isLineTableInput.groupName = fillLevelInformationInput.title;
							isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationInput.fillLevel, 0));
							isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationInput.capacity, 0));
							isLineTableInput.ratio = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationInput.ratio, 0));							
							if fillLevelInformationInput.foodGroupFillTypes ~= nil then
								for a=1,  #fillLevelInformationInput.foodGroupFillTypes do
									if fillLevelInformationInput.foodGroupFillTypes[a] ~= nil then
										local fillType = moFillTypes.values.fillTypes[fillLevelInformationInput.foodGroupFillTypes[a]];
										if isLineTableInput.fillTypeNames ~= nil then isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. "-";else isLineTableInput.fillTypeNames="";end;
										if fillType ~= nil then
											isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. fillType.name;
										else
											isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. moLanguageXml:getTxt("unknown", nil, "Unknown");
										end;
									end;
								end;
							end;
						end;																	
						---input---
						local fillLevelInformation = moModuleSetGet:getAnimalFillLevelInformation(animal);
						if fillLevelInformation ~= nil then
							if fillLevelInformation.output ~= nil and #fillLevelInformation.output > 0 then
								for o=1, #fillLevelInformation.output do
									if fillLevelInformation.output[o] ~= nil then setOutput(fillLevelInformation.output[o]);end;
								end;
							end;
							if fillLevelInformation.input ~= nil and #fillLevelInformation.input > 0 then
								for i=1, #fillLevelInformation.input do
									if fillLevelInformation.input[i] ~= nil then setInput(fillLevelInformation.input[i]);end;
								end;
							end;
						end;						
						if generateCmd ~= nil and generateCmd then moAnimalsConfig:generateCmd(animal);end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.animals, index);
			end;
			moAnimalsConfig:deleteCmd(true);			
		end;
	end;
end;

function moAnimals:loadNumOfAnimals()
	local playerFarmId = g_currentMission.player.farmId;
	local animalSystem = g_currentMission.animalSystem;
	local types = animalSystem:getTypes();
	if types ~= nil then
		for index, _ in pairs (types) do
			local animalType = animalSystem:getTypeByIndex(index);
			if animalType ~= nil then
				if moFillTypes.values.animals[animalType.name] ~= nil then
					local numAnimals = 0;
					for _, placeable in ipairs(g_currentMission.husbandrySystem.placeables) do
						if placeable ~= nil and placeable:getOwnerFarmId() == playerFarmId and placeable:getAnimalTypeIndex() == animalType.typeIndex then
							numAnimals = numAnimals + placeable:getNumOfAnimals();
						end;
					end;					
					moFillTypes.values.animals[animalType.name].amount = numAnimals;
				end;
				
			end;
		end;		
	end;	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moAnimals.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moAnimals.update } );