moAnimalsOutput = {};

function moAnimalsOutput:load(cmdTable, slotTable)
	local playerFarmId = g_currentMission.player.farmId;
	local cmdRegName = cmdTable.regName;
	local cmdObject = cmdTable.object;	
	local lineTable = {line={}};	
	for o=1, #cmdObject do
		if cmdObject[o] ~= nil and moModuleObjects:isObject(cmdObject[o]) and cmdObject[o].mohTable ~= nil and cmdObject[o].mohTable.general ~= nil and cmdObject[o].mohTable.general[1] ~= nil then
			---check edit object name---
			local displayName = cmdObject[o]:getName();
			if displayName ~= nil and tostring(displayName) ~= tostring(cmdObject[o].mohTable.name) then 
				moAnimalsConfig:refreshCmdDisplayName(cmdRegName, displayName);
				cmdObject[o].mohTable.name = tostring(displayName);				
			end;
			---check edit object name---			
			---separator---
			local setSeparator = false;
			function setExtraSeparator()
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txtOutputTitle";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = "----";
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txtOutputTitle";
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].txt = "----";
				isLineTable.txt[2].alignment = 3;				
			end;
			---separator---
			-------------------------------general-------------------------------
			---objectName---
			local stopInOutput = false;
			local viewMoreInfo = cmdObject[o].mohTable.viewMoreInfo;			
			local viewProductionInfo = cmdObject[o].mohTable.viewProductionInfo;
			local viewProductionInfoSmall = cmdObject[o].mohTable.viewProductionInfoSmall;
			local animalGeneral = cmdObject[o].mohTable.general[1];
			local isOwned = playerFarmId == animalGeneral.ownedFarmId and playerFarmId ~= 0; 
			local canBuy = animalGeneral.ownedFarmId == 0;
			local iconColor = "gray";
			local buttonName = "buttonDown";
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};			
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].bold = true;					
			if viewProductionInfoSmall and animalGeneral.productivity ~= nil and isOwned then
				isLineTable.txt[1].txt = tostring(animalGeneral.objectName).. " (".. tostring(animalGeneral.productivity).. "%)";				
				
			else
				isLineTable.txt[1].txt = tostring(animalGeneral.objectName);
			end;
			isLineTable.txt[1].callback = moAnimalsOutput.clickAnimalObjectName;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			if g_currentMission.hl.isMouseCursor then
				if slotTable ~= nil and slotTable.help.outputOn then
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moAnimalsOutput.clickAnimalsHelpTxt}};
				end;
				iconColor = "green";
				buttonName = "buttonUp";
				if viewProductionInfoSmall then iconColor = "gray";buttonName = "buttonDown";end;				
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moAnimalsOutput.clickViewProductionInfoSmall}, ownTable={cmdObject[o].rootNode}, infoTxt="Animal Info Small"};
			end;
			if viewProductionInfoSmall and animalGeneral.productivityWarning and slotTable ~= nil and slotTable.isWarning and isOwned and not canBuy then
				if not g_currentMission.hl.runsTimer("1sec", true) or not slotTable.isWarningBlinking then
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="viewWarning", color="yellow", modName="MultiOverlayV4", groupName="slotoutput", infoTxt="Animals have Problem"};
				end;
			elseif not isOwned and canBuy then
				iconColor = "red";
				local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
				local tempCanBuy = playerFarm.money >= animalGeneral.price;
				if tempCanBuy then iconColor = "green";end;
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="pricesOnOff", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moAnimalsOutput.clickBuyAnimal}, ownTable={cmdObject[o].rootNode}, infoTxt="Buy Animal"};
			end;
			local objectId = cmdObject[o].nodeId or cmdObject[o].rootNode;		
			local oX,oY,oZ = getWorldTranslation(objectId);
			if oX ~= nil and oY ~= nil and oZ ~= nil then
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
					if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
				end;
			end;		
			isLineTable.txt[1].alignment = 2;			
			if not viewProductionInfoSmall then
				if g_currentMission.hl.isMouseCursor and isOwned then
					iconColor = "gray";
					if viewMoreInfo then iconColor = "green";end;
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="moreInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moAnimalsOutput.clickViewMoreInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="More Info"};
				end;
			end;
			---objectName---
			if not viewProductionInfoSmall then
				---numAnimals---
				local numAnimalsTxt = ""
				if animalGeneral.numAnimals ~= nil and animalGeneral.numAnimals <= 0 then
					numAnimalsTxt = tostring(g_i18n:getText("ui_noAnimals"));
				else
					numAnimalsTxt = tostring(g_i18n:getText("ui_statisticViewAnimals"));
				end;
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;						
				if animalGeneral.numAnimals ~= nil and animalGeneral.numAnimals > 0 then
					isLineTable.txt[1].width = 85;
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txt";
					isLineTable.txt[2].bold = true;					
					isLineTable.txt[1].txt = numAnimalsTxt;
					isLineTable.txt[2].txt = tostring(animalGeneral.numAnimals);									
					isLineTable.txt[2].width = 15;
					isLineTable.txt[2].alignment = 3;
					isLineTable.txt[2].callback = moAnimalsOutput.clickNumAnimalsNum;
					isLineTable.txt[2].ownTable = {animalGeneral.numAnimals, animalGeneral.maxNumAnimals, animalGeneral.maxNumVisualAnimals};
					if viewMoreInfo and animalGeneral.genderFemale ~= nil and animalGeneral.genderMale ~= nil then												
						if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={},behindTxt={}};end;					
						if animalGeneral.genderFemale > 0 then iconColor = "white";else iconColor = "darkGray";end;
						isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="femaleInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", infoTxt="Female Info"};
						if animalGeneral.genderMale > 0 then iconColor = "white";else iconColor = "darkGray";end;
						isLineTable.txt[1].icon.behindTxt[#isLineTable.txt[1].icon.behindTxt+1] = {name="maleInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", infoTxt="Male Info"};												
						isLineTable.txt[2].txt = tostring(animalGeneral.genderFemale).. "/".. tostring(animalGeneral.genderMale);						
					end;
				else
					isLineTable.txt[1].txt = numAnimalsTxt;
				end;
				isLineTable.txt[1].callback = moAnimalsOutput.clickNumAnimalsTxt;
				isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};				
				---numAnimals---
				if isOwned and viewMoreInfo then				
					---age---
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("modHub_object")).. " ".. tostring(g_i18n:getText("ui_age"));
					isLineTable.txt[1].width = 70;
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txt";
					isLineTable.txt[2].bold = true;			
					if animalGeneral.age > 1 or animalGeneral.age == 0 then 
						isLineTable.txt[2].txt = tostring(animalGeneral.age).. " ".. tostring(g_i18n:getText("ui_days"));
					else
						isLineTable.txt[2].txt = tostring(animalGeneral.age).. " ".. tostring(g_i18n:getText("ui_day"));
					end;		
					isLineTable.txt[2].width = 30;
					isLineTable.txt[2].alignment = 3;
					---age---
					---costsPerActiveMonth---
					--lineTable.line[#lineTable.line+1] = {};
					--isLineTable = lineTable.line[#lineTable.line];
					--isLineTable.txt = {};
					--isLineTable.txt[1] = {};
					--isLineTable.txt[1].slotColor = "txt";
					--isLineTable.txt[1].bold = true;
					--isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_maintenance").. "/".. g_i18n:getText("ui_month"));	
					--isLineTable.txt[1].width = 70;
					--isLineTable.txt[2] = {};
					--isLineTable.txt[2].slotColor = "txt";
					--isLineTable.txt[2].bold = true;				
					--isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(animalGeneral.costsPerActiveMonth, 0, true, false));						
					--isLineTable.txt[2].width = 30;
					--isLineTable.txt[2].alignment = 3;				
					---costsPerActiveMonth---
					---fedding roboter---
					if animalGeneral.feddingRobot ~= nil and animalGeneral.feddingRobot then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						local stateString = "";
						local fillLevel = 0;
						if animalGeneral.feddingRobotFillLevel ~= nil then						
							fillLevel = animalGeneral.feddingRobotFillLevel;										
						end;
						if animalGeneral.feddingRobotState ~= nil then						
							if (animalGeneral.feddingRobotState == 2 and fillLevel > 0) or fillLevel > 0 then
								stateString = tostring(g_i18n:getText("ui_on"));
							else
								stateString = tostring(g_i18n:getText("ui_off"));
							end;						
						end;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("category_feeding")).. " ".. tostring(stateString);
						isLineTable.txt[1].width = 70;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;										
						isLineTable.txt[2].txt = tostring(fillLevel);											
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;
					end;
					---fedding roboter---
					---total SellPrice---
					if animalGeneral.totalSellPrice ~= nil then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_sellPrices")).. "/".. tostring(g_i18n:getText("fieldJob_tally_total"));
						isLineTable.txt[1].width = 70;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(animalGeneral.totalSellPrice, 0, true, false));
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;					
					end;
					---total SellPrice---
					---age animal---
					if animalGeneral.ageAnimal ~= nil and animalGeneral.numAnimals > 0 then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						local lowHighString = "";
						local lowHighSeparatorF = " (";
						local lowHighSeparatorB = ")";						
						if animalGeneral.ageAnimalClusters > 1 and animalGeneral.highestAgeAnimal ~= animalGeneral.lowestAgeAnimal and animalGeneral.highestAgeAnimal > 0 then							
							lowHighString = tostring(animalGeneral.lowestAgeAnimal).. "-".. tostring(animalGeneral.highestAgeAnimal);							
						else
							lowHighSeparatorF = "";lowHighSeparatorB = "";
						end;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;
						local ageAnimalTotalString = "";
						if animalGeneral.ageAnimalClusters > 1 then
							ageAnimalTotalString = "/".. tostring(animalGeneral.ageAnimalClusters);						
						end;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_age")).. " ".. tostring(g_i18n:getText("ui_statisticViewAnimals")).. tostring(ageAnimalTotalString).. " (^)";
						isLineTable.txt[1].width = 60;						
						isLineTable.txt[2] = {};						
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(animalGeneral.ageAnimal).. tostring(lowHighSeparatorB);
						isLineTable.txt[2].width = 40;
						isLineTable.txt[2].alignment = 3;
					end;
					---age aninaml---
					---duration---
					if animalGeneral.duration ~= nil and animalGeneral.duration >= 0 and animalGeneral.durationClusters > 0 and animalGeneral.genderFemale ~= nil and animalGeneral.genderFemale > 0 then						
						local lowHighString = "";
						local lowHighSeparatorF = " (";
						local lowHighSeparatorB = ")";							
						if animalGeneral.durationClusters > 1 and animalGeneral.highestDuration > 0 and animalGeneral.highestDuration ~= animalGeneral.lowestDuration then
							lowHighString = tostring(animalGeneral.lowestDuration).. "-".. tostring(animalGeneral.highestDuration);
						else
							lowHighSeparatorF = "";lowHighSeparatorB = "";
						end;												
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;
						local durationTotalString = "";
						if animalGeneral.durationClusters > 1 then
							durationTotalString = "/".. tostring(animalGeneral.durationClusters);							
						end;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("infohud_reproductionDuration")).. tostring(durationTotalString).. " (^)"; --statistic_reproductionRate, statistic_timeTillNextAnimal, category_feeding,infohud_reproductionDuration 
						isLineTable.txt[1].width = 60;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;													
						isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(g_i18n:formatNumMonth(animalGeneral.lowestDuration)).. tostring(lowHighSeparatorB);							
						isLineTable.txt[2].width = 40;
						isLineTable.txt[2].alignment = 3;						
					end;
					---duration---
					---reproduction---
					if animalGeneral.reproduction ~= nil and animalGeneral.reproduction >= 0 and animalGeneral.reproductionClusters > 0 and animalGeneral.genderFemale ~= nil and animalGeneral.genderFemale > 0 then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						local lowHighString = "";
						local lowHighSeparatorF = " (";
						local lowHighSeparatorB = ")";						
						if animalGeneral.reproductionClusters > 1 and animalGeneral.highestReproduction > 0 and animalGeneral.highestReproduction ~= animalGeneral.lowestReproduction then
							lowHighString = tostring(animalGeneral.lowestReproduction).. "-".. tostring(string.format("%d %%", animalGeneral.highestReproduction));
						else
							lowHighSeparatorF = "";lowHighSeparatorB = "";
						end;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						local color = animalGeneral.reproductionColor;
						if color > 1 then
							isLineTable.txt[1].prozentColor = color;
						else
							isLineTable.txt[1].slotColor = "txt";
						end;						
						isLineTable.txt[1].bold = true;
						local reproductionTotalString = "";
						if animalGeneral.reproductionClusters > 1 then
							reproductionTotalString = "/".. tostring(animalGeneral.reproductionClusters);						
						end;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("infohud_reproduction")).. tostring(reproductionTotalString).. " (%^)"; 
						isLineTable.txt[1].width = 60;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(string.format("%d %%", animalGeneral.reproduction)).. tostring(lowHighSeparatorB);
						isLineTable.txt[2].width = 40;
						isLineTable.txt[2].alignment = 3;
						if animalGeneral.highestReproduction > 0 and animalGeneral.lowestReproductionMonth ~= nil then
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};							
							if color > 1 then
								isLineTable.txt[1].prozentColor = color;
							else
								isLineTable.txt[1].slotColor = "txt";
							end;							
							isLineTable.txt[1].bold = true;
							reproductionTotalString = "";
							if animalGeneral.lowestReproductionMonthTotal ~= nil and animalGeneral.lowestReproductionMonthTotal > 1 then
								reproductionTotalString = "/".. tostring(animalGeneral.lowestReproductionMonthTotal);						
							end;							
							isLineTable.txt[1].txt = tostring(g_i18n:getText("statistic_timeTillNextAnimal")).. tostring(reproductionTotalString); 
							isLineTable.txt[1].width = 60;
							isLineTable.txt[2] = {};
							isLineTable.txt[2].slotColor = "txt";
							isLineTable.txt[2].bold = true;
							if animalGeneral.lowestReproductionMonth ~= nil and color < 7 then
								isLineTable.txt[2].txt = tostring(g_i18n:formatNumMonth(animalGeneral.lowestReproductionMonth));
							else
								isLineTable.txt[2].txt = "? ".. tostring(g_i18n:getText("ui_month"));
							end;
							isLineTable.txt[2].width = 40;
							isLineTable.txt[2].alignment = 3;
						end;
					end;
					---reproduction---					
					---puberty---
					if animalGeneral.puberty ~= nil and animalGeneral.puberty > 0 and animalGeneral.pubertyClusters > 0 and animalGeneral.genderFemale ~= nil and animalGeneral.genderFemale > 0 then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						local lowHighString = "";
						local lowHighSeparatorF = " (";
						local lowHighSeparatorB = ")";						
						if animalGeneral.pubertyClusters > 1 and animalGeneral.highestPuberty > 0 and animalGeneral.highestPuberty ~= animalGeneral.lowestPuberty then							
							lowHighString = tostring(animalGeneral.lowestPuberty).. "-".. tostring(string.format("%d %%", animalGeneral.highestPuberty));
						else
							lowHighSeparatorF = "";lowHighSeparatorB = "";
						end;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;
						local pubertyTotalString = "";
						if animalGeneral.pubertyClusters > 1 then
							pubertyTotalString = "/".. tostring(animalGeneral.pubertyClusters);						
						end;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("infohud_reproductionMinAge")).. tostring(pubertyTotalString).. " (%^)";
						isLineTable.txt[1].width = 60;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(string.format("%d %%", animalGeneral.puberty)).. tostring(lowHighSeparatorB);
						isLineTable.txt[2].width = 40;
						isLineTable.txt[2].alignment = 3;
					end;					
					---puberty---
					---health---
					if animalGeneral.health ~= nil and animalGeneral.numAnimals > 0 then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						local lowHighString = "";
						local lowHighSeparatorF = " (";
						local lowHighSeparatorB = ")";						
						if animalGeneral.healthClusters > 1 and animalGeneral.highestHealth > 0 and animalGeneral.highestHealth ~= animalGeneral.lowestHealth then							
							lowHighString = tostring(animalGeneral.lowestHealth).. "-".. tostring(string.format("%d %%", animalGeneral.highestHealth));
						else 
							lowHighSeparatorF = "";lowHighSeparatorB = "";
						end;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						local color = animalGeneral.healthColor;
						if color > 1 then
							isLineTable.txt[1].prozentColor = color;
						else
							isLineTable.txt[1].slotColor = "txt";
						end;						
						isLineTable.txt[1].bold = true;
						local healthTotalString = "";
						if animalGeneral.healthClusters > 1 then
							healthTotalString = "/".. tostring(animalGeneral.healthClusters);						
						end;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("infohud_health")).. tostring(healthTotalString).. " (%^)";
						isLineTable.txt[1].width = 60;
						isLineTable.txt[2] = {};						
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(string.format("%d %%", animalGeneral.health)).. tostring(lowHighSeparatorB);
						isLineTable.txt[2].width = 40;
						isLineTable.txt[2].alignment = 3;
					end;
					---health---
					---horse---
					if animalGeneral.isHorse then
						---horse dirt---
						if animalGeneral.dirt ~= nil and animalGeneral.numAnimals > 0 then
							if not setSeparator then setSeparator = true;setExtraSeparator();end;
							local lowHighString = "";
							local lowHighSeparatorF = " (";
							local lowHighSeparatorB = ")";							
							if animalGeneral.dirtClusters > 1 and animalGeneral.highestDirt > 0 and animalGeneral.highestDirt ~= animalGeneral.lowestDirt then							
								lowHighString = tostring(animalGeneral.lowestDirt).. "-".. tostring(string.format("%d %%", animalGeneral.highestDirt));
							else
								lowHighSeparatorF = "";lowHighSeparatorB = "";
							end;						
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};
							isLineTable.txt[1].slotColor = "txt";
							isLineTable.txt[1].bold = true;
							local dirtTotalString = "";
							if animalGeneral.dirtClusters > 1 then
								dirtTotalString = "/".. tostring(animalGeneral.dirtClusters);						
							end;
							isLineTable.txt[1].txt = tostring(g_i18n:getText("statistic_cleanliness")).. tostring(dirtTotalString).. " (%^)";
							isLineTable.txt[1].width = 60;
							isLineTable.txt[2] = {};
							isLineTable.txt[2].slotColor = "txt";
							isLineTable.txt[2].bold = true;
							isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(string.format("%d %%", animalGeneral.dirt)).. tostring(lowHighSeparatorB);
							isLineTable.txt[2].width = 40;
							isLineTable.txt[2].alignment = 3;
						end;
						---horse dirt---
						---horse fitness---
						if animalGeneral.fitness ~= nil and animalGeneral.numAnimals > 0 then
							if not setSeparator then setSeparator = true;setExtraSeparator();end;
							local lowHighString = "";
							local lowHighSeparatorF = " (";
							local lowHighSeparatorB = ")";							
							if animalGeneral.fitnessClusters > 1 and animalGeneral.highestFitness > 0 and animalGeneral.highestFitness ~= animalGeneral.lowestFitness then								
								lowHighString = tostring(lowestFitness).. "-".. tostring(string.format("%d %%", highestFitness));
							else
								lowHighSeparatorF = "";lowHighSeparatorB = "";
							end;
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};
							isLineTable.txt[1].slotColor = "txt";
							isLineTable.txt[1].bold = true;
							local fitnessTotalString = "";
							if animalGeneral.fitnessClusters > 1 then
								fitnessTotalString = "/".. tostring(animalGeneral.fitnessClusters);						
							end;
							isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_horseFitness")).. tostring(fitnessTotalString).. " (%^)";
							isLineTable.txt[1].width = 60;
							isLineTable.txt[2] = {};
							isLineTable.txt[2].slotColor = "txt";
							isLineTable.txt[2].bold = true;
							isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(string.format("%d %%", animalGeneral.fitness)).. tostring(lowHighSeparatorB);
							isLineTable.txt[2].width = 40;
							isLineTable.txt[2].alignment = 3;
						end;
						---horse fitness---
						---horse riding---
						if animalGeneral.riding ~= nil and animalGeneral.numAnimals > 0 then
							if not setSeparator then setSeparator = true;setExtraSeparator();end;
							local lowHighString = "";
							local lowHighSeparatorF = " (";
							local lowHighSeparatorB = ")";							
							if animalGeneral.ridingClusters > 1 and animalGeneral.highestRiding > 0 and animalGeneral.highestRiding ~= animalGeneral.lowestRiding then
								lowHighString = tostring(lowestRiding).. "-".. tostring(string.format("%d %%", highestRiding));
							else
								lowHighSeparatorF = "";lowHighSeparatorB = "";
							end;
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};
							isLineTable.txt[1].slotColor = "txt";
							isLineTable.txt[1].bold = true;
							local ridingTotalString = "";
							if animalGeneral.ridingClusters > 1 then
								ridingTotalString = "/".. tostring(animalGeneral.ridingClusters);						
							end;
							isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_horseDailyRiding")).. tostring(ridingTotalString).. " (%^)";
							isLineTable.txt[1].width = 60;
							isLineTable.txt[2] = {};
							isLineTable.txt[2].slotColor = "txt";
							isLineTable.txt[2].bold = true;
							isLineTable.txt[2].txt = tostring(lowHighString).. tostring(lowHighSeparatorF).. tostring(string.format("%d %%", animalGeneral.riding)).. tostring(lowHighSeparatorB);
							isLineTable.txt[2].width = 40;
							isLineTable.txt[2].alignment = 3;
						end;
						---horse riding---
					end;
					---horse---					
				else
					if not isOwned and canBuy then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
						canBuy = playerFarm.money >= animalGeneral.price;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("action_buyProductionPoint"));
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].width = 70;
						isLineTable.txt[1].callback = moAnimalsOutput.clickBuyAnimal;
						isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};					
						isLineTable.txt[2] = {};
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(animalGeneral.price, 0, true, false));
						if canBuy then
							isLineTable.txt[2].slotColor = "settingOn";
						else
							isLineTable.txt[2].slotColor = "settingOff";
						end;
						isLineTable.txt[2].callback = moAnimalsOutput.clickBuyAnimal;
						isLineTable.txt[2].ownTable = {cmdObject[o].rootNode};
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;
						stopInOutput = true;				
					elseif not isOwned and not canBuy then
						if not setSeparator then setSeparator = true;setExtraSeparator();end;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_construction_landIsNotOwned")).. " (".. tostring(g_i18n:getText("construction_category_production")).. ")";
						isLineTable.txt[1].slotColor = "settingReady";					
					end;					
				end;
				setSeparator = false;
				-------------------------------general-------------------------------
				-----------------------------productivity------------------------------
				if not animalGeneral.isHorse and not stopInOutput then
					if not setSeparator then setSeparator = true;setExtraSeparator();end;
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(animalGeneral.productivityName);
					local color = animalGeneral.productivityColor;
					if color > 1 then
						isLineTable.txt[1].prozentColor = color;
					else
						isLineTable.txt[1].slotColor = "txt";
					end;
					isLineTable.txt[1].width = 80;
					
					isLineTable.txt[2] = {};			
					isLineTable.txt[2].width = 20;	
					if color > 1 then
						isLineTable.txt[2].prozentColor = color;
					else
						isLineTable.txt[2].slotColor = "txt";
					end;
					isLineTable.txt[2].bold = true;
					if animalGeneral.productivity > 0 then
						isLineTable.txt[2].txt = animalGeneral.productivity.. "%";				
					else
						isLineTable.txt[2].txt = "0%";	
					end;
					isLineTable.txt[2].alignment = 3;
					if g_currentMission.hl.isMouseCursor then
						iconColor = "gray";
						buttonName = "buttonDown";
						if viewProductionInfo then iconColor = "green";buttonName = "buttonUp";end;				
						isLineTable.txt[1].icon = {before={},after={},behindTxt={}};
						isLineTable.txt[1].icon.behindTxt[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moAnimalsOutput.clickViewProductionInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="Production Info"};
					end;
				elseif animalGeneral.isHorse then
					viewProductionInfo = true;
				end;
				setSeparator = false;
				-----------------------------productivity------------------------------
				-----------------------------output input------------------------------			
				if isOwned then					
					local animalOutput = cmdObject[o].mohTable.output;
					local animalInput = cmdObject[o].mohTable.input;
					local viewOutput = cmdObject[o].mohTable.viewOutput;
					local viewInput = cmdObject[o].mohTable.viewInput;						
					if not stopInOutput and viewProductionInfo then						
						---output---
						if #animalOutput > 0 then
							if #animalOutput > 2 then
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];			
								isLineTable.txt = {};			
								isLineTable.txt[1] = {};			
								isLineTable.txt[1].slotColor = "txt";
								isLineTable.txt[1].bold = true;			
								if not moModule.values.inputOutputInLanguage then
									isLineTable.txt[1].txt = "Out ++ ".. "(".. tostring(#animalOutput).. ")";			
								else
									isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_outgoingProducts")).. " (".. tostring(#animalOutput).. ")";
								end;								
								isLineTable.txt[1].callback = moAnimalsOutput.clickViewInputOutputOnOff;
								isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 1};
								iconColor = "red";
								buttonName = "buttonDown";
								if viewOutput then iconColor = "green";buttonName = "buttonUp";end;
								isLineTable.txt[1].icon = {before={},after={}};
								isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moAnimalsOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode, 1}};
							else
								viewOutput = true;
							end;
							if viewOutput then
								for output=1, #animalOutput do
									if animalOutput[output] ~= nil then
										lineTable.line[#lineTable.line+1] = {};
										isLineTable = lineTable.line[#lineTable.line];
										isLineTable.txt = {};
										isLineTable.txt[1] = {};
										isLineTable.txt[1].slotColor = "txt";
										isLineTable.txt[1].bold = false;
										isLineTable.txt[1].txt = tostring(animalOutput[output].groupName);
										isLineTable.txt[1].width = 60;
										if animalOutput[output].fillTypeNames ~= nil then
											isLineTable.txt[1].callback = moAnimalsOutput.clickOutInGroupName;
											isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 1, tostring(animalOutput[output].groupName), tostring(animalOutput[output].fillTypeNames)};
										end;
										isLineTable.txt[2] = {};
										isLineTable.txt[2].slotColor = "txt";
										isLineTable.txt[2].bold = false;
										isLineTable.txt[2].txt = tostring(animalOutput[output].fillLevel);
										isLineTable.txt[2].callback = moAnimalsOutput.clickFillLevelCapacity;
										isLineTable.txt[2].ownTable = {cmdObject[o].rootNode, tostring(animalGeneral.objectName), tostring(animalOutput[output].groupName), tostring(animalOutput[output].capacity)};
										isLineTable.txt[2].width = 40;
										isLineTable.txt[2].alignment = 3;
									end;
								end;
							end;
						end;
						---output---
						---input---
						if #animalInput > 0 then
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];			
							isLineTable.txt = {};			
							isLineTable.txt[1] = {};			
							isLineTable.txt[1].slotColor = "txt";
							isLineTable.txt[1].bold = true;										
							if not moModule.values.inputOutputInLanguage then
								isLineTable.txt[1].txt = "In ++ ".. "(".. tostring(#animalInput).. ")";				
							else
								isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_incomingMaterials")).. " (".. tostring(#animalInput).. ")";
							end;							
							isLineTable.txt[1].callback = moAnimalsOutput.clickViewInputOutputOnOff;
							isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 2};
							iconColor = "red";
							buttonName = "buttonDown";
							if viewInput then iconColor = "green";buttonName = "buttonUp";end;
							isLineTable.txt[1].icon = {before={},after={}};
							isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moAnimalsOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode, 2}};
							if viewInput then
								for input=1, #animalInput do
									if animalInput[input] ~= nil then
										lineTable.line[#lineTable.line+1] = {};
										isLineTable = lineTable.line[#lineTable.line];
										isLineTable.txt = {};
										isLineTable.txt[1] = {};
										isLineTable.txt[1].slotColor = "txt";
										isLineTable.txt[1].bold = false;
										isLineTable.txt[1].txt = tostring(animalInput[input].groupName);
										isLineTable.txt[1].width = 70;
										if animalInput[input].fillTypeNames ~= nil then
											isLineTable.txt[1].callback = moAnimalsOutput.clickOutInGroupName;
											isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 2, tostring(animalInput[input].groupName), tostring(animalInput[input].fillTypeNames)};
										end;
										isLineTable.txt[2] = {};
										isLineTable.txt[2].slotColor = "txt";
										isLineTable.txt[2].bold = false;
										isLineTable.txt[2].txt = tostring(animalInput[input].fillLevel); --tostring(animalInput[input].percentageCapacity).. "%";
										isLineTable.txt[2].callback = moAnimalsOutput.clickFillLevelCapacity;
										isLineTable.txt[2].ownTable = {cmdObject[o].rootNode, tostring(animalGeneral.objectName), tostring(animalInput[input].groupName), tostring(animalInput[input].capacity)};
										isLineTable.txt[2].width = 30;
										isLineTable.txt[2].alignment = 3;						
									end;
								end;
							end;
						end;
						---input---						
					end;				
				end;
				-----------------------------output input------------------------------
			end;
			---objectLineDistance---
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};		
			isLineTable.txt[1].txt = " ";
			---objectLineDistance---
		end;
	end;
	moAnimals[cmdRegName] = {output=lineTable};
end;

function moAnimalsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.object == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="animals" } );
	moAnimalsOutput:load(args.cmdTable, args.slotTable);
	return moAnimals[args.cmdTable.regName].output;
end;

function moAnimalsOutput.clickAnimalHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Animal Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Animal Name/Productivity Name for more Info or MapHotSpot or ...\nClick Mouse Right Optional Titel Animal Name for Teleport(onFoot)";
	end;
end;

function moAnimalsOutput.clickViewMoreInfo(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				object.mohTable.viewMoreInfo = not object.mohTable.viewMoreInfo;
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickViewProductionInfoSmall(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				object.mohTable.viewProductionInfoSmall = not object.mohTable.viewProductionInfoSmall;
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickBuyAnimal(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				--object.spec_productionPoint.productionPoint:buyRequest();				
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickViewProductionInfo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				object.mohTable.viewProductionInfo = not object.mohTable.viewProductionInfo;
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickOutInGroupName(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and args.ownTable[3] ~= nil and args.ownTable[4] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				if args.ownTable[2] == 1 then
					moSetGetOverlays.infoHelpBox.info.titel = "Animal *".. tostring(args.ownTable[3]).. "*";
					moSetGetOverlays.infoHelpBox.info.txt = tostring(args.ownTable[4]);
				else
					moSetGetOverlays.infoHelpBox.info.titel = "Animal ".. tostring(g_i18n:getText("ui_animalFood")).. ": *".. tostring(args.ownTable[3]).. "*";
					moSetGetOverlays.infoHelpBox.info.txt = tostring(args.ownTable[4]);
				end;
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickNumAnimalsTxt(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moAnimalsOutput.clickNumAnimals title"); --force mouseOff		
			moModule:showInGameMenuFrame("pageAnimals", args.ownTable[1], false, true, 0);
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			moModule:showInGameMenuFrame("pageAnimals", args.ownTable[1], false, false, 0);			
		end;	
	end;
end;

function moAnimalsOutput.clickNumAnimalsNum(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and args.ownTable[3] ~= nil then
			moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.info.titel = "Animal Info";
			local capacityLanguage = g_i18n:getText("shop_capacity");
			local animalLanguage = g_i18n:getText("ui_statisticViewAnimals");
			local warningTxt = g_i18n:getText("shop_messageNotEnoughSpaceAnimals");
			local moreTxt = "";
			if args.ownTable[1] == args.ownTable[2] then moreTxt = "\n".. warningTxt;
			else
				moreTxt = "\n".. tostring(g_i18n:getText("ui_freeSlots")).. ": ".. tostring(args.ownTable[2]-args.ownTable[1]).. " ".. tostring(animalLanguage).. "\n".. 
				tostring(g_i18n:getText("helpLine_FirstSteps_Seasons_visual_title")).. ": ".. tostring(args.ownTable[3]).. " ".. tostring(animalLanguage);
			end;
			moSetGetOverlays.infoHelpBox.info.txt = tostring(capacityLanguage).. ": ".. tostring(args.ownTable[2]).. " ".. tostring(animalLanguage).. tostring(moreTxt) ;
		end;		
	end;
end;

function moAnimalsOutput.clickFillLevelCapacity(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				local capacityLanguage = g_i18n:getText("shop_capacity");
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.titel = "Animal Info";
				moSetGetOverlays.infoHelpBox.info.txt = tostring(args.ownTable[2]).. ": ".. tostring(args.ownTable[3]).. "\n".. capacityLanguage.. " ".. tostring(args.ownTable[4]);
			end;
		end;
	end;
end;

function moAnimalsOutput.clickAnimalObjectName(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then					
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moAnimalsOutput.clickAnimalObjectName"); --force mouseOff
				end;				
			end;
		end;	
	end;
end;

function moAnimalsOutput.clickViewInputOutputOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then					
			local object = moModuleObjects:getObject(args.ownTable[1], "animals");			
			if object ~= nil then				
				if args.ownTable[2] == 1 then
					object.mohTable.viewOutput = not object.mohTable.viewOutput;
				elseif args.ownTable[2] == 2 then
					object.mohTable.viewInput = not object.mohTable.viewInput;
				end;
			end;			
		end;
	end;
end;
moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="animals" } );