moBeehives = {};
source(MultiOverlayV4.modDir.."scripte/module/beehives/moBeehivesConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/beehives/moBeehivesOutput.lua");

function moBeehives:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="beehives"} ) then
		if moBeehivesConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateBeehives"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moBeehivesConfig.values.updateTimer, name="updateBeehives", repeatable=1, ms=moBeehivesConfig.values.msec, action=moBeehives.load} ); 
		else
			moBeehives:load();
		end;
	end;
end;

function moBeehives.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moBeehivesConfig.values == nil then moBeehivesConfig:defaultValues();end;
	if update == nil or not update then moBeehivesConfig:generateAllCmd();end;
	if update then moBeehivesConfig:deleteCmd();end;
	moBeehives:loadAllBeehives(true);	
end;

function moBeehives.load() --updateTimer Callback	
	moBeehives:loadAllBeehives();	
end;
local test = true;
function moBeehives:loadAllBeehives(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	if moModule.beehives ~= nil and #moModule.beehives > 0 then
		local deleteObject = {};
		for index=1, #moModule.beehives do			
			if moModule.beehives[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.beehives[index].object);
				if isObject then
					local beehive = moModule.beehives[index].object;
					local isViewOutput = (generateCmd ~= nil and generateCmd) or beehive.ownerFarmId == playerFarmId or beehive.ownerFarmId == 0;
					if isViewOutput then						
						if beehive.mohTable == nil then
							beehive.mohTable = {general={},production={},output={},input={}};						
						else
							beehive.mohTable.general={};beehive.mohTable.production={};beehive.mohTable.output={};beehive.mohTable.input={};
						end;
						if beehive.mohTable.viewOutput == nil then beehive.mohTable.viewOutput = {};end;	
						if beehive.mohTable.viewInput == nil then beehive.mohTable.viewInput = {};end;
						if beehive.mohTable.viewMoreInfo == nil then beehive.mohTable.viewMoreInfo = false;end;						
						if beehive.mohTable.viewProductionInfo == nil then beehive.mohTable.viewProductionInfo = {};end;
						---general---
						beehive.mohTable.general[#beehive.mohTable.general+1] = {};
						local isLineTableGeneral = beehive.mohTable.general[#beehive.mohTable.general];
						if beehive.mohDisplayName ~= nil then 
							isLineTableGeneral.objectName = beehive.mohTable.mohDisplayName;
						else
							isLineTableGeneral.objectName = beehive.mohTable.name;
						end;
						isLineTableGeneral.age = beehive.age;
						isLineTableGeneral.productivityName = g_i18n:getText("statistic_productivity");
						isLineTableGeneral.productivityColor = 2;
						isLineTableGeneral.costsPerActiveMonth = 0;
						isLineTableGeneral.ownedFarmId = beehive.ownerFarmId;
						isLineTableGeneral.price = Utils.getNoNil(beehive.price, 0);
						isLineTableGeneral.productionActive = beehive.spec_beehive.isProductionActive;
						isLineTableGeneral.fillLevel = 0;
						isLineTableGeneral.isWinter = g_currentMission.environment.currentSeason == Environment.SEASON.WINTER;
						isLineTableGeneral.radius = beehive.spec_beehive.actionRadius;
						isLineTableGeneral.pal = -1;	
						local honeyPerHour = beehive.spec_beehive.honeyPerHour * g_currentMission.environment.timeAdjustment;						
						if not isLineTableGeneral.productionActive or isLineTableGeneral.isWinter then honeyPerHour = 0;end;
						isLineTableGeneral.honeyPerHourUnFormat = Utils.getNoNil(g_i18n:getVolume(honeyPerHour), 0);						
						isLineTableGeneral.honeyPerHour = string.format(g_i18n:getText("shop_incomeValue"), g_i18n:formatVolume(isLineTableGeneral.honeyPerHourUnFormat, 1));
						isLineTableGeneral.honeyPerDay = string.format(g_i18n:getText("shop_maintenanceValue"), g_i18n:formatVolume(isLineTableGeneral.honeyPerHourUnFormat*24, 1));						
						if beehive.ownerFarmId == playerFarmId then
							local honeyPal = g_currentMission.beehiveSystem:getFarmBeehivePalletSpawner(playerFarmId);
							if honeyPal ~= nil then
								if honeyPal.spec_beehivePalletSpawner.palletSpawner ~= nil and honeyPal.spec_beehivePalletSpawner.palletSpawner.spawnPlaces ~= nil then
									isLineTableGeneral.fillLevel = honeyPal.spec_beehivePalletSpawner.pendingLiters;
									isLineTableGeneral.pal = Utils.getNoNil(#honeyPal.spec_beehivePalletSpawner.palletSpawner.spawnPlaces, 0);
								end;
							end;
						end;
						local foundVot, isOpening, votOpeningTime, votOpeningTimeString, votSpecialeActive, votSpecialeStop = moModuleSetGet:getVotMod(beehive); --VariableOpeningTime Mod Support
						if foundVot then
							isLineTableGeneral.vot = {};
							isLineTableGeneral.vot.openingTime = votOpeningTime;
							isLineTableGeneral.vot.isOpening = isOpening;
							isLineTableGeneral.vot.openingTimeString = votOpeningTimeString;
							isLineTableGeneral.vot.specialeActive = votSpecialeActive;
							isLineTableGeneral.vot.specialeStop = votSpecialeStop;								
						end;
						---general---						
						---input---											
																							
						---input---																	
						if generateCmd ~= nil and generateCmd then moBeehivesConfig:generateCmd(beehive);end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.beehives, index);
			end;
			moBeehivesConfig:deleteCmd(true);			
		end;
	end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moBeehives.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moBeehives.update } );