moBunkerSilos = {};
source(MultiOverlayV4.modDir.."scripte/module/bunkerSilos/moBunkerSilosConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/bunkerSilos/moBunkerSilosOutput.lua");

function moBunkerSilos:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="bunkerSilos"} ) then
		if moBunkerSilosConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateBunkerSilos"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moBunkerSilosConfig.values.updateTimer, name="updateBunkerSilos", repeatable=1, ms=moBunkerSilosConfig.values.msec, action=moBunkerSilos.load} ); 
		else
			moBunkerSilos:load();
		end;
	end;
end;

function moBunkerSilos.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moBunkerSilosConfig.values == nil then moBunkerSilosConfig:defaultValues();end;
	if update then moBunkerSilosConfig:deleteCmd();end;
	moBunkerSilos:loadAllBunkerSilos(true);	
end;

function moBunkerSilos.load() --updateTimer Callback	
	moBunkerSilos:loadAllBunkerSilos();	
end;
local test = true;
function moBunkerSilos:loadAllBunkerSilos(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	if moModule.bunkerSilos ~= nil and #moModule.bunkerSilos > 0 then
		local deleteObject = {};
		for index=1, #moModule.bunkerSilos do			
			if moModule.bunkerSilos[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.bunkerSilos[index].object);
				if isObject then
					local bunkerSilo = moModule.bunkerSilos[index].object;
					local isViewOutput = (generateCmd ~= nil and generateCmd) or bunkerSilo.ownerFarmId == playerFarmId or bunkerSilo.ownerFarmId == 0;
					if isViewOutput then										
						if bunkerSilo.mohTable == nil then
							bunkerSilo.mohTable = {general={},production={},output={},input={}};						
						else
							bunkerSilo.mohTable.general={};bunkerSilo.mohTable.production={};bunkerSilo.mohTable.output={};bunkerSilo.mohTable.input={};
						end;
						if bunkerSilo.mohTable.viewOutput == nil then bunkerSilo.mohTable.viewOutput = false;end;	
						if bunkerSilo.mohTable.viewInput == nil then bunkerSilo.mohTable.viewInput = false;end;
						if bunkerSilo.mohTable.viewMoreInfo == nil then bunkerSilo.mohTable.viewMoreInfo = false;end;
						if bunkerSilo.mohTable.viewProductionInfo == nil then bunkerSilo.mohTable.viewProductionInfo = false;end;						
						if bunkerSilo.mohTable.viewProductionInfoSmall == nil then bunkerSilo.mohTable.viewProductionInfoSmall = true;end;
						---general output---
						bunkerSilo.mohTable.general[#bunkerSilo.mohTable.general+1] = {};
						local isLineTableGeneral = bunkerSilo.mohTable.general[#bunkerSilo.mohTable.general];
						if bunkerSilo.mohDisplayName ~= nil then 
							isLineTableGeneral.objectName = bunkerSilo.mohTable.mohDisplayName;
						else
							isLineTableGeneral.objectName = bunkerSilo.mohTable.name;
						end;
						isLineTableGeneral.age = bunkerSilo.age;
						isLineTableGeneral.costsPerActiveMonth = 0;
						isLineTableGeneral.ownedFarmId = bunkerSilo.ownerFarmId;
						isLineTableGeneral.price = Utils.getNoNil(bunkerSilo.price, 0);						
						---general output---
						
						---infoGeneral---
						function setInfoGeneral(info)
							isLineTableGeneral.compactedPercent = Utils.getNoNil(info.compactedPercent, 0);
							isLineTableGeneral.compactedFillLevel = Utils.getNoNil(info.compactedFillLevel, 0);
							isLineTableGeneral.fermentingPercent = Utils.getNoNil(info.fermentingPercent, 0);
							isLineTableGeneral.state = Utils.getNoNil(info.state, 0);
							isLineTableGeneral.fermentingColor = g_currentMission.hl.getProzentColor(Utils.getNoNil(isLineTableGeneral.fermentingPercent*100, 0), true);
							if isLineTableGeneral.fermentingColor == 1 and (isLineTableGeneral.state == BunkerSilo.STATE_CLOSED or isLineTableGeneral.state == STATE_FERMENTED) then isLineTableGeneral.fermentingColor = 2;end;
							if isLineTableGeneral.compactedPercent >= 50 and isLineTableGeneral.compactedPercent <= 80 then 
								isLineTableGeneral.compactedColor = 4;
							elseif isLineTableGeneral.compactedPercent > 80 and isLineTableGeneral.compactedPercent <= 98 then 
								isLineTableGeneral.compactedColor = 3;
							elseif isLineTableGeneral.compactedPercent > 98 then 
								isLineTableGeneral.compactedColor = 2;	
							else
								isLineTableGeneral.compactedColor = 1;
							end;							
						end;
						---infoGeneral---
						---output---											
						function setOutput(fillLevelInformationOutput)													
							bunkerSilo.mohTable.output[#bunkerSilo.mohTable.output+1] = {};							
							local isLineTableOutput = bunkerSilo.mohTable.output[#bunkerSilo.mohTable.output];
							local fillType = moFillTypes.values.fillTypes[fillLevelInformationOutput.fillType];
							if fillType ~= nil then
								isLineTableOutput.fillTypeName = fillType.name;
							else
								isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
							end;							
							isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationOutput.fillLevel, 0));													
						end;
						---output---
						---input---											
						function setInput(fillLevelInformationInput)							
							bunkerSilo.mohTable.input[#bunkerSilo.mohTable.input+1] = {};	
							local isLineTableInput = bunkerSilo.mohTable.input[#bunkerSilo.mohTable.input];
							isLineTableInput.groupName = fillLevelInformationInput.title;
							isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevelInformationInput.fillLevel, 0));							
							local moreFillTypes = 0;
							if fillLevelInformationInput.groupFillTypes ~= nil then
								for a=1,  #fillLevelInformationInput.groupFillTypes do
									if fillLevelInformationInput.groupFillTypes[a] ~= nil then
										local fillType = moFillTypes.values.fillTypes[fillLevelInformationInput.groupFillTypes[a]];
										if isLineTableInput.fillTypeNames ~= nil then isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. "-";else isLineTableInput.fillTypeNames="";end;
										if fillType ~= nil then
											isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. fillType.name;
										else
											isLineTableInput.fillTypeNames = isLineTableInput.fillTypeNames.. moLanguageXml:getTxt("unknown", nil, "Unknown");
										end;
										moreFillTypes = moreFillTypes+1;
									end;
								end;
							end;
							if moreFillTypes > 0 then isLineTableInput.groupName = isLineTableInput.groupName.. " (".. tostring(moreFillTypes).. ")";end;
						end;																	
						---input---
						local fillLevelInformation = moModuleSetGet:getBunkerSiloFillLevelInformation(bunkerSilo);
						if fillLevelInformation ~= nil then
							if fillLevelInformation.output ~= nil and #fillLevelInformation.output > 0 then
								for o=1, #fillLevelInformation.output do
									if fillLevelInformation.output[o] ~= nil then setOutput(fillLevelInformation.output[o]);end;
								end;
							end;
							if fillLevelInformation.input ~= nil and #fillLevelInformation.input > 0 then
								for i=1, #fillLevelInformation.input do
									if fillLevelInformation.input[i] ~= nil then setInput(fillLevelInformation.input[i]);end;
								end;
							end;
							if fillLevelInformation.info ~= nil and #fillLevelInformation.info > 0 then
								for i=1, #fillLevelInformation.info do
									if fillLevelInformation.info[i] ~= nil then setInfoGeneral(fillLevelInformation.info[i]);end;
								end;
							end;
						end;						
						if generateCmd ~= nil and generateCmd then moBunkerSilosConfig:generateCmd(bunkerSilo);end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.bunkerSilos, index);
			end;
			moBunkerSilosConfig:deleteCmd(true);			
		end;
	end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moBunkerSilos.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moBunkerSilos.update } );