moBuyingStations = {};
source(MultiOverlayV4.modDir.."scripte/module/buyingStations/moBuyingStationsConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/buyingStations/moBuyingStationsOutput.lua");

function moBuyingStations:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="buyingStations"} ) then
		if moBuyingStationsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateBuyingStations"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moBuyingStationsConfig.values.updateTimer, name="updateBuyingStations", repeatable=1, ms=moBuyingStationsConfig.values.msec, action=moBuyingStations.load} ); 
		else
			moBuyingStations:load();
		end;
	end;
end;

function moBuyingStations.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moBuyingStationsConfig.values == nil then moBuyingStationsConfig:defaultValues();end;	
	if update == nil or not update then moBuyingStationsConfig:generateCmd();end;
	moBuyingStations:loadAllBuyingStations();
	
end;

function moBuyingStations.load() --updateTimer Callback	
	moBuyingStations:loadAllBuyingStations();	
end;

function moBuyingStations:loadAllBuyingStations()
	local playerFarmId = g_currentMission.player.farmId;	
	--local farmId = g_currentMission:getFarmId();	
	if moModule.buyingStations ~= nil and #moModule.buyingStations > 0 then
		local deleteObject = {};
		for index=1, #moModule.buyingStations do			
			if moModule.buyingStations[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.buyingStations[index].object);
				if isObject then
					local buyingStation = moModule.buyingStations[index].object;
					if buyingStation ~= nil and buyingStation.spec_buyingStation ~= nil and buyingStation.spec_buyingStation.buyingStation ~= nil then
						local node = Utils.getNoNil(buyingStation.rootNode, buyingStation.nodeId);
						local mohDisplayName = "Unknown";
						if buyingStation.mohTable ~= nil then 
							mohDisplayName = Utils.getNoNil(buyingStation.mohTable.name, "Unknown");
							buyingStation.mohTable.general={};buyingStation.mohTable.output={};buyingStation.mohTable.input={};
						else							
							buyingStation.mohTable = {general={},output={},input={}};							
						end;
						if buyingStation.mohTable.viewOutput == nil then buyingStation.mohTable.viewOutput = false;end;
						local spec_buyingStation = buyingStation.spec_buyingStation.buyingStation;
						local stationName = spec_buyingStation.uiName;
						if stationName == nil or type(stationName) ~= "string" or stationName:len() <= 0 then stationName = mohDisplayName;end;
						buyingStation.mohTable.general[#buyingStation.mohTable.general+1] = {};
						local isLineTableGeneral = buyingStation.mohTable.general[#buyingStation.mohTable.general];						
						isLineTableGeneral.objectName = stationName;
						
						local foundVot, isOpening, votOpeningTime, votOpeningTimeString, votSpecialeActive, votSpecialeStop = moModuleSetGet:getVotMod(spec_buyingStation); --VariableOpeningTime Mod Support
						if foundVot then
							isLineTableGeneral.vot = {};
							isLineTableGeneral.vot.openingTime = votOpeningTime;
							isLineTableGeneral.vot.isOpening = isOpening;
							isLineTableGeneral.vot.openingTimeString = votOpeningTimeString;
							isLineTableGeneral.vot.specialeActive = votSpecialeActive;
							isLineTableGeneral.vot.specialeStop = votSpecialeStop;								
						end;
					
						
						---output---	
						function setOutput(fillTypeIndex, price, priceTrend)
							buyingStation.mohTable.output[#buyingStation.mohTable.output+1] = {};
							local isLineTableOutput = buyingStation.mohTable.output[#buyingStation.mohTable.output];	
							local fillType = moFillTypes.values.fillTypes[fillTypeIndex];
							if fillType ~= nil then
								isLineTableOutput.fillTypeName = fillType.name;
							else
								isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
							end;
							isLineTableOutput.fillType = fillTypeIndex;
							isLineTableOutput.price = price;
							isLineTableOutput.priceTrend = priceTrend;
						end;
						---output---
						
						for fillType,isAccepted in pairs(spec_buyingStation.providedFillTypes) do
							if isAccepted and spec_buyingStation:getIsFillTypeSupported(fillType) then
								local difficultyMultiplier = 1000;
								--if moFillTypes.values.bestPrice[fillType] == nil then
								--	moFillTypes.values.bestPrice[fillType] = {};									
								--end;								
								--local price = spec_buyingStation:getEffectiveFillTypePrice(fillType)*difficultyMultiplier;
								local price = math.floor(spec_buyingStation:getEffectiveFillTypePrice(fillType) * difficultyMultiplier - 0.5);
								--local priceTrend = spec_buyingStation:getCurrentPricingTrend(fillType)
								local isPriceTrend = "normal";
								--if priceTrend ~= nil then
								--	if Utils.isBitSet(priceTrend, SellingStation.PRICE_GREAT_DEMAND) then
								--		isPriceTrend = "greatDemand";
								--		isLineTableGeneral.isGreatDemand = true;
								--	elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_CLIMBING) then
								--		isPriceTrend = "up";
								--	elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_FALLING) then
								--		isPriceTrend = "down";
								--	end;
								--end;
								setOutput(fillType, price, isPriceTrend);
								--moFillTypes.values.bestPrice[fillType][#moFillTypes.values.bestPrice[fillType]+1] = {price, stationName, isPriceTrend, index, node};
							end;
						end;						
					end;
				end;	
			else
				table.insert(deleteObject, index);
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.buyingStations, index);
			end;						
		end;
		--function comp(w1,w2)		
		--	if w1[1] > w2[1] then
		--		return true;
		--	end;				
		--end;		
		--for index, _ in pairs(moFillTypes.values.bestPrice) do
		--	table.sort(moFillTypes.values.bestPrice[index], comp);
		--end;		
	end;	
end;


moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moBuyingStations.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moBuyingStations.update } );