moBuyingStationsConfig = {};

function moBuyingStationsConfig:defaultValues()
	moBuyingStationsConfig.values = {station={}, updateTimer=30, msec=true};
end;

function moBuyingStationsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moBuyingStationsConfig.values == nil then moBuyingStationsConfig:defaultValues();end;	
	--local groupNameTag = (xmlNameTag.. ".module.buyingStations(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
	--	moBuyingStationsConfig.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moBuyingStationsConfig.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;	
end;

function moBuyingStationsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;	
	if moBuyingStationsConfig.values == nil then moBuyingStationsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.buyingStations(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moBuyingStationsConfig.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moBuyingStationsConfig.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moBuyingStationsConfig:generateCmd(object)
	function generateCmd(cmdName, displayName, object, ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = cmdName;
				groupName = "BuyingStations";			
				displayName = tostring(displayName);
				infoTxt = "View All BuyingStaions";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {object};
				actionCallback = moBuyingStationsOutput.giveOutputTable;			
			}
		)
	end;
	if object ~= nil and moModuleObjects:isObject(object) then
		local objectId = object.nodeId or object.rootNode;		
		local x, y ,z = getWorldTranslation(objectId);
		local cmdName = "";
		local displayName = object.mohTable.name;
		local tempName = object.mohTable.cmdName;		
		if x == nil or y == nil or z == nil then			
			cmdName = "output_buyingStation_".. tostring(tempName).. "_";
		else
			cmdName = "output_buyingStation_".. tostring(tempName).. "_x"..tostring(x).."_y"..tostring(y).."_z"..tostring(z).."_";
		end;
		if MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName] ~= nil and MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName].object ~= nil then
			MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName].object[#MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName].object+1] = object;
		else
			generateCmd(cmdName, displayName, object, {});
		end;
	else
		local displayName = g_i18n:getText("station_us_shoppingMall"); --moLanguageXml:getTxt("buyingstations", nil, "Stations:");
		local cmdName = "output_buyingStations_";
		generateCmd(cmdName, displayName, nil, {"simpleBuyingStations"});
	end;
end;


moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moBuyingStationsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moBuyingStationsConfig.saveXml } );
