moChargingStations = {};
source(MultiOverlayV4.modDir.."scripte/module/chargingStations/moChargingStationsConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/chargingStations/moChargingStationsOutput.lua");

function moChargingStations:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="chargingStations"} ) then
		if moChargingStationsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateChargingStations"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moChargingStationsConfig.values.updateTimer, name="updateChargingStations", repeatable=1, ms=moChargingStationsConfig.values.msec, action=moChargingStations.load} ); 
		else
			moChargingStations:load();
		end;
	end;
end;

function moChargingStations.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moChargingStationsConfig.values == nil then moChargingStationsConfig:defaultValues();end;	
	if update == nil or not update then moChargingStationsConfig:generateCmd();end;
	moChargingStations:loadAllChargingStations();
	
end;

function moChargingStations.load() --updateTimer Callback	
	moChargingStations:loadAllChargingStations();	
end;

function moChargingStations:loadAllChargingStations()
	local playerFarmId = g_currentMission.player.farmId;	
	--local farmId = g_currentMission:getFarmId();	
	if moModule.chargingStations ~= nil and #moModule.chargingStations > 0 then
		local deleteObject = {};
		for index=1, #moModule.chargingStations do			
			if moModule.chargingStations[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.chargingStations[index].object);
				if isObject then
					local chargingStation = moModule.chargingStations[index].object;
					if chargingStation ~= nil and chargingStation.spec_chargingStation ~= nil then
						local node = Utils.getNoNil(chargingStation.rootNode, chargingStation.nodeId);
						local mohDisplayName = "Unknown";
						if chargingStation.mohTable ~= nil then 
							mohDisplayName = Utils.getNoNil(chargingStation.mohTable.name, "Unknown");
							chargingStation.mohTable.general={};chargingStation.mohTable.output={};chargingStation.mohTable.input={};
						else							
							chargingStation.mohTable = {general={},output={},input={}};							
						end;
						if chargingStation.mohTable.viewOutput == nil then chargingStation.mohTable.viewOutput = false;end;
						if chargingStation.mohTable.viewChargingInfoSmall == nil then chargingStation.mohTable.viewChargingInfoSmall = true;end;
						local stationName = nil;
						if chargingStation.spec_chargingStation.buyingStation ~= nil then
							stationName = chargingStation.spec_chargingStation.buyingStation.uiName;
						end;
						if stationName == nil or type(stationName) ~= "string" or stationName:len() <= 0 then stationName = mohDisplayName;end;
						chargingStation.mohTable.general[#chargingStation.mohTable.general+1] = {};
						local isLineTableGeneral = chargingStation.mohTable.general[#chargingStation.mohTable.general];						
						isLineTableGeneral.objectName = stationName;						
						---infoGeneral---
						isLineTableGeneral.status = 0;
						isLineTableGeneral.statusColor = 1;
						isLineTableGeneral.statusTxt = "";
						isLineTableGeneral.vehicleName = "";
						local fillLevel, capacity = 0,1;
						if chargingStation.spec_chargingStation.loadTrigger ~= nil then
							local isActive = next(chargingStation.spec_chargingStation.loadTrigger.fillableObjects) ~= nil;
							if chargingStation.spec_chargingStation.chargeIndicatorNode ~= nil and isActive then
								fillLevel, capacity = chargingStation:getChargeState();
								if fillLevel / capacity > 0.99 then
									isLineTableGeneral.status = 3;
									isLineTableGeneral.statusColor = 2;
								else
									isLineTableGeneral.status = 2;
									isLineTableGeneral.statusColor = 4;
								end;								
							end;
							if chargingStation.spec_chargingStation.loadTrigger.isLoading then
								fillLevel, capacity = chargingStation:getChargeState();
								local fillLevelToFill = capacity - fillLevel;
								local literPerSecond = chargingStation.spec_chargingStation.loadTrigger.fillLitersPerMS * 1000;
								local seconds = fillLevelToFill / literPerSecond;
								if seconds >= 1 then
									local minutes = math.floor(seconds / 60);
									seconds = seconds - minutes * 60;
									isLineTableGeneral.statusTxt = string.format(g_i18n:getText("info_chargeTime"), minutes, seconds, fillLevel / capacity * 100);
								end;								
							else
								isLineTableGeneral.status = 1;
							end;
							local index = next(chargingStation.spec_chargingStation.loadTrigger.fillableObjects)
							if index ~= nil then
								local vehicle = chargingStation.spec_chargingStation.loadTrigger.fillableObjects[index].object;
								isLineTableGeneral.vehicleName = Utils.getNoNil(vehicle.getFullName(vehicle), "Unknown");
							else
								isLineTableGeneral.status = 0;
							end;
						end;						
						---infoGeneral---
						
						---output---	
						function setOutput(fillTypeIndex, price, priceTrend)
							chargingStation.mohTable.output[#chargingStation.mohTable.output+1] = {};
							local isLineTableOutput = chargingStation.mohTable.output[#chargingStation.mohTable.output];	
							local fillType = moFillTypes.values.fillTypes[fillTypeIndex];
							if fillType ~= nil then
								isLineTableOutput.fillTypeName = fillType.name;
							else
								isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
							end;
							isLineTableOutput.fillType = fillTypeIndex;
							isLineTableOutput.price = price;
							isLineTableOutput.priceTrend = priceTrend;
						end;
						---output---
						if chargingStation.spec_chargingStation.buyingStation ~= nil then
							for fillType,isAccepted in pairs(chargingStation.spec_chargingStation.buyingStation.providedFillTypes) do
								if isAccepted and chargingStation.spec_chargingStation.buyingStation:getIsFillTypeSupported(fillType) then
									local difficultyMultiplier = 1000;
									--if moFillTypes.values.bestPrice[fillType] == nil then
									--	moFillTypes.values.bestPrice[fillType] = {};									
									--end;								
									--local price = spec_chargingStation:getEffectiveFillTypePrice(fillType)*difficultyMultiplier;
									local price = math.floor(chargingStation.spec_chargingStation.buyingStation:getEffectiveFillTypePrice(fillType) * difficultyMultiplier - 0.5);
									--local priceTrend = spec_chargingStation:getCurrentPricingTrend(fillType)
									local isPriceTrend = "normal";
									--if priceTrend ~= nil then
									--	if Utils.isBitSet(priceTrend, SellingStation.PRICE_GREAT_DEMAND) then
									--		isPriceTrend = "greatDemand";
									--		isLineTableGeneral.isGreatDemand = true;
									--	elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_CLIMBING) then
									--		isPriceTrend = "up";
									--	elseif Utils.isBitSet(priceTrend, SellingStation.PRICE_FALLING) then
									--		isPriceTrend = "down";
									--	end;
									--end;
									setOutput(fillType, price, isPriceTrend);
									--moFillTypes.values.bestPrice[fillType][#moFillTypes.values.bestPrice[fillType]+1] = {price, stationName, isPriceTrend, index, node};
								end;
							end;
						end;						
					end;
				end;	
			else
				table.insert(deleteObject, index);
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.chargingStations, index);
			end;						
		end;				
	end;	
end;


moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moChargingStations.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moChargingStations.update } );