moFarmlands = {};
source(MultiOverlayV4.modDir.."scripte/module/farmlands/moFarmlandsConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/farmlands/moFarmlandsOutput.lua");

function moFarmlands:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="farmlands"} ) then
		if moFarmlands.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateFarmlands"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moFarmlands.values.updateTimer, name="updateFarmlands", repeatable=1, ms=moFarmlands.values.msec, action=moFarmlands.load} ); 
		else
			moFarmlands:load();
		end;
	end;
end;

function moFarmlands.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moFarmlands.values == nil then moFarmlandsConfig:defaultValues();end;	
	if update == nil or not update then moFarmlandsConfig:generateCmd();moFarmlands:loadAllFarmlands();else moFarmlands.values.farmlandFields = {};end;
	
end;

function moFarmlands.load() --updateTimer Callback	
	moFarmlands:loadAllFarmlands();	
end;

function moFarmlands:loadAllFarmlands()	
	local playerFarmId = g_currentMission.player.farmId;	
	if #moFarmlands.values.farmlandFields == 0 then moFarmlands:setFieldsByFarmland();end;
	moFarmlands.values.farmlands = {}; --new
	for farmlandId, farm in pairs (g_farmlandManager.farmlands) do
		local farmland = {
			farmlandId = farmlandId;
			price = Utils.getNoNil(farm.price, 0);
			farmId = Utils.getNoNil(farm.id, 0);
			farmlandHectar = Utils.getNoNil(farm.areaInHa, 0);
			isPlayerFarm = Utils.getNoNil(farm.id, 0) == playerFarmId;
			isOwned = farm.isOwned;			
			fields = 0;
			fieldsHectar = 0;
			fieldsTxt = "";
			isLeased = false;
		};
		if farm.isLeased ~= nil and farm.isLeased then farmland.isLeased = true;end;
		if moFarmlands.values.farmlandFields[farmlandId] ~= nil then
			farmland.fields = moFarmlands.values.farmlandFields[farmlandId][1];
			farmland.fieldsTxt = moFarmlands.values.farmlandFields[farmlandId][2];
			farmland.fieldsHectar = Utils.getNoNil(moFarmlands.values.farmlandFields[farmlandId][3], 0);
		end;
		table.insert(moFarmlands.values.farmlands, farmland);	
	end;	
	function farmId(w1,w2)			
		if w1.isPlayerFarm and not w2.isPlayerFarm then
			return true;
		end;			
	end;
	function farmlandId(w1,w2)			
		if w1.farmlandId < w2.farmlandId then
			return true;
		end;			
	end;
	function price(w1,w2)			
		if w1.price > w2.price then
			return true;
		end;			
	end;	
	function farmlandHectar(w1,w2)			
		if w1.farmlandHectar > w2.farmlandHectar then
			return true;
		end;			
	end;
	function farmlandFieldsHectar(w1,w2)			
		if w1.fieldsHectar > w2.fieldsHectar then
			return true;
		end;			
	end;
	function fields(w1,w2)			
		if w1.fields > w2.fields then
			return true;
		end;			
	end;	
	if moFarmlands.values.sortBy == 1 then
		table.sort(moFarmlands.values.farmlands, farmlandId);
	elseif moFarmlands.values.sortBy == 2 then
		table.sort(moFarmlands.values.farmlands, price);	
	elseif moFarmlands.values.sortBy == 3 then
		table.sort(moFarmlands.values.farmlands, farmlandHectar);
	elseif moFarmlands.values.sortBy == 4 then
		table.sort(moFarmlands.values.farmlands, farmlandFieldsHectar);	
	elseif moFarmlands.values.sortBy == 5 then
		table.sort(moFarmlands.values.farmlands, fields);		
	else
		table.sort(moFarmlands.values.farmlands, farmId);
	end;
end;

function moFarmlands:setFieldsByFarmland()
	for a=1, #g_fieldManager.fields do
		local field = g_fieldManager.fields[a];
		if field ~= nil and field.farmland ~= nil then
			if moFarmlands.values.farmlandFields[field.farmland.id] == nil then
				local stringFieldArea = tostring(string.format("%1.2f", "".. tostring(field.fieldArea))).. " ".. tostring(g_i18n:getText("unit_haShort"));
				moFarmlands.values.farmlandFields[field.farmland.id] = {[1]=1,[2]=tostring(field.fieldId).. " (".. tostring(stringFieldArea).. ")",[3]=field.fieldArea};
			else
				local stringFieldArea = tostring(string.format("%1.2f", "".. tostring(field.fieldArea))).. " ".. tostring(g_i18n:getText("unit_haShort"));
				moFarmlands.values.farmlandFields[field.farmland.id][1] = moFarmlands.values.farmlandFields[field.farmland.id][1]+1;
				moFarmlands.values.farmlandFields[field.farmland.id][2] = moFarmlands.values.farmlandFields[field.farmland.id][2].. " - ".. tostring(field.fieldId).. " (".. tostring(stringFieldArea).. ")";
				moFarmlands.values.farmlandFields[field.farmland.id][3] = moFarmlands.values.farmlandFields[field.farmland.id][3] + field.fieldArea;
			end;
		end;
	end;	
end;

function moFarmlands:getInfoBar()

end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moFarmlands.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moFarmlands.update } );