moFarmlandsOutput = {};

function moFarmlandsOutput:load(slotTable)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {line={}};
	local isLineTable = nil;	
	if moFarmlands.values.farmlands ~= nil and #moFarmlands.values.farmlands > 0 then		
		for f=1, #moFarmlands.values.farmlands do
			local farm = moFarmlands.values.farmlands[f];			
			local color = "txt";
			local txtBold = true;
			local moreTxt = "";			
			local isFarmId = g_farmlandManager:getFarmlandOwner(farm.farmId) == playerFarmId;		
			local isOwned = farm.isOwned;
			local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
			local canBuy = playerFarm.money >= farm.price;			
			if isFarmId and isOwned then 
				color = "settingOn";				
				txtBold = true;
			elseif not isFarmId and isOwned then
				color = "settingOn";				
				txtBold = false;
			elseif not canBuy and not isOwned then
				color = "settingOff";
				txtBold = true;
			end;	
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];			
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].bold = txtBold;
			isLineTable.txt[1].slotColor = color;			
			moreTxt = " (".. tostring(string.format("%1.2f", "".. tostring(farm.farmlandHectar))).. " ".. tostring(g_i18n:getText("unit_haShort")).. ")";
			isLineTable.txt[1].txt = "Farmland ".. tostring(farm.farmlandId).. tostring(moreTxt);			
			isLineTable.txt[1].callback = moFarmlandsOutput.clickFarmlands;
			isLineTable.txt[1].ownTable = {farm.farmlandId};
			isLineTable.txt[1].width = 50;			
			isLineTable.txt[2] = {};
			isLineTable.txt[2].bold = txtBold;
			isLineTable.txt[2].slotColor = color;			
			moreTxt = "(".. tostring(farm.fields).. ")";			
			local fieldsHectar = tostring(string.format("%1.2f", "".. tostring(farm.fieldsHectar))).. " ".. tostring(g_i18n:getText("unit_haShort"));			
			isLineTable.txt[2].txt = tostring(fieldsHectar).. tostring(moreTxt);
			isLineTable.txt[2].callback = moFarmlandsOutput.clickFarmlandsHectar;
			isLineTable.txt[2].ownTable = {farm.farmlandId};
			isLineTable.txt[2].alignment = 2;
			isLineTable.txt[2].width = 25;			
			moreTxt = "";
			if farm.isLeased then moreTxt = " #L";end;
			local price = g_i18n:formatMoney(farm.price, 0, true, true)
			isLineTable.txt[3] = {};
			isLineTable.txt[3].bold = txtBold;
			isLineTable.txt[3].slotColor = color;			
			if not isFarmId and isOwned then
				isLineTable.txt[3].txt = "--".. tostring(moreTxt)
			else
				isLineTable.txt[3].txt = tostring(price).. tostring(moreTxt)		
			end;
			isLineTable.txt[3].callback = moFarmlandsOutput.clickFarmlandMoney;
			isLineTable.txt[3].ownTable = {farm.farmlandId};
			isLineTable.txt[3].alignment = 3;
			isLineTable.txt[3].width = 25;
			
		end;		
		------------------------
		table.insert(lineTable.line, 1, {});
		isLineTable = lineTable.line[1];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "Map Farmlands (".. tostring(#moFarmlands.values.farmlands).. ")";
		isLineTable.txt[1].callback = moFarmlandsOutput.clickFarmlandsTotal;
		isLineTable.txt[1].alignment = 2;
		if slotTable ~= nil and slotTable.help.outputOn then
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moFarmlandsOutput.clickFarmlandsHelpTxt}};
		end;
		
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;		
		if moFarmlands.values.sortBy == 1 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Farmland*";
		elseif moFarmlands.values.sortBy == 2 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Price*";
		elseif moFarmlands.values.sortBy == 3 then		
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Farmland Hectar*";
		elseif moFarmlands.values.sortBy == 4 then		
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Farmland Fields Hectar*";		
		elseif moFarmlands.values.sortBy == 5 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Fields*";		
		else
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Farm*";
		end;
		isLineTable.txt[1].callback = moFarmlandsOutput.clickFarmlandsSortBy;
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonFlip", color="green", modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFarmlandsOutput.clickFarmlandsSortBy}};
		
		---title---
		table.insert(lineTable.line, 3, {});
		isLineTable = lineTable.line[3];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "*".. tostring(g_i18n:getText("ui_farmlandScreen")).. "*";
		isLineTable.txt[1].width = 50;		
		isLineTable.txt[2] = {};	
		isLineTable.txt[2].slotColor = "txtOutputTitle";
		isLineTable.txt[2].bold = true;
		isLineTable.txt[2].txt = "*".. tostring(g_i18n:getText("ui_fields")).. "*";
		isLineTable.txt[2].width = 25;
		isLineTable.txt[2].alignment = 2;
		isLineTable.txt[3] = {};	
		isLineTable.txt[3].slotColor = "txtOutputTitle";
		isLineTable.txt[3].bold = true;
		isLineTable.txt[3].txt = "*".. tostring(g_i18n:getText("ui_prices")).. "*"
		isLineTable.txt[3].width = 25;
		isLineTable.txt[3].alignment = 3;
		---title---
		------------------------
		---objectLineDistance---
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		isLineTable.txt[1].txt = " ";
		---objectLineDistance---
	end;
	moFarmlandsOutput.output = lineTable;
end;

function moFarmlandsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="farmlands" } );	
	moFarmlandsOutput:load(args.slotTable);
	return moFarmlandsOutput.output;
end;

function moFarmlandsOutput.clickFarmlandsSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if moFarmlands.values.sortBy+1 > moFarmlands.values.maxSortBy then moFarmlands.values.sortBy = 1;else moFarmlands.values.sortBy = moFarmlands.values.sortBy+1;end;
		moFarmlands.load(args.slotTable); --refresh
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then	
		if moFarmlands.values.sortBy-1 < 1 then moFarmlands.values.sortBy = moFarmlands.values.maxSortBy;else moFarmlands.values.sortBy = moFarmlands.values.sortBy-1;end;
		moFarmlands.load(args.slotTable); --refresh		
	end;
end;

function moFarmlandsOutput.clickFarmlandsTotal(args)	
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.inGameMenu.pageMapOverview == nil then return;end;
		g_gui:showGui("InGameMenu");
		local farmlandPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageMapOverview);
		local farmlandPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(farmlandPageId);
		g_currentMission.inGameMenu.pageSelector:setState(farmlandPageIndex, true);
	end;
end;		

function moFarmlandsOutput.clickFarmlands(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		local farmlandId = args.ownTable[1];
		local farmland = Utils.getNoNil(g_farmlandManager:getFarmlandById(farmlandId), 0);
		local x = farmland.xWorldPos;
		local z = farmland.zWorldPos;		
		if x ~= nil and x ~= 0 then
			moSetGetOverlays:mapHotSpot({"Test"}, {x}, {z}, 1);
		end;				
	end;
end;

function moFarmlandsOutput.clickFarmlandsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Map Farmlands Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Mouse Left Optional Map Farmlands/Sort By/Farmland/FarmlandHectar/FieldsHectar/Price for activeded or more Info or MapHotSpot or ...";
	end;
end;

function moFarmlandsOutput.clickFarmlandsHectar(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		local farmlandId = args.ownTable[1];
		if moFarmlands.values.farmlandFields[farmlandId] ~= nil then 
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.titel = "Farmland ".. tostring(farmlandId);
			moSetGetOverlays.infoHelpBox.help.txt = "Field(s):\n".. tostring(moFarmlands.values.farmlandFields[farmlandId][2]);
		else
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.titel = "Farmland ".. tostring(farmlandId);
			moSetGetOverlays.infoHelpBox.help.txt = "Farmland has no fields";
		end;				
	end;
end;

function moFarmlandsOutput.clickFarmlandMoney(args)	
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.inGameMenu.pageMapOverview == nil or args.ownTable[1] == nil then return;end;
		g_gui:showGui("InGameMenu");
		local farmlandPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageMapOverview);
		local farmlandPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(farmlandPageId);
		g_currentMission.inGameMenu.pageSelector:setState(farmlandPageIndex, true);		
		g_currentMission.inGameMenu.pageMapOverview:setMode(InGameMenuMapFrame.MODE_FARMLANDS);		
		local farmland = g_farmlandManager:getFarmlandById(args.ownTable[1]);		
		if farmland ~= nil then
			local x = farmland.xWorldPos;
			local z = farmland.zWorldPos;			
			if x ~= nil and x ~= 0 then					
				g_currentMission.inGameMenu.pageMapOverview:onClickMap(nil, x, z);				
			end;
		end;		
	end;	
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="farmlands" } );