moFieldsOutput = {};

function moFieldsOutput:load(slotTable)
	local playerFarmId = g_currentMission.player.farmId;
	local lineTable = {line={}};
	local isLineTable = nil;	
	if moFields.values.fields ~= nil and #moFields.values.fields > 0 then		
		local isLime = g_currentMission.missionInfo.limeRequired;
		local isWeed = g_currentMission.missionInfo.weedsEnabled;
		local isPlow = g_currentMission.missionInfo.plowingRequiredEnabled;
		local isRoller = g_currentMission.missionInfo.stonesEnabled;
		local nextTxt = 1;
		local maxWidth = 1;
		if isLime then maxWidth = maxWidth+1;end;
		if isWeed then maxWidth = maxWidth+1;end;
		if isPlow then maxWidth = maxWidth+1;end;
		if isRoller then maxWidth = maxWidth+1;end;
		maxWidth = 59/maxWidth;
		for a=1, #moFields.values.fields do
			if moFields.values.fields[a] ~= nil then
				local field = moFields.values.fields[a];				
				local moreTxt = "";
				local txt = "";
				nextTxt = 1;
								
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];			
				isLineTable.txt = {};
				isLineTable.txt[nextTxt] = {};				
				isLineTable.txt[nextTxt].txt = tostring(field.fieldId);
				isLineTable.txt[nextTxt].slotColor = "txt";
				isLineTable.txt[nextTxt].callback = moFieldsOutput.clickFields;
				isLineTable.txt[nextTxt].ownTable = {field.fieldId};
				isLineTable.txt[nextTxt].alignment = 2;
				isLineTable.txt[nextTxt].width = 10;
				nextTxt = nextTxt+1;				
				if field.fieldData ~= nil then				
					if field.fieldData.fruitTypeName ~= nil then
						txt = tostring(field.fieldData.fruitTypeName)
					else
						txt = "--"
					end;
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].txt = txt;
					isLineTable.txt[nextTxt].slotColor = "txt";					
					isLineTable.txt[nextTxt].alignment = 2;
					isLineTable.txt[nextTxt].width = 15;
					nextTxt = nextTxt+1;
					
					if field.fieldData.growthTxt ~= nil and field.fieldData.growthTxt:len() > 0 then
						txt = tostring(field.fieldData.growthTxt);
					else
						txt = "--";
					end;
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].txt = txt;
					if field.fieldData.growthTxtColor == nil then
						isLineTable.txt[nextTxt].slotColor = "txt";
					else
						isLineTable.txt[nextTxt].color = tostring(field.fieldData.growthTxtColor);
					end;
					isLineTable.txt[nextTxt].alignment = 2;
					isLineTable.txt[nextTxt].width = 15;
					nextTxt = nextTxt+1;
					
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].txt = tostring(field.fieldData.sprayProzent);
					isLineTable.txt[nextTxt].slotColor = "txt";
					isLineTable.txt[nextTxt].alignment = 2;	
					isLineTable.txt[nextTxt].width = maxWidth;
					nextTxt = nextTxt+1;
										
					if isLime then
						isLime = true;
						isLineTable.txt[nextTxt] = {};
						if field.fieldData.limeFactor ~= nil then
							isLineTable.txt[nextTxt].txt = tostring(field.fieldData.limeProzent);
						else
							isLineTable.txt[nextTxt].txt = "--";
						end;
						isLineTable.txt[nextTxt].slotColor = "txt";
						isLineTable.txt[nextTxt].alignment = 2;
						isLineTable.txt[nextTxt].width = maxWidth;
						nextTxt = nextTxt+1;					
					end;
					if isWeed then
						isWeed = true;
						isLineTable.txt[nextTxt] = {};
						if field.fieldData.weedFactor ~= nil then
							isLineTable.txt[nextTxt].txt = tostring(field.fieldData.weedProzent);
						else
							isLineTable.txt[nextTxt].txt = "--";
						end;
						isLineTable.txt[nextTxt].slotColor = "txt";
						isLineTable.txt[nextTxt].alignment = 2;
						isLineTable.txt[nextTxt].width = maxWidth;
						nextTxt = nextTxt+1;					
					end;
					if isPlow then
						isPlow = true;
						isLineTable.txt[nextTxt] = {};
						if field.fieldData.plowFactor ~= nil then
							isLineTable.txt[nextTxt].txt = tostring(field.fieldData.plowProzent);
						else
							isLineTable.txt[nextTxt].txt = "--";
						end;
						isLineTable.txt[nextTxt].slotColor = "txt";
						isLineTable.txt[nextTxt].alignment = 2;
						isLineTable.txt[nextTxt].width = maxWidth;
						nextTxt = nextTxt+1;					
					end;
					if isRoller then
						isRoller = true;
						isLineTable.txt[nextTxt] = {};
						if field.fieldData.rollerFactor ~= nil then
							isLineTable.txt[nextTxt].txt = tostring(field.fieldData.rollerProzent);
						else
							isLineTable.txt[nextTxt].txt = "--";
						end;
						isLineTable.txt[nextTxt].slotColor = "txt";
						isLineTable.txt[nextTxt].alignment = 2;
						isLineTable.txt[nextTxt].width = maxWidth;
						nextTxt = nextTxt+1;					
					end;					
					
					isLineTable.txt[nextTxt] = {};
					isLineTable.txt[nextTxt].txt = "";
					isLineTable.txt[nextTxt].slotColor = "txt";
					isLineTable.txt[nextTxt].alignment = 2;					
					isLineTable.txt[nextTxt].width = 1;
					nextTxt = nextTxt+1;
				end;			
			end;
		end;
		------------------------
		table.insert(lineTable.line, 1, {});
		isLineTable = lineTable.line[1];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "Map FieldsInfo (".. tostring(#moFields.values.fields).. ")";		
		isLineTable.txt[1].alignment = 2;
		if slotTable ~= nil and slotTable.help.outputOn then
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moFieldsOutput.clickFieldsHelpTxt}};
		end;
		
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;		
		if moFields.values.sortBy == 1 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Fields*";
		elseif moFields.values.sortBy == 2 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *FruitName*";
		elseif moFields.values.sortBy == 3 then		
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *State/Wachstum*";
		elseif moFields.values.sortBy == 4 then		
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *SprayFactor*";		
		elseif moFields.values.sortBy == 5 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *LimeFactor*";		
		elseif moFields.values.sortBy == 6 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *WeedFactor*";
		elseif moFields.values.sortBy == 7 then
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *RollerFactor*";
		else
			isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *PlowFactor*";
		end;
		isLineTable.txt[1].callback = moFieldsOutput.clickFieldsSortBy;
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonFlip", color="green", modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFieldsOutput.clickFieldsSortBy}};
		
		---title---
		nextTxt = 1;
		table.insert(lineTable.line, 3, {});
		isLineTable = lineTable.line[3];
		isLineTable.txt = {};
		isLineTable.txt[nextTxt] = {};	
		isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
		isLineTable.txt[nextTxt].bold = true;
		isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("ui_fields")).. "*";
		isLineTable.txt[nextTxt].width = 10;
		isLineTable.txt[nextTxt].alignment = 2;
		nextTxt = nextTxt+1;
		isLineTable.txt[nextTxt] = {};	
		isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
		isLineTable.txt[nextTxt].bold = true;
		isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("statistic_fillType")).. "*";
		isLineTable.txt[nextTxt].width = 15;
		isLineTable.txt[nextTxt].alignment = 2;
		nextTxt = nextTxt+1;
		isLineTable.txt[nextTxt] = {};	
		isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
		isLineTable.txt[nextTxt].bold = true;
		isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("ui_map_growth")).. "*";
		isLineTable.txt[nextTxt].width = 15;
		isLineTable.txt[nextTxt].alignment = 2;
		nextTxt = nextTxt+1;		
		isLineTable.txt[nextTxt] = {};	
		isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
		isLineTable.txt[nextTxt].bold = true;
		isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("ui_growthMapFertilized")).. "*";
		isLineTable.txt[nextTxt].width = maxWidth;
		isLineTable.txt[nextTxt].alignment = 2;
		nextTxt = nextTxt+1;
				
		if isLime then
			isLineTable.txt[nextTxt] = {};	
			isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
			isLineTable.txt[nextTxt].bold = true;
			isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("fillType_lime")).. "*";
			isLineTable.txt[nextTxt].alignment = 2;
			isLineTable.txt[nextTxt].width = maxWidth;
			nextTxt = nextTxt+1;
		end;
		if isWeed then
			isLineTable.txt[nextTxt] = {};	
			isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
			isLineTable.txt[nextTxt].bold = true;
			isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("fillType_weed")).. "*";
			isLineTable.txt[nextTxt].alignment = 2;
			isLineTable.txt[nextTxt].width = maxWidth;
			nextTxt = nextTxt+1;
		end;
		if isPlow then
			isLineTable.txt[nextTxt] = {};	
			isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
			isLineTable.txt[nextTxt].bold = true;
			isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("ui_growthMapPlowed")).. "*";
			isLineTable.txt[nextTxt].alignment = 2;
			isLineTable.txt[nextTxt].width = maxWidth;
			nextTxt = nextTxt+1;		
		end;
		if isRoller then
			isLineTable.txt[nextTxt] = {};	
			isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
			isLineTable.txt[nextTxt].bold = true;
			isLineTable.txt[nextTxt].txt = "*".. tostring(g_i18n:getText("setting_stonesEnabled")).. "*";
			isLineTable.txt[nextTxt].alignment = 2;
			isLineTable.txt[nextTxt].width = maxWidth;
			nextTxt = nextTxt+1;
		end;
		isLineTable.txt[nextTxt] = {};	
		isLineTable.txt[nextTxt].slotColor = "txtOutputTitle";
		isLineTable.txt[nextTxt].bold = true;
		isLineTable.txt[nextTxt].txt = "";
		isLineTable.txt[nextTxt].alignment = 2;
		isLineTable.txt[nextTxt].width = 1;
		nextTxt = nextTxt+1;
		---title---
		------------------------
		---objectLineDistance---
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		isLineTable.txt[1].txt = " ";
		---objectLineDistance---
	end;
	moFieldsOutput.output = lineTable;
end;

function moFieldsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="fields" } );	
	moFieldsOutput:load(args.slotTable);
	return moFieldsOutput.output;
end;

function moFieldsOutput.clickFieldsSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if moFields.values.sortBy+1 > moFields.values.maxSortBy then moFields.values.sortBy = 1;else moFields.values.sortBy = moFields.values.sortBy+1;end;
		--moFields.load(args.slotTable); --refresh
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then	
		if moFields.values.sortBy-1 < 1 then moFields.values.sortBy = moFields.values.maxSortBy;else moFields.values.sortBy = moFields.values.sortBy-1;end;		
	end;
end;

function moFieldsOutput.clickFields(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown and args.ownTable[1] ~= nil then				
		local field = Utils.getNoNil(g_fieldManager:getFieldByIndex(args.ownTable[1]), 0);
		if field ~= nil and type(field) ~= "number" then
			local x = field.posX;
			local z = field.posZ;		
			if x ~= nil and x ~= 0 then
				moSetGetOverlays:mapHotSpot({"Test"}, {x}, {z}, 1);
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown and args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
		local field = Utils.getNoNil(g_fieldManager:getFieldByIndex(args.ownTable[1]), 0);
		if field ~= nil and type(field) ~= "number" then
			local x = field.posX;
			local z = field.posZ;
			if x ~= nil and x ~= 0 and z ~= nil then
				local y = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 300, z);
				if y == nil then y = 0;end;
				g_currentMission.player:moveToAbsolute(x, y, z, false, false);
				MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moSellingStationsOutput.clickSellingStation"); --force mouseOff
			end;
		end;
	end;
end;

function moFieldsOutput.clickFieldsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Map FieldsInfo Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Mouse Left Optional Map Fields/Sort By/FieldNumber for activeded or more Info or MapHotSpot or Click Mouse Right FieldNumber for Teleport";
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="fields" } );