moFillTypes = {};
source(MultiOverlayV4.modDir.."scripte/module/filltypes/moFillTypesConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/filltypes/moFillTypesOutput.lua");

function moFillTypes:update(dt)
end;

function moFillTypes.loadFillTypes(update) --onStartMission Callback	
	if update == nil or not update then moFillTypesConfig:defaultValues();moFillTypesConfig.generateCmd();moFillTypes:loadTotalFillTypes();end;		
end;

function moFillTypes:loadTotalFillTypes()	
	function isFillAnimals(index)		
		if g_currentMission.fillTypeManager.categoryNameToFillTypes["ANIMAL"][index] ~= nil or g_currentMission.fillTypeManager.categoryNameToFillTypes["HORSE"][index] ~= nil then return true;end;
		return false;
	end;
	function noFillTypes(descIndex)
		return moFillTypes.values.noFillTypes[descIndex] ~= nil;		
	end;
	local lineTable = {};
	function getAnmialName(name, descName, descIndex)
		for index, value in pairs (g_currentMission.animalSystem.types) do			
			local isName = g_currentMission.animalSystem.types[index].name;
			if name == isName then
				local tempName = g_i18n:getText("ui_statisticView_".. string.lower(isName));
				local languageXmlName = moLanguageXml:getTxt(string.lower("fill_"..descName), nil, name);
				if string.find(tempName, "MISSING") then tempName = isName;end;
				if moModule.values.languageXml and not string.find(languageXmlName, "MISSING") then tempName = languageXmlName;end;
				return tempName;
			end;
		end;
		return name;
	end;	
	if g_currentMission.fillTypeManager.fillTypes ~= nil then		
		for index, desc in pairs(g_currentMission.fillTypeManager.fillTypes) do		
			if desc ~= nil and desc.name ~= nil and desc.index ~= nil then		
				lineTable[desc.index] = {};
				isLineTable = lineTable[desc.index];								
				isLineTable.index = desc.index;
				isLineTable.regName = desc.name;
				isLineTable.titleName = desc.title;				
				isLineTable.isAnimal = isFillAnimals(desc.index);
				local name = desc.title;
				if isLineTable.isAnimal then
					name = getAnmialName(name, desc.name, desc.index);					
				else
					local languageXmlName = moLanguageXml:getTxt(string.lower("fill_".. desc.name), nil, name);
					if moModule.values.languageXml and not string.find(languageXmlName, "MISSING") then name = languageXmlName;end;
				end;
				local subType = g_currentMission.animalSystem:getSubTypeByIndex(desc.index)
				if subType ~= nil then
					local animalType = g_currentMission.animalSystem:getTypeByIndex(subType.typeIndex);
					if animalType ~= nil and moFillTypes.values.animals[animalType.name] == nil then isLineTable.isAnimal = false;moFillTypes.values.animals[animalType.name] = {index=desc.index,amount=0};end;
				end;
				isLineTable.name = tostring(name); --convert Name
				isLineTable.view = not noFillTypes(desc.index) and not isLineTable.isAnimal;
				isLineTable.pricePerLiter= Utils.getNoNil(desc.pricePerLiter, 0);
				isLineTable.previousHourPrice = Utils.getNoNil(desc.previousHourPrice, 0);
				isLineTable.massPerLiter = Utils.getNoNil(desc.massPerLiter, 0);
				isLineTable.startPricePerLiter = Utils.getNoNil(desc.startPricePerLiter, 0);
				isLineTable.totalAmount = Utils.getNoNil(desc.totalAmount, 0);
				isLineTable.canPal = desc.palletFilename ~= nil;				
				if isLineTable.canPal then moFillTypes:regPalFillTypes(desc);end;
				isLineTable.showOnPriceTable = desc.showOnPriceTable;				
				isLineTable.greatDemandReady = false;
				isLineTable.greatDemand = {};
				isLineTable.bestPrice = 0;
				isLineTable.bestPriceStations = "";
				isLineTable.amounts = {};
				isLineTable.viewAmountStorages = false;
			end;			
		end;
	end;	
	moFillTypes.values.fillTypes = lineTable;	
end;

function moFillTypes:regPalFillTypes(desc)
	local palletXmlFile = XMLFile.load("palletXmlFilename", desc.palletFilename, Vehicle.xmlSchema);
	local capacity = FillUnit.getCapacityFromXml(palletXmlFile);
	moFillTypes.values.pal.fillTypes[desc.index] = {index=desc.index,capacity=capacity,xml=Utils.getNoNil(desc.palletFilename, nil)};
end;

function moFillTypes:setOnOffFillTypes(fillType)
	local regName = moFillTypes.values.fillTypes[fillType].regName;
	if not moFillTypes.values.fillTypes[fillType].view then 
		moFillTypes.values.noFillTypes[fillType] = regName;				
	elseif moFillTypes.values.fillTypes[fillType].view then
		if moFillTypes.values.noFillTypes[fillType] ~= nil then moFillTypes.values.noFillTypes[fillType] = nil;end;				
	end;
end;

function moFillTypes:getFillTypeByTyp(fillType, typ)
	local fillType = fillType;
	if moFillTypes.values.fillTypes[fillType] ~= nil then
		local regName = moFillTypes.values.fillTypes[fillType].regName:upper();
		if regName ~= nil then
			regName = string.gsub(regName, "_WINDROW", "");
			if string.find(typ, "BALE") and regName == "STRAW" then end; 
			local fillTypeIndex = g_currentMission.fillTypeManager:getFillTypeIndexByName(typ.. "_".. regName);
			if fillTypeIndex == nil then fillTypeIndex = g_currentMission.fillTypeManager:getFillTypeIndexByName(typ);end;
			if fillTypeIndex ~= nil then
				return true, fillTypeIndex;			
			end;		
		end;
	end;
	return false, fillType;
end;

function getMultiplier()
	if g_currentMission.missionDynamicInfo.isMultiplayer then return 1 else return EconomyManager.getPriceMultiplier();end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moFillTypes.loadFillTypes } );