moFillTypesConfig = {};

function moFillTypesConfig:defaultValues()
	moFillTypes.values = {animals={}, items={rBales={},rBalesTotal=0,sBales={},sBalesTotal=0,pal={},palTotal=0}, bestPrice={}, storages={}, amount={}, totalAmount={}, greatDemand={}, pal={fillTypes={}}, fillTypes={}, noFillTypes={}, name=true, regName=false, index=false, sortBy="Name", viewBy="Name"};
	moFillTypes.values.noFillTypesDefaultTemp = {"UNKNOWN", "AIR", "POPLAR", "WEED", "FUEL", "ROUNDBALE_WHEAT", "ROUNDBALE_GRASS", "ROUNDBALE_DRYGRASS", "ROUNDBALE_BARLEY", "SQUAREBALE_WHEAT", "SQUAREBALE_BARLEY", "TARP", "DRYGRASS", "GRASS", "DEF", "TREESAPLINGS"};		
	moFillTypes.values.noFillTypes = {};
	for _, name in pairs (moFillTypes.values.noFillTypesDefaultTemp) do
		local fillType = g_fillTypeManager:getFillTypeIndexByName(name)
		if fillType ~= nil then 
			moFillTypes.values.noFillTypes[fillType] = name;
			if moFillTypes.values.fillTypes[fillType] ~= nil then moFillTypes.values.fillTypes[fillType].view = false;end;
		end;	
	end;
end;

function moFillTypesConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback
	if typ ~= "profilSettings" then return;end;	
	if moFillTypes.values == nil then moFillTypesConfig:defaultValues();end;	
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.fillTypes(%d)"):format(0);	
	if getXMLBool(Xml, groupNameTag.. "#seeName") ~= nil then
		moFillTypes.values.name = getXMLBool(Xml, groupNameTag.. "#seeName");
	else
		return; --first config not found
	end;
	if getXMLBool(Xml, groupNameTag.. "#seeRegName") ~= nil then
		moFillTypes.values.regName = getXMLBool(Xml, groupNameTag.. "#seeRegName");
	end;
	if getXMLBool(Xml, groupNameTag.. "#seeIndex") ~= nil then
		moFillTypes.values.index = getXMLBool(Xml, groupNameTag.. "#seeIndex");
	end;	
	----------------------------------------------------------------------------------------------
	groupNameTag = (xmlNameTag.. ".module.fillTypes.noFillTypes");
	if getXMLString(Xml, groupNameTag.. "#name") then
		local noFillTypes = getXMLString(Xml, groupNameTag.. "#name");
		if string.len(noFillTypes) > 0 then
			local stringTable, isOkay = MultiOverlayV4:get_hl("stringSplit", {noFillTypes, ","}, "noFillTypes configFile XML/String Split");
			if isOkay then				
				for index, name in pairs (moFillTypes.values.noFillTypes) do
					if index ~= nil and moFillTypes.values.fillTypes[index] ~= nil then moFillTypes.values.fillTypes[index].view = true;end;
				end;								
				moFillTypes.values.noFillTypes = {};
				for a=1, #stringTable do
					local fillType = g_fillTypeManager:getFillTypeIndexByName(stringTable[a])
					if fillType ~= nil then 
						moFillTypes.values.noFillTypes[fillType] = stringTable[a];
						if moFillTypes.values.fillTypes[fillType] ~= nil then moFillTypes.values.fillTypes[fillType].view = false;end;
					end;
					
				end;
			end;		
		end;
	end;	
	----------------------------------------------------------------------------------------------	
end;

function moFillTypesConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moFillTypes.values == nil then moFillTypesConfig:defaultValues();end;	
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.fillTypes(%d)"):format(0);	
	setXMLBool(Xml, groupNameTag.. "#seeName", moFillTypes.values.name);
	setXMLBool(Xml, groupNameTag.. "#seeRegName", moFillTypes.values.regName);
	setXMLBool(Xml, groupNameTag.. "#seeIndex", moFillTypes.values.index);
	----------------------------------------------------------------------------------------------
	groupNameTag = (xmlNameTag.. ".module.fillTypes.noFillTypes");	
	local noFillTypes = "";	
	for index, name in pairs (moFillTypes.values.noFillTypes) do
		if string.len(noFillTypes) > 0 then noFillTypes = noFillTypes.. ",".. tostring(name);else noFillTypes = tostring(name);end;
	end;
	setXMLString(Xml, groupNameTag.. "#name", tostring(noFillTypes));		
	----------------------------------------------------------------------------------------------		
end;

function moFillTypesConfig.generateCmd()
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "output_fillTypesOnOff_";
			groupName = "Speziale";			
			displayName = "FillTypes On/Off Global";
			infoTxt = "Enabled or Disabled a FillType - for all Slots with MultiOverlay FillTypes";
			mouseClickAccepts = {true,false,false};
			typ = {"output_"};			
			actionCallback = moFillTypesOutput.giveOutputTable;			
		}
	)
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moFillTypesConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moFillTypesConfig.saveXml } );