moFillTypesOutput = {};

function moFillTypesOutput:load(slotTable)
	if moFillTypes == nil or moFillTypes.values == nil or moFillTypes.values.fillTypes == nil then moFillTypesOutput.output = {};return;end;
	local lineTable = {line={}};
	local isLineTable = nil;
	
	for a=1, #moFillTypes.values.fillTypes do		
		local fillTypes = moFillTypes.values.fillTypes[a]
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];				
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		if fillTypes.view then
			isLineTable.txt[1].outputColor = "txtFillTypesColor";
			isLineTable.txt[1].view = "true";
		else
			isLineTable.txt[1].outputColor = "txtNoAmountColor";
			isLineTable.txt[1].view = "false";
		end;
		isLineTable.txt[1].callback = moFillTypesOutput.clickOnOffFillTypes;
		isLineTable.txt[1].ownTable = {index=fillTypes.index};
		local name = "";
		if moFillTypes.values.name then name = fillTypes.name;end;
		if moFillTypes.values.regName then
			if string.len(name) == 0 then name = fillTypes.regName;else name = name.. " (".. fillTypes.regName.. ")";end;
		end;
		if moFillTypes.values.index then
			if string.len(name) == 0 then name = fillTypes.index;else name = name.. " *".. fillTypes.index.. "*";end;
		end;
		isLineTable.txt[1].txt = tostring(name);		
	end;
	function comp(w1,w2)		
		if w1.txt[1].txt < w2.txt[1].txt then
			return true;
		end;				
	end;
	function comp1(w1,w2)		
		if w1.txt[1].view > w2.txt[1].view then
			return true;
		end;				
	end;
	function comp2(w1,w2)		
		if w1.txt[1].view < w2.txt[1].view then
			return true;
		end;				
	end;
	if moFillTypes.values.sortBy == "Name" then
		table.sort(lineTable.line, comp);
	elseif moFillTypes.values.sortBy == "On" then
		table.sort(lineTable.line, comp1);
	elseif moFillTypes.values.sortBy == "Off" then
		table.sort(lineTable.line, comp2);
	end;
	
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = "FillTypes On/Off Global (".. tostring(#moFillTypes.values.fillTypes).. ")";	
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moFillTypesOutput.clickStoragesHelpTxt}};
	end;
	
	table.insert(lineTable.line, 2, {});
	isLineTable = lineTable.line[2];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *".. tostring(moFillTypes.values.sortBy).. "*";
	isLineTable.txt[1].callback = moFillTypesOutput.clickButtonSortBy;
	isLineTable.txt[1].icon = {before={},after={}};
	isLineTable.txt[1].icon.before[1] = {name="buttonFlip", color="green", modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moFillTypesOutput.clickButtonSortBy}};
	
	table.insert(lineTable.line, 3, {});
	isLineTable = lineTable.line[3];				
	isLineTable.txt = {};
	isLineTable.txt[1] = {};
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = "View *".. tostring(moFillTypes.values.viewBy).. "*";
	isLineTable.txt[1].callback = moFillTypesOutput.clickButtonViewBy;
	isLineTable.txt[1].icon = {before={},after={}};
	isLineTable.txt[1].icon.before[1] = {name="buttonLeft", color="green", settingButton=true, callback={[1]=moFillTypesOutput.clickButtonViewBy}};	
	---objectLineDistance---
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};		
	isLineTable.txt[1].txt = " ";
	---objectLineDistance---
	
	moFillTypesOutput.output = lineTable;
end;

function moFillTypesOutput.giveOutputTable(args)
	moFillTypesOutput:load(args.slotTable);
	return moFillTypesOutput.output;
end;

function moFillTypesOutput.clickStoragesHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "FillTypes On/Off Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse FillType Name for On or Off";
	end;
end;

function moFillTypesOutput.clickOnOffFillTypes(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moFillTypes.values.fillTypes[args.ownTable.index].view = not moFillTypes.values.fillTypes[args.ownTable.index].view;
		moFillTypes:setOnOffFillTypes(args.ownTable.index);
		moGeneralSettings.isSave = false;
	end;
	return;
end;

function moFillTypesOutput.clickButtonSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if moFillTypes.values.sortBy == "Name" then
			moFillTypes.values.sortBy = "Off"
		elseif moFillTypes.values.sortBy == "Off" then
			moFillTypes.values.sortBy = "On"
		elseif moFillTypes.values.sortBy == "On" then
			moFillTypes.values.sortBy = "Name"
		end;		
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		if moFillTypes.values.sortBy == "Name" then
			moFillTypes.values.sortBy = "On"
		elseif moFillTypes.values.sortBy == "On" then
			moFillTypes.values.sortBy = "Off"
		elseif moFillTypes.values.sortBy == "Off" then
			moFillTypes.values.sortBy = "Name"
		end;
	end;
	return;	
end;

function moFillTypesOutput.clickButtonViewBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		local name=moFillTypes.values.name; local regName=moFillTypes.values.regName; local index=moFillTypes.values.index;
		if name and regName and index then 
			regName = false; index = false;
			moFillTypes.values.viewBy = "Name";
		elseif name and regName and not index then 
			index = true;
			moFillTypes.values.viewBy = "Name/RegName/Index";
		elseif name and not regName and not index then 
			regName = true;
			moFillTypes.values.viewBy = "Name/RegName";
		end;
		moFillTypes.values.name = name; moFillTypes.values.regName = regName; moFillTypes.values.index = index;	
	end;
	return;	
end;
