moItems = {};
source(MultiOverlayV4.modDir.."scripte/module/items/moItemsConfig.lua");
--source(MultiOverlayV4.modDir.."scripte/module/items/moItemsOutput.lua");

function moItems:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="items"} ) then
		if moItemsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateItems"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moItemsConfig.values.updateTimer, name="updateItems", repeatable=1, ms=moItemsConfig.values.msec, action=moItems.loadAllPalItems} ); 
		else
			moItems:loadAllPalItems();
		end;
	end;
end;

function moItems.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moItemsConfig.values == nil then moItemsConfig:defaultValues();end;	
	--moItems:loadAllBaleItems();	
end;

function moItems.load() --updateTimer Callback	
	moItems:loadAllBaleItems();
	moItems:loadAllPalItems();
end;

function moItems:loadAllBaleItems()	
	local playerFarmId = g_currentMission.player.farmId;	
	--local farmId = g_currentMission:getFarmId()
	moFillTypes.values.items.rBales = {}; --new
	moFillTypes.values.items.sBales = {}; --new
	moFillTypes.values.items.rBalesTotal = 0; --new
	moFillTypes.values.items.sBalesTotal = 0; --new
	for _, items in pairs(g_currentMission.itemSystem.itemsToSave) do
		if items.item.ownerFarmId == playerFarmId then	 
			if items.className == "Bale" then
				local fillLevel = items.item.fillLevel;				
				local fillType = items.item.fillType;
				local typ = "SQUAREBALE";
				local isFermentingTyp = string.find(moFillTypes.values.fillTypes[fillType].regName:lower(), "grass");
				if items.item.isRoundbale then typ = "ROUNDBALE";end;
				local fillTypeIndex = g_currentMission.fillTypeManager:getFillTypeIndexByName(typ);
				if fillTypeIndex ~= nil and fillTypeIndex > 0 then
					--moFillTypes.values.amount[fillTypeIndex] = Utils.getNoNil(moFillTypes.values.amount[fillTypeIndex], 0) + 1;
				end;
				local objectId = items.item.rootNode or items.item.nodeId;
				moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);
				if typ == "SQUAREBALE" then
					if moFillTypes.values.items.sBales[fillType] == nil then moFillTypes.values.items.sBales[fillType] = {objects={},fillLevel=0,amount=0,amountF=0,percentF=0};end;
					if objectId ~= nil then moFillTypes.values.items.sBales[fillType].objects[#moFillTypes.values.items.sBales[fillType].objects+1] = objectId;end;
					if items.item.isFermenting and isFermentingTyp then 
						--moFillTypes.values.items.sBales[fillType].fillLevelF = Utils.getNoNil(moFillTypes.values.items.sBales[fillType].fillLevelF, 0) + Utils.getNoNil(fillLevel, 0);
						moFillTypes.values.items.sBales[fillType].amountF = Utils.getNoNil(moFillTypes.values.items.sBales[fillType].amountF, 0) + 1;
						moFillTypes.values.items.sBales[fillType].percentF = Utils.getNoNil(moFillTypes.values.items.sBales[fillType].percentF, 0) + Utils.getNoNil(items.item.fermentingPercentage, 0);
					end;
					moFillTypes.values.items.sBales[fillType].fillLevel = Utils.getNoNil(moFillTypes.values.items.sBales[fillType].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
					moFillTypes.values.items.sBales[fillType].amount = Utils.getNoNil(moFillTypes.values.items.sBales[fillType].amount, 0) + 1;
					
					moFillTypes.values.items.sBalesTotal = moFillTypes.values.items.sBalesTotal +1;
				else
					if moFillTypes.values.items.rBales[fillType] == nil then moFillTypes.values.items.rBales[fillType] = {objects={},fillLevel=0,amount=0,amountF=0,percentF=0};end;
					if objectId ~= nil then moFillTypes.values.items.rBales[fillType].objects[#moFillTypes.values.items.rBales[fillType].objects+1] = objectId;end;
					if items.item.isFermenting and isFermentingTyp then 
						--moFillTypes.values.items.rBales[fillType].fillLevelF = Utils.getNoNil(moFillTypes.values.items.rBales[fillType].fillLevelF, 0) + Utils.getNoNil(fillLevel, 0);
						moFillTypes.values.items.rBales[fillType].amountF = Utils.getNoNil(moFillTypes.values.items.rBales[fillType].amountF, 0) + 1;
						moFillTypes.values.items.rBales[fillType].percentF = Utils.getNoNil(moFillTypes.values.items.rBales[fillType].percentF, 0) + Utils.getNoNil(items.item.fermentingPercentage, 0);
					end;
					moFillTypes.values.items.rBales[fillType].fillLevel = Utils.getNoNil(moFillTypes.values.items.rBales[fillType].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
					moFillTypes.values.items.rBales[fillType].amount = Utils.getNoNil(moFillTypes.values.items.rBales[fillType].amount, 0) + 1;
					
					moFillTypes.values.items.rBalesTotal = moFillTypes.values.items.rBalesTotal +1;
				end;				
			end;			
		end;		
	end;	
end;

function moItems:loadAllPalItems()	
	local playerFarmId = g_currentMission.player.farmId;	
	--local farmId = g_currentMission:getFarmId()
	moFillTypes.values.items.pal = {}; --new
	moFillTypes.values.items.palTotal = 0; --new	
	for key, value in pairs (g_currentMission.ownedItems) do
		if key ~= nil and value ~= nil and value.items ~= nil and type(value.items) == "table" then			
			for _, item in pairs(value.items) do				
				if item.ownerFarmId == playerFarmId then
					if item ~= nil and type(item) == "table" and item.typeName ~= nil and (string.find(item.typeName:lower(), "pallet")) then							
						if item.spec_fillUnit ~= nil and item.spec_fillUnit.fillUnits ~= nil and item.spec_fillUnit.fillUnits[1] ~= nil and item.spec_fillUnit.fillUnits[1].fillType ~= nil then
							--local isGenerate = moModuleObjects:isObject(item, true);
							local objectId = item.rootNode or item.nodeId;
							local fillType = item.spec_fillUnit.fillUnits[1].fillType;						
							local fillLevel = item.spec_fillUnit.fillUnits[1].fillLevel;
							moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);
							if moFillTypes.values.items.pal[fillType] == nil then moFillTypes.values.items.pal[fillType] = {objects={},fillLevel=0,amount=0,waiting=0};end;
							if objectId ~= nil then moFillTypes.values.items.pal[fillType].objects[#moFillTypes.values.items.pal[fillType].objects+1] = objectId;end;
							moFillTypes.values.items.pal[fillType].fillLevel = Utils.getNoNil(moFillTypes.values.items.pal[fillType].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
							moFillTypes.values.items.pal[fillType].amount = Utils.getNoNil(moFillTypes.values.items.pal[fillType].amount, 0) + 1;
							--if not isGenerate then moFillTypes.values.items.pal[fillType].waiting = Utils.getNoNil(moFillTypes.values.items.pal[fillType].waiting, 0) + 1;end;
							moFillTypes.values.items.palTotal = moFillTypes.values.items.palTotal +1;
						end;										
					end;
				end;
			end;
		end;
	end;	
end;

--moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="items" } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moItems.loadOnStart } );
--moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moItems.update } );