moKeySettingsOutput = {};

function moKeySettingsOutput:load(slotTable)
	local lineTable = {line={}};
	local isLineTable = nil;	
	if moKeySettings.values.mod ~= nil then		
		for mod, modValues in pairs (moKeySettings.values.mod) do
			local hashEvents, events = moKeySettings:hashEvents(modValues.name);			
			if hashEvents or moKeySettings.values.viewAll then
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};		
				isLineTable.txt[1].txt = tostring(modValues.name).. "(".. tostring(events).. ")";
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;			
				local color = "green";
				if not hashEvents then color = "darkGray";end;
				if hashEvents and not moKeySettings.values.mod[modValues.name].isReady then color = "red";end;
				isLineTable.txt[1].icon = {before={},after={}};
				isLineTable.txt[1].icon.before[1] = {name="buttonOnOff", color=color, settingButton=true, callback={[1]=moKeySettingsOutput.clickKeySettingsModOnOff}, ownTable={hashEvents, modValues.name}};
				color = "green";
				if not hashEvents then color = "darkGray";end;
				isLineTable.txt[1].icon.after[1] = {name="buttonDown", color=color, settingButton=true, callback={[1]=moKeySettingsOutput.clickKeySettingsModViewEvents}, ownTable={hashEvents, modValues.name}};
				if hashEvents and modValues.viewEvents then
					for a=1, #moKeySettings.values.modBindings[modValues.name] do
						if moKeySettings.values.modBindings[modValues.name][a] ~= nil then
							local isDisplayTxt = true;
							local displayTxt = moKeySettings.values.modBindings[modValues.name][a].activeBindingsDisplayText;
							if displayTxt == nil or displayTxt:len() <=0 then displayTxt = moKeySettings.values.modBindings[modValues.name][a].bindingsDisplayText;end;
							if displayTxt ~= nil and displayTxt:len() > 0 then 						
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[1] = {};
								isLineTable.txt[1].txt = tostring(displayTxt);
								isLineTable.txt[1].slotColor = "txt";
								isLineTable.txt[1].width = 30;							
								isLineTable.txt[2] = {};
								isLineTable.txt[2].txt = tostring(moKeySettings.values.modBindings[modValues.name][a].displayNamePositive);
								isLineTable.txt[2].slotColor = "txt";
								isLineTable.txt[2].width = 70;
								isLineTable.txt[2].alignment = 3;						
							end;
						end;
					end;
				end;
			end;
		end;
	end;	
	
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_keyboard")).. "/".. tostring(g_i18n:getText("ui_mouse")).. "-".. tostring(g_i18n:getText("ui_inGameMenuModeSettings")); 
	isLineTable.txt[1].callback = moKeySettingsOutput.clickMissionsTotal;
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moKeySettingsOutput.clickKeySettingsHelpTxt}};
	end;	
	---objectLineDistance---
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};		
	isLineTable.txt[1].txt = " ";
	---objectLineDistance---
	
	moKeySettingsOutput.output = lineTable;
end;

function moKeySettingsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="keySettings" } );
	moKeySettingsOutput:load(args.slotTable);
	return moKeySettingsOutput.output;
end;

function moKeySettingsOutput.clickKeySettingsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Key Settings Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Key Settings";
	end;
end;

function moKeySettingsOutput.clickKeySettingsModViewEvents(args)
	if args == nil or type(args) ~= "table" and args.ownTable ~= nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and args.ownTable[1] then
			moKeySettings.values.mod[args.ownTable[2]].viewEvents = not moKeySettings.values.mod[args.ownTable[2]].viewEvents;
		end;
	end;
end;

function moKeySettingsOutput.clickKeySettingsModOnOff(args)
	if args == nil or type(args) ~= "table" and args.ownTable ~= nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and args.ownTable[1] then
			moKeySettings:displayIsVisible(args.ownTable[2]);
		end;
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="keySettings" } );