moMissionsOutput = {};

function moMissionsOutput:load(slotTable)
	local lineTable = {line={}};
	local isLineTable = nil;	
	if moMissions.values.missions ~= nil then		
		if #moMissions.values.missions > 0 then
			for m=1, #moMissions.values.missions do
				local mission = moMissions.values.missions[m];			
				local color = "txt";
				local moreTxt = "";
				if mission.active then color = "txtExtra";end;
				if mission.finished then 
					color = "settingOn";
					if tonumber(mission.prozent) < 98 then color = "settingOff";end;
				end;				
				if mission.active or mission.finished then
					table.insert(lineTable.line, 1, {});				
					isLineTable = lineTable.line[1];
				else
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];				
				end;
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].slotColor = color;
				local money = g_i18n:formatMoney(mission.mission:getReward(), 0, true, true)
				isLineTable.txt[1].txt = tostring(money);
				isLineTable.txt[1].callback = moMissionsOutput.clickMissionsMoney;
				isLineTable.txt[1].ownTable = {mission.missionId};
				isLineTable.txt[1].width = 20;
				
				isLineTable.txt[2] = {};
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].slotColor = color;			
				local name = mission.jobType;
				local fillFruitName = "Unknown or not defined";
				local pickupMission = mission.numObjects ~= nil and mission.numObjects > 0;
				if mission.isField then 
					if mission.fillType ~= nil then
						if moFillTypes.values.fillTypes[mission.fillType] ~= nil then
							fillFruitName = moFillTypes.values.fillTypes[mission.fillType].name;
							moreTxt = "#".. string.sub(fillFruitName, 1,3):upper();
						end;
					elseif mission.fruitType ~= nil then
						local fruitTypeIndex = g_fruitTypeManager:getFillTypeIndexByFruitTypeIndex(mission.fruitType);
						if moFillTypes.values.fillTypes[fruitTypeIndex] ~= nil then
							fillFruitName = moFillTypes.values.fillTypes[fruitTypeIndex].name;
							moreTxt = "#".. string.sub(fillFruitName, 1,3):upper();
						end;
					end;
					moreTxt = moreTxt.. "(F-".. tostring(mission.fieldId).. ") ".. tostring(string.format("%1.2f", "".. tostring(mission.fieldHectar))).. " ".. tostring(g_i18n:getText("unit_haShort"));
				elseif pickupMission then
					moreTxt = "(".. tostring(mission.numObjects).. ")";					
				end; 
				isLineTable.txt[2].txt = tostring(name).. tostring(moreTxt);
				if mission.isField then				
					isLineTable.txt[2].callback = moMissionsOutput.clickMissionsName;
					if mission.sellPointId ~= nil and mission.sellPointId > 0 then
						isLineTable.txt[2].ownTable = {mission.fieldId, mission.sellPointId};
					else
						isLineTable.txt[2].ownTable = {mission.fieldId};
					end;
				elseif pickupMission then
					isLineTable.txt[2].callback = moMissionsOutput.clickMissionsNameTransport;
					isLineTable.txt[2].ownTable = {mission};
				end;
				isLineTable.txt[2].alignment = 2;
				isLineTable.txt[2].width = 65;
				
				moreTxt = "";
				isLineTable.txt[3] = {};
				isLineTable.txt[3].bold = true;
				isLineTable.txt[3].slotColor = color;
				if mission.vehicle then moreTxt = "L#";end;
				isLineTable.txt[3].txt = tostring(moreTxt).. tostring(mission.prozent).. "%";			
				if mission.isField then				
					isLineTable.txt[3].callback = moMissionsOutput.clickMissionsProzent;
					isLineTable.txt[3].ownTable = {fillFruitName};
				end;
				isLineTable.txt[3].alignment = 3;
				isLineTable.txt[3].width = 15;
			end;	
		end;		
		
		table.insert(lineTable.line, 1, {});
		isLineTable = lineTable.line[1];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "Map ".. tostring(g_i18n:getText("ui_mapHotspotFilter_contracts")).. "(".. tostring(#moMissions.values.missions).. ")"; 
		isLineTable.txt[1].callback = moMissionsOutput.clickMissionsTotal;
		isLineTable.txt[1].alignment = 2;
		if slotTable ~= nil and slotTable.help.outputOn then
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moMissionsOutput.clickMissionsHelpTxt}};
		end;
		if #moMissions.values.missions <= 0 then
			table.insert(lineTable.line, 2, {});
			isLineTable = lineTable.line[2];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_noMissions"));
		else 
			table.insert(lineTable.line, 2, {});
			isLineTable = lineTable.line[2];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].bold = true;		
			if moMissions.values.sortBy == 1 then
				isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Price*";
			elseif moMissions.values.sortBy == 2 then
				isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Type*";
			elseif moMissions.values.sortBy == 3 then
				isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Hectar*";
			else
				isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Field*";	
			end;
			isLineTable.txt[1].callback = moMissionsOutput.clickMissionsSortBy;
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonFlip", color="green", modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moMissionsOutput.clickMissionsSortBy}};
		end;
		---objectLineDistance---
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		isLineTable.txt[1].txt = " ";
		---objectLineDistance---
	end;
	moMissionsOutput.output = lineTable;
end;

function moMissionsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="missions" } );
	moMissionsOutput:load(args.slotTable);
	return moMissionsOutput.output;
end;

function moMissionsOutput.clickMissionsSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if moMissions.values.sortBy+1 > 4 then moMissions.values.sortBy = 1;else moMissions.values.sortBy = moMissions.values.sortBy+1;end;
		moMissions.load(args.slotTable); --refresh
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then	
		if moMissions.values.sortBy-1 < 1 then moMissions.values.sortBy = 4;else moMissions.values.sortBy = moMissions.values.sortBy-1;end;
		moMissions.load(args.slotTable); --refresh
	end;
end;

function moMissionsOutput.clickMissionsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Map Missions Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Map Missions/Sort By/Mission/Price for more Info or MapHotSpot or ...";
	end;
end;

function moMissionsOutput.clickMissionsTotal(args)	
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moModule:showInGameMenuFrame("pageContracts", 0, true, false, 0);		
	end;
end;

function moMissionsOutput.clickMissionsProzent(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil then
			g_currentMission.hl.addTextDisplay( {txt="Mission Fill/FruitType: ".. tostring(args.ownTable[1]), txtBold=true, duration=3} );			
		end;
	end;
end;

function moMissionsOutput.clickMissionsName(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil and args.ownTable[1] > 0 then
			local field = g_fieldManager.fields[args.ownTable[1]];
			if field ~= nil then				
				local x, z = field:getCenterOfFieldWorldPosition();
				local x1, y1, z1 = 0,0,0;
				if args.ownTable[2] ~= nil and args.ownTable[2] > 0 then
					x1, y1, z1 = getWorldTranslation(args.ownTable[2]);
				end;
				if x ~= nil and x ~= 0 and x1 ~= nil and x1 ~= 0 then
					moSetGetOverlays:mapHotSpot({"Field", "Target"}, {x, x1}, {z, z1}, 2);					
				elseif x ~= nil and x ~= 0 then  
					moSetGetOverlays:mapHotSpot({"Field"}, {x}, {z}, 1);
				elseif x1 ~= nil and x1 ~= 0 then  
					moSetGetOverlays:mapHotSpot({"Target"}, {x1}, {z1}, 1);
				end;				
			end;			
		end;
	end;
end;

function moMissionsOutput.clickMissionsNameTransport(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil and args.ownTable[1] > 0 then
			local mission = missions.output[args.line].ownValues[1];
			local trigger1 = g_missionManager.transportTriggers[mission.object.pickup];
			local trigger2 = g_missionManager.transportTriggers[mission.object.dropoff];
			local x, y, z = 0,0,0;
			local x1, y1, z1 = 0,0,0;
			if trigger1.triggerId ~= nil then
				x, y, z = getWorldTranslation(trigger1.triggerId);				
			end;
			if trigger2.triggerId ~= nil then
				x1, y1, z1 = getWorldTranslation(trigger2.triggerId);				
			end;
			if x ~= nil and x ~= 0 and x1 ~= nil and x1 ~= 0 then
				moSetGetOverlays:mapHotSpot({"Pickup", "Target"}, {x, x1}, {z, z1}, 2);
			elseif x ~= nil and x ~= 0 then  
				moSetGetOverlays:mapHotSpot({"Pickup"}, {x}, {z}, 1);
			elseif x1 ~= nil and x1 ~= 0 then  
				moSetGetOverlays:mapHotSpot({"Target"}, {x1}, {z1}, 1);
			end;
		end;
	end;
end;		

function moMissionsOutput.clickMissionsMoney(args)	
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			moModule:showInGameMenuFrame("pageContracts", args.ownTable[1], false, false, 0, false);			
		end;
	end;	
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="missions" } );