moModule = {};
source(MultiOverlayV4.modDir.."scripte/module/moModuleObjects.lua");
source(MultiOverlayV4.modDir.."scripte/module/moModuleSetGet.lua");

moModule.time = {delay=1, dt=0, minute=0}; --1 min
moModule.activeRunning = {};
moModule.activeRunning["MultiOverlayV4"] = {		 
	fillTypes={isRunning=false, last=0};	
}; --insert new active module and ... check your module with ....getActiveRunningModul
moModule.values = {maxTimer=120, languageXml=false, inputOutputInLanguage=false};

--moModule.guiMenue = {"moFillTypes", "moAmount", "moAnimals", "moBGAs", "moBunkerSilos", "moByingStations", "moGC_Factorys", "moFillTypeMovers", "moFeedMixers", "moGreatDemand", "moGreenhouses", "moItems", "moMissions", "moObjectStorages", "moSellingStations", "moStorages", "Text Color", "Prozent Color"};
function moModule:isRunning()	
	for modName, modulTable in pairs (moModule.activeRunning) do
		for modulName, modul in pairs (modulTable) do
			if modul.isRunning then
				if modul.last < moModule.time.minute then
					modul.isRunning=false;modul.last=0;					
				end;
			end;
		end;
	end;
end;

moModule.updateCallbacks = {};
function moModule:update(dt)	
	moModule.time.minute = tonumber(getDate("%M"));	
	for _, index in pairs (moModule.updateCallbacks) do
		for _, callback in pairs (index) do
			if callback ~= nil then
				callback(dt);
			end;
		end;
	end;	
end;

moModule.updateTickCallbacks = {};
function moModule:updateTick(dt)	
	for _, index in pairs (moModule.updateTickCallbacks) do
		for _, callback in pairs (index) do
			if callback ~= nil then
				callback(dt);
			end;
		end;
	end;	
end;

moModule.loadConfigCallbacks = {};
function moModule:loadConfigs(Xml, xmlNameTag, directory, typ)
	for _, index in pairs (moModule.loadConfigCallbacks) do		
		for _, callback in pairs (index) do			
			if callback ~= nil then
				callback(Xml, xmlNameTag, directory, typ);
			end;
		end;
	end;
	moModule:loadXml(Xml, xmlNameTag, directory, typ);
end;

moModule.saveConfigCallbacks = {};
function moModule:saveConfigs(Xml, xmlNameTag, directory, typ)		
	for _, index in pairs (moModule.saveConfigCallbacks) do
		for _, callback in pairs (index) do
			if callback ~= nil then
				callback(Xml, xmlNameTag, directory, typ);
			end;
		end;
	end;	
	moModule:saveXml(Xml, xmlNameTag, directory, typ);
end;

moModule.onStartMissionCallbacks = {};
function moModule:onStartMission(update)	
	moModuleObjects:load();		
	if update == nil or not update then moModule:generateCmd();end;
	if g_currentMission.hl.timers["mohActiveRunningModule"] == nil then 
		g_currentMission.hl.addTimer( {delay=10, name="mohActiveRunningModule", action=moModule.isRunning} );
		for modName, modulTable in pairs (moModule.activeRunning) do
			for modulName, modul in pairs (modulTable) do
				modul.isRunning=true;modul.last=moModule.time.minute+moModule.time.delay;		
			end;
		end;
	end;	
	for _, index in pairs (moModule.onStartMissionCallbacks) do
		for _, callback in pairs (index) do
			if callback ~= nil then				
				callback(update);
			end;
		end;
	end;	
end;

function moModule.updateByPlayer(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.hl.timers["mohUpdateModuleCooldown"] == nil then 
			g_currentMission.hl.addTimer( {delay=10, name="mohUpdateModuleCooldown", repeatable=1, action=nil} ); --cooldown Timer
			moModule:onStartMission(true);			
			g_currentMission.hl.addTextDisplay( {txt="Objects Update executed successfully", txtBold=true, duration=3} );
		else
			g_currentMission.hl.addTextDisplay( {txt="Wait 10 sec -Cooldown Active-", txtBold=true, duration=3, warning=true} );			
		end;
	end;
end;


function moModule:loadXml(Xml, xmlNameTag, directory, typ)
	if typ ~= "profilSettings" then return;end;	
	local groupNameTag = (xmlNameTag.. ".module.global(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#inputOutputInLanguage") ~= nil then
		moModule.values.inputOutputInLanguage = getXMLBool(Xml, groupNameTag.. "#inputOutputInLanguage");
	else
		return; --first config not found
	end;
end;

function moModule:saveXml(Xml, xmlNameTag, directory, typ)	
	if typ ~= "profilSettings" then return;end;		
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.global(%d)"):format(0);	
	setXMLBool(Xml, groupNameTag.. "#inputOutputInLanguage", moModule.values.inputOutputInLanguage);
	----------------------------------------------------------------------------------------------	
end;

function moModule:generateCmd()	
	moSetGetCmd:generateCmd( {	
			modName = "MultiOverlayV4";
			cmdName = "action_updateObjectsByPlayer_";
			groupName = "Speziale";			
			displayName = "Objets/Module manual Update";
			infoTxt = "Gelöschte Objecte werden Automatisch entfernt.Neue kann man mit diesem Cmd dann in den Mod laden.Schont die Performens.All Module manual update (when you set a new object or join other Farm)";
			typ = {"action_"};			
			mouseClickAccepts = {true,false,false};
			actionCallback = moModule.updateByPlayer;
		}
	)	
end;

function moModule:addCallbackModul(args)	
	if args == nil or type(args) ~= "table" or args.modName == nil or args.modulCallbackName == nil or moModule[args.modulCallbackName.. "Callbacks"] == nil or args.callback == nil then return false, "args missing or incorrect";end;
	if type(args.callback) == "function" then		
		if moModule[args.modulCallbackName.. "Callbacks"][args.modName] == nil then moModule[args.modulCallbackName.. "Callbacks"][args.modName] = {};end;
		moModule[args.modulCallbackName.. "Callbacks"][args.modName][#moModule[args.modulCallbackName.. "Callbacks"][args.modName]+1] = args.callback;		
		return true;
	end;
	return false, "Callback function not found";
end;

function moModule:deleteCallbackModul(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.modulCallbackName == nil or moModule[args.modulCallbackName.. "Callbacks"] == nil or args.callback == nil then return false;end;
	if moModule[args.modulCallbackName.. "Callbacks"][args.modName] == nil then return false;end;
	for index=1, #moModule[args.modulCallbackName.. "Callbacks"][args.modName] do
		if moModule[args.modulCallbackName.. "Callbacks"][args.modName][index] == args.callback then
			moModule[args.modulCallbackName.. "Callbacks"][args.modName][index] = nil;
			break;
		end;
	end;	
	return true;	
end;

function moModule:addActiveRunningModul(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.modulName == nil then return false;end;
	if moModule.activeRunning[args.modName] == nil then moModule.activeRunning[args.modName] = {};end;
	if moModule.activeRunning[args.modName][args.modulName] ~= nil then return false;end;
	moModule.activeRunning[args.modName][args.modulName] = {};	
	moModule.activeRunning[args.modName][args.modulName].isRunning = false;
	moModule.activeRunning[args.modName][args.modulName].last = 0;	
	return true;
end;

function moModule:setActiveRunningModul(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.modulName == nil then return false;end;
	if moModule.activeRunning[args.modName] == nil or moModule.activeRunning[args.modName][args.modulName] == nil then return false;end;
	moModule.activeRunning[args.modName][args.modulName].isRunning = true;
	moModule.activeRunning[args.modName][args.modulName].last = moModule.time.minute+moModule.time.delay;
	return true;
end;

function moModule:getActiveRunningModul(args)
	if args == nil or type(args) ~= "table" or args.modName == nil or args.modulName == nil then return false;end;
	if moModule.activeRunning[args.modName] == nil or moModule.activeRunning[args.modName][args.modulName] == nil then return false;end;
	return moModule.activeRunning[args.modName][args.modulName].isRunning;	
end;

-------------mod setGetModuleFunction-------------
g_currentMission.multiOverlayV4.moduleFunction={
	addActiveRunningModul = function(args)return moModule:addActiveRunningModul(args);end;
	setActiveRunningModul = function(args)return moModule:setActiveRunningModul(args);end;
	getActiveRunningModul = function(args)return moModule:getActiveRunningModul(args);end;
	addCallbackModul = function(args)return moModule:addCallbackModul(args);end;
	deleteCallbackModul = function(args)return moModule:deleteCallbackModul(args);end;
};
-------------mod setGetModuleFunction-------------
--g_currentMission.densityHeightMapModifiers.getFillLevelAtArea 

source(MultiOverlayV4.modDir.."scripte/module/filltypes/moFillTypes.lua");
source(MultiOverlayV4.modDir.."scripte/module/greenhouse/moGreenhouse.lua");
source(MultiOverlayV4.modDir.."scripte/module/missions/moMissions.lua");
source(MultiOverlayV4.modDir.."scripte/module/farmlands/moFarmlands.lua");
--source(MultiOverlayV4.modDir.."scripte/module/storages/moStorages.lua"); --bugi
source(MultiOverlayV4.modDir.."scripte/module/amounts/moAmounts.lua");
source(MultiOverlayV4.modDir.."scripte/module/sellingStations/moSellingStations.lua");
source(MultiOverlayV4.modDir.."scripte/module/onlyOutputs/moFillTypeAmountPriceOutput.lua");
source(MultiOverlayV4.modDir.."scripte/module/onlyOutputs/moTeleportPointsOutput.lua");
source(MultiOverlayV4.modDir.."scripte/module/productionPoints/moProductionPoints.lua");
source(MultiOverlayV4.modDir.."scripte/module/animals/moAnimals.lua");
source(MultiOverlayV4.modDir.."scripte/module/windTurbines/moWindTurbines.lua");
source(MultiOverlayV4.modDir.."scripte/module/beehives/moBeehives.lua");
source(MultiOverlayV4.modDir.."scripte/module/solarPanels/moSolarPanels.lua");
source(MultiOverlayV4.modDir.."scripte/module/buyingStations/moBuyingStations.lua");
source(MultiOverlayV4.modDir.."scripte/module/bunkerSilos/moBunkerSilos.lua");
source(MultiOverlayV4.modDir.."scripte/module/chargingStations/moChargingStations.lua");
--source(MultiOverlayV4.modDir.."scripte/module/keySettings/moKeySettings.lua"); --bugi
source(MultiOverlayV4.modDir.."scripte/module/items/moItems.lua");
source(MultiOverlayV4.modDir.."scripte/module/vehicleSales/moVehicleSales.lua");
source(MultiOverlayV4.modDir.."scripte/module/bestPrices/moBestPrices.lua");
source(MultiOverlayV4.modDir.."scripte/module/fields/moFields.lua");