moModuleSetGet = {};

function moModuleSetGet:getFillLevelInformation(object)
	local fillLevelInformation = {production={}, revampMode={total=0, sunString="", sun=false, rainString="", rain=false, seasonalString="", seasonal=false, hourlyString="", hourly=false, monthlyString="", monthly=false, tempString="", temp=false, tempNegativeString="", tempNegative=false, windString="", wind=false}};
	local productionId = {};
	local allActive = false;
	local revampModeFound = false;	
	if object ~= nil then		
		if #object.activeProductions > 0 then
			for p= 1, #object.activeProductions do
				local production = object.activeProductions[p]
				if production ~= nil then
					productionId[production.id] = true;					
				end;
			end;							
		end;
		if #object.productions > 0 then
			for p= 1, #object.productions do
				local production = object.productions[p]
				if production ~= nil then					
					local rezeptName = production.name;
					local costsPerActiveMonth = Utils.getNoNil(production.costsPerActiveMonth, 0);
					fillLevelInformation.production[#fillLevelInformation.production+1] = {status=moModuleSetGet:getProductionStatus(object, production.id),productionIndex=p, active=productionId[production.id] ~= nil, rezeptName=rezeptName, costsPerActiveMonth=costsPerActiveMonth, output={}, input={}};
					local productionOutput = fillLevelInformation.production[#fillLevelInformation.production].output;
					for o=1, #production.outputs do
						if production.outputs[o] ~= nil then
							local output = production.outputs[o];
							--revamp--
							if not revampModeFound and production.mode ~= nil and type(production.mode) == "string" and production.mode:len() > 0 and not string.find(tostring(production.mode), "none") then
								revampModeFound, fillLevelInformation.revampMode.total = moModuleSetGet:getRevampMode(fillLevelInformation, production);								
							end;
							--revamp--
							local fillLevel = object.storage:getFillLevel(output.type);
							local freeCapacity = object.storage:getFreeCapacity(output.type);
							local capacity = object.storage:getCapacity(output.type);							
							local amount = output.amount;							
							local isPal = object.outputFillTypeIdsToPallets ~= nil and object.outputFillTypeIdsToPallets[output.type] ~= nil;
							local directSell = object.outputFillTypeIdsDirectSell[output.type] ~= nil and object.outputFillTypeIdsDirectSell[output.type] == true;
							local directDeliver = object.outputFillTypeIdsAutoDeliver[output.type] ~= nil and object.outputFillTypeIdsAutoDeliver[output.type] == true;
							if productionOutput[output.type] == nil then
								productionOutput[output.type] = {isPal=isPal, fillLevel=fillLevel or 0, freeCapacity=freeCapacity or 0, capacity=capacity or 0, amount=amount, directDeliver=directDeliver, directSell=directSell};
							else
								freeCapacity = freeCapacity+Utils.getNoNil(productionOutput[output.type].freeCapacity, 0);
								amount = amount+Utils.getNoNil(productionOutput[output.type].amount, 0);
								capacity = capacity+Utils.getNoNil(productionOutput[output.type].capacity, 0);
								fillLevel = fillLevel+Utils.getNoNil(productionOutput[output.type].fillLevel, 0);
								productionOutput[output.type].freeCapacity = freeCapacity;
								productionOutput[output.type].capacity = capacity;
								productionOutput[output.type].amount = amount;
								productionOutput[output.type].fillLevel = fillLevel;
							end;																		
						end;
					end;
					if productionId[production.id] ~= nil then
						local productionInput = fillLevelInformation.production[#fillLevelInformation.production].input;
						for i=1, #production.inputs do
							if production.inputs[i] ~= nil then
								local input = production.inputs[i];											
								--revamp--
								if not revampModeFound and production.mode ~= nil and type(production.mode) == "string" and production.mode:len() > 0 and not string.find(tostring(production.mode), "none") then
									revampModeFound, fillLevelInformation.revampMode.total = moModuleSetGet:getRevampMode(fillLevelInformation, production);
								end;
								--revamp--
								local fillLevel = object.storage:getFillLevel(input.type);											
								local capacity = object.storage:getCapacity(input.type);
								local amount = input.amount;
								if productionInput[input.type] == nil then
									productionInput[input.type] = {fillLevel=fillLevel or 0,amount=amount, capacity=capacity or 0};
								else
									fillLevel = fillLevel+Utils.getNoNil(productionInput[input.type].fillLevel, 0);
									amount = amount+Utils.getNoNil(productionInput[input.type].amount, 0);
									capacity = capacity+Utils.getNoNil(productionInput[input.type].capacity, 0);
									productionInput[input.type].fillLevel = fillLevel;
									productionInput[input.type].capacity = capacity;
									productionInput[input.type].amount = amount;
								end;
							end;
						end;
					end;
				end;
			end;
		end;
		allActive = #object.productions == #object.activeProductions;
	end;	
	return fillLevelInformation, allActive, revampModeFound;
end;

function moModuleSetGet:getRevampMode(fillLevelInformation, production)
	local revampModeFound = false;
	local revampModeFoundTotal = 0;
	if not moGeneralSettings.other.revamp.viewModeInfo then return revampModeFound, revampModeFoundTotal;end;
	if string.find(tostring(production.mode), "seasonal") and production.seasons ~= nil and production.seasons:len() > 0 then
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.seasonal = true;
		fillLevelInformation.revampMode.seasonalString = tostring(string.format(g_i18n:getText("Revamp_seasonalProduction"), "", production.seasons));
	end;
	if string.find(tostring(production.mode), "monthly") and production.months ~= nil and production.months:len() > 0 then --1-12, wobei 1 ist im LS März
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.monthly = true;
		fillLevelInformation.revampMode.monthlyString = tostring(string.format(g_i18n:getText("Revamp_monthlyProduction"), "", production.monthly));
	end;	
	if string.find(tostring(production.mode), "hourly") and production.startHour ~= nil and production.startHour >= 0 and production.endHour ~= nil and production.endHour >= 0 then
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.hourly = true;
		fillLevelInformation.revampMode.hourlyString = tostring(string.format(g_i18n:getText("Revamp_productionHoursDependent"), "", production.startHour, production.endHour));
	end;
	if string.find(tostring(production.mode), "hourly") and production.hours ~= nil and production.hours:len() > 0 then --new version
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.hourly = true;
		fillLevelInformation.revampMode.hourlyString = tostring(string.format(g_i18n:getText("Revamp_productionHoursDependent"), "", production.hours));
	end;	
	if string.find(tostring(production.mode), "sun") and production.sun ~= nil and production.sun:len() > 0 then
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.sun = true;
		fillLevelInformation.revampMode.sunString = tostring(string.format(g_i18n:getText("Revamp_sunProduction"), "", production.sun));									
	end;
	if string.find(tostring(production.mode), "rain") and production.rain ~= nil and production.rain:len() > 0 then
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.rain = true;
		fillLevelInformation.revampMode.rainString = tostring(string.format(g_i18n:getText("Revamp_rainProduction"), "", production.rain));	
	end;
	if string.find(tostring(production.mode), "wind") and production.wind ~= nil then
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.wind = true;
		fillLevelInformation.revampMode.windString = tostring(string.format(g_i18n:getText("Revamp_windProduction"), "", production.wind));	
	end;
	if string.find(tostring(production.mode), "temp") and production.temp ~= nil then
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.temp = true;
		fillLevelInformation.revampMode.tempString = tostring(string.format(g_i18n:getText("Revamp_temperatureProduction"), "", production.temp));		
	end;
	if string.find(tostring(production.mode), "tempNegative") and production.tempNegative ~= nil then
		revampModeFoundTotal = revampModeFoundTotal+1;
		revampModeFound = true;
		fillLevelInformation.revampMode.tempNegative = true;
		fillLevelInformation.revampMode.tempNegativeString = tostring(string.format(g_i18n:getText("Revamp_temperatureNegativeProduction"), "", production.tempNegative));		
	end;
	return revampModeFound, revampModeFoundTotal;
end;

function moModuleSetGet:getAnimalFillLevelInformation(object)
	local fillLevelInformation = {output={},input={}};
	if object ~= nil then
		local spec = object.spec_husbandryFood;
		if spec ~= nil then
			local animalFood = g_currentMission.animalFoodSystem:getAnimalFood(spec.animalTypeIndex);
			if animalFood ~= nil then			
				for _, foodGroup in pairs(animalFood.groups) do
					local title = foodGroup.title;
					local fillLevel = 0;
					local capacity = spec.capacity;				
					local foodGroupFillTypes = {};
					for _, fillTypeIndex in pairs(foodGroup.fillTypes) do					
						foodGroupFillTypes[#foodGroupFillTypes+1] = fillTypeIndex;
						if spec.fillLevels[fillTypeIndex] ~= nil then
							fillLevel = fillLevel + spec.fillLevels[fillTypeIndex];
						end;
					end;
					local info = {
						title = string.format("%s (%d%%)", title, foodGroup.productionWeight * 100);
						fillLevel = fillLevel;
						foodGroupFillTypes = foodGroupFillTypes;
						capacity = capacity;
						ratio = 0;
					};
					if capacity > 0 then
						info.ratio = fillLevel / capacity;
					end;
					table.insert(fillLevelInformation.input, #fillLevelInformation.input+1, info);
				end;
			end;
		end;
		local conditionInfo = object:getConditionInfos();
		if conditionInfo ~= nil and #conditionInfo > 0 then
			local otherCapacity = moModuleSetGet:getOtherCapacity(object);
			for c=1, #conditionInfo do
				if conditionInfo[c] ~= nil then
					if conditionInfo[c].title ~= g_i18n:getText("statistic_productivity") then
						if conditionInfo[c].invertedBar ~= nil and not conditionInfo[c].invertedBar then
							local info = {
								title = conditionInfo[c].title;
								fillLevel = conditionInfo[c].value;
								--foodGroupFillTypes = nil;
								capacity = conditionInfo[c].capacity;
								ratio = conditionInfo[c].ratio;
							};
							if info.capacity == nil or info.capacity == 0 then
								if otherCapacity[info.title] ~= nil then info.capacity = otherCapacity[info.title];end;
							end;
							table.insert(fillLevelInformation.input, #fillLevelInformation.input+1, info);
						else
							local info = {
								title = conditionInfo[c].title;
								fillLevel = conditionInfo[c].value;
								--foodGroupFillTypes = nil;
								--capacity = conditionInfo[c].capacity;
								ratio = conditionInfo[c].ratio;
							};
							if otherCapacity[info.title] ~= nil then info.capacity = otherCapacity[info.title];end;
							table.insert(fillLevelInformation.output, #fillLevelInformation.output+1, info);
						end;
					end;
				end;
			end;
		end;
	end;
	return fillLevelInformation;
end;

function moModuleSetGet:getOtherCapacity(object)
	local otherCapacity = {};
	if object ~= nil and object.spec_husbandryAnimals ~= nil then
		if object.spec_husbandryAnimals.spec_husbandryMilk ~= nil then
			local spec = object.spec_husbandryAnimals.spec_husbandryMilk;
			local capacity = object.spec_husbandryAnimals:getHusbandryCapacity(spec.fillType);
			local fillType = g_fillTypeManager:getFillTypeByIndex(spec.fillType);
			otherCapacity[fillType.title] = capacity;			
		end;
		if object.spec_husbandryAnimals.spec_husbandryManure ~= nil then
			local spec = object.spec_husbandryAnimals.spec_husbandryManure;
			local capacity = object.spec_husbandryAnimals:getHusbandryCapacity(spec.fillType);
			local fillType = g_fillTypeManager:getFillTypeByIndex(spec.fillType);
			otherCapacity[fillType.title] = capacity;			
		end;
		if object.spec_husbandryAnimals.spec_husbandryLiquidManure ~= nil then
			local spec = object.spec_husbandryAnimals.spec_husbandryLiquidManure;
			local capacity = object.spec_husbandryAnimals:getHusbandryCapacity(spec.fillType);
			local fillType = g_fillTypeManager:getFillTypeByIndex(spec.fillType);
			otherCapacity[fillType.title] = capacity;			
		end;
		if object.spec_husbandryAnimals.spec_husbandryStraw ~= nil then
			local spec = object.spec_husbandryAnimals.spec_husbandryStraw;
			local capacity = object.spec_husbandryAnimals:getHusbandryCapacity(spec.inputFillType);
			local fillType = g_fillTypeManager:getFillTypeByIndex(spec.inputFillType);
			otherCapacity[fillType.title] = capacity;			
		end;
		if object.spec_husbandryAnimals.spec_husbandryWater ~= nil then
			local spec = object.spec_husbandryAnimals.spec_husbandryWater;
			local capacity = object.spec_husbandryAnimals:getHusbandryCapacity(spec.fillType);
			local fillType = g_fillTypeManager:getFillTypeByIndex(spec.fillType);
			if spec.automaticWaterSupply then capacity = -1;end;
			otherCapacity[fillType.title] = capacity;			
		end;
		if object.spec_husbandryAnimals.spec_husbandryPallets ~= nil then
			local spec = object.spec_husbandryAnimals.spec_husbandryPallets;
			local capacity = spec.maxNumPallets;
			local fillType = g_fillTypeManager:getFillTypeByIndex(spec.fillTypeIndex);
			otherCapacity[fillType.title] = capacity;			
		end;		
	end;
	return otherCapacity;
end;

function moModuleSetGet:getMoreAnimalsInfo(object, isHorse)
	local moreInfos = {};
	if object ~= nil and object.spec_husbandryAnimals ~= nil and object.spec_husbandryAnimals.clusterSystem ~= nil and object.spec_husbandryAnimals.clusterSystem.getClusters ~= nil then
		local spec = object.spec_husbandryAnimals.clusterSystem;
		function setMoreInfos()			
			--braucht man alle Werte ! NEIN ! aber wenn man schon durch geht kann man sich ja ruhig alle Werte holen ;-)
			--generate/refresh all Tables automatic--
			local tempValues = {}; --health,sellPrice,duration,reproduction,reproductionStand,reproductionMonth,puberty,fitness,riding,dirt,gender,numAnimals,age,names; --duration=reproductionDurationMonth/Tragezeit, puberty=reproductionMinAgeMonth/Geschlechstreife	
			--set string: names/typName--
			function setStringClusterValue(typ, clusterTyp, stringClusterTypValue)				
				if tempValues[typ] == nil then tempValues[typ] = {};end;
				if tempValues[typ][clusterTyp] == nil or #tempValues[typ][clusterTyp] == 0 then tempValues[typ][clusterTyp] = {};end;
				if stringClusterTypValue ~= nil then				
					tempValues[typ][clusterTyp][#tempValues[typ][clusterTyp]+1] = tostring(stringClusterTypValue);					
				end;
				if tempValues[typ][clusterTyp] ~= nil and #tempValues[typ][clusterTyp] > 0 then table.sort(tempValues[typ][clusterTyp]);end;
			end;
			--set string: names/typName--
			--set gender: female,male--			
			function setGender(clusterTyp, subType, numClusterTypValue)				
				if tempValues[clusterTyp] == nil or #tempValues[clusterTyp] == 0 then tempValues[clusterTyp] = {0,0};end;
				if subType.supportsReproduction then
					tempValues[clusterTyp][1] = tempValues[clusterTyp][1]+numClusterTypValue;
					return true;
				else
					tempValues[clusterTyp][2] = tempValues[clusterTyp][2]+numClusterTypValue;					
				end;
				return false;				
			end;
			--set gender: female,male--
			--set number: health,dirt,fitness,riding,reproduction,reproductionStand,reproductionMonth,duration,puberty,sellPriceOne,sellPrice x numType,age,+all highest x numTypes,lowest x numTypes--
			function setHighestLowest(clusterTyp, value, set0) --not set0 for sellPriceOne/sellPriceTotal/numAnimals			
				if set0 or (not set0 and value > 0) then 
					clusterTyp[3][#clusterTyp[3]+1] = value;				
				end;				
				table.sort(clusterTyp[3], function(a,b)return a>b;end);				
			end;	
			function setNumClusterValue(clusterTyp, numClusterTypValue, set0)				
				if tempValues[clusterTyp] == nil or #tempValues[clusterTyp] == 0 then tempValues[clusterTyp] = {0,0,{}};end;
				if numClusterTypValue ~= nil then					
					tempValues[clusterTyp][1] = tempValues[clusterTyp][1]+numClusterTypValue;
					tempValues[clusterTyp][2] = tempValues[clusterTyp][2]+1;
					setHighestLowest(tempValues[clusterTyp], numClusterTypValue, set0);				
				end;
			end;
			--set number: health,dirt,fitness,riding,reproduction,reproductionStand,reproductionMonth,duration,puberty,sellPriceOne,sellPrice x numType,age,+all highest x numTypes,lowest x numTypes--
			local clusters = spec:getClusters();
			if clusters ~= nil and type(clusters) == "table" and #clusters > 0 then
				for _, cluster in ipairs(clusters) do					
					if cluster ~= nil then
						local subType = g_currentMission.animalSystem:getSubTypeByIndex(cluster.subTypeIndex);
						if subType ~= nil then	
							cluster.typName = " / ".. tostring(cluster.numAnimals);cluster.duration = 0;cluster.puberty = 0;cluster.sellPriceTotal = cluster:getSellPrice()*cluster.numAnimals;cluster.sellPriceOne = cluster:getSellPrice(); --set temp cluster own Values
							local visual = g_currentMission.animalSystem:getVisualByAge(cluster.subTypeIndex, cluster.age)
							if visual ~= nil and visual.store ~= nil then cluster.typName = Utils.getNoNil(visual.store.name, "").. " / ".. tostring(cluster.numAnimals);end;
							setStringClusterValue("names", "typName", cluster.typName);							
							setNumClusterValue("numAnimals", cluster.numAnimals, false);
							setNumClusterValue("health", cluster.health, true);
							setNumClusterValue("sellPriceTotal", cluster.sellPriceTotal, false);
							setNumClusterValue("sellPriceOne", cluster.sellPriceOne, false);
							setNumClusterValue("age", cluster.age, true);
							local canReproduction = setGender("gender", subType, cluster.numAnimals);														
							if canReproduction then
								cluster.duration = subType.reproductionDurationMonth;
								setNumClusterValue("duration", cluster.duration, true);
								if cluster.age < subType.reproductionMinAgeMonth then
									cluster.puberty = MathUtil.clamp(cluster.age / subType.reproductionMinAgeMonth, 0, 1);
									setNumClusterValue("puberty", cluster.puberty, true);
								else
									setNumClusterValue("reproduction", cluster.reproduction, true);									
									local formatMonth = (100-cluster.reproduction)*(cluster.duration/100); --8 Monate = 0.08 -- > 1%
									setNumClusterValue("reproductionMonth", formatMonth, true); 
									if subType.reproductionMinHealth <= cluster:getHealthFactor() or subType.reproductionMinAgeMonth <= cluster.age then
										setNumClusterValue("reproductionStand", 0, true);
									else
										setNumClusterValue("reproductionStand", 100, true);
									end;
								end;							
							end;
							--horse--
							if isHorse then
								setNumClusterValue("dirt", 100-cluster.dirt, true); --dirt negieren								
								setNumClusterValue("fitness", cluster.fitness, true);
								setNumClusterValue("riding", cluster.riding, true);
							end;
							--horse--							
						end;
					end;										
				end;
				moreInfos.animalClusters = {health=tempValues.health,dirt=tempValues.dirt,fitness=tempValues.fitness,gender=tempValues.gender,riding=tempValues.riding,puberty=tempValues.puberty,reproduction=tempValues.reproduction,duration=tempValues.duration,numAnimals=tempValues.numAnimals,sellPriceOne=tempValues.sellPriceOne,sellPriceTotal=tempValues.sellPriceTotal,reproductionMonth=tempValues.reproductionMonth,names=tempValues.names,age=tempValues.age};
										
				--if MultiOverlayV4.debugPrint then					
				--	MultiOverlayV4.debugPrint = false;
				--	print("-----------test print begin----------")
				--	print(DebugUtil.printTableRecursively(moreInfos.animalClusters, tostring(object.spec_husbandryAnimals.animalTypeIndex).. " moreInfos.animalCluster ", 0, 4))
				--	print("-----------test print ende-----------")
				--end;
			end;			
		end;
		if spec ~= nil then setMoreInfos();end;		
		moreInfos.feedingRobot = object.spec_husbandryFeedingRobot ~= nil and object.spec_husbandryFeedingRobot.feedingRobot ~= nil;
		if moreInfos.feedingRobot then 
			local state = object.spec_husbandryFeedingRobot.feedingRobot:getState();
			if state ~= nil and object.spec_husbandryFeedingRobot.feedingRobot.stateMachine[state] ~= nil then
				if state == object.spec_husbandryFeedingRobot.feedingRobot.state.DRIVING then
					moreInfos.feedingRobotState = 2;
				else
					moreInfos.feedingRobotState = 1;
				end;				
			end;
			moreInfos.feedingRobotFillLevel = 0;
			if object.spec_husbandryFeedingRobot.feedingRobot.robot ~= nil then
				local fillPlane = object.spec_husbandryFeedingRobot.feedingRobot.robot.fillPlane;
				if fillPlane ~= nil and fillPlane.node ~= nil then
					moreInfos.feedingRobotFillLevel = Utils.getNoNil(fillPlane.fillLevel, 0);
				end;
			end;
		end;	
	end;
	return moreInfos;
end;

function moModuleSetGet:getBunkerSiloFillLevelInformation(object)
	local fillLevelInformation = {info={},output={},input={}};
	if object ~= nil then
		local spec = object.spec_bunkerSilo;
		if spec ~= nil and spec.bunkerSilo ~= nil then
			local siloGroupFillTypes = {};
			for fillType,isAccepted in pairs(spec.bunkerSilo.acceptedFillTypes) do
				if isAccepted then
					siloGroupFillTypes[#siloGroupFillTypes+1] = fillType;							
				end;
			end;
			local info = {
				title = g_i18n:getText("info_fillLevel");
				groupFillTypes = siloGroupFillTypes;
				fillLevel = spec.bunkerSilo.fillLevel;					
			};
			table.insert(fillLevelInformation.input, #fillLevelInformation.input+1, info);
			local info = {
				fillType = spec.bunkerSilo.outputFillType;
				fillLevel = spec.bunkerSilo.fillLevel;					
			};
			table.insert(fillLevelInformation.output, #fillLevelInformation.output+1, info);
			local info = {
				compactedPercent = spec.bunkerSilo.compactedPercent;
				compactedFillLevel = spec.bunkerSilo.compactedFillLevel;
				fermentingPercent = spec.bunkerSilo.fermentingPercent;
				state = spec.bunkerSilo.state;
			};
			table.insert(fillLevelInformation.info, #fillLevelInformation.info+1, info);
		end;
	end;
	return fillLevelInformation;
end;

function moModule:showInGameMenuFrame(frame, objectId, global, selectObject, change, pointIndex, forceMouse)
	if frame == nil or objectId == nil or g_currentMission.inGameMenu[frame] == nil or change > 1 then return;end;
	local change = change or 0;		
	if frame == "pageAnimals" then
		if global ~= nil and global and not selectObject then
			if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff
			g_gui:showGui("InGameMenu");
			g_currentMission.inGameMenu:goToPage(g_currentMission.inGameMenu.pageAnimals, true);
		else
			local object = moModuleObjects:getObject(objectId, "animals");
			if object ~= nil then
				if selectObject then
					if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff	
					g_gui:showGui("InGameMenu");
					local objectSelect = 0;
					if object:getNumOfClusters() > 0 then 			
						for a=1, #g_currentMission.inGameMenu.pageAnimals.sortedHusbandries do
							if g_currentMission.inGameMenu.pageAnimals.sortedHusbandries[a] == object then objectSelect = a;break;end;
						end;			
						if objectSelect ~= 0 and g_currentMission.inGameMenu.pageAnimals.list.selectedSectionIndex ~= objectSelect then
							--g_currentMission.inGameMenu.pageAnimals.selectedHusbandry = object;	
							g_currentMission.inGameMenu.pageAnimals.list.selectedSectionIndex = objectSelect;
						end;
					else
						objectSelect = 1;
					end;					
					g_currentMission.inGameMenu:goToPage(g_currentMission.inGameMenu.pageAnimals, true);
					if objectSelect == 0 and change == 0 then moModule:showInGameMenuFrame(frame, objectId, global, selectObject, change+1, forceMouse);end; --change
				else
					local controller = AnimalScreenDealerFarm.new(object);
					if controller ~= nil then
						controller:init();
						MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame"); --force mouseOff
						g_animalScreen:setController(controller);
						g_gui:showGui("AnimalScreen");
					end;
				end;
			end;
		end;
	elseif frame == "pageContracts"	then
		if global ~= nil and global and not selectObject then
			if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff
			g_gui:showGui("InGameMenu");
			g_currentMission.inGameMenu:goToPage(g_currentMission.inGameMenu.pageContracts, true);
		else
			local missionId = objectId;
			if missionId > 0 then
				if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff
				g_gui:showGui("InGameMenu");
				local missionPageId = g_currentMission.inGameMenu.pagingElement:getPageIdByElement(g_currentMission.inGameMenu.pageContracts);
				local missionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndex(missionPageId);
				g_currentMission.inGameMenu.pageSelector:setState(missionPageIndex, true);						
				local section, index = g_currentMission.inGameMenu.pageContracts.contractsList:getSelectedPath()
				local sectionContracts = g_currentMission.inGameMenu.pageContracts.sectionContracts[section];
				
				if sectionContracts.contracts[index].mission.id ~= missionId then
					for s=1, #g_currentMission.inGameMenu.pageContracts.sectionContracts do
						for i=1, #g_currentMission.inGameMenu.pageContracts.sectionContracts[s].contracts do
							if g_currentMission.inGameMenu.pageContracts.sectionContracts[s].contracts[i].mission.id == missionId then
								g_currentMission.inGameMenu.pageContracts.contractsList:setSelectedItem(s, i);							
								return;
							end;
						end;
					end;
				end;			
			end;
		end;
	elseif frame == "pageProduction" then
		if global ~= nil and global and not selectObject then
			if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff
			g_gui:showGui("InGameMenu");
			g_currentMission.inGameMenu:goToPage(g_currentMission.inGameMenu.pageProduction, true);
		else
			local object = moModuleObjects:getObject(objectId, "productionPoints");
			if object == nil then object = moModuleObjects:getObject(objectId, "greenhouses");end; --change
			if object ~= nil then				
				local productions = object.spec_productionPoint;
				if productions ~= nil then productions = productions.productionPoint;end;
				if productions == nil and object.spec_extendedProductionPoint ~= nil then productions = object.spec_extendedProductionPoint.productionPoint;end;
				if productions ~= nil then					
					if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff
					--local productionPageIndex = g_currentMission.inGameMenu.pagingElement:getPageMappingIndexByElement(g_currentMission.inGameMenu.pageProduction);
					--g_currentMission.inGameMenu.pageSelector:setState(productionPageIndex, true)
					--g_currentMission.inGameMenu.pageProduction:setSelectedProductionPoint(object.spec_productionPoint.productionPoint);
					--if pointIndex ~= nil and g_currentMission.inGameMenu.pageProduction.productionList.selectedIndex ~= pointIndex then
					--	g_currentMission.inGameMenu.pageProduction.productionList.selectedIndex = pointIndex;
					--end;
					g_gui:showGui("InGameMenu");
					g_currentMission.inGameMenu:openProductionScreen(productions);
					--if pointIndex ~= nil and g_currentMission.inGameMenu.pageProduction.productionList.selectedIndex ~= pointIndex then
					--	g_currentMission.inGameMenu.pageProduction.productionList:notifyIndexChange(pointIndex, #productions);
					--	g_currentMission.inGameMenu.pageProduction.productionList.selectedIndex = pointIndex;					
					--end;	
				else
					if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff
					g_gui:showGui("InGameMenu");
					g_currentMission.inGameMenu:goToPage(g_currentMission.inGameMenu.pageProduction, true);	
				end;
			else
				if forceMouse == nil or forceMouse then MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moModule:showInGameMenuFrame");end; --force mouseOff
				g_gui:showGui("InGameMenu");
				g_currentMission.inGameMenu:goToPage(g_currentMission.inGameMenu.pageProduction, true);
			end;
		end;
	end;
end;

function moModuleSetGet:getProductionStatus(object, productionId)
	return object.productionsIdToObj[productionId].status;
end

function moModuleSetGet:getProductionPoints()
	local playerFarmId = g_currentMission.player.farmId;
	if playerFarmId == 0 then return nil;end;
	if g_currentMission.productionChainManager == nil then return nil;end;
	return g_currentMission.productionChainManager:getProductionPointsForFarmId(playerFarmId);
end;

function moModuleSetGet:getSelectedProduction()
	local productionPoint = moModuleSetGet:getProductionPoints(); --[g_currentMission.inGameMenu.pageProduction.productionList:getSelectedSection()];
	local production = productionPoint.productions[g_currentMission.inGameMenu.pageProduction.productionList:getSelectedIndexInSection()];
	return production, productionPoint;
end;

function moModuleSetGet:setSelectedProductionPoint(productionPoint, production)
	local productionList = moModuleSetGet:getProductionPoints();
	if productionList ~= nil and #productionList > 0 then
		for index, listProdPoint in ipairs(productionList) do
			if listProdPoint == productionPoint then
				g_currentMission.inGameMenu.pageProduction.productionList:setSelectedItem(index, 1);
				break;
			end;
		end;
	end;
end;

function moModuleSetGet:getVotModName()
	local modName = "VariableOpeningTime";
	local missing = string.find(g_i18n:getText("vot_ClockTime", modName), "Missing");
	if missing then modName = "FS22_VariableOpeningTime";end; --modHub
	return modName;
end;

function moModuleSetGet:getVotMod(object)
	if not moGeneralSettings.other.vot.viewOpeningTimeInfo then return false;end;
	if object ~= nil then
		local isVotObject = object.votOpeningTime ~= nil and #object.votOpeningTime > 0;
		local votObject = nil;
		local votObjectNew = nil;
		if not isVotObject then 
			isVotObject = object.spec_vot ~= nil and object.spec_vot.openingTime ~= nil and #object.spec_vot.openingTime > 0;
			if isVotObject then votObjectNew = object.spec_vot;end;
		else
			votObject = object;
		end;
		local isOpening = true;
		local votOpeningTime = nil;
		local votString = "";
		local votSpecialeActive = false;
		local votSpecialeStop = false;
		if votObject ~= nil then
			isOpening = votObject.votIsOpening;
			votOpeningTime = votObject.votOpeningTime;
			votSpecialeStop = votObject.votOtherMod.stopProduction;
			votSpecialeActive = votObject.votOtherMod.active;
		elseif votObjectNew ~= nil then	
			isOpening = votObjectNew.isOpening;
			votOpeningTime = votObjectNew.openingTime;
			votSpecialeStop = votObjectNew.otherMod.stopProduction;
			votSpecialeActive = votObjectNew.otherMod.active;
		end;
		if votOpeningTime ~= nil then
			local votModName = moModuleSetGet:getVotModName();			
			if isOpening and not votSpecialeStop then
				if #votOpeningTime == 1 then
					votString = string.format(g_i18n:getText("vot_ClockTime", votModName), tostring(votOpeningTime[1].startTime), tostring(votOpeningTime[1].endTime));
				else
					votString = tostring(g_i18n:getText("vot_Opened", votModName));
				end;
			else
				votString = tostring(g_i18n:getText("vot_Closed", votModName));
			end;
			return true, isOpening, votOpeningTime, votString, votSpecialeActive, votSpecialeStop;
		end;
	end;
	return false;
end;
