moFillTypeAmountPriceConfig = {};

function moFillTypeAmountPriceConfig:defaultValues()
	moFillTypeAmountPriceConfig.values = {sortBy=3, maxSortBy=4, viewSettingLines=false, viewDetailsBalesS=false, viewDetailsBalesR=false, viewBales=true, viewDetailsPal=false, viewPal=true, viewAnimals=true, viewPrices=true, viewPriceTrend=true, viewAmounts=true, txtBold=false, viewAllFillTypes=false, viewFillTypeNoAmount=true};
	--sortBy 1=Name, 2=price, 3=amount, 4=nosort,	
end;

function moFillTypeAmountPriceConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moFillTypeAmountPriceConfig.values == nil then moFillTypeAmountPriceConfig:defaultValues();end;	
	local groupNameTag = (xmlNameTag.. ".module.onlyOutputs.fillTypeAmountPrice(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#viewPrices") ~= nil then
		moFillTypeAmountPriceConfig.values.viewPrices = getXMLBool(Xml, groupNameTag.. "#viewPrices");
	else
		return; --first config not found
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewAmounts") ~= nil then
		moFillTypeAmountPriceConfig.values.viewAmounts = getXMLBool(Xml, groupNameTag.. "#viewAmounts");
	end;
	if getXMLBool(Xml, groupNameTag.. "#txtBold") ~= nil then
		moFillTypeAmountPriceConfig.values.txtBold = getXMLBool(Xml, groupNameTag.. "#txtBold");
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewAllFillTypes") ~= nil then
		moFillTypeAmountPriceConfig.values.viewAllFillTypes = getXMLBool(Xml, groupNameTag.. "#viewAllFillTypes");
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewFillTypeNoAmount") ~= nil then
		moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount = getXMLBool(Xml, groupNameTag.. "#viewFillTypeNoAmount");
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewPriceTrend") ~= nil then
		moFillTypeAmountPriceConfig.values.viewPriceTrend = getXMLBool(Xml, groupNameTag.. "#viewPriceTrend");
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewAnimals") ~= nil then
		moFillTypeAmountPriceConfig.values.viewAnimals = getXMLBool(Xml, groupNameTag.. "#viewAnimals");
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewBales") ~= nil then
		moFillTypeAmountPriceConfig.values.viewBales = getXMLBool(Xml, groupNameTag.. "#viewBales");
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewPallets") ~= nil then
		moFillTypeAmountPriceConfig.values.viewPal = getXMLBool(Xml, groupNameTag.. "#viewPallets");
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewSettingLines") ~= nil then
		moFillTypeAmountPriceConfig.values.viewSettingLines = getXMLBool(Xml, groupNameTag.. "#viewSettingLines");
	end;
	if getXMLInt(Xml, groupNameTag.. "#sortBy") ~= nil then
		moFillTypeAmountPriceConfig.values.sortBy = getXMLInt(Xml, groupNameTag.. "#sortBy");
	end;	
end;

function moFillTypeAmountPriceConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moFillTypeAmountPriceConfig.values == nil then moFillTypeAmountPriceConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.onlyOutputs.fillTypeAmountPrice(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#viewSettingLines", moFillTypeAmountPriceConfig.values.viewSettingLines);
	setXMLInt(Xml, groupNameTag.. "#sortBy", moFillTypeAmountPriceConfig.values.sortBy);
	setXMLBool(Xml, groupNameTag.. "#viewPrices", moFillTypeAmountPriceConfig.values.viewPrices);
	setXMLBool(Xml, groupNameTag.. "#viewPriceTrend", moFillTypeAmountPriceConfig.values.viewPriceTrend);
	setXMLBool(Xml, groupNameTag.. "#viewAmounts", moFillTypeAmountPriceConfig.values.viewAmounts);
	setXMLBool(Xml, groupNameTag.. "#viewAnimals", moFillTypeAmountPriceConfig.values.viewAnimals);
	setXMLBool(Xml, groupNameTag.. "#viewBales", moFillTypeAmountPriceConfig.values.viewBales);
	setXMLBool(Xml, groupNameTag.. "#viewPallets", moFillTypeAmountPriceConfig.values.viewPal);
	setXMLBool(Xml, groupNameTag.. "#txtBold", moFillTypeAmountPriceConfig.values.txtBold);
	setXMLBool(Xml, groupNameTag.. "#viewAllFillTypes", moFillTypeAmountPriceConfig.values.viewAllFillTypes);
	setXMLBool(Xml, groupNameTag.. "#viewFillTypeNoAmount", moFillTypeAmountPriceConfig.values.viewFillTypeNoAmount);
	----------------------------------------------------------------------------------------------	
end;

function moFillTypeAmountPriceConfig.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moFillTypeAmountPriceConfig.values == nil then moFillTypeAmountPriceConfig:defaultValues();end;	
	if update == nil or not update then moFillTypeAmountPriceConfig:generateCmd();end;
	moModule:deleteCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moFillTypeAmountPriceConfig.loadOnStart } );
end;

function moFillTypeAmountPriceConfig:generateCmd(object)
	function generateCmd(cmdName, displayName)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = cmdName;
				groupName = "OutputByMoh";			
				displayName = tostring(displayName);
				infoTxt = "View All FillTypes and/or Amounts and/or Price";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = {};
				object = {};
				actionCallback = moFillTypeAmountPriceOutput.giveOutputTable;			
			}
		)
	end;
	
	local displayName = "FillType/Amount/Price";
	local cmdName = "output_fillTypeAmountPrice_";
	generateCmd(cmdName, displayName);
	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moFillTypeAmountPriceConfig.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moFillTypeAmountPriceConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moFillTypeAmountPriceConfig.saveXml } );