moTeleportPointsConfig = {};

function moTeleportPointsConfig:defaultValues()
	moTeleportPointsConfig.values = {groups={}, autoMouseCursorOff=true, viewSettingLines=false};	
end;

function moTeleportPointsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moTeleportPointsConfig.values == nil then moTeleportPointsConfig:defaultValues();end;	
	local groupNameTag = (xmlNameTag.. ".module.onlyOutputs.teleportPoints(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#autoMouseCursorOff") ~= nil then
		moTeleportPointsConfig.values.autoMouseCursorOff = getXMLBool(Xml, groupNameTag.. "#autoMouseCursorOff");
	else
		return; --first config not found
	end;
	local int = 0;
	while true do
		groupNameTag = (xmlNameTag.. ".module.onlyOutputs.teleportPoints.group(%d)"):format(int);
		if groupNameTag == nil or getXMLString(Xml, groupNameTag.. "#name") == nil or not getXMLString(Xml, groupNameTag.. "#name") or int > 100 then break;else
		local groupName = getXMLString(Xml, groupNameTag.. "#name");
		if moTeleportPointsConfig.values.groups[groupName] == nil then
			moTeleportPointsConfig.values.groups[groupName] = {name=groupName,point={},view=false};
			if getXMLInt(Xml, groupNameTag.. "#points") ~= nil then
				local points = getXMLInt(Xml, groupNameTag.. "#points");
				if points > 0 then
					for point=1, points do
						local pointGroupNameTag = (groupNameTag.. ".point(%d)"):format(point-1);
						if pointGroupNameTag ~= nil and getXMLString(Xml, pointGroupNameTag.. "#name") ~= nil or point > 50 then
							moTeleportPointsConfig.values.groups[groupName].point[#moTeleportPointsConfig.values.groups[groupName].point+1] = {name=getXMLString(Xml, pointGroupNameTag.. "#name")};
							moTeleportPointsConfig.values.groups[groupName].point[#moTeleportPointsConfig.values.groups[groupName].point].x = getXMLFloat(Xml, pointGroupNameTag.. "#x");
							moTeleportPointsConfig.values.groups[groupName].point[#moTeleportPointsConfig.values.groups[groupName].point].y = getXMLFloat(Xml, pointGroupNameTag.. "#y");
							moTeleportPointsConfig.values.groups[groupName].point[#moTeleportPointsConfig.values.groups[groupName].point].z = getXMLFloat(Xml, pointGroupNameTag.. "#z");
						end;
					end;
				end;
			end;
		end;
		int = int+1;
		end;
	end;
	function comp(w1,w2)		
		if w1.name < w2.name then
			return true;
		end;			
	end;	
	table.sort(moTeleportPointsConfig.values.groups, comp);
	for group, _ in pairs (moTeleportPointsConfig.values.groups) do
		if moTeleportPointsConfig.values.groups[group].point ~= nil and #moTeleportPointsConfig.values.groups[group].point > 0 then
			table.sort(moTeleportPointsConfig.values.groups[group].point, comp);
		end;
	end;
end;

function moTeleportPointsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;
	if moTeleportPointsConfig.values == nil then moTeleportPointsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.onlyOutputs.teleportPoints(%d)"):format(0);
	setXMLBool(Xml, groupNameTag.. "#autoMouseCursorOff", moTeleportPointsConfig.values.autoMouseCursorOff);	
	local int = 0;
	local intA = 0;
	for group, _ in pairs (moTeleportPointsConfig.values.groups) do
		if group ~= nil then
			groupNameTag = (xmlNameTag.. ".module.onlyOutputs.teleportPoints.group(%d)"):format(int);
			setXMLString(Xml, groupNameTag.. "#name", moTeleportPointsConfig.values.groups[group].name);
			setXMLInt(Xml, groupNameTag.. "#points", #moTeleportPointsConfig.values.groups[group].point);
			intA = 0;
			for point=1, #moTeleportPointsConfig.values.groups[group].point do
				if moTeleportPointsConfig.values.groups[group].point[point] ~= nil then
					local pointGroupNameTag = (groupNameTag.. ".point(%d)"):format(intA);
					setXMLString(Xml, pointGroupNameTag.. "#name", moTeleportPointsConfig.values.groups[group].point[point].name);
					setXMLFloat(Xml, pointGroupNameTag.. "#x", moTeleportPointsConfig.values.groups[group].point[point].x);
					setXMLFloat(Xml, pointGroupNameTag.. "#y", moTeleportPointsConfig.values.groups[group].point[point].y);
					setXMLFloat(Xml, pointGroupNameTag.. "#z", moTeleportPointsConfig.values.groups[group].point[point].z);
					intA = intA+1;
				end;
			end;
			int = int+1;
		end;
	end;
	----------------------------------------------------------------------------------------------	
end;

function moTeleportPointsConfig.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moTeleportPointsConfig.values == nil then moTeleportPointsConfig:defaultValues();end;	
	if update == nil or not update then moTeleportPointsConfig:generateCmd();end;
	moModule:deleteCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moTeleportPointsConfig.loadOnStart } );
end;

function moTeleportPointsConfig:generateCmd(object)
	function generateCmd(cmdName, displayName)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = cmdName;
				groupName = "OutputByMoh";			
				displayName = tostring(displayName);
				infoTxt = "Teleport on Saved Position";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = {};
				object = {};
				actionCallback = moTeleportPointsOutput.giveOutputTable;			
			}
		)
	end;
	
	local displayName = "TeleportPoints";
	local cmdName = "output_teleportPoints_";
	generateCmd(cmdName, displayName);
	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moTeleportPointsConfig.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moTeleportPointsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moTeleportPointsConfig.saveXml } );