moTeleportPointsOutput = {};
source(MultiOverlayV4.modDir.."scripte/module/onlyOutputs/moTeleportPointsConfig.lua");

function moTeleportPointsOutput:load(cmdTable, slotTable)
	local cmdRegName = cmdTable.regName;	
	local lineTable = {line={}};
	if moTeleportPointsConfig.values.groups ~= nil then
		for groupName, _ in pairs (moTeleportPointsConfig.values.groups) do
			if groupName ~= nil then
				lineTable.line[#lineTable.line+1] = {};
				local isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};	
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(groupName);				
				local color = "red";
				if moTeleportPointsConfig.values.groups[groupName].view then
					color = "green";
				end;
				isLineTable.txt[1].icon = {before={},after={}};
				isLineTable.txt[1].icon.before[1] = {name="buttonDown", color=color, settingButton=true, callback={[1]=moTeleportPointsOutput.clickViewGroup}, ownTable={groupName}};				
				if g_currentMission.hl.isMouseCursor and moTeleportPointsConfig.values.viewSettingLines then
					isLineTable.txt[1].icon.after[1] = {name="buttonDelete", color="yellow", settingButton=true, callback={[1]=moTeleportPointsOutput.clickDeleteGroup}, ownTable={groupName}, infoTxt="Delete this group"};
					isLineTable.txt[1].icon.after[2] = {name="buttonGenerate", color="green", settingButton=true, callback={[1]=moTeleportPointsOutput.clickGenerateTeleportPoint}, ownTable={groupName}, infoTxt="Generate new Teleport Point(this group)"};
				end;
				if moTeleportPointsConfig.values.groups[groupName].view and moTeleportPointsConfig.values.groups[groupName].point ~= nil and #moTeleportPointsConfig.values.groups[groupName].point > 0 then
					for point=1, #moTeleportPointsConfig.values.groups[groupName].point do
						lineTable.line[#lineTable.line+1] = {};
						local isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};	
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = false;
						isLineTable.txt[1].txt = tostring(moTeleportPointsConfig.values.groups[groupName].point[point].name);
						isLineTable.txt[1].callback = moTeleportPointsOutput.clickTeleportPoint;
						isLineTable.txt[1].ownTable = {groupName, point};
						isLineTable.txt[1].infoTxt = "Teleport on Saved Position(Right Mouse Click)";
						if g_currentMission.hl.isMouseCursor and moTeleportPointsConfig.values.viewSettingLines then
							isLineTable.txt[1].icon = {before={},after={}};
							isLineTable.txt[1].icon.after[1] = {name="buttonDelete", color="yellow", settingButton=true, callback={[1]=moTeleportPointsOutput.clickDeleteTeleportPoint}, ownTable={groupName, point}, infoTxt="Delete this Teleport Point"};
						end;
					end;
				end;
			end;
		end;
	end;
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = "TeleportPoints";	
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moTeleportPointsOutput.clickTitleHelpTxt}};
	end;
	if g_currentMission.hl.isMouseCursor then
		local color = "gray"
		if moTeleportPointsConfig.values.viewSettingLines then color = "green";end;
		if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;		
		isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="outputSetting", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moTeleportPointsOutput.clickViewSettingLines}, infoTxt="Settings"};
	end;
	if moTeleportPointsConfig.values.viewSettingLines then
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;		
		isLineTable.txt[1].txt = "Generate New Group Name";
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonGenerate", color="green", settingButton=true, callback={[1]=moTeleportPointsOutput.clickGenerateGroup}, infoTxt="Generate New Group"};
		---seperator---
		table.insert(lineTable.line, 3, {});
		isLineTable = lineTable.line[3];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "--";
		isLineTable.txt[2] = {};
		isLineTable.txt[2].slotColor = "txtOutputTitle";
		isLineTable.txt[2].bold = true;
		isLineTable.txt[2].txt = "--";
		isLineTable.txt[2].alignment = 3;
		---seperator---	
	end;
	---objectLineDistance---
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};		
	isLineTable.txt[1].txt = " ";
	---objectLineDistance---
	moTeleportPointsOutput[cmdRegName] = {output=lineTable};
end;

function moTeleportPointsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;	
	moTeleportPointsOutput:load(args.cmdTable, args.slotTable);	
	return moTeleportPointsOutput[args.cmdTable.regName].output;
end;

function moTeleportPointsOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "TeleportPoints";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Icons Left Mouse for Generate Group/Saved Position(Player)...\nClick Right Mouse in Group(Teleport Name) for Teleport on Saved Position";
	end;
end;

function moTeleportPointsOutput.clickViewSettingLines(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moTeleportPointsConfig.values.viewSettingLines = not moTeleportPointsConfig.values.viewSettingLines;
	end;
end;

function moTeleportPointsOutput.clickTeleportPoint(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]].point[args.ownTable[2]] ~= nil then
			local point = moTeleportPointsConfig.values.groups[args.ownTable[1]].point[args.ownTable[2]];
			g_currentMission.player:moveToAbsolute(point.x, point.y, point.z, false, false);
			--if moTeleportPointsConfig.values.autoMouseCursorOff then
				MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moTeleportPointsOutput.clickTeleportPoint"); --force mouseOff	
			--end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]].point[args.ownTable[2]] ~= nil then
			local point = moTeleportPointsConfig.values.groups[args.ownTable[1]].point[args.ownTable[2]];
			moSetGetOverlays:mapHotSpot({}, {point.x}, {point.z}, 1);
		end;	
	end;
end;

function moTeleportPointsOutput.clickDeleteTeleportPoint(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]].point[args.ownTable[2]] ~= nil then
			table.remove(moTeleportPointsConfig.values.groups[args.ownTable[1]].point, args.ownTable[2]);			
		end;
	end;
end;

function moTeleportPointsOutput.clickViewGroup(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]] ~= nil then
			moTeleportPointsConfig.values.groups[args.ownTable[1]].view = not moTeleportPointsConfig.values.groups[args.ownTable[1]].view;
		end;
	end;
end;

function moTeleportPointsOutput.clickGenerateGroup(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		guiDialog:setNewTeleportGroup();
	end;
end;

function moTeleportPointsOutput.clickGenerateTeleportPoint(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]] ~= nil then
			if g_currentMission.controlledVehicle == nil then
				guiDialog:setNewTeleportPoint(args.ownTable[1]); --later check point is free				
			else
				g_currentMission.hl.addTextDisplay( {txt="Only on Foot Features (Leave Vehicle Pls)", txtBold=true, duration=3, warning=true} );				
			end;
		end;
	end;
end;

function moTeleportPointsOutput.clickDeleteGroup(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and moTeleportPointsConfig.values.groups[args.ownTable[1]] ~= nil then
			moTeleportPointsConfig.values.groups[args.ownTable[1]] = nil;
		end;
	end;
end;

