moProductionPoints = {};
source(MultiOverlayV4.modDir.."scripte/module/productionPoints/moProductionPointsConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/productionPoints/moProductionPointsOutput.lua");

function moProductionPoints:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="productionPoints"} ) then
		if moProductionPointsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateProductionPoints"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moProductionPointsConfig.values.updateTimer, name="updateProductionPoints", repeatable=1, ms=moProductionPointsConfig.values.msec, action=moProductionPoints.load} ); 
		else
			moProductionPoints:load();
		end;
	end;
end;

function moProductionPoints.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moProductionPointsConfig.values == nil then moProductionPointsConfig:defaultValues();end;
	if update then moProductionPointsConfig:deleteCmd();end;
	moProductionPoints:loadAllProductionPoints(true);	
end;

function moProductionPoints.load() --updateTimer Callback	
	moProductionPoints:loadAllProductionPoints();	
end;

function moProductionPoints:loadAllProductionPoints(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	if moModule.productionPoints ~= nil and #moModule.productionPoints > 0 then
		local deleteObject = {};
		for index=1, #moModule.productionPoints do			
			if moModule.productionPoints[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.productionPoints[index].object);
				if isObject then
					local productionPoint = moModule.productionPoints[index].object;
					local isViewOutput = (generateCmd ~= nil and generateCmd) or productionPoint.ownerFarmId == playerFarmId or productionPoint.ownerFarmId == 0;
					local productions = productionPoint.spec_productionPoint;
					if productions ~= nil then productions = productions.productionPoint;end;
					if productions == nil and productionPoint.spec_extendedProductionPoint ~= nil then productions = productionPoint.spec_extendedProductionPoint.productionPoint;end;
					if isViewOutput and productions ~= nil then						
						local status = Utils.getNoNil(productions.status, 0);
						if productionPoint.mohTable == nil then
							productionPoint.mohTable = {general={},production={},output={},input={}};						
						else
							productionPoint.mohTable.general={};productionPoint.mohTable.production={};productionPoint.mohTable.output={};productionPoint.mohTable.input={};
						end;
						if productionPoint.mohTable.viewOutput == nil then productionPoint.mohTable.viewOutput = {};end;	
						if productionPoint.mohTable.viewInput == nil then productionPoint.mohTable.viewInput = {};end;
						if productionPoint.mohTable.viewMoreInfo == nil then productionPoint.mohTable.viewMoreInfo = false;end;
						if productionPoint.mohTable.viewProductionInfoAll == nil then productionPoint.mohTable.viewProductionInfoAll = false;end;						
						if productionPoint.mohTable.viewProductionInfo == nil then productionPoint.mohTable.viewProductionInfo = {};end;
						if productionPoint.mohTable.viewProductionInfoSmall == nil then productionPoint.mohTable.viewProductionInfoSmall = true;end;
						---general output---
						productionPoint.mohTable.general[#productionPoint.mohTable.general+1] = {};
						local isLineTableGeneral = productionPoint.mohTable.general[#productionPoint.mohTable.general];
						if productionPoint.mohDisplayName ~= nil then 
							isLineTableGeneral.objectName = productionPoint.mohTable.mohDisplayName;
						else
							isLineTableGeneral.objectName = productionPoint.mohTable.name;
						end;
						isLineTableGeneral.age = productionPoint.age;
						isLineTableGeneral.productivityGlobal = 0;
						isLineTableGeneral.productivityGlobalWarning = false;
						isLineTableGeneral.productivityGlobalColor = 1;
						isLineTableGeneral.productivityStatus = 0;
						isLineTableGeneral.productionAllActive = false;
						isLineTableGeneral.costsPerActiveMonth = 0;
						isLineTableGeneral.ownedFarmId = productionPoint.ownerFarmId;
						isLineTableGeneral.price = Utils.getNoNil(productions.owningPlaceable:getPrice(), 0);
						---general output---
						---production general---						
						local productivityGlobal = 0;
						local activeProductivityFound = 0;
						local notActiveProductivityFound = 0;
						local totalFillLevel = 0;
						local totalCapacity = 0;
						local productivityName = g_i18n:getText("statistic_productivity");
						function setProductivityGlobal()
							if productivityGlobal > 0 then
								local tempProductivityGlobal = productivityGlobal/(activeProductivityFound+notActiveProductivityFound);								
								isLineTableGeneral.productivityGlobal = tempProductivityGlobal;
								isLineTableGeneral.productivityGlobalColor = g_currentMission.hl.getProzentColor(tempProductivityGlobal, true);
							end;
							if notActiveProductivityFound > 0 or (isLineTableGeneral.productivityGlobal < 1 and activeProductivityFound > 0) then isLineTableGeneral.productivityGlobalWarning = true;end;
						end;
						function setProductionGeneral(active, status, rezeptName, costsPerActiveMonth, productionIndex)
							local isLineTableProductionGeneral = productionPoint.mohTable.production[#productionPoint.mohTable.production];
							if productionPoint.mohTable.viewOutput[#productionPoint.mohTable.production] == nil then productionPoint.mohTable.viewOutput[#productionPoint.mohTable.production] = false;end;
							if productionPoint.mohTable.viewInput[#productionPoint.mohTable.production] == nil then productionPoint.mohTable.viewInput[#productionPoint.mohTable.production] = false;end;
							if productionPoint.mohTable.viewProductionInfo[#productionPoint.mohTable.production] == nil then productionPoint.mohTable.viewProductionInfo[#productionPoint.mohTable.production] = false;end;
							isLineTableProductionGeneral.productionIndex = productionIndex or 1;
							isLineTableProductionGeneral.productivity = 0;
							isLineTableProductionGeneral.productivityStatusTxt = nil;
							isLineTableProductionGeneral.productivityStatus = false;
							isLineTableProductionGeneral.productivityName = productivityName;
							isLineTableProductionGeneral.productivityColor = 1;							
							if rezeptName == nil then
								rezeptName = Utils.getNoNil(isLineTableProductionGeneral.rezeptOtherName, "Unknown");
							end;							
							isLineTableProductionGeneral.rezeptName = tostring(rezeptName);
							if costsPerActiveMonth ~= nil and costsPerActiveMonth > 0 and active then
								isLineTableGeneral.costsPerActiveMonth = isLineTableGeneral.costsPerActiveMonth+costsPerActiveMonth;
							end;
							if totalCapacity > 0 then
								isLineTableProductionGeneral.productivity = g_i18n:formatNumber(Utils.getNoNil(totalFillLevel/totalCapacity, 0)*100);
								isLineTableProductionGeneral.productivityColor = g_currentMission.hl.getProzentColor(Utils.getNoNil(totalFillLevel/totalCapacity, 0)*100, true);
								if isLineTableProductionGeneral.productivityColor == 1 then isLineTableProductionGeneral.productivityColor = 2;end;
							end;
							isLineTableProductionGeneral.active = active or false;
							if isLineTableProductionGeneral.active and status ~= nil and type(status) == "number" then
								if status ~= 1 then 
									isLineTableProductionGeneral.productivityColor = 7;
									isLineTableProductionGeneral.productivityStatus = true;									
								end;								
								if status == 0 then 
									isLineTableProductionGeneral.productivityStatusTxt = g_i18n:getText("ui_production_status_inactive");
									--notActiveProductivityFound = notActiveProductivityFound+1; --productivity Global
									--productivityGlobal = productivityGlobal+isLineTableProductionGeneral.productivity; --productivity Global
								elseif status == 2 then
									isLineTableProductionGeneral.productivityStatusTxt = g_i18n:getText("ui_production_status_materialsMissing");
									notActiveProductivityFound = notActiveProductivityFound+1; --productivity Global
									productivityGlobal = productivityGlobal+isLineTableProductionGeneral.productivity; --productivity Global
								elseif status == 3 then
									isLineTableProductionGeneral.productivityStatusTxt = g_i18n:getText("ui_production_status_outOfSpace").. " ".. g_i18n:getText("ai_validationErrorUnloadingStationIsFull");
									notActiveProductivityFound = notActiveProductivityFound+1; --productivity Global
									productivityGlobal = productivityGlobal+isLineTableProductionGeneral.productivity; --productivity Global
								elseif status == 1 then
									isLineTableGeneral.productivityStatusTxt = g_i18n:getText("ui_production_status_running");
									productivityGlobal = productivityGlobal+isLineTableProductionGeneral.productivity; --productivity Global
									activeProductivityFound = activeProductivityFound+1; --productivity Global--
								end;
							elseif not isLineTableProductionGeneral.active then
								isLineTableProductionGeneral.productivityColor = 7;
								isLineTableProductionGeneral.productivityStatus = true;
								isLineTableProductionGeneral.productivityStatusTxt = g_i18n:getText("ui_production_status_inactive");
							end;
							if isLineTableProductionGeneral.active then isLineTableGeneral.productivityStatus = 1;end;							
						end;						
						---production general---
						local isFillLevelInformation = false;
						---output---											
						function setOutput(fillTypeIndex, fillLevel, capacity, freeCapacity, amount, directSell, directDeliver, isPal)
							isFillLevelInformation = true;							
							productionPoint.mohTable.production[#productionPoint.mohTable.production].output[#productionPoint.mohTable.production[#productionPoint.mohTable.production].output+1] = {};							
							local isLineTableOutput = productionPoint.mohTable.production[#productionPoint.mohTable.production].output[#productionPoint.mohTable.production[#productionPoint.mohTable.production].output];
							local fillType = moFillTypes.values.fillTypes[fillTypeIndex];
							if fillType ~= nil then
								isLineTableOutput.fillTypeName = fillType.name;
							else
								isLineTableOutput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
							end;
							isLineTableOutput.isPal = isPal;
							isLineTableOutput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));
							isLineTableOutput.freeCapacity = g_i18n:formatNumber(Utils.getNoNil(freeCapacity, 0));
							isLineTableOutput.directSell = directSell;
							isLineTableOutput.directDeliver = directDeliver;
							isLineTableOutput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));							
							productionPoint.mohTable.production[#productionPoint.mohTable.production].rezeptOtherName = isLineTableOutput.fillTypeName;
							--totalFillLevel = totalFillLevel+Utils.getNoNil(fillLevel, 0);							
						end;
						---output---
						---input---											
						function setInput(fillTypeIndex, fillLevel, capacity, amount)
							isFillLevelInformation = true;
							productionPoint.mohTable.production[#productionPoint.mohTable.production].input[#productionPoint.mohTable.production[#productionPoint.mohTable.production].input+1] = {};	
							local isLineTableInput = productionPoint.mohTable.production[#productionPoint.mohTable.production].input[#productionPoint.mohTable.production[#productionPoint.mohTable.production].input];
							local fillType = moFillTypes.values.fillTypes[fillTypeIndex];
							if fillType ~= nil then
								isLineTableInput.fillTypeName = fillType.name;
							else
								isLineTableInput.fillTypeName = moLanguageXml:getTxt("unknown", nil, "Unknown");
							end;
							isLineTableInput.fillLevel = g_i18n:formatNumber(Utils.getNoNil(fillLevel, 0));							
							isLineTableInput.capacity = g_i18n:formatNumber(Utils.getNoNil(capacity, 0));	
							totalFillLevel = totalFillLevel+Utils.getNoNil(fillLevel, 0);
							totalCapacity = totalCapacity+Utils.getNoNil(capacity, 0);
						end;																	
						---input---
						local fillLevelInformation, allActive, revampModeFound = moModuleSetGet:getFillLevelInformation(productions);
						isLineTableGeneral.productionAllActive = allActive;
						if fillLevelInformation ~= nil then
							if fillLevelInformation.revampMode ~= nil and revampModeFound then --Revamp Mod Support
								isLineTableGeneral.revampMode = fillLevelInformation.revampMode;
								if fillLevelInformation.revampMode.total == 1 then
									local revampModeOnlyString = "";
									if fillLevelInformation.revampMode.hourly then 
										revampModeOnlyString = fillLevelInformation.revampMode.hourlyString;
									elseif fillLevelInformation.revampMode.monthly then
										revampModeOnlyString = fillLevelInformation.revampMode.monthlyString;
									elseif fillLevelInformation.revampMode.sun then
										revampModeOnlyString = fillLevelInformation.revampMode.sunString;
									elseif fillLevelInformation.revampMode.rain then
										revampModeOnlyString = fillLevelInformation.revampMode.rainString;	
									elseif fillLevelInformation.revampMode.wind then
										revampModeOnlyString = fillLevelInformation.revampMode.windString;
									elseif fillLevelInformation.revampMode.temp then
										revampModeOnlyString = fillLevelInformation.revampMode.tempString;
									elseif fillLevelInformation.revampMode.tempNegative then
										revampModeOnlyString = fillLevelInformation.revampMode.tempNegativeString;	
									elseif fillLevelInformation.revampMode.seasonal then
										revampModeOnlyString = fillLevelInformation.revampMode.seasonalString;
									end;
									if revampModeOnlyString:len() > 0 then isLineTableGeneral.revampModeString = revampModeOnlyString;end;
								end;								
							end;
							local foundVot, isOpening, votOpeningTime, votOpeningTimeString, votSpecialeActive, votSpecialeStop = moModuleSetGet:getVotMod(productions); --VariableOpeningTime Mod Support
							if foundVot then
								isLineTableGeneral.vot = {};
								isLineTableGeneral.vot.openingTime = votOpeningTime;
								isLineTableGeneral.vot.isOpening = isOpening;
								isLineTableGeneral.vot.openingTimeString = votOpeningTimeString;
								isLineTableGeneral.vot.specialeActive = votSpecialeActive;
								isLineTableGeneral.vot.specialeStop = votSpecialeStop;								
							end;
							if fillLevelInformation.production ~= nil then
								for p=1, #fillLevelInformation.production do
									if fillLevelInformation.production[p] ~= nil then
										totalFillLevel = 0;
										totalCapacity = 0;
										productionPoint.mohTable.production[#productionPoint.mohTable.production+1] = {output={}, input={}};										
										if fillLevelInformation.production[p].output ~= nil then										
											for fillType, values in pairs (fillLevelInformation.production[p].output) do
												setOutput(fillType, values.fillLevel, values.capacity, values.freeCapacity, values.amount, values.directSell, values.directDeliver, values.isPal);	
											end;
										end;
										if fillLevelInformation.production[p].active and fillLevelInformation.production[p].input ~= nil then										
											for fillType, values in pairs (fillLevelInformation.production[p].input) do
												setInput(fillType, values.fillLevel, values.capacity, values.amount);	
											end;
										end;
										setProductionGeneral(fillLevelInformation.production[p].active, fillLevelInformation.production[p].status, fillLevelInformation.production[p].rezeptName, fillLevelInformation.production[p].costsPerActiveMonth, fillLevelInformation.production[p].productionIndex);
									end;
								end;
								setProductivityGlobal(); --userWunsch
							end;							
						end;												
						if generateCmd ~= nil and generateCmd then moProductionPointsConfig:generateCmd(productionPoint);end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.productionPoints, index);
			end;
			moProductionPointsConfig:deleteCmd(true);			
		end;
	end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moProductionPoints.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moProductionPoints.update } );