moProductionPointsOutput = {};

function moProductionPointsOutput:load(cmdTable, slotTable)
	local playerFarmId = g_currentMission.player.farmId;
	local cmdRegName = cmdTable.regName;
	local cmdObject = cmdTable.object;	
	local lineTable = {line={}};	
	for o=1, #cmdObject do
		if cmdObject[o] ~= nil and moModuleObjects:isObject(cmdObject[o]) and cmdObject[o].mohTable ~= nil and cmdObject[o].mohTable.general ~= nil and cmdObject[o].mohTable.general[1] ~= nil then
			---check edit object name---
			local displayName = cmdObject[o]:getName();
			if displayName ~= nil and tostring(displayName) ~= tostring(cmdObject[o].mohTable.name) then 
				moProductionPointsConfig:refreshCmdDisplayName(cmdRegName, displayName);
				cmdObject[o].mohTable.name = tostring(displayName);				
			end;
			---check edit object name---			
			-------------------------------general-------------------------------
			---objectName---
			local stopInOutput = false;
			local viewMoreInfo = cmdObject[o].mohTable.viewMoreInfo;
			local viewProductionInfoAll = cmdObject[o].mohTable.viewProductionInfoAll;
			local viewProductionInfoSmall = cmdObject[o].mohTable.viewProductionInfoSmall;
			local productionPointGeneral = cmdObject[o].mohTable.general[1];
			local productionAllActive = productionPointGeneral.productionAllActive;
			local isOwned = playerFarmId == productionPointGeneral.ownedFarmId and playerFarmId ~= 0; 
			local canBuy = productionPointGeneral.ownedFarmId == 0;
			local iconColor = "gray";
			local buttonName = "buttonDown";
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].bold = true;
			if viewProductionInfoSmall and productionPointGeneral.productivityGlobal ~= nil and isOwned then
				isLineTable.txt[1].txt = tostring(productionPointGeneral.objectName).. " (".. tostring(productionPointGeneral.productivityGlobal).. "%)";
			else
				isLineTable.txt[1].txt = tostring(productionPointGeneral.objectName);
			end;
			isLineTable.txt[1].callback = moProductionPointsOutput.clickProductionPoint;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			if g_currentMission.hl.isMouseCursor then
				if slotTable ~= nil and slotTable.help.outputOn then
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moProductionPointsOutput.clickProductionPointHelpTxt}};
				end;
				iconColor = "green";
				buttonName = "buttonUp";
				if viewProductionInfoSmall then iconColor = "gray";buttonName = "buttonDown";end;				
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moProductionPointsOutput.clickViewProductionInfoSmall}, ownTable={cmdObject[o].rootNode}, infoTxt="Production Info Small"};
			end;
			if viewProductionInfoSmall and productionPointGeneral.vot ~= nil then
				iconColor = "green";
				if not productionPointGeneral.vot.isOpening then iconColor = "yellow";end;
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.after[#isLineTable.txt[1].icon.after+1] = {name="buttonClock", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moProductionPointsOutput.clickProductionVotOpeningTime}, ownTable={productionPointGeneral.vot.openingTime, p}, infoTxt="VariableOpeningTime Production WorkingHours"};
			end;
			if viewProductionInfoSmall and productionPointGeneral.productivityGlobalWarning and slotTable ~= nil and slotTable.isWarning and isOwned and not canBuy then
				if not g_currentMission.hl.runsTimer("1sec", true) or not slotTable.isWarningBlinking then
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="viewWarning", color="yellow", modName="MultiOverlayV4", groupName="slotoutput", infoTxt="One Production have Problem"};
				end;
			elseif not isOwned and canBuy then
				iconColor = "red";
				local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
				local tempCanBuy = playerFarm.money >= productionPointGeneral.price;
				if tempCanBuy then iconColor = "green";end;
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="pricesOnOff", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moProductionPointsOutput.clickBuyProduction}, ownTable={cmdObject[o].rootNode}, infoTxt="Buy Production"};
			end;
			
			local objectId = cmdObject[o].nodeId or cmdObject[o].rootNode;		
			local oX,oY,oZ = getWorldTranslation(objectId);
			if oX ~= nil and oY ~= nil and oZ ~= nil then
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
					if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
				end;
			end;		
			isLineTable.txt[1].alignment = 2;			
			if not viewProductionInfoSmall then
				if g_currentMission.hl.isMouseCursor and isOwned then
					iconColor = "gray";
					if viewMoreInfo then iconColor = "green";end;
					if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
					isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="moreInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moProductionPointsOutput.clickViewMoreInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="More Info"};
					if not productionAllActive then
						iconColor = "gray"
						if viewProductionInfoAll then iconColor = "green";end;
						isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="productionInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moProductionPointsOutput.clickViewProductionInfoAll}, ownTable={cmdObject[o].rootNode, p}, infoTxt="Production Info"};
					else
						cmdObject[o].mohTable.viewProductionInfoAll = false;
					end;
				end;
			end;
			---objectName---
			if not viewProductionInfoSmall then
				if isOwned and not moreInfo and productionPointGeneral.productivityStatus == 0 then
					---status---				
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_status"));
					isLineTable.txt[1].slotColor = "txt";				
					isLineTable.txt[1].callback = moProductionPointsOutput.clickProductionOrProductivity;
					isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 1};
					isLineTable.txt[1].width = 30;
					isLineTable.txt[2] = {};
					isLineTable.txt[2].bold = true;
					isLineTable.txt[2].txt = tostring(g_i18n:getText("infohud_noActiveProduction"));
					isLineTable.txt[2].prozentColor = 4;
					isLineTable.txt[2].callback = moProductionPointsOutput.clickProductionOrProductivity;
					isLineTable.txt[2].ownTable = {cmdObject[o].rootNode, 1};				
					isLineTable.txt[2].width = 70;
					isLineTable.txt[2].alignment = 3;
					stopInOutput = true;				
					---status---			
				end;
				if isOwned and viewMoreInfo then				
					---age---
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("modHub_object")).. " ".. tostring(g_i18n:getText("ui_age"));	
					isLineTable.txt[1].width = 70;
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txt";
					isLineTable.txt[2].bold = true;			
					if productionPointGeneral.age > 1 or productionPointGeneral.age == 0 then 
						isLineTable.txt[2].txt = tostring(productionPointGeneral.age).. " ".. tostring(g_i18n:getText("ui_days"));
					else
						isLineTable.txt[2].txt = tostring(productionPointGeneral.age).. " ".. tostring(g_i18n:getText("ui_day"));
					end;		
					isLineTable.txt[2].width = 30;
					isLineTable.txt[2].alignment = 3;
					---age---
					---costsPerActiveMonth---
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("finance_productionCosts").. "/".. g_i18n:getText("ui_month"));	
					isLineTable.txt[1].width = 70;
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txt";
					isLineTable.txt[2].bold = true;				
					isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(productionPointGeneral.costsPerActiveMonth, 0, true, false));						
					isLineTable.txt[2].width = 30;
					isLineTable.txt[2].alignment = 3;				
					---costsPerActiveMonth---
					---revamp support---
					if productionPointGeneral.revampMode ~= nil then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("Revamp_productionMode")).. "/Revamp";	
						isLineTable.txt[1].width = 70;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;
						if productionPointGeneral.revampModeString ~= nil then
							isLineTable.txt[2].txt = tostring(productionPointGeneral.revampModeString);
							isLineTable.txt[1].width = 60;
							isLineTable.txt[2].width = 40;
						else
							isLineTable.txt[2].txt = tostring(g_i18n:getText("ui_on"));
							isLineTable.txt[2].width = 30;
							if g_currentMission.hl.isMouseCursor and isOwned then
								isLineTable.txt[1].icon = {before={},after={}};
								isLineTable.txt[1].icon.after[1] = {name="moreInfo", color="ls22", modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moProductionPointsOutput.clickProductionModeRevamp}, ownTable={productionPointGeneral.revampMode, p}, infoTxt="Revamp Production Mode"};
							end;
						end;					
						isLineTable.txt[2].alignment = 3;
					end;
					---revamp support---
					---vot support---
					if productionPointGeneral.vot ~= nil then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = true;							
						isLineTable.txt[1].width = 70;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = true;
						if productionPointGeneral.vot.isOpening then
							isLineTable.txt[2].slotColor = "settingOn";
						else
							isLineTable.txt[2].slotColor = "settingOff";
						end;
						isLineTable.txt[2].txt = tostring(productionPointGeneral.vot.openingTimeString);
						if #productionPointGeneral.vot.openingTime == 1 then
							isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_operatingHours")).. "/VOT";
							isLineTable.txt[1].width = 60;
							isLineTable.txt[2].width = 40;
						else
							isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_operatingHours")).. "/VOT (".. tostring(#productionPointGeneral.vot.openingTime).. ")";							
							isLineTable.txt[2].width = 30;						
							if g_currentMission.hl.isMouseCursor and isOwned then
								local color = "green";
								if not productionPointGeneral.vot.isOpening then
									color = "yellow";
								end;
								isLineTable.txt[1].icon = {before={},after={}};
								isLineTable.txt[1].icon.after[1] = {name="buttonClock", color=color, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moProductionPointsOutput.clickProductionVotOpeningTime}, ownTable={productionPointGeneral.vot.openingTime, p}, infoTxt="VariableOpeningTime Production WorkingHours"};
							end;
						end;					
						isLineTable.txt[2].alignment = 3;						
					end;
					---vot support---
					---seperator---
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txtOutputTitle";
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = "----";
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txtOutputTitle";
					isLineTable.txt[2].bold = true;
					isLineTable.txt[2].txt = "----";
					isLineTable.txt[2].alignment = 3;				
					---seperator---
				else
					if not isOwned and canBuy then
						local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
						canBuy = playerFarm.money >= productionPointGeneral.price;
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						isLineTable.txt[1].txt = tostring(g_i18n:getText("action_buyProductionPoint"));
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].width = 70;
						isLineTable.txt[1].callback = moProductionPointsOutput.clickBuyProduction;
						isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};					
						isLineTable.txt[2] = {};
						isLineTable.txt[2].bold = true;
						isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(productionPointGeneral.price, 0, true, false));
						if canBuy then
							isLineTable.txt[2].slotColor = "settingOn";
						else
							isLineTable.txt[2].slotColor = "settingOff";
						end;
						isLineTable.txt[2].callback = moProductionPointsOutput.clickBuyProduction;
						isLineTable.txt[2].ownTable = {cmdObject[o].rootNode};
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;
						stopInOutput = true;				
					elseif not isOwned and not canBuy then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].bold = true;
						--isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_messageBoughtPlaceable")).. " (".. tostring(g_i18n:getText("statistic_numOwned")).. ")";
						isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_construction_landIsNotOwned")).. " (".. tostring(g_i18n:getText("construction_category_production")).. ")";
						isLineTable.txt[1].slotColor = "settingReady";
						--warning_placeable_error_cannotBeBought,shop_messageSoldObject,ui_construction_landIsNotOwned,construction_category_production					
					end;
				end;			
				-------------------------------general-------------------------------
				
				-----------------------------production------------------------------			
				if isOwned then
					local setSeparator = false;
					for p=1, #cmdObject[o].mohTable.production do
						local productionGeneral = cmdObject[o].mohTable.production[p];
						local productionOutput = cmdObject[o].mohTable.production[p].output;
						local productionInput = cmdObject[o].mohTable.production[p].input;
						local viewOutput = cmdObject[o].mohTable.viewOutput[p];
						local viewInput = cmdObject[o].mohTable.viewInput[p];
						local viewProductionInfo = cmdObject[o].mohTable.viewProductionInfo[p];
						if productionGeneral.active or viewProductionInfoAll then						
							if setSeparator then							
								---seperator---
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[1] = {};
								isLineTable.txt[1].slotColor = "txtOutputTitle";
								isLineTable.txt[1].bold = true;
								isLineTable.txt[1].txt = "----";
								isLineTable.txt[2] = {};
								isLineTable.txt[2].slotColor = "txtOutputTitle";
								isLineTable.txt[2].bold = true;
								isLineTable.txt[2].txt = "----";
								isLineTable.txt[2].alignment = 3;							
								---seperator---						
							end;						
							
							---productivity general---						
							lineTable.line[#lineTable.line+1] = {};
							isLineTable = lineTable.line[#lineTable.line];
							isLineTable.txt = {};
							isLineTable.txt[1] = {};
							isLineTable.txt[1].txt = g_i18n:getText("ui_productions_production"); --g_i18n:getText("ui_productions_recipe");
							isLineTable.txt[1].bold = true;
							isLineTable.txt[1].slotColor = "txt";
							isLineTable.txt[1].width = 30;
							isLineTable.txt[1].callback = moProductionPointsOutput.clickProductionOrProductivity;
							isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, productionGeneral.productionIndex};
							isLineTable.txt[2] = {};
							isLineTable.txt[2].bold = true;
							isLineTable.txt[2].slotColor = "txt";
							isLineTable.txt[2].txt = tostring(productionGeneral.rezeptName);				
							isLineTable.txt[2].width = 70;
							isLineTable.txt[2].alignment = 3;						
								
							if productionGeneral.active then	
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[1] = {};
								isLineTable.txt[1].width = 80;
								local color = productionGeneral.productivityColor;
								if color > 1 then
									isLineTable.txt[1].prozentColor = color;
								else
									isLineTable.txt[1].slotColor = "txt";
								end;
								isLineTable.txt[1].bold = true;
								isLineTable.txt[1].txt = tostring(productionGeneral.productivityName);
								isLineTable.txt[1].callback = moProductionPointsOutput.clickViewProductionInfo;
								isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, p};						
								if g_currentMission.hl.isMouseCursor then
									iconColor = "gray";
									buttonName = "buttonDown";
									if viewProductionInfo then iconColor = "green";buttonName = "buttonUp";end;				
									isLineTable.txt[1].icon = {before={},after={},behindTxt={}};
									isLineTable.txt[1].icon.behindTxt[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moProductionPointsOutput.clickViewProductionInfo}, ownTable={cmdObject[o].rootNode, p}, infoTxt="Production Info"};
								end;
								
								isLineTable.txt[2] = {};			
								isLineTable.txt[2].width = 20;	
								if color > 1 then
									isLineTable.txt[2].prozentColor = color;
								else
									isLineTable.txt[2].slotColor = "txt";
								end;
								isLineTable.txt[2].bold = true;
								if productionGeneral.productivityStatus ~= nil and not productionGeneral.productivityStatus then
									isLineTable.txt[2].txt = productionGeneral.productivity.. "%";				
								else
									isLineTable.txt[2].txt = "0%";	
								end;
								isLineTable.txt[2].alignment = 3;						
							end;
							if productionGeneral.productivityStatus ~= nil and productionGeneral.productivityStatus then
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];
								isLineTable.txt = {};
								isLineTable.txt[1] = {};
								isLineTable.txt[1].bold = true;
								isLineTable.txt[1].txt = tostring(productionGeneral.productivityStatusTxt);
								isLineTable.txt[1].prozentColor = 4;
							end;
							---productivity general---
							if not stopInOutput and productionGeneral.active and viewProductionInfo then
								---output---
								if #productionOutput > 2 then
									lineTable.line[#lineTable.line+1] = {};
									isLineTable = lineTable.line[#lineTable.line];			
									isLineTable.txt = {};			
									isLineTable.txt[1] = {};			
									isLineTable.txt[1].slotColor = "txt";
									isLineTable.txt[1].bold = true;			
									if not moModule.values.inputOutputInLanguage then
										isLineTable.txt[1].txt = "Out ++ ".. "(".. tostring(#productionOutput).. ")";			
									else
										isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_outgoingProducts")).. " (".. tostring(#productionOutput).. ")";
									end;
									isLineTable.txt[1].callback = moProductionPointsOutput.clickViewInputOutputOnOff;
									isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 1, p};
									iconColor = "red";
									buttonName = "buttonDown";
									if viewOutput then iconColor = "green";buttonName = "buttonUp";end;
									isLineTable.txt[1].icon = {before={},after={}};
									isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moProductionPointsOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode, 1, p}};
								else
									viewOutput = true;
								end;
								if viewOutput then
									for output=1, #productionOutput do
										if productionOutput[output] ~= nil then
											lineTable.line[#lineTable.line+1] = {};
											isLineTable = lineTable.line[#lineTable.line];
											isLineTable.txt = {};
											isLineTable.txt[1] = {};
											isLineTable.txt[1].slotColor = "txt";
											isLineTable.txt[1].bold = false;
											isLineTable.txt[1].txt = tostring(productionOutput[output].fillTypeName);
											isLineTable.txt[1].width = 60;
											isLineTable.txt[2] = {};
											isLineTable.txt[2].slotColor = "txt";
											isLineTable.txt[2].bold = false;
											if productionOutput[output].directSell ~= nil and productionOutput[output].directSell then
												isLineTable.txt[2].txt = tostring(g_i18n:getText("ui_production_output_selling"));
											elseif productionOutput[output].directDeliver ~= nil and productionOutput[output].directDeliver then
												isLineTable.txt[2].txt = tostring(g_i18n:getText("ui_production_output_distributing"));
											else
												isLineTable.txt[2].txt = tostring(productionOutput[output].fillLevel);								
											end;
											isLineTable.txt[2].callback = moProductionPointsOutput.clickFillLevelCapacity;
											isLineTable.txt[2].ownTable = {cmdObject[o].rootNode, tostring(productionPointGeneral.objectName), tostring(productionOutput[output].fillTypeName), tostring(productionOutput[output].capacity)};
											isLineTable.txt[2].width = 40;
											isLineTable.txt[2].alignment = 3;
										end;
									end;
								end;
								---output---
								---input---
								lineTable.line[#lineTable.line+1] = {};
								isLineTable = lineTable.line[#lineTable.line];			
								isLineTable.txt = {};			
								isLineTable.txt[1] = {};			
								isLineTable.txt[1].slotColor = "txt";
								isLineTable.txt[1].bold = true;										
								if not moModule.values.inputOutputInLanguage then
									isLineTable.txt[1].txt = "In ++ ".. "(".. tostring(#productionInput).. ")";				
								else
									isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_productions_incomingMaterials")).. " (".. tostring(#productionInput).. ")";
								end;
								isLineTable.txt[1].callback = moProductionPointsOutput.clickViewInputOutputOnOff;
								isLineTable.txt[1].ownTable = {cmdObject[o].rootNode, 2, p};
								iconColor = "red";
								buttonName = "buttonDown";
								if viewInput then iconColor = "green";buttonName = "buttonUp";end;
								isLineTable.txt[1].icon = {before={},after={}};
								isLineTable.txt[1].icon.before[1] = {name=buttonName, color=iconColor, settingButton=true, callback={[1]=moProductionPointsOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode, 2, p}};
								if viewInput then
									for input=1, #productionInput do
										if productionInput[input] ~= nil then
											lineTable.line[#lineTable.line+1] = {};
											isLineTable = lineTable.line[#lineTable.line];
											isLineTable.txt = {};
											isLineTable.txt[1] = {};
											isLineTable.txt[1].slotColor = "txt";
											isLineTable.txt[1].bold = false;
											isLineTable.txt[1].txt = tostring(productionInput[input].fillTypeName);
											isLineTable.txt[1].width = 70;
											isLineTable.txt[2] = {};
											isLineTable.txt[2].slotColor = "txt";
											isLineTable.txt[2].bold = false;
											isLineTable.txt[2].txt = tostring(productionInput[input].fillLevel); --tostring(productionInput[input].percentageCapacity).. "%";
											isLineTable.txt[2].callback = moProductionPointsOutput.clickFillLevelCapacity;
											isLineTable.txt[2].ownTable = {cmdObject[o].rootNode, tostring(productionPointGeneral.objectName), tostring(productionInput[input].fillTypeName), tostring(productionInput[input].capacity)};
											isLineTable.txt[2].width = 30;
											isLineTable.txt[2].alignment = 3;						
										end;
									end;
								end;							
								---input---
							end;
							setSeparator = true;
						end;
					end;
				end;
				-----------------------------production------------------------------
			end;
			---objectLineDistance---
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};		
			isLineTable.txt[1].txt = " ";
			---objectLineDistance---
		end;
	end;
	moProductionPoints[cmdRegName] = {output=lineTable};
end;

function moProductionPointsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.object == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="productionPoints" } );
	moProductionPointsOutput:load(args.cmdTable, args.slotTable);
	return moProductionPoints[args.cmdTable.regName].output;
end;

function moProductionPointsOutput.clickProductionPointHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Production Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Mouse Left Optional Titel Productions Name/Production Name for buy or more Info or MapHotSpot or ...\nClick Mouse Right Optional Titel Productions Name for Teleport(onFoot)";
	end;
end;

function moProductionPointsOutput.clickProductionModeRevamp(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = args.ownTable[1];
			if object ~= nil and type(object) == "table" then
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.titel = "REVAMP ".. tostring(g_i18n:getText("Revamp_productionMode"));
				local txt = "";
				if object.wind and object.windString:len() > 0 then txt = txt.. tostring(object.windString).. "\n";end;
				if object.rain and object.rainString:len() > 0 then txt = txt.. tostring(object.rainString).. "\n";end;
				if object.sun and object.sunString:len() > 0 then txt = txt.. tostring(object.sunString).. "\n";end;
				if object.temp and object.tempString:len() > 0 then txt = txt.. tostring(object.tempString).. "\n";end;
				if object.tempNegative and object.tempNegativeString:len() > 0 then txt = txt.. tostring(object.tempNegativeString).. "\n";end;
				if object.seasonal and object.seasonalString:len() > 0 then txt = txt.. tostring(object.seasonalString).. "\n";end;
				if object.monthly and object.monthlyString:len() > 0 then txt = txt.. tostring(object.monthlyString).. "\n";end;
				if object.hourly and object.hourlyString:len() > 0 then txt = txt.. tostring(object.hourlyString).. "\n";end;
				moSetGetOverlays.infoHelpBox.info.txt = txt;
			end;
		end;		
	end;
end;

function moProductionPointsOutput.clickProductionVotOpeningTime(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local votOpeningTime = args.ownTable[1];
			if votOpeningTime ~= nil and type(votOpeningTime) == "table" then
				local votModName = moModuleSetGet:getVotModName();
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.titel = "Variable-Opening-Time ".. tostring(g_i18n:getText("ui_operatingHours"));
				local txt = tostring(g_i18n:getText("vot_WorkingHours", votModName)).. "\n";
				for a=1, #votOpeningTime do
					txt = txt.. string.format(g_i18n:getText("vot_ClockTime", votModName), tostring(votOpeningTime[a].startTime), tostring(votOpeningTime[a].endTime)).. "\n";
				end;				
				moSetGetOverlays.infoHelpBox.info.txt = txt;
			end;
		end;		
	end;
end;

function moProductionPointsOutput.clickFillLevelCapacity(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then
				local capacityLanguage = g_i18n:getText("shop_capacity");
				moSetGetOverlays.infoHelpBox.info.lsTimer = -1;
				moSetGetOverlays.infoHelpBox.info.titel = "Production Info";
				moSetGetOverlays.infoHelpBox.info.txt = tostring(args.ownTable[2]).. ": ".. tostring(args.ownTable[3]).. "\n".. capacityLanguage.. " ".. tostring(args.ownTable[4]);
			end;
		end;
	end;
end;

function moProductionPointsOutput.clickBuyProduction(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then
				if object.spec_productionPoint ~= nil then				
					object.spec_productionPoint.productionPoint:buyRequest();
				elseif object.spec_extendedProductionPoint ~= nil then
					object.spec_extendedProductionPoint.productionPoint:buyRequest();
				end;
			end;
		end;	
	end;
end;

function moProductionPointsOutput.clickViewMoreInfo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then
				object.mohTable.viewMoreInfo = not object.mohTable.viewMoreInfo;
			end;
		end;	
	end;
end;

function moProductionPointsOutput.clickViewProductionInfoSmall(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then
				object.mohTable.viewProductionInfoSmall = not object.mohTable.viewProductionInfoSmall;
			end;
		end;	
	end;
end;

function moProductionPointsOutput.clickViewProductionInfoAll(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then
				object.mohTable.viewProductionInfoAll = not object.mohTable.viewProductionInfoAll;
			end;
		end;	
	end;
end;

function moProductionPointsOutput.clickViewProductionInfo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then
				object.mohTable.viewProductionInfo[args.ownTable[2]] = not object.mohTable.viewProductionInfo[args.ownTable[2]];
			end;
		end;	
	end;
end;

function moProductionPointsOutput.clickProductionPoint(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then					
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moProductionPointsOutput.clickProductionPoint"); --force mouseOff
				end;				
			end;
		end;	
	end;
end;

function moProductionPointsOutput.clickViewInputOutputOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil and args.ownTable[3] ~= nil then					
			local object = moModuleObjects:getObject(args.ownTable[1], "productionPoints");			
			if object ~= nil then				
				if args.ownTable[2] == 1 then
					object.mohTable.viewOutput[args.ownTable[3]] = not object.mohTable.viewOutput[args.ownTable[3]];
				elseif args.ownTable[2] == 2 then
					object.mohTable.viewInput[args.ownTable[3]] = not object.mohTable.viewInput[args.ownTable[3]];
				end;
			end;			
		end;
	end;
end;

function moProductionPointsOutput.clickProductionOrProductivity(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moModule:showInGameMenuFrame("pageProduction", 0, true, false, 0);		
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then
		moModule:showInGameMenuFrame("pageProduction", args.ownTable[1], false, false, 0, args.ownTable[2] or 1);
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="productionPoints" } );