moSellingStationsConfig = {};

function moSellingStationsConfig:defaultValues()
	moSellingStationsConfig.values = {station={}, updateTimer=30, msec=true};
end;

function moSellingStationsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;	
	if moSellingStationsConfig.values == nil then moSellingStationsConfig:defaultValues();end;	
	--local groupNameTag = (xmlNameTag.. ".module.sellingStations(%d)"):format(0);
	--if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
	--	moSellingStationsConfig.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	--else
	--	return; --first config not found
	--end;
	--if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		--moSellingStationsConfig.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	--end;	
end;

function moSellingStationsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;	
	if moSellingStationsConfig.values == nil then moSellingStationsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.sellingStations(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moSellingStationsConfig.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moSellingStationsConfig.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moSellingStationsConfig:generateCmd(object)
	function generateCmd(cmdName, displayName, object, ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = cmdName;
				groupName = "SellingStations";			
				displayName = tostring(displayName);
				infoTxt = "View All SellingStaions";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {object};
				actionCallback = moSellingStationsOutput.giveOutputTable;			
			}
		)
	end;
	if object ~= nil and moModuleObjects:isObject(object) then
		local objectId = object.nodeId or object.rootNode;		
		local x, y ,z = getWorldTranslation(objectId);
		local cmdName = "";
		local displayName = object.mohTable.name;
		local tempName = object.mohTable.cmdName;		
		if x == nil or y == nil or z == nil then			
			cmdName = "output_sellingStation_".. tostring(tempName).. "_";
		else
			cmdName = "output_sellingStation_".. tostring(tempName).. "_x"..tostring(x).."_y"..tostring(y).."_z"..tostring(z).."_";
		end;
		if MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName] ~= nil and MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName].object ~= nil then
			MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName].object[#MultiOverlayV4.cmd["MultiOverlayV4_cmd_"..cmdName].object+1] = object;
		else
			generateCmd(cmdName, displayName, object, {});
		end;
	else
		local displayName = g_i18n:getText("construction_tab_sellingPoints"); --moLanguageXml:getTxt("sellingstations", nil, "Stations:");
		local cmdName = "output_sellingStations_";
		generateCmd(cmdName, displayName, nil, {"simpleSellingStations"});
	end;
end;


moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moSellingStationsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moSellingStationsConfig.saveXml } );
