moSolarPanels = {};
source(MultiOverlayV4.modDir.."scripte/module/solarPanels/moSolarPanelsConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/solarPanels/moSolarPanelsOutput.lua");

function moSolarPanels:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="solarPanels"} ) then
		if moSolarPanelsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateSolarPanels"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moSolarPanelsConfig.values.updateTimer, name="updateSolarPanels", repeatable=1, ms=moSolarPanelsConfig.values.msec, action=moSolarPanels.load} ); 
		else
			moSolarPanels:load();
		end;
	end;
end;

function moSolarPanels.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moSolarPanelsConfig.values == nil then moSolarPanelsConfig:defaultValues();end;
	if update == nil or not update then moSolarPanelsConfig:generateAllCmd();end;
	if update then moSolarPanelsConfig:deleteCmd();end;
	moSolarPanels:loadAllSolarPanels(true);	
end;

function moSolarPanels.load() --updateTimer Callback	
	moSolarPanels:loadAllSolarPanels();	
end;

function moSolarPanels:loadAllSolarPanels(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	if moModule.solarPanels ~= nil and #moModule.solarPanels > 0 then
		local deleteObject = {};
		for index=1, #moModule.solarPanels do			
			if moModule.solarPanels[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.solarPanels[index].object);
				if isObject then
					local solarPanel = moModule.solarPanels[index].object;
					local isViewOutput = (generateCmd ~= nil and generateCmd) or solarPanel.ownerFarmId == playerFarmId or solarPanel.ownerFarmId == 0;
					if isViewOutput then						
						if solarPanel.mohTable == nil then
							solarPanel.mohTable = {general={},production={},output={},input={}};						
						else
							solarPanel.mohTable.general={};solarPanel.mohTable.production={};solarPanel.mohTable.output={};solarPanel.mohTable.input={};
						end;
						if solarPanel.mohTable.viewOutput == nil then solarPanel.mohTable.viewOutput = {};end;	
						if solarPanel.mohTable.viewInput == nil then solarPanel.mohTable.viewInput = {};end;
						if solarPanel.mohTable.viewMoreInfo == nil then solarPanel.mohTable.viewMoreInfo = false;end;						
						if solarPanel.mohTable.viewProductionInfo == nil then solarPanel.mohTable.viewProductionInfo = {};end;
						---general---
						solarPanel.mohTable.general[#solarPanel.mohTable.general+1] = {};
						local isLineTableGeneral = solarPanel.mohTable.general[#solarPanel.mohTable.general];
						if solarPanel.mohDisplayName ~= nil then 
							isLineTableGeneral.objectName = solarPanel.mohTable.mohDisplayName;
						else
							isLineTableGeneral.objectName = solarPanel.mohTable.name;
						end;
						isLineTableGeneral.age = solarPanel.age;
						isLineTableGeneral.productivityName = g_i18n:getText("statistic_productivity");
						isLineTableGeneral.costsPerActiveMonth = 0;
						isLineTableGeneral.ownedFarmId = solarPanel.ownerFarmId;
						isLineTableGeneral.price = Utils.getNoNil(solarPanel.price, 0);
						local incomePerHour = solarPanel.spec_incomePerHour.incomePerHour * solarPanel.spec_incomePerHour.incomePerHourFactor * g_currentMission.environment.timeAdjustment;
						--isLineTableGeneral.incomePerHour = string.format("%s / %s", g_i18n:formatMoney(incomePerHour), g_i18n:getText("shop_incomeValue"));
						isLineTableGeneral.incomePerHourUnFormat = Utils.getNoNil(incomePerHour, 0);
						isLineTableGeneral.incomePerHour = string.format(g_i18n:getText("shop_incomeValue"), g_i18n:formatMoney(incomePerHour));
						isLineTableGeneral.incomePerDay = string.format(g_i18n:getText("shop_maintenanceValue"), g_i18n:formatMoney(incomePerHour*24));		
						--isLineTableGeneral.incomePerMonth = string.format("%s / %s", g_i18n:formatMoney(incomePerHour*24), g_i18n:getText("ui_month"));		shop_maintenanceValue				
						---general---						
						---input---											
																							
						---input---																	
						if generateCmd ~= nil and generateCmd then moSolarPanelsConfig:generateCmd(solarPanel);end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.solarPanels, index);
			end;
			moSolarPanelsConfig:deleteCmd(true);			
		end;
	end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moSolarPanels.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moSolarPanels.update } );