moStoragesOutput = {};

function moStoragesOutput:load(cmdTable, slotTable)
	local cmdRegName = cmdTable.regName;
	local cmdObject = cmdTable.object;
	local lineTable = {line={}};
	for o=1, #cmdObject do
		if cmdObject[o] ~= nil and moModuleObjects:isObject(cmdObject[o]) and cmdObject[o].mohTable ~= nil and cmdObject[o].mohTable.general ~= nil and cmdObject[o].mohTable.general[1] ~= nil then
			-----general-----
			---check edit object name---
			local displayName = cmdObject[o]:getName();
			if displayName ~= nil and tostring(displayName) ~= tostring(cmdObject[o].mohTable.name) then 
				moStoragesConfig:refreshCmdDisplayName(cmdRegName, displayName);
				cmdObject[o].mohTable.name = tostring(displayName);				
			end;
			---check edit object name---
			---objectName---
			local storageGeneral = cmdObject[o].mohTable.general[1];
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txtOutputTitle";
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(storageGeneral.objectName);		
			isLineTable.txt[1].callback = moStoragesOutput.clickStorages;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			local objectId = cmdObject[o].nodeId or cmdObject[o].rootNode;		
			local oX,oY,oZ = getWorldTranslation(objectId);
			if oX ~= nil and oY ~= nil and oZ ~= nil then
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
					if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
				end;
			end;		
			isLineTable.txt[1].alignment = 2;
			if slotTable ~= nil and slotTable.help.outputOn then
				isLineTable.txt[1].icon = {before={},after={}};
				isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moStoragesOutput.clickStoragesHelpTxt}};
			end;
			---objectName---
			---capacity---				
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};
			isLineTable.txt[1].width = 50;
			local color = storageGeneral.capacityColor;
			if color > 1 then
				isLineTable.txt[1].prozentColor = color;
			else
				isLineTable.txt[1].slotColor = "txt";
			end;
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(storageGeneral.capacityName);
			isLineTable.txt[1].callback = moStoragesOutput.clickCapacityTotal;
			isLineTable.txt[1].ownTable = {storageGeneral.capacityTotal, tostring(storageGeneral.objectName)};
			isLineTable.txt[2] = {};			
			isLineTable.txt[2].width = 50;	
			if color > 1 then
				isLineTable.txt[2].prozentColor = color;
			else
				isLineTable.txt[2].slotColor = "txt";
			end;
			isLineTable.txt[2].bold = true;
			isLineTable.txt[2].txt = tostring(storageGeneral.capacity); --moLanguageXml:getTxt("per", nil, "per").. " ".. storageGeneral.capacity; --storageGeneral.capacityTotal;				
			isLineTable.txt[2].alignment = 3;	
			isLineTable.txt[2].callback = moStoragesOutput.clickCapacityTotal;
			isLineTable.txt[2].ownTable = {storageGeneral.capacityTotal, tostring(storageGeneral.objectName)};
			---capacity---
			---usage---			
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];		
			isLineTable.txt = {};
			isLineTable.txt[1] = {};			
			isLineTable.txt[1].prozentColor = storageGeneral.usageColor;
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(storageGeneral.usageName);
			isLineTable.txt[1].width = 50;	--width prozent	
			isLineTable.txt[2] = {};			
			isLineTable.txt[2].prozentColor = storageGeneral.usageColor;
			isLineTable.txt[2].bold = true;
			isLineTable.txt[2].txt = storageGeneral.usage.. "%";				
			isLineTable.txt[2].width = 50;	--width prozent	
			isLineTable.txt[2].alignment = 3;
			---usage---			
			---age---
			if moModule.values.viewAge then
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("modHub_object")).. " ".. tostring(g_i18n:getText("ui_age"));
				isLineTable.txt[1].width = 50;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;
				if storageGeneral.age > 1 or storageGeneral.age == 0 then 
					isLineTable.txt[2].txt = tostring(storageGeneral.age).. " ".. moLanguageXml:getTxt("agedays", nil, "Day(s)");
				else
					isLineTable.txt[2].txt = tostring(storageGeneral.age).. " ".. moLanguageXml:getTxt("ageday", nil, "Day");
				end;
				isLineTable.txt[2].width = 50;
				isLineTable.txt[2].alignment = 3;
			end;
			---age---			
			-----general-----
			-----output-----
			local storageOutput = cmdObject[o].mohTable.output;
			local viewOutput = cmdObject[o].mohTable.viewOutput;
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];			
			isLineTable.txt = {};			
			isLineTable.txt[1] = {};			
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = true;			
			isLineTable.txt[1].txt = "Out ++ ".. "(".. tostring(#storageOutput).. ")";			
			isLineTable.txt[1].callback = moStoragesOutput.clickViewInputOutputOnOff;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			if viewOutput then color = "green";else color = "red";end;
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonDown", color=color, settingButton=true, callback={[1]=moStoragesOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode, 1}};
			if viewOutput then
				for output=1, #storageOutput do
					if storageOutput[output] ~= nil then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = false;
						isLineTable.txt[1].txt = tostring(storageOutput[output].fillTypeName);
						isLineTable.txt[1].width = 70;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = false;
						isLineTable.txt[2].txt = tostring(storageOutput[output].fillLevel);
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;
					end;
				end;
			end;			
			-----output-----
			-----input-----
			local storageInput = cmdObject[o].mohTable.input;
			local viewInput = cmdObject[o].mohTable.viewInput;
			lineTable.line[#lineTable.line+1] = {};
			isLineTable = lineTable.line[#lineTable.line];			
			isLineTable.txt = {};			
			isLineTable.txt[1] = {};			
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = true;			
			isLineTable.txt[1].txt = "In ++ ".. "(".. tostring(#storageInput).. ")";			
			isLineTable.txt[1].callback = moStoragesOutput.clickViewInputOutputOnOff;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			if viewInput then color = "green";else color = "red";end;
			isLineTable.txt[1].icon = {before={},after={}};
			isLineTable.txt[1].icon.before[1] = {name="buttonDown", color=color, settingButton=true, callback={[1]=moStoragesOutput.clickViewInputOutputOnOff}, ownTable={cmdObject[o].rootNode}, 2};
			if viewInput then			
				for input=1, #storageInput do
					if storageInput[input] ~= nil then
						lineTable.line[#lineTable.line+1] = {};
						isLineTable = lineTable.line[#lineTable.line];
						isLineTable.txt = {};
						isLineTable.txt[1] = {};
						isLineTable.txt[1].slotColor = "txt";
						isLineTable.txt[1].bold = false;
						isLineTable.txt[1].txt = tostring(storageInput[input].fillTypeName);
						isLineTable.txt[1].width = 70;
						isLineTable.txt[2] = {};
						isLineTable.txt[2].slotColor = "txt";
						isLineTable.txt[2].bold = false;
						isLineTable.txt[2].txt = tostring(storageInput[input].percentageCapacity).. "%";
						isLineTable.txt[2].width = 30;
						isLineTable.txt[2].alignment = 3;						
					end;
				end;
			end;
			-----input-----
		end;
	end;
	moStorages[cmdRegName] = {output=lineTable};
end;

function moStoragesOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.object == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="storages" } );
	moStoragesOutput:load(args.cmdTable, args.slotTable);
	return moStorages[args.cmdTable.regName].output;
end;

function moStoragesOutput.clickStoragesHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Storages Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Storage/Amount for more Info or MapHotSpot or ...";
	end;
end;

function moStoragesOutput.clickCapacityTotal(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local capacityLanguage = g_i18n:getText("shop_capacity");
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.titel = tostring(args.ownTable[2]);
			moSetGetOverlays.infoHelpBox.help.txt = tostring(capacityLanguage).. ": ".. tostring(args.ownTable[1]);
		end;
	end;
end;

function moStoragesOutput.clickStorages(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "storages");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	end;
end;

function moStoragesOutput.clickViewInputOutputOnOff(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil and args.ownTable[2] ~= nil then					
			local object = moModuleObjects:getObject(args.ownTable[1], "storages");			
			if object ~= nil then				
				if args.ownTable[2] == 1 then
						object.mohTable.viewOutput = not object.mohTable.viewOutput;
				elseif args.ownTable[2] == 2 then
					object.mohTable.viewInput = not object.mohTable.viewInput;
				end;
			end;			
		end;
	end;
end;

--moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="storages" } );