moVehicleSales = {};
source(MultiOverlayV4.modDir.."scripte/module/vehicleSales/moVehicleSalesConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/vehicleSales/moVehicleSalesOutput.lua");

function moVehicleSales:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="vehicleSales"} ) then
		if moVehicleSalesConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateVehicleSales"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moVehicleSalesConfig.values.updateTimer, name="updateVehicleSales", repeatable=1, ms=moVehicleSalesConfig.values.msec, action=moVehicleSales.loadAllVehicleSales} ); 
		else
			moVehicleSales:loadAllVehicleSales();
		end;
	end;
end;

function moVehicleSales.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moVehicleSalesConfig.values == nil then moVehicleSalesConfig:defaultValues();end;	
	if update == nil then moVehicleSales:loadAllVehicleSales(true);end;			
end;

function moVehicleSales.load() --updateTimer Callback	
	moVehicleSales:loadAllVehicleSales();	
end;

function moVehicleSales:loadAllVehicleSales(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	--local farmId = g_currentMission:getFarmId()
	moVehicleSalesConfig.values.sales = {}; --new
	local items = g_currentMission.vehicleSaleSystem:getItems();
	if items ~= nil and #items > 0 then		
		for s=1, #items do
			moVehicleSalesConfig.values.sales[s] = {};			
			moVehicleSalesConfig.values.sales[s].age = items[s].age;
			moVehicleSalesConfig.values.sales[s].operatingTime = items[s].operatingTime;
			moVehicleSalesConfig.values.sales[s].timeLeft = items[s].timeLeft;
			moVehicleSalesConfig.values.sales[s].price = items[s].price;
			moVehicleSalesConfig.values.sales[s].priceTxt = tostring(g_i18n:formatMoney(items[s].price, 0, true, false));
			moVehicleSalesConfig.values.sales[s].pricePercent = 0;
			moVehicleSalesConfig.values.sales[s].damage = items[s].damage;
			moVehicleSalesConfig.values.sales[s].damageTxt = g_i18n:formatNumber(math.ceil((1 - items[s].damage) * 100), 0) .. "%";
			moVehicleSalesConfig.values.sales[s].wear = items[s].wear;
			local storeItem = g_storeManager:getItemByXMLFilename(items[s].xmlFilename);
			if storeItem ~= nil then				
				moVehicleSalesConfig.values.sales[s].name = Utils.getNoNil(storeItem.brandNameRaw.. "").. " ".. storeItem.name;
				moVehicleSalesConfig.values.sales[s].defaultPrice = storeItem.price;
				moVehicleSalesConfig.values.sales[s].defaultPriceTxt = tostring(g_i18n:formatMoney(storeItem.price, 0, true, false));
				moVehicleSalesConfig.values.sales[s].category = g_storeManager:getCategoryByName(storeItem.categoryName);
				local pricePercent = math.floor(items[s].price/storeItem.price * 100, 0.5);
				moVehicleSalesConfig.values.sales[s].pricePercent = g_i18n:formatNumber(math.ceil((100 - pricePercent)), 0) .. "%";
			end;
		end;
	end;
	if generateCmd ~= nil and generateCmd then moVehicleSalesConfig:generateCmd();end;	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moVehicleSales.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moVehicleSales.update } );