moVehicleSalesOutput = {};

function moVehicleSalesOutput:load(cmdTable, slotTable)
	local cmdRegName = cmdTable.regName;	
	local lineTable = {line={}};
	if moVehicleSalesConfig.values.sales ~= nil then
		if #moVehicleSalesConfig.values.sales > 0 then
			for s=1, #moVehicleSalesConfig.values.sales do 
				local item = moVehicleSalesConfig.values.sales[s];
				lineTable.line[#lineTable.line+1] = {};
				local isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};	
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_category"));
				isLineTable.txt[1].width = 30;
				isLineTable.txt[2] = {};	
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = false;
				isLineTable.txt[2].txt = tostring(item.category.title);
				isLineTable.txt[2].width = 70;
				
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};	
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = false;
				isLineTable.txt[1].txt = tostring(item.name);
				
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};	
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = false;
				isLineTable.txt[1].txt = tostring(string.format(g_i18n:getText("shop_age"), string.format("%d", item.age)));
				isLineTable.txt[2] = {};	
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = false;
				isLineTable.txt[2].txt = tostring(g_i18n:getText("infohud_damage")).. ": ".. tostring(item.damageTxt); 
				isLineTable.txt[2].alignment = 3;
				
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};	
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = false;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_sellPrices"));
				isLineTable.txt[2] = {};	
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = false;
				isLineTable.txt[2].txt = tostring(item.priceTxt).. " (-".. tostring(item.pricePercent).. ")";
				isLineTable.txt[2].callback = moVehicleSalesOutput.clickPriceTxt;
				isLineTable.txt[2].ownTable = {item.defaultPriceTxt};
				isLineTable.txt[2].alignment = 3;
				
				local minutes = item.operatingTime / 60000;
				local hours = math.floor(minutes / 60);
				minutes = math.floor((minutes - hours * 60) / 6) * 10;				
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};	
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = false;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_saleRemaingHours"));
				isLineTable.txt[2] = {};	
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = false;
				isLineTable.txt[2].txt = tostring(string.format(g_i18n:getText("shop_operatingTime"), hours, minutes));
				isLineTable.txt[2].alignment = 3;
				
				if s ~= #moVehicleSalesConfig.values.sales then
					---seperator---
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].slotColor = "txtOutputTitle";
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = "----";
					isLineTable.txt[2] = {};
					isLineTable.txt[2].slotColor = "txtOutputTitle";
					isLineTable.txt[2].bold = true;
					isLineTable.txt[2].txt = "----";
					isLineTable.txt[2].alignment = 3;				
					---seperator---
				end;
			end;
		else
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = false;
			isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_noVehicles"));
		end;
	else
		moVehicleSalesConfig.values.sales = {};
	end;
	local moreTxt = "(".. tostring(#moVehicleSalesConfig.values.sales).. ")";
	if #moVehicleSalesConfig.values.sales <= 0 then moreTxt = "";end;
	table.insert(lineTable.line, 1, {});
	isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(g_i18n:getText("inputCategory_VEHICLE")).. " ".. tostring(g_i18n:getText("category_sales")).. moreTxt;	
	if #moVehicleSalesConfig.values.sales > 0 then isLineTable.txt[1].callback = moVehicleSalesOutput.clickVehicleSalesTotal;end;
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moVehicleSalesOutput.clickTitleHelpTxt}};
	end;	
	---objectLineDistance---
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};		
	isLineTable.txt[1].txt = " ";
	---objectLineDistance---
	moVehicleSalesOutput[cmdRegName] = {output=lineTable};
end;

function moVehicleSalesOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;	
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="vehicleSales" } );
	moVehicleSalesOutput:load(args.cmdTable, args.slotTable);	
	return moVehicleSalesOutput[args.cmdTable.regName].output;
end;

function moVehicleSalesOutput.clickTitleHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = tostring(g_i18n:getText("inputCategory_VEHICLE")).. " ".. tostring(g_i18n:getText("category_sales"));
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Title Text/Price for more Info or ...";
	end;
end;

function moVehicleSalesOutput.clickVehicleSalesTotal(args)	
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if g_currentMission.shopMenu.pageUsedSale == nil then return;end;
		g_gui:showGui("ShopMenu");		
		local salePageIndex = g_currentMission.shopMenu.pagingElement:getPageMappingIndexByElement(g_currentMission.shopMenu.pageUsedSale);
		g_currentMission.shopMenu.pageSelector:setState(salePageIndex, true);
	end;
end;

function moVehicleSalesOutput.clickPriceTxt(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
			moSetGetOverlays.infoHelpBox.help.titel = tostring(g_i18n:getText("inputCategory_VEHICLE")).. " ".. tostring(g_i18n:getText("category_sales"));
			moSetGetOverlays.infoHelpBox.help.txt = tostring(g_i18n:getText("animal_new")).. " ".. tostring(g_i18n:getText("ui_sellPrices")).. ": ".. tostring(args.ownTable[1]);
		end;
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="vehicleSales" } );