moWindTurbines = {};
source(MultiOverlayV4.modDir.."scripte/module/windTurbines/moWindTurbinesConfig.lua");
source(MultiOverlayV4.modDir.."scripte/module/windTurbines/moWindTurbinesOutput.lua");

function moWindTurbines:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="windTurbines"} ) then
		if moWindTurbinesConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateWindTurbines"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moWindTurbinesConfig.values.updateTimer, name="updateWindTurbines", repeatable=1, ms=moWindTurbinesConfig.values.msec, action=moWindTurbines.load} ); 
		else
			moWindTurbines:load();
		end;
	end;
end;

function moWindTurbines.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete obbject etc. delete your old cmds!	
	if moWindTurbinesConfig.values == nil then moWindTurbinesConfig:defaultValues();end;
	if update == nil or not update then moWindTurbinesConfig:generateAllCmd();end;
	if update then moWindTurbinesConfig:deleteCmd();end;
	moWindTurbines:loadAllWindTurbines(true);	
end;

function moWindTurbines.load() --updateTimer Callback	
	moWindTurbines:loadAllWindTurbines();	
end;

function moWindTurbines:loadAllWindTurbines(generateCmd)	
	local playerFarmId = g_currentMission.player.farmId;	
	if moModule.windTurbines ~= nil and #moModule.windTurbines > 0 then
		local deleteObject = {};
		for index=1, #moModule.windTurbines do			
			if moModule.windTurbines[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.windTurbines[index].object);
				if isObject then
					local windTurbine = moModule.windTurbines[index].object;
					local isViewOutput = (generateCmd ~= nil and generateCmd) or windTurbine.ownerFarmId == playerFarmId or windTurbine.ownerFarmId == 0;
					if isViewOutput then						
						if windTurbine.mohTable == nil then
							windTurbine.mohTable = {general={},production={},output={},input={}};						
						else
							windTurbine.mohTable.general={};windTurbine.mohTable.production={};windTurbine.mohTable.output={};windTurbine.mohTable.input={};
						end;
						if windTurbine.mohTable.viewOutput == nil then windTurbine.mohTable.viewOutput = {};end;	
						if windTurbine.mohTable.viewInput == nil then windTurbine.mohTable.viewInput = {};end;
						if windTurbine.mohTable.viewMoreInfo == nil then windTurbine.mohTable.viewMoreInfo = false;end;						
						if windTurbine.mohTable.viewProductionInfo == nil then windTurbine.mohTable.viewProductionInfo = {};end;
						---general---
						windTurbine.mohTable.general[#windTurbine.mohTable.general+1] = {};
						local isLineTableGeneral = windTurbine.mohTable.general[#windTurbine.mohTable.general];
						if windTurbine.mohDisplayName ~= nil then 
							isLineTableGeneral.objectName = windTurbine.mohTable.mohDisplayName;
						else
							isLineTableGeneral.objectName = windTurbine.mohTable.name;
						end;
						isLineTableGeneral.age = windTurbine.age;
						isLineTableGeneral.productivityName = g_i18n:getText("statistic_productivity");
						isLineTableGeneral.costsPerActiveMonth = 0;
						isLineTableGeneral.ownedFarmId = windTurbine.ownerFarmId;
						isLineTableGeneral.price = Utils.getNoNil(windTurbine.price, 0);
						local incomePerHour = windTurbine.spec_incomePerHour.incomePerHour * windTurbine.spec_incomePerHour.incomePerHourFactor * g_currentMission.environment.timeAdjustment;
						--isLineTableGeneral.incomePerHour = string.format("%s / %s", g_i18n:formatMoney(incomePerHour), g_i18n:getText("shop_incomeValue"));
						isLineTableGeneral.incomePerHourUnFormat = Utils.getNoNil(incomePerHour, 0);
						isLineTableGeneral.incomePerHour = string.format(g_i18n:getText("shop_incomeValue"), g_i18n:formatMoney(incomePerHour));
						isLineTableGeneral.incomePerDay = string.format(g_i18n:getText("shop_maintenanceValue"), g_i18n:formatMoney(incomePerHour*24));		
						--isLineTableGeneral.incomePerMonth = string.format("%s / %s", g_i18n:formatMoney(incomePerHour*24), g_i18n:getText("ui_month"));		shop_maintenanceValue				
						---general---						
						---input---											
																							
						---input---																	
						if generateCmd ~= nil and generateCmd then moWindTurbinesConfig:generateCmd(windTurbine);end;
					end;
				else
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.windTurbines, index);
			end;
			moWindTurbinesConfig:deleteCmd(true);			
		end;
	end;
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moWindTurbines.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moWindTurbines.update } );