moWindTurbinesOutput = {};

function moWindTurbinesOutput:load(cmdTable, slotTable, giveAll)
	local playerFarmId = g_currentMission.player.farmId;
	local cmdRegName = cmdTable.regName;
	local cmdObject = cmdTable.object;	
	local lineTable = {line={}};	
	local incomePerHour = 0;
	for o=1, #cmdObject do
		if cmdObject[o] ~= nil and moModuleObjects:isObject(cmdObject[o]) and cmdObject[o].mohTable ~= nil and cmdObject[o].mohTable.general ~= nil and cmdObject[o].mohTable.general[1] ~= nil then
			---check edit object name---
			local displayName = cmdObject[o]:getName();
			if displayName ~= nil and tostring(displayName) ~= tostring(cmdObject[o].mohTable.name) then 
				moWindTurbinesConfig:refreshCmdDisplayName(cmdRegName, displayName);
				cmdObject[o].mohTable.name = tostring(displayName);				
			end;
			---check edit object name---			
			-------------------------------general-------------------------------
			---objectName---
			local stopInOutput = false;
			local viewMoreInfo = cmdObject[o].mohTable.viewMoreInfo;			
			local windTurbineGeneral = cmdObject[o].mohTable.general[1];			
			local isOwned = playerFarmId == windTurbineGeneral.ownedFarmId and playerFarmId ~= 0; 
			local canBuy = windTurbineGeneral.ownedFarmId == 0;
			incomePerHour = windTurbineGeneral.incomePerHourUnFormat
			local iconColor = "gray";
			local buttonName = "buttonDown";
			lineTable.line[#lineTable.line+1] = {};
			local isLineTable = lineTable.line[#lineTable.line];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			if giveAll == nil or not giveAll then
				isLineTable.txt[1].slotColor = "txtOutputTitle";
			else
				isLineTable.txt[1].slotColor = "txt";
			end;
			isLineTable.txt[1].bold = true;
			isLineTable.txt[1].txt = tostring(windTurbineGeneral.objectName);		
			isLineTable.txt[1].callback = moWindTurbinesOutput.clickWindTurbine;
			isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};
			local objectId = cmdObject[o].nodeId or cmdObject[o].rootNode;		
			local oX,oY,oZ = getWorldTranslation(objectId);
			if oX ~= nil and oY ~= nil and oZ ~= nil then
				local x,y,z = g_currentMission.hl.getPlayerPos();
				if x ~= nil and y ~= nil and z ~= nil then
					local nearObject = g_currentMission.hl.playerNearObject({x=x,y=y,z=z},{x=oX,y=oY,z=oZ}, 10);
					if nearObject then isLineTable.txt[1].txt = ">>".. isLineTable.txt[1].txt.. "<<";end;
				end;
			end;
			if giveAll == nil or not giveAll then 
				isLineTable.txt[1].alignment = 2;
			end;
			if slotTable ~= nil and slotTable.help.outputOn then
				isLineTable.txt[1].icon = {before={},after={}};
				isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moWindTurbinesOutput.clickWindTurbinesHelpTxt}};
			end;
			if g_currentMission.hl.isMouseCursor and isOwned then
				iconColor = "gray";
				if viewMoreInfo then iconColor = "green";end;
				if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
				isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="moreInfo", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moWindTurbinesOutput.clickViewMoreInfo}, ownTable={cmdObject[o].rootNode}, infoTxt="More Info"};
			end;
			---objectName---			
			if isOwned and viewMoreInfo then				
				---incomeHour---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_income")); --.. " ".. tostring(g_i18n:getText("shop_incomeValue"));
				isLineTable.txt[1].width = 40;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;				
				isLineTable.txt[2].txt = tostring(windTurbineGeneral.incomePerHour); --tostring(g_i18n:formatMoney(windTurbineGeneral.incomePerHour, 0, true, false));						
				isLineTable.txt[2].width = 60;
				isLineTable.txt[2].alignment = 3;
				---incomeHour---
				---incomeMonth---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_income")); --.. " ".. tostring(g_i18n:getText("ui_month"));	
				isLineTable.txt[1].width = 40;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;				
				isLineTable.txt[2].txt = tostring(windTurbineGeneral.incomePerDay);						
				isLineTable.txt[2].width = 60;
				isLineTable.txt[2].alignment = 3;
				---incomeMonth---				
				---age---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].slotColor = "txt";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = tostring(g_i18n:getText("modHub_object")).. " ".. tostring(g_i18n:getText("ui_age"));	
				isLineTable.txt[1].width = 70;
				isLineTable.txt[2] = {};
				isLineTable.txt[2].slotColor = "txt";
				isLineTable.txt[2].bold = true;			
				if windTurbineGeneral.age > 1 or windTurbineGeneral.age == 0 then 
					isLineTable.txt[2].txt = tostring(windTurbineGeneral.age).. " ".. tostring(g_i18n:getText("ui_days"));
				else
					isLineTable.txt[2].txt = tostring(windTurbineGeneral.age).. " ".. tostring(g_i18n:getText("ui_day"));
				end;		
				isLineTable.txt[2].width = 30;
				isLineTable.txt[2].alignment = 3;
				---age---
				---costsPerActiveMonth---
				--lineTable.line[#lineTable.line+1] = {};
				--isLineTable = lineTable.line[#lineTable.line];
				--isLineTable.txt = {};
				--isLineTable.txt[1] = {};
				--isLineTable.txt[1].slotColor = "txt";
				--isLineTable.txt[1].bold = true;
				--isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_maintenance").. "/".. g_i18n:getText("ui_month"));--shop_maintenance	
				--isLineTable.txt[1].width = 70;
				--isLineTable.txt[2] = {};
				--isLineTable.txt[2].slotColor = "txt";
				--isLineTable.txt[2].bold = true;				
				--isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(windTurbineGeneral.costsPerActiveMonth, 0, true, false));						
				--isLineTable.txt[2].width = 30;
				--isLineTable.txt[2].alignment = 3;				
				---costsPerActiveMonth---
				---seperator---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].isSeparator = true;
				isLineTable.txt[1].slotColor = "txtOutputTitle";
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].txt = "----";
				isLineTable.txt[2] = {};
				isLineTable.txt[2].isSeparator = true;
				isLineTable.txt[2].slotColor = "txtOutputTitle";
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].txt = "----";
				isLineTable.txt[2].alignment = 3;				
				---seperator---
			else
				if not isOwned and canBuy then
					local playerFarm = Utils.getNoNil(g_farmManager:getFarmById(playerFarmId), 0);
					canBuy = playerFarm.money >= windTurbineGeneral.price;
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("action_buyProductionPoint"));
					isLineTable.txt[1].slotColor = "txt";
					isLineTable.txt[1].width = 70;
					isLineTable.txt[1].callback = moWindTurbinesOutput.clickBuyWindTurbine;
					isLineTable.txt[1].ownTable = {cmdObject[o].rootNode};					
					isLineTable.txt[2] = {};
					isLineTable.txt[2].bold = true;
					isLineTable.txt[2].txt = tostring(g_i18n:formatMoney(windTurbineGeneral.price, 0, true, false));
					if canBuy then
						isLineTable.txt[2].slotColor = "settingOn";
					else
						isLineTable.txt[2].slotColor = "settingOff";
					end;
					isLineTable.txt[2].callback = moWindTurbinesOutput.clickBuyWindTurbine;
					isLineTable.txt[2].ownTable = {cmdObject[o].rootNode};
					isLineTable.txt[2].width = 30;
					isLineTable.txt[2].alignment = 3;
					stopInOutput = true;				
				elseif not isOwned and not canBuy then
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];
					isLineTable.txt = {};
					isLineTable.txt[1] = {};
					isLineTable.txt[1].bold = true;
					isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_construction_landIsNotOwned")).. " (".. tostring(g_i18n:getText("construction_category_production")).. ")";
					isLineTable.txt[1].slotColor = "settingReady";					
				end;
			end;			
			-------------------------------general-------------------------------			
			if giveAll == nil or not giveAll then
				---objectLineDistance---
				lineTable.line[#lineTable.line+1] = {};
				isLineTable = lineTable.line[#lineTable.line];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};		
				isLineTable.txt[1].txt = " ";
				---objectLineDistance---
			end;		
		end;
	end;
	if giveAll == nil or not giveAll then
		moWindTurbinesOutput[cmdRegName] = {output=lineTable};
	else
		return lineTable, incomePerHour;
	end;
end;

function moWindTurbinesOutput:loadAll(slotTable)
	local playerFarmId = g_currentMission.player.farmId;	
	local incomePerHourAll = 0;
	local lineTable = {line={}};
	if moModule.windTurbines ~= nil and #moModule.windTurbines > 0 then
		local cmdGroup = g_currentMission.multiOverlayV4.cmdFunction.getGroupCmdTable("WindTurbines");
		if cmdGroup ~= nil and #cmdGroup > 0 then
			for g=1, #cmdGroup do
				if cmdGroup[g] ~= nil and cmdGroup[g].cmd ~= nil and cmdGroup[g].cmd ~= "MultiOverlayV4_cmd_output_allWindturbines_" then
					local cmdTable = MultiOverlayV4.cmd[cmdGroup[g].cmd];
					local lineByObject, incomePerHour = moWindTurbinesOutput:load(cmdTable, nil, true);
					incomePerHourAll = incomePerHourAll+incomePerHour;
					if lineByObject ~= nil and #lineByObject.line > 0 then
						table.foreach(lineByObject.line, function(k, v) table.insert(lineTable.line, v) end);
					end;
				end;
			end;
		end;
	end;
	if #lineTable.line > 0 and lineTable.line[#lineTable.line].txt ~= nil and lineTable.line[#lineTable.line].txt[1] ~= nil then
		if lineTable.line[#lineTable.line].txt[1].isSeparator ~= nil and lineTable.line[#lineTable.line].txt[1].isSeparator then table.remove(lineTable.line, #lineTable.line);end;
	end;
	table.insert(lineTable.line, 1, {});
	local isLineTable = lineTable.line[1];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};	
	isLineTable.txt[1].slotColor = "txtOutputTitle";
	isLineTable.txt[1].bold = true;
	isLineTable.txt[1].txt = tostring(g_i18n:getText("shopItem_windTurbine"));	
	isLineTable.txt[1].alignment = 2;
	if slotTable ~= nil and slotTable.help.outputOn then
		isLineTable.txt[1].icon = {before={},after={}};
		isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moWindTurbinesOutput.clickWindTurbinesHelpTxt}};
	end;
	if #lineTable.line <= 1 then
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "settingReady";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_noItemsAvailable"));	
	else
		table.insert(lineTable.line, 2, {});
		isLineTable = lineTable.line[2];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txt";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = tostring(g_i18n:getText("shop_income")).. " ".. tostring(g_i18n:getText("fieldJob_tally_total"));
		isLineTable.txt[1].width = 60;
		isLineTable.txt[2] = {};	
		isLineTable.txt[2].slotColor = "txt";
		isLineTable.txt[2].bold = true;
		isLineTable.txt[2].txt = tostring(string.format(g_i18n:getText("shop_incomeValue"), g_i18n:formatMoney(incomePerHourAll, 0, true, false)));
		isLineTable.txt[2].width = 40;
		isLineTable.txt[2].alignment = 3;
	end;
	---objectLineDistance---
	lineTable.line[#lineTable.line+1] = {};
	isLineTable = lineTable.line[#lineTable.line];
	isLineTable.txt = {};
	isLineTable.txt[1] = {};		
	isLineTable.txt[1].txt = " ";
	---objectLineDistance---
	moWindTurbinesOutput["all"] = {output=lineTable};
end;	

function moWindTurbinesOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil or args.cmdTable.object == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="windTurbines" } );
	moWindTurbinesOutput:load(args.cmdTable, args.slotTable);
	return moWindTurbinesOutput[args.cmdTable.regName].output;
end;

function moWindTurbinesOutput.giveAllOutputTable(args)
	if args == nil or type(args) ~= "table" or args.cmdTable == nil then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="windTurbines" } );
	moWindTurbinesOutput:loadAll(args.slotTable);
	return moWindTurbinesOutput["all"].output;
end;

function moWindTurbinesOutput.clickWindTurbinesHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "WindTurbines Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional WindTurbine Name for more Info or MapHotSpot or ...\nClick Mouse Right Optional Titel WindTurbine Name for Teleport(onFoot)";
	end;
end;

function moWindTurbinesOutput.clickViewMoreInfo(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "windTurbines");			
			if object ~= nil then
				object.mohTable.viewMoreInfo = not object.mohTable.viewMoreInfo;
			end;
		end;	
	end;
end;

function moWindTurbinesOutput.clickBuyWindTurbine(args)
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "windTurbines");			
			if object ~= nil then
				--object.spec_productionPoint.productionPoint:buyRequest();				
			end;
		end;	
	end;
end;

function moWindTurbinesOutput.clickWindTurbine(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then				
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "windTurbines");			
			if object ~= nil then
				local x, _, z = getWorldTranslation(args.ownTable[1]);						
				if x ~= nil and x ~= 0 then					
					moSetGetOverlays:mapHotSpot({}, {x}, {z}, 1);
				end;
			end;
		end;
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then				
		if args.ownTable[1] ~= nil and g_currentMission.controlledVehicle == nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "windTurbines");			
			if object ~= nil and object.spec_hotspots ~= nil and object.spec_hotspots.mapHotspots ~= nil then
				local hotspot = object.spec_hotspots.mapHotspots[1];
				if hotspot ~= nil and hotspot.teleportWorldX ~= nil and hotspot.teleportWorldY ~= nil and hotspot.teleportWorldZ ~= nil then
					g_currentMission.player:moveToAbsolute(hotspot.teleportWorldX, hotspot.teleportWorldY, hotspot.teleportWorldZ, false, false);
					MultiOverlayV4:get_hl("mouseOnOff", {false,false,g_currentMission.hl.controlMod}, "moWindTurbinesOutput.clickWindTurbine"); --force mouseOff
				end;				
			end;
		end;	
	end;
end;


function moWindTurbinesOutput.clickViewProductionInfo(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			local object = moModuleObjects:getObject(args.ownTable[1], "windTurbines");			
			if object ~= nil then
				object.mohTable.viewProductionInfo = not object.mohTable.viewProductionInfo;
			end;
		end;	
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="windTurbines" } );