moSetGetOverlaysLight = {};
source(MultiOverlayV4.modDir.."scripte/overlays/light/moSetGetLight.lua");
source(MultiOverlayV4.modDir.."scripte/draw/light/moDrawLight.lua");

moSetGetOverlaysLight.default = {	
	keyInteraction = false;
	setting = {isOn=false,typ="",selectApp=0};
	limitViewApps = 20;
	limitMinViewApps = 2; --not edit
	masterPda ={
		color = {select="green",selectInactive="whiteInactive",inactive="whiteOff",default="white",open="ls22",infoBar="whiteOff",notice="warningRed"};
		minViewApps=2; --not edit
		maxViewApps=20;
		autoWidth=true;
		bounds={1,0,0,0};		
		selectApp=1;
		appOrder = {
			{1,true,"fillTypeAmountPriceSlot_","slot",true,[6]={} };
			{2,true,"mapMissionsSlot_","slot",true,[6]={true,0,false,15} }; --dds order,viewBounds(not visible),slot/pda name,typ slot or pda,autoclose,[6]=view infoBar/infoBar Prozent/infoBar Last Info/infoBar updateTimer
			{10,true,"mapFarmlandsSlot_","slot",true,[6]={} }; --later implements infoBar
			{3,true,"animalsPda_","pda",true,[6]={} };
			{7,true,"greenhouse1Slot_","slot",true,[6]={} };
			{4,true,"factorys1Slot_","slot",true,[6]={} };
			{12,true,"bgasSlot_","slot",true,[6]={} };
			{13,true,"fermentingSilosSlot_","slot",true,[6]={} };
			{14,true,"buyingSellingStationsSlot_","slot",true,[6]={} };
			{11,true,"others1Slot_","slot",true,[6]={} };
			{15,false,"productionsPda_","pda",true,[6]={} };			
			{5,true,"factorys2Slot_","slot",true,[6]={} };
			{6,false,"factorys3Slot_","slot",true,[6]={} };
			{8,false,"greenhouse2Slot_","slot",true,[6]={} };
			{9,false,"greenhouse3Slot_","slot",true,[6]={} };
			{16,true,"viTotalStateSlot_","slot",true,[6]={} };
			{17,false,"vehiclePda_","pda",true,[6]={} };
			{18,false,"productionInfoHudSlot_","slot",true,[6]={} };
		};
	};
	backgroundM = {};
	backgroundBox = {};
	temperatureBox = {};	
	moneyBox = {};
	timeBox = {};
	dateBox = {};
	weatherBox = {};	
};

function moSetGetOverlaysLight:getMasterPdaMaxViewApps()	
	local width = moSetGetOverlaysLight.default.masterPda.background.width-(moSetGetOverlaysLight.default.masterPda.buttonLeft.width*2);
	local maxViewApps = g_currentMission.hl.getMaxIconWidth(width, moSetGetOverlaysLight.default.masterPda.appWidth);	
	if maxViewApps < moSetGetOverlaysLight.default.limitMinViewApps then maxViewApps = moSetGetOverlaysLight.default.limitMinViewApps;end;
	if maxViewApps > moSetGetOverlaysLight.default.limitViewApps then maxViewApps = moSetGetOverlaysLight.default.limitViewApps;end;
	return maxViewApps;	
end;

function moSetGetOverlaysLight:getMasterPdaWidth()
	if not moSetGetOverlaysLight.default.masterPda.autoWidth then	
		--return moSetGetOverlaysLight.default.masterPda.buttonSetting.x-moSetGetOverlaysLight.default.masterPda.buttonLeft.x;
		return (moSetGetOverlaysLight.default.masterPda.appWidth*moSetGetOverlaysLight.default.masterPda.minViewApps)+(moSetGetOverlaysLight.default.masterPda.buttonLeft.width*2);
	end;
	if moSetGetOverlaysLight.default.backgroundBox[3] < (moSetGetOverlaysLight.default.masterPda.appWidth*moSetGetOverlaysLight.default.limitMinViewApps)+(moSetGetOverlaysLight.default.masterPda.buttonLeft.width*2) then
		return (moSetGetOverlaysLight.default.masterPda.appWidth*moSetGetOverlaysLight.default.limitMinViewApps)+(moSetGetOverlaysLight.default.masterPda.buttonLeft.width*2);
	end;
	return moSetGetOverlaysLight.default.backgroundBox[3];
	--local visible = moSetGetLight:getMasterPdaVisibleApps();	
	--if visible < moSetGetOverlaysLight.default.masterPda.minViewApps then visible = moSetGetOverlaysLight.default.masterPda.minViewApps;end;	
	--return (moSetGetOverlaysLight.default.masterPda.appWidth*visible)+(moSetGetOverlaysLight.default.masterPda.buttonLeft.width*2);
end;

function moSetGetOverlaysLight:getMasterPdaPosX(width)
	if width ~= nil then return 1.00 - width;end;
	return 1.00 - moSetGetOverlaysLight:getMasterPdaWidth();
end;

function moSetGetOverlaysLight:isVisible()
	if not moGeneralSettings.pdaType.light then return false;end;	
	return moSetGetOverlaysLight.default.masterPda.background ~= nil and moSetGetOverlaysLight.default.masterPda.background.width > 0 ;
end;

function moSetGetOverlaysLight:generate()
	moSetGetOverlaysLight.default.backgroundBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.backgroundOverlay.overlay)};
	moSetGetOverlaysLight.default.temperatureBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.temperatureBox.overlay)};
	moSetGetOverlaysLight.default.moneyBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.moneyBox.overlay)};
	moSetGetOverlaysLight.default.timeBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.timeBox.overlay)};
	moSetGetOverlaysLight.default.dateBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.dateBox.overlay)};
	moSetGetOverlaysLight.default.weatherBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.weatherBox.overlay)};
	
	local iconHeight = moSetGetOverlays.buttonGfxHeight1*25;	
	local iconWidth = moSetGetOverlays.buttonGfxWidth1*25;	
	moSetGetOverlaysLight.default.masterPda.appHeight = iconHeight*2;
	moSetGetOverlaysLight.default.masterPda.appWidth = iconWidth*2;	
	moSetGetOverlaysLight.default.masterPda.optiHeightSize = g_currentMission.hl.optiHeightSize(moSetGetOverlaysLight.default.masterPda.appHeight/2, "Ä", 0.015);
	--local separatorWidth = moSetGetOverlays.buttonGfxWidth1*3;
	--local separatorHeight = moSetGetOverlaysLight.default.masterPda.background.height/2;
	local iconFilePath = Utils.getFilename("icons/settings.dds", MultiOverlayV4.modDir);
	---------setting---------
	--ground--
	moSetGetOverlaysLight.default.setting.background = Overlay.new(g_baseUIFilename, 0, 0, 0, 0);
	moSetGetOverlaysLight.default.setting.background:setUVs(g_colorBgUVs);
	moSetGetOverlaysLight.default.setting.background:setColor(0, 0, 0, 0.75);
	--ground--
	--buttonLeftRight--
	moSetGetOverlaysLight.default.setting.buttonLeftRight = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.buttonLeftRight, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 39)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.buttonLeftRight, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.default, true));
	--buttonLeftRight--	
	--buttonAutoClose--
	moSetGetOverlaysLight.default.setting.buttonAutoClose = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.buttonAutoClose, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 46)));	
	--buttonAutoClose--
	--buttonInofBar--
	moSetGetOverlaysLight.default.setting.buttonInfoBar = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.buttonInfoBar, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));	
	--buttonInfoBar--
	--buttonView--
	moSetGetOverlaysLight.default.setting.buttonView = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.buttonView, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 35)));
	--buttonView--
	--buttonClose--
	moSetGetOverlaysLight.default.setting.buttonClose = Overlay.new(iconFilePath, 0, 0, iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.setting.buttonClose, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 2)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.setting.buttonClose, g_currentMission.hl.getColor("red", true));
	--buttonClose--
	---------setting---------
	
	---------master---------
	--ground-- moSetGetOverlaysLight.default.backgroundBox[1], moSetGetOverlaysLight.default.backgroundBox[2]+moSetGetOverlaysLight.default.backgroundBox[4]+0.001
	moSetGetOverlaysLight.default.masterPda.background = Overlay.new(g_baseUIFilename, moSetGetOverlaysLight.default.backgroundBox[1], moSetGetOverlaysLight.default.backgroundBox[2]+moSetGetOverlaysLight.default.backgroundBox[4]+0.001, moSetGetOverlaysLight.default.backgroundBox[3], 1.00-(moSetGetOverlaysLight.default.backgroundBox[2]+moSetGetOverlaysLight.default.backgroundBox[4])-0.001);
	moSetGetOverlaysLight.default.masterPda.background:setUVs(g_colorBgUVs);
	moSetGetOverlaysLight.default.masterPda.background:setColor(0, 0, 0, 0.75);
	--ground--	
	--left/right/separator--	
	moSetGetOverlaysLight.default.masterPda.buttonLeft = Overlay.new(iconFilePath, moSetGetOverlaysLight.default.masterPda.background.x, moSetGetOverlaysLight.default.masterPda.background.y+(moSetGetOverlaysLight.default.masterPda.background.height/2)-(iconHeight/2), iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.buttonLeft, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 4)));	
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.buttonLeft, g_currentMission.hl.getColor("ls22", true));
	--moSetGetOverlaysLight.default.masterPda.leftSeparator = Overlay.new(iconFilePath, moSetGetOverlaysLight.default.masterPda.buttonLeft.x+moSetGetOverlaysLight.default.masterPda.buttonLeft.width, moSetGetOverlaysLight.default.masterPda.buttonLeft.y, separatorWidth, separatorHeight); 
	--g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.leftSeparator, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 31)));	
	--g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.leftSeparator, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.inactive, true));
	moSetGetOverlaysLight.default.masterPda.buttonSetting = Overlay.new(iconFilePath, (moSetGetOverlaysLight.default.masterPda.background.x+moSetGetOverlaysLight.default.masterPda.background.width)-(iconWidth), moSetGetOverlaysLight.default.masterPda.background.y+(moSetGetOverlaysLight.default.masterPda.background.height/2)-(iconHeight/2), iconWidth, iconHeight);
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.buttonSetting, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 20)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.buttonSetting, g_currentMission.hl.getColor("ls22", true));
	
	--moSetGetOverlaysLight.default.masterPda.rightSeparator = Overlay.new(iconFilePath, moSetGetOverlaysLight.default.masterPda.buttonRight.x-(separatorWidth), moSetGetOverlaysLight.default.masterPda.buttonRight.y, separatorWidth, separatorHeight); 
	--g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.rightSeparator, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 31)));
	--g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.rightSeparator, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.inactive, true));	
	--left/right/separator--
	--appSeparator--
	--moSetGetOverlaysLight.default.masterPda.appSeparator = Overlay.new(iconFilePath, moSetGetOverlaysLight.default.masterPda.buttonRight.x-(separatorWidth), moSetGetOverlaysLight.default.masterPda.buttonRight.y, separatorWidth, separatorHeight); 
	--g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.appSeparator, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 31)));
	--g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.appSeparator, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.inactive, true));
	--appSeparator--
	--appInfoBar--
	moSetGetOverlaysLight.default.masterPda.appInfoBar = Overlay.new(iconFilePath, 0, (moSetGetOverlaysLight.default.masterPda.background.y+moSetGetOverlaysLight.default.masterPda.background.height)-0.010, moSetGetOverlaysLight.default.masterPda.appWidth, 0.015); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.appInfoBar, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.appInfoBar, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.infoBar, true));
	moSetGetOverlaysLight.default.masterPda.appInfoBarProzent = Overlay.new(iconFilePath, 0, (moSetGetOverlaysLight.default.masterPda.background.y+moSetGetOverlaysLight.default.masterPda.background.height)-0.010, 0, 0.015); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.appInfoBarProzent, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.appInfoBarProzent, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.default, true));
	--appInfoBar--
	--appNotice--
	moSetGetOverlaysLight.default.masterPda.appNotice = Overlay.new(iconFilePath, 0, moSetGetOverlaysLight.default.masterPda.appInfoBar.y-(iconHeight/3), iconWidth, iconHeight); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.appNotice, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 47)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.appNotice, g_currentMission.hl.getColor(moSetGetOverlaysLight.default.masterPda.color.notice, true));
	--appNotice--
	--appSelect--
	moSetGetOverlaysLight.default.masterPda.appSelect = Overlay.new(iconFilePath, 0, moSetGetOverlaysLight.default.masterPda.background.y-0.005, moSetGetOverlaysLight.default.masterPda.appWidth, 0.012); 
	g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.appSelect, unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, 32)));
	g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.appSelect, g_currentMission.hl.getColor("deepPink", true));
	--appSelect--
	
	iconFilePath = Utils.getFilename("icons/lights.dds", MultiOverlayV4.modDir);
	moSetGetOverlaysLight.default.masterPda.app = {};
	
	for order=1, #moSetGetOverlaysLight.default.masterPda.appOrder do
		moSetGetOverlaysLight.default.masterPda.app[#moSetGetOverlaysLight.default.masterPda.app+1] = Overlay.new(iconFilePath, 0, moSetGetOverlaysLight.default.masterPda.background.y, moSetGetOverlaysLight.default.masterPda.appWidth, moSetGetOverlaysLight.default.masterPda.appHeight);
		g_currentMission.hl.setOverlayUVsPx(moSetGetOverlaysLight.default.masterPda.app[#moSetGetOverlaysLight.default.masterPda.app], unpack(g_currentMission.hl.getNormalUVs(0, 0, 0, moSetGetOverlaysLight.default.masterPda.appOrder[order][1]))); 
		g_currentMission.hl.setBackgroundColor(moSetGetOverlaysLight.default.masterPda.app[#moSetGetOverlaysLight.default.masterPda.app], g_currentMission.hl.getColor("white", true));		
		moSetGetOverlaysLight.default.masterPda.app[#moSetGetOverlaysLight.default.masterPda.app].view = moSetGetOverlaysLight.default.masterPda.appOrder[order][2];		
	end;	
	---------master---------
	
	moSetGetLight:setMasterPdaBounds();
end;

function moSetGetOverlaysLight:updateMasterPda()
	local resetBounds = false;
	local minWidth = moSetGetOverlaysLight:getMasterPdaWidth();
	local minPosX = moSetGetOverlaysLight:getMasterPdaPosX(minWidth);
	if moSetGetOverlaysLight.default.masterPda.autoWidth then	
		if minPosX < moSetGetOverlaysLight.default.backgroundBox[1] then minPosX = moSetGetOverlaysLight.default.backgroundBox[1];resetBounds = true;end;			
	end;	
	if minWidth ~= moSetGetOverlaysLight.default.masterPda.background.width or minPosX ~= moSetGetOverlaysLight.default.masterPda.background.x then 
		g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.masterPda.background, minPosX, nil, minWidth);
		g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.masterPda.buttonLeft, moSetGetOverlaysLight.default.masterPda.background.x);
		resetBounds = true;
	end;
	if resetBounds then moSetGetLight:setMasterPdaBounds();end;
	--g_currentMission.hl.setOverlay(moSetGetOverlaysLight.default.masterPda.leftSeparator, moSetGetOverlaysLight.default.masterPda.buttonLeft.x+moSetGetOverlaysLight.default.masterPda.buttonLeft.width);	
end;

function moSetGetOverlaysLight:update(dt)
	if not moGeneralSettings.pdaType.light then return;end;
	moSetGetOverlaysLight.default.backgroundBox = {g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.backgroundOverlay.overlay)};
	moSetGetOverlaysLight:updateMasterPda();	
end;

function moSetGetOverlaysLight:setMasterPdaViewIconsByBounds()
	local bounds1 = moSetGetOverlaysLight.default.masterPda.bounds[1];
	local bounds2 = moSetGetOverlaysLight.default.masterPda.bounds[2];
	local bounds3 = moSetGetOverlaysLight.default.masterPda.bounds[3];
	local viewApps = 1;
	for app=1, #moSetGetOverlaysLight.default.masterPda.app do		
		if app >= bounds1 and viewApps <= bounds3 then
			if moSetGetOverlaysLight.default.masterPda.appOrder[app][2] then
				moSetGetOverlaysLight.default.masterPda.app[app].view = true;
				viewApps = viewApps+1;
				--bounds1 = bounds1+1
			else
				moSetGetOverlaysLight.default.masterPda.app[app].view = false;
			end;
		else
			moSetGetOverlaysLight.default.masterPda.app[app].view = false;			
		end;		
	end;	
end;







