moSetGetOverlays = {};
source(MultiOverlayV4.modDir.."scripte/overlays/moOverlaysDDS.lua");
source(MultiOverlayV4.modDir.."scripte/overlays/slot/moSetGetSlot.lua");
source(MultiOverlayV4.modDir.."scripte/overlays/slot/moAutoGenerateSlot.lua");
source(MultiOverlayV4.modDir.."scripte/overlays/pda/moSetGetPda.lua");
source(MultiOverlayV4.modDir.."scripte/overlays/pda/moAutoGeneratePda.lua");

function moSetGetOverlays:loadTables()	
	g_currentMission.multiOverlayV4.moSetGetOverlays = moSetGetOverlays;
	moSetGetOverlays.iconWidescreenFix = 0;
	if moGeneralSettings.iconWidescreenFix ~= nil and (moGeneralSettings.iconWidescreenFix > 0 or moGeneralSettings.iconWidescreenFix < 0) then		
		moSetGetOverlays.iconWidescreenFix = moGeneralSettings.iconWidescreenFix;
	end;
	moSetGetOverlays.buttonGfxWidth1 = (1 / g_screenWidth);
	--moSetGetOverlays.buttonGfxHeight1 = 1 / g_screenHeight;
	moSetGetOverlays.buttonGfxHeight1 = (1 / g_screenWidth)*1.6;	
	if g_screenWidth <= 1920 and g_screenWidth >= 1600 then moSetGetOverlays.buttonGfxWidth1 = moSetGetOverlays.buttonGfxWidth1/(1.5+(moSetGetOverlays.iconWidescreenFix));moSetGetOverlays.buttonGfxHeight1 = moSetGetOverlays.buttonGfxHeight1/1.5;end;
	if g_screenWidth < 1600 then moSetGetOverlays.buttonGfxWidth1 = moSetGetOverlays.buttonGfxWidth1/(2+(moSetGetOverlays.iconWidescreenFix));moSetGetOverlays.buttonGfxHeight1 = moSetGetOverlays.buttonGfxHeight1/2;end;
		
	if moSetGetOverlays.iconWidescreenFix ~= nil and (moSetGetOverlays.iconWidescreenFix > 0 or moSetGetOverlays.iconWidescreenFix < 0) then moSetGetOverlays.buttonGfxWidth1 = (1 / g_screenWidth)/(1+(moSetGetOverlays.iconWidescreenFix));end; --Breitbild 34 Zoll Format
	
	moSetGetOverlays.infoHelpBox = {
		design = {}; 
		info   = {txt="", titel=tostring(MultiOverlayV4.metadata.title).. " Info Text", typ=0, txtColor="yellow", posX=0, posY=0, width=0, height=0, timer=1, bounds={1, 1}, lsTimer=-1, defaultColor=HUDPopupMessage.COLOR.TEXT};
		help   = {txt="", titel=tostring(MultiOverlayV4.metadata.title).. " Help Text", typ=0, txtColor="yellow", posX=0, posY=0, width=0, height=0, timer=1, bounds={1, 1}, lsTimer=-1, defaultColor=HUDPopupMessage.COLOR.TEXT};
	};
	
	moSetGetOverlays:generateHotSpots();
	
	moSetGetOverlays.slot = {};	
	moSetGetOverlays.slotSettingCopyPaste = {};
	moSetGetOverlays.pda = {};
	moSetGetOverlays.pdaSettingCopyPaste = {};		
	moSetGetOverlays.foreignSlot = {};
	moSetGetOverlays.foreignIcons = {};
	moSetGetOverlays.previewIcons = {};
	moSetGetOverlays.appIconLoadChange = {};
	moSetGetOverlays.icons = {};
	
	
	moSetGetOverlays:setMenuePreviewIcons();
	
	moSetGetOverlays:loadIcons( {xmlTagName="intern.intern1", modDir=MultiOverlayV4.modDir, iconFile="icons/sonstiges1.dds", xmlFile="icons/intern.xml", modName="MultiOverlayV4", groupName="intern", fileFormat="m512x512"} ); --Global Pda smallView Icon
	moSetGetOverlays:loadIcons( {xmlTagName="vehicles.vehicleExtra", modDir=MultiOverlayV4.modDir, iconFile="icons/vehicles1.dds", xmlFile="icons/vehicle.xml", modName="MultiOverlayV4", groupName="intern", fileFormat="m512x512"} ); --Global Vehicle Extras
	
	moSetGetOverlays:loadIcons( {xmlTagName="intern.intern2", modDir=MultiOverlayV4.modDir, iconFile="icons/wtm1.dds", xmlFile="icons/intern.xml", modName="MultiOverlayV4", groupName="intern", fileFormat="m512x512"} ); --Global TimeScale highter
	moSetGetOverlays:loadIcons( {xmlTagName="intern.intern3", modDir=MultiOverlayV4.modDir, iconFile="icons/sonstiges1.dds", xmlFile="icons/intern.xml", modName="MultiOverlayV4", groupName="intern", fileFormat="m512x512"} ); --Global miniMapAutoState Icons
	
	moSetGetOverlays:loadIcons( {xmlTagName="intern.slotoutputicons", modDir=MultiOverlayV4.modDir, iconFile="icons/slotoutputicons.dds", xmlFile="icons/intern.xml", modName="MultiOverlayV4", groupName="slotoutput", fileFormat="m256x256", foreign=true} ); --Global Output Icons
	moSetGetOverlays:loadIcons( {xmlTagName="intern.pricetrend", modDir=MultiOverlayV4.modDir, iconFile="icons/pricetrend.dds", xmlFile="icons/intern.xml", modName="MultiOverlayV4", groupName="intern", fileFormat="m128x128", foreign=true} );
	
	moSetGetOverlays:loadIcons( {xmlTagName="digiclock", modDir=MultiOverlayV4.modDir, iconFile="icons/digiclock.dds", xmlFile="icons/digiclock.xml", modName="MultiOverlayV4", groupName="digiclock", fileFormat="m256x256", foreign=true} );
	moSetGetOverlays:loadIcons( {xmlTagName="digimoney", modDir=MultiOverlayV4.modDir, iconFile="icons/digimoney.dds", xmlFile="icons/digimoney.xml", modName="MultiOverlayV4", groupName="digimoney", fileFormat="m512x512"} );
	moSetGetOverlays:loadIcons( {xmlTagName="weather", modDir=MultiOverlayV4.modDir, iconFile="icons/weather.dds", xmlFile="icons/weather.xml", modName="MultiOverlayV4", groupName="weather", fileFormat="m512x512"} );	
		
end;

function moSetGetOverlays:generateHotSpots()
	local _, txtSize = getNormalizedScreenValues(0, 10);
	--local txtOffsetX, txtOffsetY = getNormalizedScreenValues(30, 27);
	moSetGetOverlays.mapHotspot = {};	
	local width, height = getNormalizedScreenValues(50, 50);
	local uvsAi = GuiUtils.getUVs({436,111,100,100}, {1024,512});
	local uvsInfo = GuiUtils.getUVs({760,219,100,100}, {1024,512}); 
	
	for a=1, 3 do
		moSetGetOverlays.mapHotspot[a] = MapHotspot.new();
		moSetGetOverlays.mapHotspot[a].icon = Overlay.new("dataS/menu/hud/mapHotspots.png", 0, 0,width, height);
		moSetGetOverlays.mapHotspot[a].icon:setUVs(uvsInfo);
		--moSetGetOverlays.mapHotspot[a].icon:setScale(1.3, 1.3); --see better icon :-)
		moSetGetOverlays.mapHotspot[a]:setColor(unpack(g_currentMission.hl.getColor("yellow", true)));
		moSetGetOverlays.mapHotspot[a].txtSize = txtSize;
		moSetGetOverlays.mapHotspot[a].name = "";
		moSetGetOverlays.mapHotspot[a].field = true;
		moSetGetOverlays.mapHotspot[a].isBlinking = true;
		moSetGetOverlays.mapHotspot[a].isPersistent = true;
		moSetGetOverlays.mapHotspot[a].isVisible = false;		
		g_currentMission:addMapHotspot(moSetGetOverlays.mapHotspot[a]);
	end;	
	--moSetGetOverlays.mapHotspot:setTextOptions(txtSize, nil, txtOffsetY, g_currentMission.hl.getColor("mangenta", true), Overlay.ALIGN_VERTICAL_MIDDLE)
end;

function moSetGetOverlays:setMenuePreviewIcons()
	local modDir = MultiOverlayV4.modDir;
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="animals1", modDir=modDir, iconFile="icons/animals1.dds", xmlFile="icons/animals.xml", modName="MultiOverlayV4", groupName="animals", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="factorys1", modDir=modDir, iconFile="icons/factorys1.dds", xmlFile="icons/factorys.xml", modName="MultiOverlayV4", groupName="factorys", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="fruits1", modDir=modDir, iconFile="icons/fruits1.dds", xmlFile="icons/fruits.xml", modName="MultiOverlayV4", groupName="fruits", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="woods1", modDir=modDir, iconFile="icons/woods1.dds", xmlFile="icons/woods.xml", modName="MultiOverlayV4", groupName="woods", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="silos1", modDir=modDir, iconFile="icons/silos1.dds", xmlFile="icons/silos.xml", modName="MultiOverlayV4", groupName="silos", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="stocks1", modDir=modDir, iconFile="icons/stocks1.dds", xmlFile="icons/stocks.xml", modName="MultiOverlayV4", groupName="stocks", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="others1", modDir=modDir, iconFile="icons/other1.dds", xmlFile="icons/other.xml", modName="MultiOverlayV4", groupName="others", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="farms1", modDir=modDir, iconFile="icons/farms1.dds", xmlFile="icons/farms.xml", modName="MultiOverlayV4", groupName="farms", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="wtms1", modDir=modDir, iconFile="icons/wtm1.dds", xmlFile="icons/wtm.xml", modName="MultiOverlayV4", groupName="wetterMoneyTime", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="vehicles.vehicle", modDir=modDir, iconFile="icons/vehicles1.dds", xmlFile="icons/vehicles.xml", modName="MultiOverlayV4", groupName="vehicles", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="othermods1", modDir=modDir, iconFile="icons/othermods1.dds", xmlFile="icons/othermods.xml", modName="MultiOverlayV4", groupName="otherMods", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="sonstiges1", modDir=modDir, iconFile="icons/sonstiges1.dds", xmlFile="icons/sonstiges.xml", modName="MultiOverlayV4", groupName="sonstiges", fileFormat="m512x512", previewIcons=true} );
	--moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="speciale1", modDir=modDir, iconFile="icons/speciale1.dds", xmlFile="icons/speciale.xml", modName="MultiOverlayV4", groupName="speciale", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="ls22.fruits1", modDir=modDir, iconFile="icons/ls22fruits1.dds", xmlFile="icons/ls22.xml", modName="MultiOverlayV4", groupName="ls22_fruits1", fileFormat="m512x512", previewIcons=true} );
	moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="ls22.fruits2", modDir=modDir, iconFile="icons/ls22fruits2.dds", xmlFile="icons/ls22.xml", modName="MultiOverlayV4", groupName="ls22_fruits2", fileFormat="m512x512", previewIcons=true} );
	--moSetGetOverlays:saveMenuePreviewIcons( {xmlTagName="ls22.menu", modDir=modDir, iconFile="icons/ls22menu.dds", xmlFile="icons/ls22.xml", modName="MultiOverlayV4", groupName="ls22_menu", fileFormat="m512x512", previewIcons=true} );
end;

function moSetGetOverlays:loadDefaultSlotIcons(whichSlot)
	if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then
		moSetGetOverlays:loadIcons( {xmlTagName="settings.ground", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="ground", fileFormat="m512x512", previewIcons=false, foreign=false, whichSlot=tostring(whichSlot)} );
		moSetGetOverlays:loadIcons( {xmlTagName="settings.button", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false, whichSlot=tostring(whichSlot)} );		
		moSetGetOverlays:loadIcons( {xmlTagName="settings.line", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="line", fileFormat="m512x512", previewIcons=false, foreign=false, whichSlot=tostring(whichSlot)} );
		moSetGetOverlays:loadIcons( {xmlTagName="settings.mouse", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false, whichSlot=tostring(whichSlot)} );
	end;
end;

function moSetGetOverlays:loadDefaultPdaIcons(whichPda)
	if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then
		moSetGetOverlays:loadIcons( {xmlTagName="settings.ground", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="ground", fileFormat="m512x512", previewIcons=false, foreign=false, whichPda=tostring(whichPda)} );
		moSetGetOverlays:loadIcons( {xmlTagName="settings.frame", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="ground", fileFormat="m512x512", previewIcons=false, foreign=false, whichPda=tostring(whichPda)} );
		moSetGetOverlays:loadIcons( {xmlTagName="settings.button", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false, whichPda=tostring(whichPda)} );		
		moSetGetOverlays:loadIcons( {xmlTagName="settings.line", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="line", fileFormat="m512x512", previewIcons=false, foreign=false, whichPda=tostring(whichPda)} );
		moSetGetOverlays:loadIcons( {xmlTagName="settings.mouse", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false, whichPda=tostring(whichPda)} );
		moSetGetOverlays:loadIcons( {xmlTagName="settings.app", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false, whichPda=tostring(whichPda)} );
	end;
end;

function moSetGetOverlays:loadDefaultMenueIcons()	
	--moSetGetOverlays:loadIcons( {xmlTagName="settings.ground", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="ground", fileFormat="m512x512", previewIcons=false, foreign=false} );
	--moSetGetOverlays:loadIcons( {xmlTagName="settings.frame", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="ground", fileFormat="m512x512", previewIcons=false, foreign=false} );
	--moSetGetOverlays:loadIcons( {xmlTagName="settings.button", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false} );		
	--moSetGetOverlays:loadIcons( {xmlTagName="settings.line", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="line", fileFormat="m512x512", previewIcons=false, foreign=false} );
	--moSetGetOverlays:loadIcons( {xmlTagName="settings.mouse", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false} );
	--moSetGetOverlays:loadIcons( {xmlTagName="settings.app", modDir=MultiOverlayV4.modDir, iconFile="icons/settings.dds", xmlFile="icons/settings.xml", loadIcons=nil, modName="MultiOverlayV4", groupName="icon", fileFormat="m512x512", previewIcons=false, foreign=false} );
	--local optiSize = MultiOverlayV4:get_hl("optiHeightSize", {moSetGetOverlays.buttonGfxHeight1*moGeneralSettings.menue.previewIcons.zoomOutIn, "Äg", 0.015}, "moSetGetOverlays:loadDefaultMenueIcons");
	--local optiSizeHalf = MultiOverlayV4:get_hl("optiHeightSize", {moSetGetOverlays.buttonGfxHeight1*moGeneralSettings.menue.previewIcons.zoomOutIn/2, "Äg", 0.015}, "moSetGetOverlays:loadDefaultMenueIcons");
	--moGeneralSettings.menue.previewIcons.appOptiSizeTxtHeight = optiSize;
	--moGeneralSettings.menue.previewIcons.appOptiSizeHalfTxtHeight = optiSizeHalf;
end;

function moSetGetOverlays:cloneOverlay(overlay, cloneOverlay)
	local overlayId = overlay.overlayId;
	local cloneOverlayTable = g_currentMission.hl.getTableCopy(cloneOverlay);	
	overlay = cloneOverlayTable;
	overlay.overlayId = overlayId;
	setOverlayUVs(overlayId, unpack(cloneOverlay.uvs));	
end;

function moSetGetOverlays:loadIcons(args)	
	if args == nil or type(args) ~= "table" or args.xmlTagName == nil or args.modName == nil or args.groupName == nil or args.iconFile == nil or args.xmlFile == nil or args.fileFormat == nil then return nil;end;
	local icons = nil;	
	if type(args.loadIcons) == "table" then icons = args.loadIcons;end; 
	local iconFilePath, xmlFilePath = moSetGetOverlays:checkFilePath(args.iconFile, args.xmlFile, args.modDir);	
	if iconFilePath == nil or xmlFilePath == nil then return nil;end;
	local iconOverlayTable = nil;
	local isSlot = false;
	local isPda = false;
	local isForeign = false;
	local zoomOutInTemp = 20;
	local iconsSize = moOverlaysDDS.iconsSize;
	local iconsDDS = moOverlaysDDS.icons;	
	if args.foreign then iconsSize = moOverlaysDDS.foreignIconsSize;iconsDDS = moOverlaysDDS.foreignIcons[args.fileFormat];end;
	if args.previewIcons ~= nil and args.previewIcons then
		if moSetGetOverlays.previewIcons[args.modName] == nil then moSetGetOverlays.previewIcons[args.modName] = {};end;
		if moSetGetOverlays.previewIcons[args.modName][args.groupName] == nil then moSetGetOverlays.previewIcons[args.modName][args.groupName] = {};end;
		iconOverlayTable = moSetGetOverlays.previewIcons[args.modName][args.groupName]
		zoomOutInTemp = 5;
	elseif args.whichSlot ~= nil and type(args.whichSlot) == "string" and moSetGetOverlays.slot[args.whichSlot] ~= nil then
		if moSetGetOverlays.slot[args.whichSlot].design[args.groupName] == nil then moSetGetOverlays.slot[args.whichSlot].design[args.groupName] = {};end;		
		iconOverlayTable = moSetGetOverlays.slot[args.whichSlot].design[args.groupName];
		if moSetGetOverlays.slot[args.whichSlot].design.byName == nil then moSetGetOverlays.slot[args.whichSlot].design.byName = {};end;
		if moSetGetOverlays.slot[args.whichSlot].design.byName[args.groupName] == nil then moSetGetOverlays.slot[args.whichSlot].design.byName[args.groupName] = {};end;
		isSlot = true;
	elseif args.appIcon == nil and args.whichPda ~= nil and type(args.whichPda) == "string" and moSetGetOverlays.pda[args.whichPda] ~= nil then
		if moSetGetOverlays.pda[args.whichPda].design[args.groupName] == nil then moSetGetOverlays.pda[args.whichPda].design[args.groupName] = {};end;		
		iconOverlayTable = moSetGetOverlays.pda[args.whichPda].design[args.groupName];
		if moSetGetOverlays.pda[args.whichPda].design.byName == nil then moSetGetOverlays.pda[args.whichPda].design.byName = {};end;
		if moSetGetOverlays.pda[args.whichPda].design.byName[args.groupName] == nil then moSetGetOverlays.pda[args.whichPda].design.byName[args.groupName] = {};end;
		isPda = true;	
	elseif args.appIcon ~= nil and type(args.appIcon) == "table" and args.whichPda ~= nil and type(args.whichPda) == "string" and moSetGetOverlays.pda[args.whichPda] ~= nil then
		if moSetGetOverlays.pda[args.whichPda].apps == nil then moSetGetOverlays.pda[args.whichPda].apps = {};end;		
		
		if moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]] == nil then moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]] = {};end;
		if moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]][args.appIcon[2]] == nil then
			moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]][args.appIcon[2]] = {cmd={}, icon={}};			
		else
			if moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]][args.appIcon[2]].cmd == nil then
				moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]][args.appIcon[2]].cmd = {};
			end;
			if moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]][args.appIcon[2]].icon == nil then
				moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]][args.appIcon[2]].icon = {};
			end;
		end;
		zoomOutInTemp = moSetGetOverlays.pda[args.whichPda].appIconZoomOutIn;
		iconOverlayTable = moSetGetOverlays.pda[args.whichPda].apps[args.appIcon[1]][args.appIcon[2]].icon;
	else
		if moSetGetOverlays.icons[args.modName] == nil then moSetGetOverlays.icons[args.modName] = {};end;
		if moSetGetOverlays.icons[args.modName][args.groupName] == nil then moSetGetOverlays.icons[args.modName][args.groupName] = {};end;
		if moSetGetOverlays.icons.byName == nil then moSetGetOverlays.icons.byName = {};end;
		if moSetGetOverlays.icons.byName[args.modName] == nil then moSetGetOverlays.icons.byName[args.modName] = {};end;
		if moSetGetOverlays.icons.byName[args.modName][args.groupName] == nil then moSetGetOverlays.icons.byName[args.modName][args.groupName] = {};end;
		iconOverlayTable = moSetGetOverlays.icons[args.modName][args.groupName];
		isForeign = true;		
	end;
	local Xml = loadXMLFile("MultiOverlayV4_XML", xmlFilePath);
	local xmlNameTag = tostring(args.xmlTagName);
	local loadIcons = 0;		
	local firstIcon = #iconOverlayTable+1;
	local endIcon = nil;
	function generateOverlay(int)		
		iconOverlayTable[#iconOverlayTable+1] = Overlay.new(iconFilePath, 0, 0, moSetGetOverlays.buttonGfxWidth1*zoomOutInTemp, moSetGetOverlays.buttonGfxHeight1*zoomOutInTemp);
		local overlay = iconOverlayTable[#iconOverlayTable];		
		local iconPlace = getXMLInt(Xml, xmlNameTag.."#place");
		if iconPlace ~= nil then int = iconPlace;end;
		g_currentMission.hl.setOverlayUVsPx(overlay, iconsDDS["icon".. int], iconsSize[args.fileFormat][1], iconsSize[args.fileFormat][2]);
		local iconName = getXMLString(Xml, xmlNameTag.."#name");
		if isSlot then
			moSetGetOverlays.slot[args.whichSlot].design.byName[args.groupName][iconName] = #iconOverlayTable;
		elseif isPda then
			moSetGetOverlays.pda[args.whichPda].design.byName[args.groupName][iconName] = #iconOverlayTable;
		elseif isForeign then
			moSetGetOverlays.icons.byName[args.modName][args.groupName][iconName] = #iconOverlayTable;
		end;		
		--overlay.iconDDS = iconsDDS["icon".. int];		
		overlay.iconPlace = int;
		overlay.saveArgs = args;
		overlay.iconName = tostring(iconName);
		overlay.xmlTagName = tostring(args.xmlTagName);
		overlay.modName = tostring(args.modName);
		overlay.groupName = tostring(args.groupName);
		overlay.infoTxt = Utils.getNoNil(getXMLString(Xml, xmlNameTag.."#infoTxt"), nil);
		overlay.isBlinking = false;
		overlay.ownValue = "";
		local iconType = getXMLInt(Xml, xmlNameTag.."#type");		
		if iconType == nil then iconType = 1;end;		
		overlay.iconType = iconType;
		if getXMLString(Xml, xmlNameTag.."#ownValue") then
			overlay.ownValue = getXMLString(Xml, xmlNameTag.."#ownValue");
		end;
		if getXMLString(Xml, xmlNameTag.."#onOpen") then
			local func = moSetGetOverlays.getFunction(getXMLString(Xml, xmlNameTag.."#onOpen"))
			if func ~= nil then overlay.onOpen = func;end;
		end;		
		if getXMLString(Xml, xmlNameTag.."#action") then
			local func = moSetGetOverlays.getFunction(getXMLString(Xml, xmlNameTag.."#action"))
			if func ~= nil then overlay.action = func;end;
		end;
		if getXMLString(Xml, xmlNameTag.."#onDrawBefore") then
			local func = moSetGetOverlays.getFunction(getXMLString(Xml, xmlNameTag.."#onDrawBefore"))
			if func ~= nil then overlay.onDrawBefore = func;end;
		end;
		if getXMLString(Xml, xmlNameTag.."#onDrawAfter") then
			local func = moSetGetOverlays.getFunction(getXMLString(Xml, xmlNameTag.."#onDrawAfter"))
			if func ~= nil then overlay.onDrawAfter = func;end;
		end;
		local iconRotation = getXMLFloat(Xml, xmlNameTag.."#rotation");
		if iconRotation ~= nil then 
			setOverlayRotation(overlay.overlayId, iconRotation, 0+overlay.width/2, 0+overlay.height/2);	
		end;		
		local iconColorState = false;
		if iconType == 0 or iconType == 3 then
			overlay.editTxt = false;
			overlay.isFormatTxt = false;
			overlay.txt = {};			
			if getXMLString(Xml, xmlNameTag.."#txt1") then				
				if getXMLBool(Xml, xmlNameTag.."#editTxt") then overlay.editTxt = getXMLBool(Xml, xmlNameTag.."#editTxt");end;
				overlay.txt[1] = {txt=tostring(getXMLString(Xml, xmlNameTag.."#txt1"))};				
				if getXMLString(Xml, xmlNameTag.."#txt1Color") then
					local result, isOkay = MultiOverlayV4:get_hl("getColor", {tostring(getXMLString(Xml, xmlNameTag.."#txt1Color")), true}, "moSetGetOverlays:loadIcons");
					if isOkay then
						overlay.txt[1].color = tostring(getXMLString(Xml, xmlNameTag.."#txt1Color"));
					end;
				end;
				if getXMLBool(Xml, xmlNameTag.."#txt1Bold") then
					overlay.txt[1].bold = getXMLBool(Xml, xmlNameTag.."#txt1Bold");
				else
					overlay.txt[1].bold = false;
				end;
				if getXMLBool(Xml, xmlNameTag.."#txt1CenterHeight") then
					overlay.txt[1].centerH = getXMLBool(Xml, xmlNameTag.."#txt1CenterHeight");
				else
					overlay.txt[1].centerH = false;
				end;
				if getXMLBool(Xml, xmlNameTag.."#txt1CenterWidth") then
					overlay.txt[1].centerW = getXMLBool(Xml, xmlNameTag.."#txt1CenterWidth");
				else
					overlay.txt[1].centerW = false;
				end;
				if getXMLBool(Xml, xmlNameTag.."#txt1OptiWidthSize") then
					overlay.txt[1].optiWidthSize = getXMLBool(Xml, xmlNameTag.."#txt1OptiWidthSize");
				else
					overlay.txt[1].optiWidthSize = false;
				end;
				if getXMLInt(Xml, xmlNameTag.."#txt1SizeDif") then
					overlay.txt[1].sizeDif = getXMLInt(Xml, xmlNameTag.."#txt1SizeDif")/1000;
				end;
				if getXMLBool(Xml, xmlNameTag.."#txt1WidthLimit") then
					overlay.txt[1].widthLimit = getXMLBool(Xml, xmlNameTag.."#txt1WidthLimit");
				else
					overlay.txt[1].widthLimit = false;
				end;
				if getXMLString(Xml, xmlNameTag.."#txt2") then					
					overlay.txt[2] = {txt=tostring(getXMLString(Xml, xmlNameTag.."#txt2"))};
					if getXMLString(Xml, xmlNameTag.."#txt2Color") then
						local result, isOkay = MultiOverlayV4:get_hl("getColor", {tostring(getXMLString(Xml, xmlNameTag.."#txt2Color")), true}, "moSetGetOverlays:loadIcons");
						if isOkay then
							overlay.txt[2].color = tostring(getXMLString(Xml, xmlNameTag.."#txt2Color"));
						end;
					end;
					if getXMLBool(Xml, xmlNameTag.."#txt2Bold") then
						overlay.txt[2].bold = getXMLBool(Xml, xmlNameTag.."#txt2Bold");
					else
						overlay.txt[2].bold = false;
					end;
					if getXMLBool(Xml, xmlNameTag.."#txt2CenterHeight") then
						overlay.txt[2].centerH = getXMLBool(Xml, xmlNameTag.."#txt2CenterHeight");
					else
						overlay.txt[2].centerH = false;
					end;
					if getXMLBool(Xml, xmlNameTag.."#txt2OptiWidthSize") then
						overlay.txt[2].optiWidthSize = getXMLBool(Xml, xmlNameTag.."#txt2OptiWidthSize");
					else
						overlay.txt[2].optiWidthSize = false;
					end;
					if getXMLInt(Xml, xmlNameTag.."#txt2SizeDif") then
						overlay.txt[2].sizeDif = getXMLInt(Xml, xmlNameTag.."#txt2SizeDif")/1000;
					end;
					if getXMLBool(Xml, xmlNameTag.."#txt2CenterWidth") then
						overlay.txt[2].centerW = getXMLBool(Xml, xmlNameTag.."#txt2CenterWidth");
					else
						overlay.txt[2].centerW = false;
					end;
					if getXMLBool(Xml, xmlNameTag.."#txt2WidthLimit") then
						overlay.txt[2].widthLimit = getXMLBool(Xml, xmlNameTag.."#txt2WidthLimit");
					else
						overlay.txt[2].widthLimit = false;
					end;
				end;
			end;
		end;
		if iconType == 0 or iconType == 2 or iconType == 3 then
			local iconColor = getXMLString(Xml, xmlNameTag.."#color");
			if iconColor ~= nil then
				local result, isOkay = MultiOverlayV4:get_hl("getColor", {tostring(iconColor), true}, "moSetGetOverlays:loadIcons")
				if isOkay then
					local iconTransparent = getXMLFloat(Xml, xmlNameTag.."#transparent"); 
					if iconTransparent then
						result[4] = iconTransparent;
					end;
					iconColorState = true;
					overlay.colorState = result;
					g_currentMission.hl.setBackgroundColor(overlay, result);
				end;
			end;		
			if iconColor == nil then
				local iconColorDefault = getXMLString(Xml, xmlNameTag.."#defaultColor");
				if iconColorDefault ~= nil then
					local result, isOkay = MultiOverlayV4:get_hl("getColor", {tostring(iconColorDefault), true}, "moSetGetOverlays:loadIcons")
					if isOkay then
						overlay.defaultColor = tostring(iconColorDefault);
						if not iconColorState then overlay.colorState = result;iconColorState = true;end;
					end;
				end;
			end;			
		end;
		if not iconColorState then overlay.colorState = {1,1,1,1};end;
		endIcon = #iconOverlayTable;		
	end;	
	if icons == nil and getXMLInt(Xml, xmlNameTag.."#load") ~= nil then
		loadIcons = getXMLInt(Xml, xmlNameTag.."#load");
		if loadIcons > iconsDDS.maxIcons[1] then loadIcons = iconsDDS.maxIcons[1];end;		
		for a=1, loadIcons do
			xmlNameTag = (tostring(args.xmlTagName).. ".icon(%d)"):format(a-1);
			if getXMLString(Xml, xmlNameTag.."#name") and a <= loadIcons then				
				generateOverlay(a);								
			else
				break;
			end;
		end;		
	elseif icons ~= nil then		
		for a=1, #icons do
			local iconNumber = icons[a];
			if iconNumber ~= nil and iconNumber <= iconsDDS.maxIcons[1] then
				xmlNameTag = (tostring(args.xmlTagName).. ".icon(%d)"):format(iconNumber-1);
				if getXMLString(Xml, xmlNameTag.."#name") then				
					generateOverlay(iconNumber);								
				else
					break;
				end;
			end;
		end;		
	end;
	if enable then
		if isSlot then
			for slotName,groupTable in pairs (moSetGetOverlays.slot) do			
				print("-----------SlotName=".. tostring(slotName));
				for groupName,icon in pairs (moSetGetOverlays.slot[slotName].design.byName) do
					print("groupName=".. tostring(groupName).. " --- icon=".. tostring(icon));
				end;
			end;
		end;
	end;
	if enable then
		for modName,groupTable in pairs (moSetGetOverlays.icons) do
			print("modName=".. tostring(modName).. " --- groupTable=".. tostring(groupTable));
			for groupName,iconTable in pairs (groupTable) do
				print("groupName=".. tostring(groupName).. " --- iconTable=".. tostring(iconTable));
				for index,iconValue in pairs (iconTable) do
					print("index=".. tostring(index).. " --- iconValue=".. tostring(iconValue));
					for key,value in pairs (iconValue) do
						print("key=".. tostring(key).. " --- value=".. tostring(value));
					end;
				end;
			end;
		end;
	end;
	return firstIcon, endIcon;
end;

function moSetGetOverlays:deleteSlotIcons(whichSlot)
	if whichSlot ~= nil and moSetGetOverlays.slot[whichSlot] ~= nil then				
		for groupName,iconTable in pairs (moSetGetOverlays.slot[whichSlot].design) do						
			if groupName ~= "byName" then
				for a=1, #moSetGetOverlays.slot[whichSlot].design[groupName] do
					moSetGetOverlays:deleteOldOverlay(moSetGetOverlays.slot[whichSlot].design[groupName][a], "SlotIcons ".. tostring(whichSlot).. " ".. tostring(groupName));					
				end;
			end;
		end;
	else
		for slotName,groupTable in pairs (moSetGetOverlays.slot) do
			if groupName ~= "byName" then
				for groupName,iconTable in pairs (moSetGetOverlays.slot[slotName].design) do						
					for a=1, #moSetGetOverlays.slot[slotName].design[groupName] do
						moSetGetOverlays:deleteOldOverlay(moSetGetOverlays.slot[slotName].design[groupName][a], "SlotIcons ".. tostring(slotName).. " ".. tostring(groupName));				
					end;			
				end;
			end;
		end;
	end;
end;

function moSetGetOverlays:deletePdaIcons(whichPda)
	if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil then				
		for groupName,iconTable in pairs (moSetGetOverlays.pda[whichPda].design) do						
			if groupName ~= "byName" then
				for a=1, #moSetGetOverlays.pda[whichPda].design[groupName] do
					moSetGetOverlays:deleteOldOverlay(moSetGetOverlays.pda[whichPda].design[groupName][a], "PdaIcons ".. tostring(whichPda).. " ".. tostring(groupName));					
				end;
			end;
		end;
	else
		for pdaName,groupTable in pairs (moSetGetOverlays.pda) do
			if groupName ~= "byName" then
				for groupName,iconTable in pairs (moSetGetOverlays.pda[pdaName].design) do						
					for a=1, #moSetGetOverlays.pda[pdaName].design[groupName] do
						moSetGetOverlays:deleteOldOverlay(moSetGetOverlays.pda[pdaName].design[groupName][a], "PdaIcons ".. tostring(pdaName).. " ".. tostring(groupName));				
					end;			
				end;
			end;
		end;
	end;
end;

function moSetGetOverlays:deleteIcons()
	if moSetGetOverlays.icons == nil then return;end;
	for modName,groupTable in pairs (moSetGetOverlays.icons) do		
		for groupName,iconTable in pairs (groupTable) do						
			for a=1, #moSetGetOverlays.icons[modName][groupName] do
				moSetGetOverlays:deleteOldOverlay(moSetGetOverlays.icons[modName][groupName][a], "PreviewIcons");				
			end;			
		end;
	end;
	moSetGetOverlays.icons = {};	
end;

function moSetGetOverlays:refreshAppIconFormatTxt(whichPda)
	if whichPda ~= nil and moSetGetOverlays.pda[whichPda] ~= nil and moSetGetOverlays.pda[whichPda].apps ~= nil then		
		for line, _ in pairs (moSetGetOverlays.pda[whichPda].apps) do
			if moSetGetOverlays.pda[whichPda].apps[line] ~= nil then
				for pos, _ in pairs (moSetGetOverlays.pda[whichPda].apps[line]) do
					if moSetGetOverlays.pda[whichPda].apps[line][pos] ~= nil then
						if moSetGetOverlays.pda[whichPda].apps[line][pos].icon ~= nil and moSetGetOverlays.pda[whichPda].apps[line][pos].icon[1] ~= nil then
							if moSetGetOverlays.pda[whichPda].apps[line][pos].icon[1].isFormatTxt ~= nil then
								moSetGetOverlays.pda[whichPda].apps[line][pos].icon[1].isFormatTxt = false;
							end;
						end;
					end;
				end;
			end;
		end;		
	elseif moSetGetOverlays.previewIcons ~= nil then
		for modName,groupTable in pairs (moSetGetOverlays.previewIcons) do		
			for groupName,iconTable in pairs (groupTable) do						
				for a=1, #moSetGetOverlays.previewIcons[modName][groupName] do
					if moSetGetOverlays.previewIcons[modName][groupName][a] ~= nil and moSetGetOverlays.previewIcons[modName][groupName][a].isFormatTxt ~= nil then
						moSetGetOverlays.previewIcons[modName][groupName][a].isFormatTxt = false;
					end;			
				end;			
			end;
		end;
	end;
end;

function moSetGetOverlays:saveMenuePreviewIcons(args)
	if moSetGetOverlays.savePreviewIcons == nil then moSetGetOverlays.savePreviewIcons = {};end;	
	moSetGetOverlays.savePreviewIcons[#moSetGetOverlays.savePreviewIcons+1] = args;
end;

function moSetGetOverlays:loadPreviewIcons()
	if moSetGetOverlays.savePreviewIcons == nil or #moSetGetOverlays.savePreviewIcons < 1 then return nil;end;
	for a=1, #moSetGetOverlays.savePreviewIcons do		
		moSetGetOverlays:loadIcons(moSetGetOverlays.savePreviewIcons[a]);
	end;	
end;

function moSetGetOverlays:deletePreviewIcons()
	if moSetGetOverlays.previewIcons == nil then return nil;end;	
	for modName,groupTable in pairs (moSetGetOverlays.previewIcons) do		
		for groupName,iconTable in pairs (groupTable) do						
			for a=1, #moSetGetOverlays.previewIcons[modName][groupName] do
				moSetGetOverlays:deleteOldOverlay(moSetGetOverlays.previewIcons[modName][groupName][a], "PreviewIcons");				
			end;			
		end;
	end;
	moSetGetOverlays.previewIcons = {};
end;

function moSetGetOverlays:deleteOldOverlay(overlay, whatDelete)
	if overlay ~= nil and overlay and overlay.overlayId ~= nil and overlay.overlayId then
		overlay:delete();
		overlay = nil;
		--print("overlay delete ".. tostring(whatDelete))
		return true;		
	elseif overlay == nil then
		--print("overlay nil ".. tostring(whatDelete))
	end;
	return false;
end;

function moSetGetOverlays:checkFilePath(iconFile, xmlFile, modDir)	
	local iconFilePath = Utils.getFilename(tostring(iconFile), modDir);
	local xmlFilePath = Utils.getFilename(tostring(xmlFile), modDir);
	if not fileExists(iconFilePath) or not fileExists(xmlFilePath) then		
		return nil;		
	end;
	return iconFilePath, xmlFilePath;
end;

function moSetGetOverlays.getFunction(funcName)
	--local parts = StringUtil.splitString(".", funcName); old LS19
	local parts = g_currentMission.hl.stringSplit(funcName, ".", true);	
	local numParts = table.getn(parts);
	local currentTable = _G[parts[1]];
	if numParts > 1 then
		if type(currentTable) ~= "table" then
			return nil;
		end;
		for i = 2, numParts do
			currentTable = currentTable[parts[i]];
			if i ~= numParts and type(currentTable) ~= "table" then
				return nil;
			end;
		end;
	end;
	if type(currentTable) ~= "function" then
		return nil;
	end;
	return currentTable;
end;

function moSetGetOverlays:deleteObjectsMapHotSpot()
	if moSetGetOverlays.objectsMapHotspot ~= nil then
		for a=1, #moSetGetOverlays.objectsMapHotspot do
			if moSetGetOverlays.objectsMapHotspot[a] ~= nil and moSetGetOverlays.objectsMapHotspot[a].icon ~= nil then
				moSetGetOverlays.objectsMapHotspot[a].icon:delete();
				moSetGetOverlays.objectsMapHotspot[a].icon = nil;
				g_currentMission:removeMapHotspot(moSetGetOverlays.objectsMapHotspot[a]);
			end;
		end;
	end;
end;

function moSetGetOverlays:generateObjectsMapHotSpot(objects)
	if objects == nil or type(objects) ~= "table" then return;end;
	if g_currentMission.hl.timers["mohObjectsMapHotSpot"] ~= nil then
		g_currentMission.hl.removeTimer("mohObjectsMapHotSpot");
		moSetGetOverlays:deleteObjectsMapHotSpot();
	end;
	local width, height = getNormalizedScreenValues(25, 25);	
	local file = MultiOverlayV4.modDir.. "icons/settings.dds";
	moSetGetOverlays.objectsMapHotspot = {};
	local color = g_currentMission.hl.getColor("red", true);
	for a=1, #objects do
		local objectId = objects[a];
		if objectId ~= nil then
			local x, y, z = getWorldTranslation(objectId);
			if x ~= nil then
				moSetGetOverlays.objectsMapHotspot[a] = MapHotspot.new();
				moSetGetOverlays.objectsMapHotspot[a].icon = Overlay.new(file, 0, 0,width, height);				
				g_currentMission.hl.setOverlayUVsPx(moSetGetOverlays.objectsMapHotspot[a].icon, { 384+0.8, 384-0.8, 448-0.8, 320+0.8 }, 512, 512);				
				moSetGetOverlays.objectsMapHotspot[a].worldX = x or 0;
				moSetGetOverlays.objectsMapHotspot[a].worldZ = z or 0;
				moSetGetOverlays.objectsMapHotspot[a]:setColor(unpack(color));
				moSetGetOverlays.objectsMapHotspot[a].isBlinking = true;
				moSetGetOverlays.objectsMapHotspot[a].isPersistent = true;
				moSetGetOverlays.objectsMapHotspot[a].isVisible = true;
				g_currentMission:addMapHotspot(moSetGetOverlays.objectsMapHotspot[a]);
			end;
		end;
	end;
	g_currentMission.hl.addTimer({name="mohObjectsMapHotSpot", delay=10, repeatable=1, action=moSetGetOverlays.deleteObjectsMapHotSpot});
end;

function moSetGetOverlays:mapHotSpot(txt, x, z, total)
	if g_currentMission.hl.timers["mohMapHotSpot"] ~= nil then
		moSetGetOverlays:stopHotSpot();
		g_currentMission.hl.removeTimer("mohMapHotSpot");
		moSetGetOverlays:mapHotSpot(txt, x, z, total);
	else
		for a=1, total do
			moSetGetOverlays.mapHotspot[a].worldX = x[a] or 0;
			moSetGetOverlays.mapHotspot[a].worldZ = z[a] or 0;
			moSetGetOverlays.mapHotspot[a].name = txt[a];
			moSetGetOverlays.mapHotspot[a].isVisible = true;			
		end;
		g_currentMission.hl.addTimer({name="mohMapHotSpot", delay=10, repeatable=1, action=moSetGetOverlays.stopHotSpot});
	end;	
end;

function moSetGetOverlays:stopHotSpot()	
	for a=1, 3 do
		moSetGetOverlays.mapHotspot[a].isVisible = false;
		moSetGetOverlays.mapHotspot[a].name = "";	
		moSetGetOverlays.mapHotspot[a].worldX = 0;
		moSetGetOverlays.mapHotspot[a].worldZ = 0;
	end;
end;

-------------mod overlayFunction-------------
g_currentMission.multiOverlayV4.overlayFunction={
	loadIcons = function(args)return moSetGetOverlays:loadIcons(args);end;
	savePreviewIcons = function(args)moSetGetOverlays:saveMenuePreviewIcons(args);end;
};
-------------mod overlayFunction-------------